/*--------------------------------------------------------------------*/
/* This file contains all the I/O low level function definition used  */
/* by the Frame Library.                                              */
/*     (Code proposed by Roy Willams, Caltech) (Jun 14, 1999 version) */
/*--------------------------------------------------------------------*/
#if !defined(FRIO_DEFINED)
#define FRIO_DEFINED
#include <fcntl.h>

#define FRIOBSIZE 2048 /*--- local buffer to speed up the read process ---*/

struct FrIO{
#ifdef FRIOCFILE
  FILE *fp;
#else
  int fd;
#endif
  char buffer[FRIOBSIZE];
  int  position;          /*---------- position in the local buffer, 
                         if position = BSIZE when the buffer is empty */
};

typedef struct FrIO FrIO;

FrIO *FrIOOpenR(char* filename);
FrIO *FrIOOpenW(char* filename);
int   FrIOClose     (FrIO *frfd);
int   FrIOWrite     (FrIO *frfd, char* buf, int nbyte);
int   FrIORead      (FrIO *frfd, char* buf, int nbyte);
int   FrIOSet       (FrIO *frfd, long offset);
int   FrIOSetFromEnd(FrIO *frfd, long offset);
int   FrIOSetFromCur(FrIO *frfd, long offset);
long  FrIOTell(struct FrIO *frfd);

#endif
