#define _POSIX_SOURCE 
/* ****************************************************************************
******** FrameL.c ************************************** FrameL.c *************
******** FrameL.c ************************************** FrameL.c *************
**************************************************************************** */
/*  by B.Mours LAPP (Annecy) */

char FrVersion[] =                 "4.53 (May 02, 02)";
char FrHeader[]  = "$Header: FrameL 4.53; May 02, 02 $";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> 
#include <stdarg.h>
#include <ctype.h>
#include "FrameL.h"

/*------------------------------------ buffer space used in several places --*/
#define FRBUFSIZE 100000
char FrBuf[FRBUFSIZE];     
int FrBufSize = FRBUFSIZE;
#define FRMAXTAG 1000
/*--------------------------------------------------miscellaneous variables--*/
int    FrSshort, FrSint, FrSlong, FrSfloat, FrSdouble;
FILE  *FrFOut = NULL;  
int    FrDebugLvl = 0;
FrDetector *FrCurDetector = NULL;
/*---------------------------------------Header for each class of structure--*/
FrSH *FrSHRoot[FRMAPMAXSH];
int FrnSH = 0;
/*-----------------------------static variable used by the FrError functions-*/
void (*FrErrorHandler)() = FrErrorDefHandler;
/*----------------------------------------------------- Define for the zlib--*/
int Frz_compress   (unsigned char *dest, unsigned long *destLen,
	                   char *source, unsigned long sourceLen, int level);
int Frz_uncompress (unsigned char *dest, unsigned long *destLen,
		           char *source, unsigned long sourceLen);
/*---------------------------------------------------------------------------*/


               
/*---------------------------------------------------------------- FrLibIni -*/
FILE *FrLibIni(char *outFile, 
               FILE *fOut, 
               int dbglvl)
                 /*if not outFile == NULL, we use fOut for output file*/
/*---------------------------------------------------------------------------*/
{static int icall = 0;
 
  icall++;
  if(icall > 1) 
    {printf(" Warning, FrLibIni is call twice\n");
     return(FrFOut);}

  if(outFile == NULL)
    {FrFOut = fOut;
     if(FrFOut == NULL)  {FrFOut = stdout;}}
  else
    {printf("FrLibIni: output will be sent on file:%s\n",outFile);
     FrFOut = fopen(outFile,"w");
     if(FrFOut == NULL)
         {printf("\n !! Opening file error, output stay on screen\n");
          FrFOut = stdout;}}
  
  FrDebugLvl = dbglvl;

  FrLibVersion(FrFOut);

  FrLibShortIni();

  return(FrFOut);}

/*----------------------------------------------------------- FrLibShortIni -*/
void FrLibShortIni()
/*---------------------------------------------------------------------------*/
{static int icall = 0;
 
  icall++;
  if(icall > 1) return;

    /*----- i/o package initialization ------*/
	
  FrSshort  = sizeof(short);
  FrSint    = sizeof(int);
  FrSlong   = sizeof(FRLONG);
  FrSfloat  = sizeof(float);
  FrSdouble = sizeof(double);

    /*--- check the size of words. Unpredictible behevior will results
      from the use of non standard values ---------------------------*/

  if(FrSshort != 2)
     {FrError(3,"FrLibShortIni","Warning: sizeof(short) != 2 !!!!!");}
  if(FrSint != 4)
     {FrError(3,"FrLibShortIni","Warning: sizeof(int) != 4 !!!!!!!");}
  if(FrSlong != 4 && FrSlong != 8 )
     {FrError(3,"FrLibShortIni","Warning: sizeof(long) != 4 or 8 !");}
  if(FrSfloat != 4)
     {FrError(3,"FrLibShortIni","Warning: sizeof(float) != 4 !!!!!");}
  if(FrSdouble != 8)
     {FrError(3,"FrLibShortIni","Warning: sizeof(double) != 8 !!!!");}
	
    /*----- declare the standard structures -------*/

  if(FrObjectDef()     == NULL) return;
  if(FrSHDef()         == NULL) return;
  if(FrSEDef()         == NULL) return;

  if(FrameHDef()       == NULL) return;
  if(FrAdcDataDef()    == NULL) return;
  if(FrDetectorDef()   == NULL) return;
  if(FrEndOfFrameDef() == NULL) return;
  if(FrMsgDef()        == NULL) return;
  if(FrHistoryDef()    == NULL) return;
  if(FrRawDataDef()    == NULL) return;
  if(FrProcDataDef()   == NULL) return;
  if(FrSimDataDef()    == NULL) return;
  if(FrSimEventDef()   == NULL) return;
  if(FrSerDataDef()    == NULL) return;
  if(FrStatDataDef()   == NULL) return;
  if(FrSummaryDef()    == NULL) return;
  if(FrTableDef()      == NULL) return;
  if(FrTrigDataDef()   == NULL) return;
  if(FrTOCDef()        == NULL) return;

  if(FrVectDef()       == NULL) return;
  
  if(FrEndOfFileDef()  == NULL) return;

      /*-------- for format backward compatibility -------*/

       FrameHDef()->objReadOld = FrBack4FrameHRead;
   FrDetectorDef()->objReadOld = FrBack4DetectorRead;
   FrProcDataDef()->objReadOld = FrBack4ProcDataRead;
    FrRawDataDef()->objReadOld = FrBack4RawDataRead;
    FrSimDataDef()->objReadOld = FrBack4SimDataRead;
   FrStatDataDef()->objReadOld = FrBack4StatDataRead;
    FrSummaryDef()->objReadOld = FrBack4SummaryRead;
   FrTrigDataDef()->objReadOld = FrBack4TrigDataRead;
       FrVectDef()->objReadOld = FrBack4VectRead;

  return;}

/*------------------------------------------------------------- FrLibSetLvl -*/
void FrLibSetLvl(int dbglvl)
/*---------------------------------------------------------------------------*/
{ 
  FrDebugLvl = dbglvl;
  if(FrFOut == NULL) FrFOut = stdout;
  
  return;}

/*------------------------------------------------------------ FrLibVersion -*/
float FrLibVersion(FILE *fOut)
                              /*if fOut != NULL, we use print version on fOut*/
/*---------------------------------------------------------------------------*/
{float version;

 sscanf(FrVersion,"%f",&version);

 if(fOut != NULL) fprintf(fOut,"  FrameL Version:%s(Compiled: %s %s)\n",
	                       FrVersion,__DATE__,__TIME__);
  
 return(version);}

/*--------------------------------------------------------FrAdcDataCopy------*/
FrAdcData *FrAdcDataCopy(FrAdcData *in,
                         FrameH *frame)
/*---------------------------------------------------------------------------*/
{FrAdcData *out;
 FrRawData *rawData;

  if(in == NULL) return(NULL); 
  out = (FrAdcData *) calloc(1,sizeof(FrAdcData));
  if(out == NULL) {return(NULL);} 

  memcpy(out, in, sizeof(FrAdcData));
	 
  if(FrStrCpy(&out->name,   in->name)    == NULL) return(NULL);
  if(in->comment != NULL)
     {if(FrStrCpy(&out->comment,in->comment) == NULL) return(NULL);}
  if(in->units != NULL)
     {if(FrStrCpy(&out->units,  in->units)   == NULL) return(NULL);}
 
  if(in->data != NULL) 
     {out->data = FrVectCopy(in->data);
      if(out->data == NULL) return(NULL);}
  if(in->aux != NULL)
     {out->aux  = FrVectCopy(in->aux);
      if(out->aux == NULL) return(NULL);}

  out->next = NULL;

     /*----- now store it in the Frame structures -----*/

  if(frame != NULL) 
     {if(frame->rawData == NULL)  FrRawDataNew(frame);

      rawData = frame->rawData;
      if(rawData == NULL) return(NULL);

      out->next = rawData->firstAdc;
      rawData->firstAdc = out;}
  
  return(out);} 

/*------------------------------------------------------- FrAdcDataDecimate--*/
int FrAdcDataDecimate(FrAdcData *adc,
                      int nGroup)
/*---------------------------------------------------------------------------*/
{int i, j, sum, group;
 float  *dataF;
 double *dataD, sumD, coef;
 short  *dataS;
 int    *dataI;

 if(adc == NULL) return(1);
 if(nGroup == 0) return(2);

     /*------ this version works only for short, int and float -----*/

 if((adc->data->type != FR_VECT_2S) &&
    (adc->data->type != FR_VECT_4S) &&
    (adc->data->type != FR_VECT_4R) &&
    (adc->data->type != FR_VECT_8R)) return(4);

 if(nGroup < 4)         {group = 0;}
 else if(nGroup < 16)   {group = 1;}
 else if(nGroup < 64)   {group = 2;}
 else if(nGroup < 256)  {group = 3;}
 else if(nGroup < 1024) {group = 4;}
 else                   {group = 5;}
 if (adc->data->type == FR_VECT_4R) group = 0;

      /*---- if ngroup is negative, we do not change the resolution--*/

 if(nGroup < 0) nGroup = -nGroup;
 if(adc->data->nData % nGroup != 0) return(3);

 coef = (1.+group)/nGroup;

 adc->slope       = adc->slope * (1+group);
 adc->nBits       = adc->nBits + group;
 adc->sampleRate  = adc->sampleRate  / nGroup;
 adc->data->nData = adc->data->nData / nGroup;
 adc->data->nx[0] = adc->data->nx[0] / nGroup;
 adc->data->dx[0] = adc->data->dx[0] * nGroup;
 adc->data->nBytes= adc->data->nBytes /nGroup;

 if(adc->data->type == FR_VECT_2S)
   {if(adc->nBits > 16) adc->data->type = FR_VECT_4S;

    dataS = adc->data->dataS;
    for(i=0; i < adc->data->nData; i++)
       {sum = 0.;
        for(j=0; j<nGroup; j++) {sum += dataS[j];}
        if(adc->nBits < 17)
             {adc->data->dataS[i] = sum*coef;}
        else {adc->data->dataI[i] = sum*coef;}
        dataS = dataS + nGroup;}}

 else if(adc->data->type == FR_VECT_4S)
   {dataI = adc->data->dataI;
    for(i=0; i < adc->data->nData; i++)
       {sum = 0.;
        for(j=0; j<nGroup; j++) {sum += dataI[j];}
        adc->data->dataI[i] = sum*coef;
        dataI = dataI + nGroup;}}
    
 else if(adc->data->type == FR_VECT_4R)
   {dataF = adc->data->dataF;
    for(i=0; i < adc->data->nData; i++)
       {sumD = 0.;
        for(j=0; j<nGroup; j++) {sumD += dataF[j];}
        adc->data->dataF[i] = sumD*coef;
        dataF = dataF + nGroup;}}
    
 else if(adc->data->type == FR_VECT_8R)
   {dataD = adc->data->dataD;
    for(i=0; i < adc->data->nData; i++)
       {sumD = 0.;
        for(j=0; j<nGroup; j++) {sumD += dataD[j];}
        adc->data->dataD[i] = sumD*coef;
        dataD = dataD + nGroup;}}
    
 return(0);}

/*------------------------------------------------------------ FrAdcDataDef--*/
FrSH *FrAdcDataDef()
/*---------------------------------------------------------------------------*/
{static FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrAdcData", (void (*)())FrAdcDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "INT_4U", "channelGroup","-");
  FrSENew(classe, "INT_4U", "channelNumber","-");
  FrSENew(classe, "INT_4U", "nBits","-");
  FrSENew(classe, "REAL_4", "bias","-");
  FrSENew(classe, "REAL_4", "slope","-");
  FrSENew(classe, "STRING", "units","-");
  FrSENew(classe, "REAL_8", "sampleRate","-");
  FrSENew(classe, "INT_4S","timeOffsetS","-");
  FrSENew(classe, "INT_4U","timeOffsetN","-");
  FrSENew(classe, "REAL_8","fShift","-");
  FrSENew(classe, "INT_2U","dataValid","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "aux","-");
  FrSENew(classe, "PTR_STRUCT(FrAdcData *)", "next","-"); 

  return(classe);}
  
/*----------------------------------------------------------- FrAdcDataDump--*/
void FrAdcDataDump(FrAdcData *adc, 
                   FILE *fp, 
                   int debugLvl)
/*---------------------------------------------------------------------------*/
{
 if(adc == NULL) return;

 fprintf(fp," ADC:    %s channel(G/N):%d-%d nBits=%d Valid=%d "
                     "bias=%.4e slope=%.4e", 
     adc->name, adc->channelGroup, adc->channelNumber, 
     adc->nBits, adc->dataValid,   adc->bias, adc->slope);
 if(adc->units != NULL)
     {fprintf(fp," units=%s\n",adc->units);}
 else{fprintf(fp,"\n");}

 if(adc->comment != NULL) 
   {if(strlen(adc->comment) > 2) fprintf(fp,"   comment:%s\n", adc->comment);}
    
 FrVectDump( adc->data,  fp, debugLvl);

 return;}
/*------------------------------------------------------------FrAdcDataFind--*/
FrAdcData *FrAdcDataFind(FrameH *frame, 
                         char *adcName)
/*---------------------------------------------------------------------------*/
/* Return a pointer to the adc structure or NULL if not found                */
{FrAdcData *adc;

 if(frame == NULL)             return (NULL);
 if(frame->rawData == NULL)    return (NULL);
 if(adcName == NULL)           return (NULL);

 for(adc = frame->rawData->firstAdc; adc != NULL; adc = adc->next)
   {if(strcmp(adc->name, adcName) != 0) continue;

    if(adc->data->compress != 0) FrVectExpandF(adc->data);
    if(adc->aux != NULL)         FrVectExpandF(adc->aux);

    adc->data->GTimeS    = frame->GTimeS+adc->timeOffsetS;
    adc->data->GTimeN    = frame->GTimeN+adc->timeOffsetN;
    adc->data->ULeapS    = frame->ULeapS;
    adc->data->localTime = frame->localTime;

    return (adc);}
  
 return (NULL);}

/*------------------------------------------------------------FrAdcDataFree--*/
void FrAdcDataFree(FrAdcData *adcData)
/*---------------------------------------------------------------------------*/
{
 if(adcData == NULL) return;

 if(adcData->name    != NULL) free (adcData->name);
 if(adcData->comment != NULL) free (adcData->comment);
 if(adcData->units   != NULL) free (adcData->units);
 if(adcData->data    != NULL) FrVectFree (adcData->data);
 if(adcData->aux     != NULL) FrVectFree (adcData->aux);
 if(adcData->next    != NULL) FrAdcDataFree(adcData->next);

 free(adcData);

 return;}

/*------------------------------------------------------------FrAdcDataGetV--*/
FrVect *FrAdcDataGetV(FrameH *frame, 
                      char *adcName)
/*---------------------------------------------------------------------------*/
{FrAdcData *adc;

 adc = FrAdcDataFind(frame, adcName);

 if(adc != NULL) return(adc->data);

 return (NULL);}

/*-------------------------------------------------------------FrAdcDataNew--*/
FrAdcData *FrAdcDataNew(FrameH *frame,  
                        char *name, 
                        double sampleRate, 
                        int nData, 
                        int nBits)
/*---------------------------------------------------------------------------*/
{struct FrAdcData *adcData;

 adcData = FrAdcDataNewF(frame, name, NULL, 0, 0,
                          nBits, 0, 0, NULL, sampleRate, nData); 
  
 return(adcData);} 

/*------------------------------------------------------------FrAdcDataNewF--*/
FrAdcData *FrAdcDataNewF(FrameH *frame,  
                         char *name,
                         char *comment,
                         unsigned int channelGroup,
                         unsigned int channelNumber, 
                         int nBits,
                         float bias,
                         float slope,
                         char *units,
                         double sampleRate, 
                         int nData)
/*---------------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 struct FrRawData *rawData;
 double dx;
 int type;
 
  adcData = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(adcData == NULL) 
       {return(NULL);} 
  else {adcData->classe = FrAdcDataDef();}
	 
  if(FrStrCpy(&adcData->name,name)       == NULL) return(NULL);
  if(FrStrCpy(&adcData->comment,comment) == NULL) return(NULL);
  if(FrStrCpy(&adcData->units,units)     == NULL) return(NULL);

  adcData->channelGroup  = channelGroup;
  adcData->channelNumber = channelNumber;
  if(nBits > 0) adcData->nBits =   nBits;
  else          adcData->nBits =  -nBits;
  adcData->bias  = bias;
  adcData->slope = slope;
  adcData->sampleRate = sampleRate;
  adcData->timeOffsetS = 0;
  adcData->timeOffsetN = 0;
  adcData->fShift      = 0;
  adcData->dataValid   = 0;
  adcData->aux         = NULL;

  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  adcData->data = FrVectNew1D(name, -type, nData,dx, "Time (sec)", "Counts");
  if(adcData->data == NULL) return(NULL);
  
     /*----- now store it in the Frame structures -----*/

  if(frame != NULL) 
     {if(frame->rawData == NULL)  FrRawDataNew(frame);

      rawData = frame->rawData;
      if(rawData == NULL) return(NULL);

      adcData->next = rawData->firstAdc;
      rawData->firstAdc = adcData;}
  
  return(adcData);} 

/*--------------------------------------------------- FrAdcDataRead---*/
struct FrAdcData *FrAdcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;

  adcData = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(adcData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return(NULL);}
  else {adcData->classe = FrAdcDataDef();}

  FrReadHeader(iFile,  adcData);
  FrReadSChar (iFile, &adcData->name); 
  FrReadSChar (iFile, &adcData->comment);
  FrReadIntU  (iFile, &adcData->channelGroup);
  FrReadIntU  (iFile, &adcData->channelNumber);
  FrReadIntU  (iFile, &adcData->nBits);
  FrReadFloat (iFile, &adcData->bias);
  FrReadFloat (iFile, &adcData->slope);
  FrReadSChar (iFile, &adcData->units);
  FrReadDouble(iFile, &adcData->sampleRate);
  FrReadIntU  (iFile, &adcData->timeOffsetS);
  FrReadIntU  (iFile, &adcData->timeOffsetN);
  FrReadDouble(iFile, &adcData->fShift);
  FrReadShortU(iFile, &adcData->dataValid);
  FrReadStruct(iFile, &adcData->data);
  FrReadStruct(iFile, &adcData->aux);
  FrReadStruct(iFile, &adcData->next);
    
  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", adcData->name);

return(adcData);}

/*--------------------------------------------------- FrAdcDataReadI--*/
struct FrAdcData *FrAdcDataReadI(struct FrFile *iFile,
                                 char *name,
                                 int index)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adc;
 struct FrTOCts *ts;
 struct FrTOC *toc;

 toc = FrTOCReadFull(iFile);
 if(toc == NULL)          return(NULL);
 if(index == -1)          return(NULL);
 if(index >= toc->nFrame) return(NULL);

                                    /*------ find adc mark ---------*/

 for(ts = toc->adc; ts != NULL; ts = ts->next)
   {if(strcmp(name, ts->name) == 0)  break;}
 if(ts == NULL) return(NULL); 

                  /*---- set the file pointer and read the data -------*/

 if(FrTOCSetPos(iFile, ts->position[index]) != 0) {return (NULL);}
 adc = FrAdcDataRead(iFile);
 if(adc == NULL) return(NULL);

 adc->data = FrVectReadNext(iFile);

 return(adc);}

/*---------------------------------------------------------- FrAdcDataReadT--*/
FrAdcData *FrAdcDataReadT(FrFile *iFile,
                          char *name,
                          double gtime)
/*---------------------------------------------------------------------------*/
{FrAdcData  **current, *adc, *root;
 FrTOCts *ts;
 FrTag *frtag;
 int index;

          /*------- find frame(it will read the FrTOC if needed) ------------*/

 index = FrTOCFrameFindT(iFile, gtime);
 if(index <0) return(NULL);

 if(name == NULL) return(NULL);              /*----- build tag object -------*/
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);
                                   
 root = NULL;                           /*------ find the ADC in the TOC ----*/
 current = &root;

 for(ts = iFile->toc->adc; ts != NULL; ts = ts->next)

                          /*-------- check if we need to copy this adc ?-----*/

   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue; 

                       /*---- set the file pointer and read the data -------*/

    if(FrTOCSetPos(iFile, ts->position[index]) != 0) continue;
    adc = FrAdcDataRead(iFile);
    if(adc == NULL) continue;

    adc->data = FrVectReadNext(iFile);

    adc->data->GTimeS    = iFile->toc->GTimeS[index]+adc->timeOffsetS;
    adc->data->GTimeN    = iFile->toc->GTimeN[index]+adc->timeOffsetN;
    adc->data->ULeapS    = iFile->toc->ULeapS;
    adc->data->localTime = iFile->toc->localTime;

    *current = adc;
    current = &(adc->next);}

 FrTagFree(frtag); 

 return(root);}

/*------------------------------------------------- FrAdcDataWrite---*/
void FrAdcDataWrite(struct FrAdcData *adcData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
  FrPutNewRecord(oFile, adcData, FR_YES);
  FrPutSChar (oFile, adcData->name);
  FrPutSChar (oFile, adcData->comment);
  FrPutIntU  (oFile, adcData->channelGroup);
  FrPutIntU  (oFile, adcData->channelNumber);
  FrPutIntU  (oFile, adcData->nBits);
  FrPutFloat (oFile, adcData->bias);
  FrPutFloat (oFile, adcData->slope);
  FrPutSChar (oFile, adcData->units);
  FrPutDouble(oFile, adcData->sampleRate);
  FrPutIntU  (oFile, adcData->timeOffsetS);
  FrPutIntU  (oFile, adcData->timeOffsetN);
  FrPutDouble(oFile, adcData->fShift);
  FrPutShortU(oFile, adcData->dataValid);
  FrPutStruct(oFile, adcData->data);
  FrPutStruct(oFile, adcData->aux);
  FrPutStruct(oFile, adcData->next);

  if(oFile->toc != NULL) FrTOCtsMark(oFile, &oFile->toc->adcH, 
          adcData->name, adcData->channelGroup, adcData->channelNumber);

  FrPutWriteRecord(oFile);

  FrVectWrite(adcData->data, oFile);

  if(adcData->aux != NULL) FrVectWrite(adcData->aux, oFile);
   
 return;}


/*----------------------------------------------------- FrameCompress-*/
void FrameCompress(struct FrameH *frameH,
                   int compress,
                   int gzipLevel)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adc;
 struct FrProcData *proc;
 struct FrSimData *sim;

 if(frameH == NULL) return;
  
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Compress frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

    /*---- compress the adc vectors ----*/
     
 if(frameH->rawData != NULL) 
   {adc = frameH->rawData->firstAdc;
    while(adc != NULL)
       {FrVectCompress(adc->data, compress, gzipLevel);
        adc = adc->next;}}

    /*---- compress the processed data ----*/

 if(frameH->procData != NULL) 
   {proc = frameH->procData;   
    while(proc != NULL)
       {FrVectCompress(proc->data, compress, gzipLevel);
        proc = proc->next;}}

    /*---- compress the simulated data ----*/

 if(frameH->simData != NULL) 
   {sim = frameH->simData;
    while(sim != NULL)
      {FrVectCompress(sim->data, compress, gzipLevel);
       sim = sim->next;}}  

 return;}

/*------------------------------------------------------- FrameCopy---*/
struct FrameH *FrameCopy(struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrameH *out;
 int nBytes;
 static int size = 0;
 static char *buf;
 char comment[100];

 if(frame == NULL) return(NULL);
 
 if(size == 0)
     {size = 200000;
      buf = (char *) malloc(size);}

 nBytes = 0;

 while(nBytes == 0)
    {if(buf == NULL) return(NULL);
     nBytes = FrameWriteToBuf(frame, -1, buf, size);
     if(nBytes == 0)
         {size = size*2;
          free(buf);
          buf = malloc(size);}}

 out = FrameReadFromBuf(buf,size,-1);

   /*----- update the history record added by the frameWrite call --*/

 free(out->history->comment);
 sprintf(comment,"FrameCopy %s",FrVersion);
 FrStrCpy(&out->history->comment,comment);

 return(out);}

/*------------------------------------------------------- FrameDump---*/
void FrameDump(struct FrameH *frameH,
               FILE *fp, 
               int debugLvl)
/*--------------------------------------------------------------------*/
{struct FrProcData *proc;
 struct FrSimData  *simData;
 struct FrSimEvent *simEvent;
 struct FrHistory  *history; 
 struct FrTrigData *trig;
 struct FrSummary *sum;
 unsigned int local, UTC;

 if(fp     == NULL) return;
 if(frameH == NULL) return;

 if(debugLvl < 1) return;

 fprintf(fp,"\nDump frame: %s Run#:%d Frame#:%d",
               frameH->name,frameH->run,frameH->frame);
 fprintf(fp,"       Quality=%x\n",frameH->dataQuality);
 fprintf(fp,"  Starting time:(GPS) %d sec and %d nsec  ULeapS:%d",
                  frameH->GTimeS,frameH->GTimeN,  frameH->ULeapS);
 fprintf(fp,"  Length:%.3f sec\n",frameH->dt);
 UTC = frameH->GTimeS - frameH->ULeapS + FRGPSTAI;
 fprintf(fp,"                (UTC) %d sec %s \n", UTC,FrStrGTime(UTC));

 if(debugLvl < 2) return;

 local = UTC + frameH->localTime;
 fprintf(fp,"                (Local time)        %s \n", 
                  FrStrGTime(local));

 /* do not forget that TAI is ahead of GPS by 19 seconds */
 /*   and TAI is ahead of UTC by 31 seconds (august 97)  */
      /*----------history------------------*/

 fprintf(fp,"History records:\n");
 for(history = frameH->history; history != NULL; history = history->next)
   {fprintf(fp," %s %s\n", FrStrGTime(history->time), history->comment);}

     /*----------static data----------------*/

 if(frameH->detectProc != NULL)
    {fprintf(fp,"Detector used for reconstruction:\n");
    FrDetectorDump(frameH->detectProc, fp, debugLvl);}
 if(frameH->detectSim != NULL)
    {fprintf(fp,"Detector used for simulation:\n");
    FrDetectorDump(frameH->detectSim, fp, debugLvl);}

      /*---- dump simulated data ----------*/

 for(simData = frameH->simData; simData != NULL; simData = simData->next) 
    {FrSimDataDump(simData, fp, debugLvl);}
  
 for(simEvent = frameH->simEvent; simEvent != NULL; simEvent = simEvent->next)
    {FrSimEventDump(simEvent, fp,debugLvl);}

      /*---- dump reconstructed data ----------*/

 if(frameH->procData != NULL)
  {fprintf(fp,"Processed Data:\n");
   for(proc = frameH->procData; proc != NULL; proc = proc->next) 
     {FrProcDataDump(proc,   fp, debugLvl);}}

     /*----- dump trigger data -----------*/
     
 for(trig = frameH->trigData; trig != NULL; trig = trig->next) 
    {FrTrigDataDump(trig, fp, debugLvl);}

     /*----- dump summary data -----------*/
     
 for(sum = frameH->summaryData; sum != NULL; sum = sum->next)
    {FrSummaryDump(sum,   fp, debugLvl);}

 if(frameH->auxData != NULL) {FrVectDump(frameH->auxData, fp, debugLvl);}

     /*----- dump raw data -----------*/

 if(frameH->rawData != NULL) FrRawDataDump(frameH->rawData, fp, debugLvl);

 return;}

/*----------------------------------------------- FrameDumpToBuf------*/
char *FrameDumpToBuf(struct FrameH *frame,
                     int debugLvl, 
                     char *buf, 
                     long bufSize)
/*--------------------------------------------------------------------*/
{FILE *tmp;
 static int offset = -2;
 long sizeMin = 100; 

 if(debugLvl < 1)    return(NULL);
 if(frame == NULL)   return(NULL);
 if(buf   == NULL)   return(NULL);
 if(bufSize<sizeMin) 
      {FrError(3,"FrameDumpBuf"," too short buffer");
       return(NULL);}

  /*-------- first determine the offset in buffer---*/

 if(offset == -2)
   {tmp = tmpfile();
    if(tmp == NULL) 
      {FrError(3,"FrameDumpBuf"," cannot open tempory file");
       return(NULL);}
    setbuf(tmp, buf);
    fprintf(tmp,"Start\n");

    for(offset=0; offset<sizeMin; offset++)
      {if(buf[offset] == 'S') break;}

    if(offset == sizeMin) return(NULL);
    if(strcmp(buf+offset,"Start\n") != 0) return(NULL);

    fclose(tmp);}

  /*------- dump --------------*/

 tmp = tmpfile();
 setbuf(tmp, buf);  
 FrameDump(frame, tmp, debugLvl);
 fputc('\0',tmp);
 strcpy(buf+bufSize/2, buf+offset);
 fclose(tmp);
 
 return(buf+bufSize/2);}
/*----------------------------------------------------- FrameExpand---*/
void FrameExpand(struct FrameH *frameH)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adc;
 struct FrProcData *proc;
 struct FrSimData *sim;
 struct FrSerData *ser;
 struct FrTrigData *trig;
 struct FrSummary *sum;

 if(frameH == NULL) return;

 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Expand frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

 FrVectExpand(frameH->user);
 FrVectExpand(frameH->auxData);
 if(frameH->detectSim  != NULL) FrVectExpand(frameH->detectSim->more);
 if(frameH->detectProc != NULL) FrVectExpand(frameH->detectProc->more);

    /*---- Uncompress the adc vectors ----*/
     
 if(frameH->rawData != NULL) 
   {adc = frameH->rawData->firstAdc;
    while(adc != NULL)
       {FrVectExpand(adc->data);
        FrVectExpand(adc->aux);
        adc = adc->next;}
    ser = frameH->rawData->firstSer;
    while(ser != NULL)
       {FrVectExpand(ser->serial);
        ser = ser->next;}
    FrVectExpand(frameH->rawData->more);}

    /*---- Uncompress the processed data ----*/

 proc = frameH->procData;   
 while(proc != NULL)
       {FrVectExpand(proc->data);
        FrVectExpand(proc->aux);
        proc = proc->next;}

    /*---- Uncompress the simulated data ----*/

 sim = frameH->simData;
 while(sim != NULL)
      {FrVectExpand(sim->data);
       FrVectExpand(sim->input);
       sim = sim->next;}  

 trig = frameH->trigData;
 while(trig != NULL)
      {FrVectExpand(trig->data);
       trig = trig->next;} 

 sum = frameH->summaryData;
 while(sum != NULL)
      {FrVectExpand(sum->moments);
       sum = sum->next;}  

 return;}

/*-----------------------------------------------------FrameFree------*/
void FrameFree(struct FrameH *frameH)
/*--------------------------------------------------------------------*/
{struct FrHistory *history;

 if(frameH == NULL) return;

 FrameUntag(frameH);

     /* free all structures connected to this frame */

 if(frameH->detectSim  != NULL) FrDetectorFree(frameH->detectSim);
 if(frameH->detectProc != NULL) FrDetectorFree(frameH->detectProc);
 
 history = frameH->history;
 while(history != NULL) {history = FrHistoryFree (history);}

 if(frameH->rawData     != NULL) FrRawDataFree (frameH->rawData);
 if(frameH->procData    != NULL) FrProcDataFree(frameH->procData);   
 if(frameH->simData     != NULL) FrSimDataFree (frameH->simData);   
 if(frameH->simEvent    != NULL) FrSimEventFree(frameH->simEvent);   
 if(frameH->trigData    != NULL) FrTrigDataFree(frameH->trigData);   
 if(frameH->summaryData != NULL) FrSummaryFree (frameH->summaryData);   
 if(frameH->auxData     != NULL) FrVectFree    (frameH->auxData);   

 free(frameH->name);
 free(frameH);

 return;}
 
/*----------------------------------------------------------------FrameGetV--*/
FrVect *FrameGetV(FrameH *frame,
                  char *name)
/*---------------------------------------------------------------------------*/
{FrVect *vect;

 vect = FrAdcDataGetV(frame, name);
 if(vect != NULL) return(vect);

 vect = FrProcDataGetV(frame, name);
 if(vect != NULL) return(vect);

 vect = FrSummaryGetV(frame, name);
 if(vect != NULL) return(vect);

 vect = FrStatDataGetV(frame, name);
 if(vect != NULL) return(vect);

 return(FrSimDataGetV(frame, name));
}
   
/*-------------------------------------------------------------- FrameMerge--*/
void FrameMerge(FrameH *frame1, 
                FrameH *frame2)
/*---------------------------------------------------------------------------*/
{FrAdcData  **adc, *ad;
 FrHistory  **history;
 FrTable    **table;
 FrSerData  **ser, *se;
 FrTrigData **trig;
 FrMsg      **msg;
 FrSimData  **sim;
 FrProcData **proc, *pr;
 FrSimEvent **simE;
 FrSummary  **sum;
 FrVect     **aux;
 int offset;

 if (frame1 == NULL) return;
 if (frame2 == NULL) return;

                  /*----------------------------------- Merge header info ---*/

 frame1->dataQuality = frame1->dataQuality | frame2->dataQuality;

                  /*---------- transport to time series the frame offset ----*/

 offset = (frame2->GTimeS - frame1->GTimeS)*1000000000 +
           frame2->GTimeN - frame1->GTimeN;

                  /*-- if no timing is available for one frame, 
                                      use the values from the other one  ----*/

 if(frame2->GTimeS == 0)  offset = 0;
 if(frame1->GTimeS == 0) {offset = 0;
                          frame1->GTimeS = frame2->GTimeS;
                          frame1->GTimeN = frame2->GTimeN;}
 if(offset != 0) {
   if (frame2->rawData != NULL)
     {for(se = frame2->rawData->firstSer; se != NULL; se = se->next) 
         {se->timeNsec += offset;}
      for(ad = frame2->rawData->firstAdc; ad != NULL; ad = ad->next) 
         {ad->timeOffsetN += offset;}}

   for(pr = frame2->procData; pr != NULL; pr = pr->next) 
      {pr->timeOffsetN += offset;}}

                  /*---------- merge the raw data part ----------------------*/

 if (frame2->rawData != NULL)

   {if (frame1->rawData == NULL) 
        frame1->rawData = FrRawDataNew(NULL);

    ser = &(frame1->rawData->firstSer);
    while(*ser != NULL)  {ser = &((*ser)->next);}
    *ser = frame2->rawData->firstSer;
    frame2->rawData->firstSer = NULL;

    adc = &(frame1->rawData->firstAdc);
    while(*adc != NULL) {adc = &((*adc)->next);}
    *adc = frame2->rawData->firstAdc;
    frame2->rawData->firstAdc = NULL;

    table = &(frame1->rawData->firstTable);
    while(*table != NULL) {table = &((*table)->next);}
    *table = frame2->rawData->firstTable;
    frame2->rawData->firstTable = NULL;

    msg = &(frame1->rawData->logMsg);
    while(*msg != NULL) {msg = &((*msg)->next);}
    *msg = frame2->rawData->logMsg;
    frame2->rawData->logMsg = NULL;}

                  /*-------------- Merge the top structures -----------------*/

 history = &(frame1->history);
 while(*history != NULL) {history = &((*history)->next);}
 *history = frame2->history;
 frame2->history = NULL;

 proc = &(frame1->procData);
 while(*proc != NULL) {proc = &((*proc)->next);}
 *proc = frame2->procData;
 frame2->procData = NULL;

 sim = &(frame1->simData);
 while(*sim != NULL) {sim = &((*sim)->next);}
 *sim = frame2->simData;
 frame2->simData = NULL;

 trig = &(frame1->trigData);
 while(*trig != NULL) {trig = &((*trig)->next);}
 *trig = frame2->trigData;
 frame2->trigData = NULL;

 simE = &(frame1->simEvent);
 while(*simE != NULL) {simE = &((*simE)->next);}
 *simE = frame2->simEvent;
 frame2->simEvent = NULL;

 sum = &(frame1->summaryData);
 while(*sum != NULL) {sum = &((*sum)->next);}
 *sum = frame2->summaryData;
 frame2->summaryData = NULL;

 aux = &(frame1->auxData);
 while(*aux != NULL) {aux = &((*aux)->next);}
 *aux = frame2->auxData;
 frame2->auxData = NULL;

 table = &(frame1->auxTable);
 while(*table != NULL) {table = &((*table)->next);}
 *table = frame2->auxTable;
 frame2->auxTable = NULL;

                  /*---------------- delete the remaining of frame 2---------*/

 FrameFree(frame2);

 return;
}
/*-----------------------------------------------------------------FrameNew--*/
FrameH *FrameNew(char *name)
/*---------------------------------------------------------------------------*/
{FrameH *frame;
 time_t utc;

 frame = FrameHNew(name);
 if(frame == NULL) return(NULL);

                 /*---------  Fill timing information ----------------------*/

 frame->ULeapS    = FRGPSLEAPS;
 utc = time(NULL);
 frame->localTime = mktime(localtime(&utc)) - mktime(gmtime(&utc));
 frame->GTimeS    = utc - FRGPSOFF + frame->ULeapS;


                     /*------Add detector information -----------------------*/

 frame->detectProc = FrDetectorNew(name);

 return(frame);}
/*----------------------------------------------------------------FrameRead--*/
FrameH *FrameRead(FrFile *iFile)
/*---------------------------------------------------------------------------*/
/* this function read a new frame                                     */
{struct FrStatData *next, *sData, *copy;
 struct FrDetector *detector;
 struct FrameH *frame;
 int frameSize;

 if(iFile == NULL) return(NULL);

         /* reset relocation mechanism */

 FrSetIni(iFile);
 
         /*----  read one Frame -----*/

 iFile->curFrame = NULL;
 iFile->endOfFrame = FR_NO;
 iFile->sDataCur = NULL;
 frameSize = 0;

 while((iFile->error == FR_OK) && (iFile->endOfFrame == FR_NO))
     {FrReadInt(  iFile,  (int *) &iFile->length);
      FrReadShort(iFile,(short *) &iFile->type);
      if(iFile->error != FR_OK) break;
          
      if(FrDebugLvl > 2) 
         {frameSize += iFile->length;
          fprintf(FrFOut," length: %8d type=%4d ",iFile->length,iFile->type);
          if(iFile->type > 2 && iFile->type < iFile->maxSH)
               {if(iFile->sh[iFile->type] != NULL)
                   {fprintf(FrFOut,"(%12s)",iFile->sh[iFile->type]->name);}}}
                             
      if(iFile->type >= iFile->maxSH) 
                    {FrError(3,"FrameRead"," missiging dictionary");
                     iFile->error = FR_ERROR_READ_ERROR;
                     break;}
      if(iFile->sh[iFile->type] == NULL) 
                    {FrError(3,"FrameRead"," missiging dictionary");
                     iFile->error = FR_ERROR_READ_ERROR;
                     break;}

      iFile->sh[iFile->type]->objRead(iFile);}

  frame = iFile->curFrame; 
  if(frame == NULL) {return(NULL);}
  if(iFile->error   != FR_OK) 
         {FrError(3,"FrameRead"," Error during reading ");
          return(NULL);}
 
  if(FrDebugLvl > 2) fprintf(FrFOut,"FrameRead: Frame size=%d Bytes\n",
                               frameSize);
          
  /*---------- pointer reallocation------------------ */

  FrSetAll(iFile);   

  /*--- attach static data to the right detector ------*/
 
  sData = iFile->sDataCur;
  while(sData != NULL)
    {next = sData->next;

     detector = sData->detector;
     if(detector == NULL) FrError(3,"FrameRead","Missing detector");
     if(detector == frame->detectProc)
          {FrStatDataAddR(&(iFile->sDataProc), sData);}
     else {FrStatDataAddR(&(iFile->sDataSim),  sData);}
 
     sData = next;}
  
  /*--- restore clean up the static data information --*/
  
  FrStatDataChkT(&(iFile->sDataProc), frame->GTimeS, 
                                      frame->GTimeS + frame->dt);
  FrStatDataChkT(&(iFile->sDataSim),  frame->GTimeS, 
                                      frame->GTimeS + frame->dt);
       
  /*------- copy the stat data to this frame ---*/

  if(frame->detectSim != NULL)
    {for(sData = iFile->sDataSim; sData != NULL; sData = sData->next)
       {copy = FrStatDataCopy(sData,frame->detectSim);
        if(copy == NULL) break;
        copy->next = frame->detectSim->sData;
        frame->detectSim->sData = copy;}}

  if(frame->detectProc != NULL)
    {for(sData = iFile->sDataProc; sData != NULL; sData = sData->next)
       {copy = FrStatDataCopy(sData, frame->detectProc);
        if(copy == NULL) break;
        copy->next = frame->detectProc->sData;
        frame->detectProc->sData = copy;}}
      
  return(iFile->curFrame);}


/*---------------------------------------------------------FrameReadFromBuf--*/
FrameH *FrameReadFromBuf(char *buf, 
                         long nBytes,
                         int comp)
/*---------------------------------------------------------------------------*/
{FrFile *iFile;
 FrameH *frame;
 
 if(buf == NULL) return(NULL);
 if(nBytes <= 0) return(NULL);
  
 iFile = FrFileNew(NULL, comp, buf, nBytes);
 if(iFile == NULL) return (NULL);

 iFile->chkSumFlag = FR_NO;  /* do not compute checksum for in memory buffer*/

 FrFileIOpen(iFile);
 if(iFile->error != FR_OK) return(NULL);

 frame = FrameRead(iFile);

 FrFileIEnd(iFile);

 return(frame);}

/*-------------------------------------------------------------- FrameReadN--*/
FrameH *FrameReadN(FrFile *iFile,
                   int rNumber,
                   int fNumber)
/*---------------------------------------------------------------------------*/
{FrameH *frame;
 int i;

 i = FrTOCFrameFindN(iFile, rNumber, fNumber);

                 /*---TOC information available but no frame for this time---*/

 if(i == -2) return(NULL);

                 /*---- the frame has been found in the TOC: direct read-----*/
 if(i != -1)
   {if(FrIOSet(iFile->frfd, iFile->toc->positionH[i])==-1) {return (NULL);}
    
    frame = FrameRead(iFile);

    FrTOCStatDGet(iFile, frame);}

                /*----- no TOC information available, scan the file ---------*/

 else
   while(1)
     {frame = FrameRead(iFile);
      if(frame == NULL) break;
      if((rNumber == frame->run) && (fNumber == frame->frame)) break;
      FrameFree(frame);}
  
 return(frame);}

/*---------------------------------------------------------FrameReadRecycle--*/
FrameH *FrameReadRecycle(FrFile *iFile, 
                         FrameH *frame)
/*---------------------------------------------------------------------------*/
{FrStatData *sData, *sDataProc, *sDataSim, *sDataNext;

 if(iFile == NULL) return(NULL);

           /*--------- get the old static data and free the frame -----------*/

 sDataProc = NULL;
 sDataSim  = NULL;

 if(frame != NULL)
   {if(frame->detectProc != NULL) 
         {sDataProc = frame->detectProc->sData;
          frame->detectProc->sData = NULL;}
    if(frame->detectSim  != NULL) 
         {sDataSim  = frame->detectSim->sData;
          frame->detectSim->sData = NULL;}

    FrameFree(frame);}

           /*----- remove old static data from the file to speed up read ----*/

 sData = iFile->sDataSim;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataSim = NULL;

 sData = iFile->sDataProc;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataProc = NULL;

            /*---------------------- read the new frame ---------------------*/

 frame = FrameRead(iFile);
 if(frame == NULL) return(NULL);

            /*------- attach the old static data to the right detector ------*/
 
  if(sDataProc != NULL)
    {if(frame->detectProc == NULL)  frame->detectProc = FrDetectorNew("Proc");
     for(sData = sDataProc; sData != NULL; sData = sDataNext)
       {sDataNext = sData->next;
        FrStatDataAddR(&(frame->detectProc->sData), sData);}}

   if(sDataSim != NULL)
    {if(frame->detectSim == NULL)  frame->detectSim = FrDetectorNew("Sim");
     for(sData = sDataSim; sData != NULL; sData = sDataNext)
       {sDataNext = sData->next;
        FrStatDataAddR(&(frame->detectSim->sData), sData);}}

 return(frame);}

/*-------------------------------------------------------------- FrameReadT--*/
FrameH *FrameReadT(FrFile *iFile,
                   double gtime)
/*---------------------------------------------------------------------------*/
{struct FrameH *frame = NULL;
 int i;
 double ftime;

 i = FrTOCFrameFindT(iFile, gtime);

                 /*---- the frame has been found in the TOC: direct read-----*/

 if(i >= 0)
   {if(FrIOSet(iFile->frfd, iFile->toc->positionH[i])==-1) {return (NULL);}
    
    frame = FrameRead(iFile);

    FrTOCStatDGet(iFile, frame);}

                /*----- no TOC information available, scan the file ---------*/

 if(i == -2) 
   {while((frame = FrameReadRecycle(iFile,frame)) != NULL)
     {ftime = frame->GTimeS + 1.e-9 * frame->GTimeN;
      if((ftime <= gtime) && (gtime<= ftime+frame->dt)) break;}}
 
 return(frame);}

/*------------------------------------------------------------FrameReadTAdc--*/
FrameH *FrameReadTAdc(FrFile *iFile,
                      double gtime,
                      char *tag)
/*---------------------------------------------------------------------------*/
{FrameH *frame;

 frame = FrameHReadT(iFile,  gtime);
 if(frame == NULL) return(NULL);

 FrRawDataNew(frame);
 if(frame->rawData != NULL)
    frame->rawData->firstAdc = FrAdcDataReadT(iFile, tag, gtime);
    
 return(frame);
}
/*-----------------------------------------------------------FrameReadTChnl--*/
FrameH *FrameReadTChnl(FrFile *iFile,
                       double gtime,
                       char *tag)
/*---------------------------------------------------------------------------*/
{FrameH *frame;

 frame = FrameHReadT(iFile,  gtime);
 if(frame == NULL) return(NULL);

 FrRawDataNew(frame);
 if(frame->rawData != NULL) 
   {frame->rawData->firstSer = FrSerDataReadT(iFile, tag, gtime);
    frame->rawData->firstAdc = FrAdcDataReadT(iFile, tag, gtime);}

 frame->procData = FrProcDataReadT(iFile, tag, gtime);    
 frame->simData  = FrSimDataReadT (iFile, tag, gtime);
    
 return(frame);
}
/*-----------------------------------------------------------FrameReadTProc--*/
FrameH *FrameReadTProc(FrFile *iFile,
                       double gtime,
                       char *tag)
/*---------------------------------------------------------------------------*/
{FrameH *frame;

 frame = FrameHReadT(iFile,  gtime);
 if(frame == NULL) return(NULL);

 frame->procData = FrProcDataReadT(iFile, tag, gtime);
    
 return(frame);
}
/*------------------------------------------------------------FrameReadTSer--*/
FrameH *FrameReadTSer(FrFile *iFile,
                      double gtime,
                      char *tag)
/*---------------------------------------------------------------------------*/
{FrameH *frame;

 frame = FrameHReadT(iFile,  gtime);
 if(frame == NULL) return(NULL);

 FrRawDataNew(frame);
 if(frame->rawData != NULL) 
    frame->rawData->firstSer = FrSerDataReadT(iFile, tag, gtime);
    
 return(frame);
}
/*------------------------------------------------------------FrameReadTSim--*/
FrameH *FrameReadTSim(FrFile *iFile,
                      double gtime,
                      char *tag)
/*---------------------------------------------------------------------------*/
{FrameH *frame;

 frame = FrameHReadT(iFile,  gtime);
 if(frame == NULL) return(NULL);

 frame->simData = FrSimDataReadT(iFile, tag, gtime);
    
 return(frame);
}
/*--------------------------------------------------------- FrameReshapeAdd--*/
int FrameReshapeAdd(FrameH *frame1, 
                    FrameH *frame2)
/*---------------------------------------------------------------------------*/
/* This function add frame 2 to frame 1. unsued part of frame2 are free.     */
/*---------------------------------------------------------------------------*/
{FrAdcData  *adc1, *adc2, *adcN;
 FrSimData  *sim1, *sim2, *simN;
 FrProcData *proc1, *proc2, *procN;
 double t1,t2;

 if (frame1 == NULL) return(1);
 if (frame2 == NULL) return(1);

             /*---------- check taht the added frame is in the frame limit --*/

 t1 = frame1->GTimeS + 1.e-9*frame1->GTimeN;
 t2 = frame2->GTimeS + 1.e-9*frame2->GTimeN;
 if(t2+1.e-6 < t1)      return(2);
 if(t2 > t1+frame1->dt) return(3);

                  /*----------------------------------- Merge header info ---*/

 frame1->dataQuality = frame1->dataQuality & frame2->dataQuality;
 frame2->dataQuality = frame1->dataQuality;

                  /*----------------------- move the ADC vectors ------------*/

 if (frame2->rawData != NULL)

   {if (frame1->rawData == NULL) 
        frame1->rawData = FrRawDataNew(NULL);

   adc1 = frame1->rawData->firstAdc;
   for(adc2 = frame2->rawData->firstAdc; adc2 != NULL; adc2 = adcN) {
     adc2->data->GTimeS = frame2->GTimeS;
     adc2->data->GTimeN = frame2->GTimeN;
     adcN = adc2->next;

     /*--- Match ADC's. If the order is the same, this should be efficient--*/

     if(adc1 != NULL) {
       if(strcmp(adc1->name, adc2->name) != 0) adc1 = NULL;}
     if(adc1 == NULL) {
       for(adc1 = frame1->rawData->firstAdc; adc1 != NULL; adc1 = adc1->next) {
	 if(strcmp(adc1->name, adc2->name) == 0) break;}}

                 /*--------------------- Adc not yet in the list, move it --*/

     if(adc1 == NULL) {
       adc2->next = frame1->rawData->firstAdc;
       frame1->rawData->firstAdc = adc2;}

               /*------------Adc already in the list, move only the data ---*/

     else {
        if(adc2->data->nDim != 1) /*-- do not merge images; just move them -*/
         {adc2->timeOffsetS = frame2->GTimeS - frame1->GTimeS;
          adc2->next = frame1->rawData->firstAdc;
          frame1->rawData->firstAdc = adc2;}
       else
         {adc2->data->next = adc1->data;
          adc1->data = adc2->data;
          adc2->data = NULL;
          adc2->next = NULL;
          FrAdcDataFree(adc2);}}

     if(adc1 != NULL) adc1 = adc1->next;}

 frame2->rawData->firstAdc = NULL;}

     /*---------------- Now move the FrProcData vectors like for the ADC's--*/

 proc1 = frame1->procData;
 for(proc2 = frame2->procData; proc2 != NULL; proc2 = procN) {
   proc2->data->GTimeS = frame2->GTimeS;
   proc2->data->GTimeN = frame2->GTimeN;
   procN = proc2->next;

     /*--- Match PROC's. If the order is the same, this should be efficient--*/

   if(proc1 != NULL) {
     if(strcmp(proc1->name, proc2->name) != 0) proc1 = NULL;}
   if(proc1 == NULL) {
     for(proc1 = frame1->procData; proc1 != NULL; proc1 = proc1->next) {
       if(strcmp(proc1->name, proc2->name) == 0) break;}}

                 /*--------------------- Proc not yet in the list, move it --*/

   if(proc1 == NULL) {
     proc2->next = frame1->procData;
     frame1->procData = proc2;}

               /*------------Proc already in the list, move only the data ---*/

   else {
     proc2->data->next = proc1->data;
     proc1->data = proc2->data;
     proc2->data = NULL;
     proc2->next = NULL;
     FrProcDataFree(proc2);}

   if(proc1 != NULL) proc1 = proc1->next;}

 frame2->procData = NULL;

     /*---------------- Now move the FrSimData vectors like for the ADC's--*/

 sim1 = frame1->simData;
 for(sim2 = frame2->simData; sim2 != NULL; sim2 = simN) {
   sim2->data->GTimeS = frame2->GTimeS;
   sim2->data->GTimeN = frame2->GTimeN;
   simN = sim2->next;

     /*--- Match SIM's. If the order is the same, this should be efficient--*/

   if(sim1 != NULL) {
     if(strcmp(sim1->name, sim2->name) != 0) sim1 = NULL;}
   if(sim1 == NULL) {
     for(sim1 = frame1->simData; sim1 != NULL; sim1 = sim1->next) {
       if(strcmp(sim1->name, sim2->name) == 0) break;}}

                 /*--------------------- Sim not yet in the list, move it --*/

   if(sim1 == NULL) {
     sim2->next = frame1->simData;
     frame1->simData = sim2;}

               /*------------Sim already in the list, move only the data ---*/

   else {
     sim2->data->next = sim1->data;
     sim1->data = sim2->data;
     sim2->data = NULL;
     sim2->next = NULL;
     FrSimDataFree(sim2);}

   if(sim1 != NULL) sim1 = sim1->next;}

 frame2->simData = NULL;

                        /*---------------- Copy the other channels---------*/

 FrameMerge(frame1,frame2);

 return(0);
}
/*--------------------------------------------------------- FrameReshapeEnd--*/
int FrameReshapeEnd(FrameH *frame)
/*---------------------------------------------------------------------------*/
/* This function reformat all time series vector of the frame                */
/*---------------------------------------------------------------------------*/
{FrAdcData  *adc;
 FrSimData  *sim;
 FrProcData *proc;
 double tStart;

 if (frame == NULL) return(1);

 tStart = frame->GTimeS + 1.e-9*frame->GTimeN;

 if (frame->rawData != NULL)
   {for(adc = frame->rawData->firstAdc; adc != NULL; adc = adc->next) {
     adc->data = FrVectConcat(adc->data, tStart, frame->dt);
     if(adc->data == NULL) return(2);}}

 for(proc = frame->procData; proc != NULL; proc = proc->next) {
   proc->data = FrVectConcat(proc->data, tStart, frame->dt);
   if(proc->data == NULL) return(3);}

 for(sim = frame->simData; sim != NULL; sim = sim->next) {
   sim->data = FrVectConcat(sim->data, tStart, frame->dt);
   if(sim->data == NULL) return(4);}

 return(0);
}
/*----------------------------------------------------------FrameReshapeNew--*/
FrameH *FrameReshapeNew(FrameH *frame,
                        int nFrame,
                        int position)
/*---------------------------------------------------------------------------*/
{FrAdcData *adc;
 FrProcData *proc;
 FrSimData *sim;
 double start;

 if(nFrame  <= 0)      return(NULL);
 if(position < 0)      return(NULL);
 if(position > nFrame) return(NULL);

    /*----Copy time information and remove auxiliary vector in all channels--*/

 if(frame->rawData != NULL) {
   for(adc = frame->rawData->firstAdc; adc != NULL; adc = adc->next) {
     adc->data->GTimeS = frame->GTimeS;
     adc->data->GTimeN = frame->GTimeN;
     if(adc->data->next == NULL) continue;
     FrVectFree(adc->data->next);
     adc->data->next = NULL;}}

 for(proc = frame->procData; proc != NULL; proc = proc->next) {
     proc->data->GTimeS = frame->GTimeS;
     proc->data->GTimeN = frame->GTimeN;
     if(proc->data->next == NULL) continue;
     FrVectFree(proc->data->next);
     proc->data->next = NULL;}

 for(sim = frame->simData; sim != NULL; sim = sim->next) {
     sim->data->GTimeS = frame->GTimeS;
     sim->data->GTimeN = frame->GTimeN;
     if(sim->data->next == NULL) continue;
     FrVectFree(sim->data->next);
     sim->data->next = NULL;}

   /*-------- Update frame header ----*/

 if(position != 0)
  {start = frame->GTimeS + 1.e-9*frame->GTimeN - position*frame->dt;
   frame->GTimeS = start;
   frame->GTimeN = 1.e+9*(start - (double) frame->GTimeS);}
 
 frame->dt = nFrame*frame->dt;
 
 return(frame);
}
/*-----------------------------------------------------------------FrameTag--*/
void FrameTag(FrameH *frame,
              char *tag)
/*---------------------------------------------------------------------------*/
{
 FrameTagAdc (frame, tag);
 FrameTagSer (frame, tag);
 FrameTagSim (frame, tag);
 FrameTagProc(frame, tag);
 FrameTagTrig(frame, tag);
 FrameTagSum (frame, tag);

 return;}

/*--------------------------------------------------------------FrameTagAdc--*/
void FrameTagAdc(FrameH *frame,
                 char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 if(frame->rawData == NULL) return;

 FrameTagBasic((FrBasic**) &frame->rawData->firstAdc,
               (FrBasic**) &frame->rawData->firstAdcOld, tag);

 return;}
/*------------------------------------------------------------FrameTagBasic--*/
void FrameTagBasic(FrBasic**root,
                   FrBasic**rootOld,
                   char *tag)
/*---------------------------------------------------------------------------*/
{FrBasic **current, *adc;
 FrTag *frtag;

 if(tag == NULL) return;

 if(*rootOld != NULL) FrameUntagBasic(root, rootOld);

 if(*root == NULL) return;

              /*------------------- save the current link list --------------*/

 *rootOld = *root;
 adc = *root;
 while(adc != NULL)
    {adc->nextOld = adc->next;
     adc = adc->next;}

             /*--------- keep in the link list only the requested object ----*/

 if(strcmp("NONE", tag) == 0)
   {*root = NULL;
    return;}

 frtag = FrTagNew(tag);
 if(frtag == NULL) return;

 current = root;
 while(*current != NULL)
   {if(FrTagMatch(frtag,(*current)->name)  == FR_NO)
        {*current = (*current)->next;}
    else{current = &((*current)->next);}}

 FrTagFree(frtag); 

 return;}
/*-------------------------------------------------------------FrameTagProc--*/
void FrameTagProc(FrameH *frame,
                  char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;

 FrameTagBasic((FrBasic**) &frame->procData,
               (FrBasic**) &frame->procDataOld, tag);

 return;}

/*--------------------------------------------------------------FrameTagSer--*/
void FrameTagSer(FrameH *frame,
                 char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 if(frame->rawData == NULL) return;

 FrameTagBasic((FrBasic**) &frame->rawData->firstSer,
               (FrBasic**) &frame->rawData->firstSerOld, tag);

 return;}

/*--------------------------------------------------------------FrameTagSim--*/
void FrameTagSim(FrameH *frame,
                 char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;

 FrameTagBasic((FrBasic**) &frame->simData,
               (FrBasic**) &frame->simDataOld, tag);

 return;}

/*--------------------------------------------------------------FrameTagSum--*/
void FrameTagSum(FrameH *frame,
                 char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;

 FrameTagBasic((FrBasic**) &frame->summaryData,
               (FrBasic**) &frame->summaryDataOld, tag);

 return;}

/*-------------------------------------------------------------FrameTagTrig--*/
void FrameTagTrig(FrameH *frame,
                  char *tag)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;

 FrameTagBasic((FrBasic**) &frame->trigData,
               (FrBasic**) &frame->trigDataOld, tag);

 return;}

/*---------------------------------------------------------------FrameUntag--*/
void FrameUntag(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;

 FrameUntagAdc (frame);
 FrameUntagProc(frame);
 FrameUntagSer (frame);
 FrameUntagSim (frame);
 FrameUntagSum (frame);
 FrameUntagTrig(frame);

 return;}
/*------------------------------------------------------------FrameUntagAdc--*/
void FrameUntagAdc(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 if(frame->rawData != NULL)  FrRawDataUntagAdc(frame->rawData);

 return;}

/*----------------------------------------------------------FrameUntagBasic--*/
void FrameUntagBasic(FrBasic **root, 
                     FrBasic **rootOld)
/*---------------------------------------------------------------------------*/
{FrBasic *adc;

 if(*rootOld == NULL) return;

 *root = *rootOld;
 *rootOld = NULL;

 adc = *root;
 while(adc != NULL)
    {adc->next = adc->nextOld;
     adc = adc->next;}

 return;}
/*-----------------------------------------------------------FrameUntagProc--*/
void FrameUntagProc(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 FrameUntagBasic((FrBasic **) &frame->procData, 
                 (FrBasic **) &frame->procDataOld );

 return;}

/*------------------------------------------------------------FrameUntagSer--*/
void FrameUntagSer(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 if(frame->rawData != NULL) FrRawDataUntagSer(frame->rawData);

 return;}

/*------------------------------------------------------------FrameUntagSim--*/
void FrameUntagSim(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 FrameUntagBasic((FrBasic **) &frame->simData,
                 (FrBasic **) &frame->simDataOld);

 return;}

/*------------------------------------------------------------FrameUntagSum--*/
void FrameUntagSum(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 FrameUntagBasic((FrBasic **) &frame->summaryData,
                 (FrBasic **) &frame->summaryDataOld);

 return;}

/*-----------------------------------------------------------FrameUntagTrig--*/
void FrameUntagTrig(FrameH *frame)
/*---------------------------------------------------------------------------*/
{
 if(frame == NULL) return;
 FrameUntagBasic((FrBasic **) &frame->trigData,
                 (FrBasic **) &frame->trigDataOld);

 return;}

/*---------------------------------------------------------------FrameWrite--*/
int FrameWrite(FrameH *frameH,
               FrFile *oFile)
/*---------------------------------------------------------------------------*/
{FrHistory *history;
 
 if(oFile == NULL) 
     {return(FR_ERROR_NO_FILE);}
 if(frameH == NULL) 
     {oFile->error = FR_ERROR_NO_FRAME;
      return(oFile->error);}
 oFile->error = FR_OK;

 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Output frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

           /*--------------------- add history record -----------------*/

  if(oFile->historyMsg != NULL) 
       history = FrHistoryAdd(frameH, oFile->historyMsg);
  else history = NULL;

            /*-------------------reset instance numbers -----------------*/

  FrDicIni(oFile);

            /*------------------- write FrameH struct -------------------*/

 FrameHWrite(frameH, oFile);

             /*---------------- write the detector information ----------*/
 
 if(frameH->detectSim != NULL) FrDetectorWrite(frameH->detectSim, oFile);
 if(frameH->detectProc!= NULL) FrDetectorWrite(frameH->detectProc,oFile);

             /*------------------ write the history  ---------------------*/
 
 FrHistoryWrite(frameH->history, oFile);

             /*--------------------write the raw data  --------------------*/
 
 if(frameH->rawData != NULL) FrRawDataWrite(frameH->rawData, oFile);

             /*----------- write the reconstructed data -------------------*/

 if(frameH->procData != NULL) FrProcDataWrite(frameH->procData, oFile);   

             /*------------- write the simulated data--------------------- */

 if(frameH->simData != NULL) FrSimDataWrite(frameH->simData, oFile);   

             /*----------- write experiment dependant data-----------------*/

 if(frameH->trigData   != NULL) FrTrigDataWrite(frameH->trigData,  oFile);
 if(frameH->simEvent   != NULL) FrSimEventWrite(frameH->simEvent,  oFile);
 if(frameH->summaryData!= NULL) FrSummaryWrite(frameH->summaryData,oFile);
 if(frameH->auxData    != NULL) FrVectWrite(frameH->auxData, oFile);
 if(frameH->auxTable   != NULL) FrTableWrite(frameH->auxTable, oFile);

             /*------------- write the end of frame record ----------------*/

 FrEndOfFrameWrite(frameH, oFile);

             /*---------------- delete the history we just add------------ */

 if(history != NULL) frameH->history = FrHistoryFree(frameH->history);

 oFile->nFrames++;
 
 return(oFile->error);}

/*----------------------------------------------------------FrameWriteToBuf--*/
long FrameWriteToBuf(FrameH *frame,
                     int  comp,
                     char *buf, 
                     long nBytes)
/*--------------------------------------------------------------------------*/
{FrFile *file;
 int status;
 long size;
 
 if(buf == NULL) return(0);
 if(nBytes <= 0) return(0);
 
      /*-- first create structure ------*/
     
 file = FrFileNew(NULL, comp, buf, nBytes);
 if(file == NULL) return(0);

 file->chkSumFlag = FR_NO;  /*-- do not compute checksum for in memory buffer*/

       /*---- write file header ----*/
	 
 FrFileOOpen(file);

      /*----- write frame -----------*/

 status = FrameWrite(frame, file);
 if(status != FR_OK) return (0);

 size = FrFileOEnd(file);
 
 return(size);}

/*------------------------------------------------------ FrameHCopy---*/
struct FrameH *FrameHCopy(struct FrameH *in)
/*--------------------------------------------------------------------*/
{struct FrameH *out;

  if(in == NULL) return(NULL); 
  out = FrameHNew(in->name);
  if(out == NULL) 
       {FrError(3,"FrameHCopy","malloc failed");
        return (NULL);} 

  out->run         = in->run;
  out->frame       = in->frame;
  out->dataQuality = in ->dataQuality;
  out->GTimeS      = in->GTimeS;
  out->GTimeN      = in->GTimeN;
  out->ULeapS      = in->ULeapS;
  out->localTime   = in->localTime;
  out->dt          = in->dt;

  return(out);} 

/*----------------------------------------------------- FrameHDef ----*/
struct FrSH *FrameHDef()    
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrameH", FrameHRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4S", "run","-");
  FrSENew(classe, "INT_4U", "frame","-");
  FrSENew(classe, "INT_4U", "dataQuality","-");
  FrSENew(classe, "INT_4U", "GTimeS","-");
  FrSENew(classe, "INT_4U", "GTimeN","-");
  FrSENew(classe, "INT_2U", "ULeapS","-");
  FrSENew(classe, "INT_4S", "localTime","-");
  FrSENew(classe, "REAL_8", "dt","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "type","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "user","-");
  FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detectSim","-");
  FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detectProc","-");
  FrSENew(classe, "PTR_STRUCT(FrHistory *)", "history","-");
  FrSENew(classe, "PTR_STRUCT(FrRawData *)", "rawData","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "procData","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "strain","-");
  FrSENew(classe, "PTR_STRUCT(FrSimData *)", "simData","-");
  FrSENew(classe, "PTR_STRUCT(FrTrigData *)", "trigData","-");
  FrSENew(classe, "PTR_STRUCT(FrSimEvent *)", "simEvent","-");
  FrSENew(classe, "PTR_STRUCT(FrSummary *)", "summaryData","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "auxData","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)", "auxTable","-");

  return(classe);}
  
/*------------------------------------------------------ FrameHNew ---*/
struct FrameH *FrameHNew(char *name)
/*--------------------------------------------------------------------*/
{struct FrameH *frame;
 
  frame = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frame == NULL) 
       {FrError(3,"FrameHNew","malloc failed");
        return (NULL);} 
  else {frame->classe = FrameHDef();} 

  FrStrCpy(&frame->name,name);

  frame->type        = NULL;
  frame->user        = NULL;
  frame->detectProc  = NULL;
  frame->detectSim   = NULL;
  frame->history     = NULL;
  frame->rawData     = NULL;
  frame->procData    = NULL;
  frame->strain      = NULL;
  frame->simData     = NULL;
  frame->trigData    = NULL;
  frame->simEvent    = NULL;
  frame->summaryData = NULL;
  frame->auxData     = NULL;
  frame->auxTable    = NULL;

  return(frame);} 

/*------------------------------------------------------ FrameHRead---*/
void FrameHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrameH *frameH;
 unsigned short id;

  frameH = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frameH == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {frameH->classe = FrameHDef();} 
  
  FrReadShortU(iFile, &id);  /*frameH are not referenced by pointer*/
  FrReadSChar (iFile, &frameH->name); 
  FrReadIntU  (iFile, &frameH->run);
  FrReadIntU  (iFile, &frameH->frame);
  FrReadIntU  (iFile, &frameH->dataQuality);
  FrReadIntU  (iFile, &frameH->GTimeS);
  FrReadIntU  (iFile, &frameH->GTimeN);
  FrReadShortU(iFile, &frameH->ULeapS);
  FrReadInt   (iFile, &frameH->localTime);
  FrReadDouble(iFile, &frameH->dt);
  FrReadStruct(iFile, &frameH->type);
  FrReadStruct(iFile, &frameH->user);
  FrReadStruct(iFile, &frameH->detectSim);
  FrReadStruct(iFile, &frameH->detectProc);
  FrReadStruct(iFile, &frameH->history);
  FrReadStruct(iFile, &frameH->rawData);
  FrReadStruct(iFile, &frameH->procData);
  FrReadStruct(iFile, &frameH->strain);
  FrReadStruct(iFile, &frameH->simData);
  FrReadStruct(iFile, &frameH->trigData);
  FrReadStruct(iFile, &frameH->simEvent);
  FrReadStruct(iFile, &frameH->summaryData);
  FrReadStruct(iFile, &frameH->auxData);
  FrReadStruct(iFile, &frameH->auxTable);

  if(FrDebugLvl > 0) fprintf(FrFOut, 
            " FrameHRead: Run:%d Frame:%d\n",frameH->run,frameH->frame);

  iFile->curFrame = frameH;

  return;}
/*--------------------------------------------------------------FrameHReadN--*/
FrameH *FrameHReadN(FrFile *iFile,
                    int rNumber,
                    int fNumber)
/*---------------------------------------------------------------------------*/
{int i;

 i = FrTOCFrameFindN(iFile, rNumber, fNumber);

                 /*----------Could not access frame using the TOC------------*/

 if(i < 0) return(NULL);

                 /*---- We just read the frameH structure -----*/

 if(FrTOCSetPos(iFile, iFile->toc->positionH[i]) != 0) return (NULL);
    
 FrameHRead(iFile);
 
 return(iFile->curFrame);}

/*--------------------------------------------------------------FrameHReadT--*/
FrameH *FrameHReadT(FrFile *iFile,
                    double gtime)
/*---------------------------------------------------------------------------*/
{int i;

 i = FrTOCFrameFindT(iFile, gtime);

                 /*----------Could not access frame using the TOC------------*/

 if(i <0) return(NULL);

                 /*---- We just read the frameH structure -----*/

 if(FrTOCSetPos(iFile, iFile->toc->positionH[i]) != 0) return (NULL);
    
 FrameHRead(iFile);
 
 return(iFile->curFrame);}

/*----------------------------------------------------- FrameHWrite---*/
void FrameHWrite(struct FrameH *frameH,
                 struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

 FrTOCFrame(oFile,frameH);

 FrPutNewRecord(oFile, frameH, FR_NO);

 FrPutSChar( oFile, frameH->name);
 FrPutInt(   oFile, frameH->run);
 FrPutIntU(  oFile, frameH->frame);
 FrPutIntU(  oFile, frameH->dataQuality);
 FrPutIntU(  oFile, frameH->GTimeS);
 FrPutIntU(  oFile, frameH->GTimeN);
 FrPutShortU(oFile, frameH->ULeapS);
 FrPutInt(   oFile, frameH->localTime);
 FrPutDouble(oFile, frameH->dt);          
 FrPutStruct(oFile, frameH->type);          
 FrPutStruct(oFile, frameH->user);          
 FrPutStruct(oFile, frameH->detectSim);
 FrPutStruct(oFile, frameH->detectProc);
 FrPutStruct(oFile, frameH->history);
 FrPutStruct(oFile, frameH->rawData);
 FrPutStruct(oFile, frameH->procData);
 FrPutStruct(oFile, frameH->strain);
 FrPutStruct(oFile, frameH->simData);
 FrPutStruct(oFile, frameH->trigData);
 FrPutStruct(oFile, frameH->simEvent);
 FrPutStruct(oFile, frameH->summaryData);
 FrPutStruct(oFile, frameH->auxData);
 FrPutStruct(oFile, frameH->auxTable);
 FrPutWriteRecord(oFile);

 return;}

/*---------------------------------------------------------------------------*/
unsigned int FrChkSum(FRSCHAR *buf, int nBytes, int start)
/*---------------------------------------------------------------------------*/
/* This function compute the checksum for the buffer buf which has a size
(in bytes) of nBytes. The start variable is used to tell the alignment of buf
-----------------------------------------------------------------------------*/
{unsigned int i, n, shift, first, chksum;

 chksum = 0;
 first = start%4;

          /*------- deal with the first bytes to be 4 bytes aligned --------*/

 if(first != 0) {
   n = 4-first;
   if(n > nBytes) n = nBytes;
   shift = 8*first;

   for(i=0; i<n; i++) {
      chksum += buf[i]<<shift;
      shift = (shift+8)%32;}

   nBytes -= n;
   buf    += n;}

          /*-------- deal with the nicely aligned words (this could be 
             a plain sum on a computer with the right bytes order)-----------*/

 n = nBytes - nBytes%4;
 for(i=0; i<n; i=i+4) {
     chksum += buf[i];
     chksum += buf[i+1]<<8;
     chksum += buf[i+2]<<16;
     chksum += buf[i+3]<<24;}
 nBytes -= n;
 buf    += n;

        /*------------ deal with the extra non aligned bytes ----------------*/

 if(nBytes > 0) {chksum += buf[0];}
 if(nBytes > 1) {chksum += buf[1]<<8;}
 if(nBytes > 2) {chksum += buf[2]<<16;}

 return(chksum);
}

/*---------------------------------------------------------------------------*/
FrCList *FrCListBldAdc(FrameH *frame)
/*---------------------------------------------------------------------------*/
/* This function build an alphabetic sorted list of Adc channels.            */
/*---------------------------------------------------------------------------*/
{FrAdcData *adc, **adcField;
 FrCList *list;
 int len, maxL, pSize;
 void *current;

 if (frame == NULL)                    return(NULL);
 if (frame->rawData == NULL)           return(NULL);
 if (frame->rawData->firstAdc == NULL) return(NULL);

 list = (FrCList *) malloc(sizeof(FrCList));
 if(list == NULL)                    return (NULL);

                                       /*-------- compute the table size ----*/
 list->nChannels = 0;
 maxL = 0;
 for (adc = frame->rawData->firstAdc; adc != NULL; adc = adc->next)
    {(list->nChannels)++;
     len = strlen(adc->name)+1;
     if(len > maxL) maxL = len;}

 pSize = sizeof(FrAdcData *);
 list->nameSize = pSize*((maxL+pSize-1)/pSize);     /*-- align the address---*/
 list->rowSize  = pSize + list->nameSize;

                                       /*----------------- Allocate space ---*/

 list->table = malloc(list->nChannels * list->rowSize);
 if(list->table == NULL) return(NULL);

                                       /*------------------ Fill the table---*/
 current = list->table;
 for (adc = frame->rawData->firstAdc; adc != NULL; adc = adc->next)
    {memcpy(current, adc->name, list->nameSize);
     adcField = (FrAdcData **)((long)current + list->nameSize);
     *adcField = adc;
     current =  (void *)((long)current + list->rowSize);}
                                       /*---------------- sort the table ----*/

 qsort(list->table, list->nChannels, list->rowSize, 
                (int (*) (const void*, const void*)) strcmp);

 return(list);
}

/*---------------------------------------------------------------------------*/
FrCList *FrCListBldSer(FrameH *frame)
/*---------------------------------------------------------------------------*/
/* This function build an alphabetic sorted list of Ser channels.            */
/*---------------------------------------------------------------------------*/
{FrSerData *ser, **serField;
 FrCList *list;
 int len, maxL, pSize;
 void *current;

 if (frame == NULL)                    return(NULL);
 if (frame->rawData == NULL)           return(NULL);
 if (frame->rawData->firstSer == NULL) return(NULL);

 list = (FrCList *) malloc(sizeof(FrCList));
 if(list == NULL)                    return (NULL);

                                       /*-------- compute the table size ----*/
 list->nChannels = 0;
 maxL = 0;
 for (ser = frame->rawData->firstSer; ser != NULL; ser = ser->next)
    {(list->nChannels)++;
     len = strlen(ser->name)+1;
     if(len > maxL) maxL = len;}

 pSize = sizeof(FrSerData *);
 list->nameSize = pSize*((maxL+pSize-1)/pSize);     /*-- align the address---*/
 list->rowSize  = pSize + list->nameSize;

                                       /*----------------- Allocate space ---*/

 list->table = malloc(list->nChannels * list->rowSize);
 if(list->table == NULL) return(NULL);

                                       /*------------------ Fill the table---*/
 current = list->table;
 for (ser = frame->rawData->firstSer; ser != NULL; ser = ser->next)
    {memcpy(current, ser->name, list->nameSize);
     serField = (FrSerData **)((long)current + list->nameSize);
     *serField = ser;
     current = (void *)((long)current + list->rowSize);}
                                       /*---------------- sort the table ----*/

 qsort(list->table, list->nChannels, list->rowSize, 
                (int (*) (const void*, const void*)) strcmp);

 return(list);
}

/*---------------------------------------------------------------------------*/
void *FrCListFind(FrCList *list, char *name)
/*---------------------------------------------------------------------------*/
/* This function an Adc channel in the list.                                 */
/*---------------------------------------------------------------------------*/
{void **channel;

 if(name == NULL) return(NULL);
 if(list == NULL) return(NULL);

 channel = bsearch(name, list->table, list->nChannels, list->rowSize, 
                             (int (*) (const void*, const void*)) strcmp);
 
 if(channel == NULL) return(NULL);
 
 channel = (void **)((long)channel + list->nameSize);
 return(*channel);
}

/*---------------------------------------------------------------------------*/
void FrCListFree(FrCList *list)
/*---------------------------------------------------------------------------*/
/* This function free the space associated to an channel list                */
/*---------------------------------------------------------------------------*/
{
 if(list == NULL) return;

 free(list->table);
 free(list);

 return;
}

/*------------------------------------------------- FrDetectorDef ----*/
struct FrSH *FrDetectorDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrDetector",FrDetectorRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_2S", "longitudeD","-"); 
  FrSENew(classe, "INT_2S", "longitudeM","-"); 
  FrSENew(classe, "REAL_4", "longitudeS","-"); 
  FrSENew(classe, "INT_2S", "latitudeD","-"); 
  FrSENew(classe, "INT_2S", "latitudeM","-"); 
  FrSENew(classe, "REAL_4", "latitudeS","-"); 
  FrSENew(classe, "REAL_4", "elevation","-"); 
  FrSENew(classe, "REAL_4", "armXazimuth","-"); 
  FrSENew(classe, "REAL_4", "armYazimuth","-"); 
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "more","-"); 
  FrSENew(classe, "PTR_STRUCT(FrTable *)", "moreTable","-"); 

  return(classe);}
/*------------------------------------------------- FrDetectorDump----*/
void FrDetectorDump(struct FrDetector *detector, 
                    FILE *fp, 
                    int debugLvl)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;

 if(debugLvl < 1)     return;
 if(detector == NULL) return;
 if(fp       == NULL) return;

 fprintf(fp,"Detector: %s \n",detector->name);

      /*----------static data----------------*/

 fprintf(fp,"Static Data:\n");
 sData = detector->sData;
 while(sData != NULL)
   {fprintf(fp," %s ", sData->name);
    if(sData->comment != NULL) fprintf(fp," (%s)", sData->comment);
    fprintf(fp,"\n  valid from GPS=%d (UTC=%s)",
               sData->timeStart, FrStrUTC(sData->timeStart, 0));
    fprintf(fp," to %d (%s) version %d\n",
	       sData->timeEnd, FrStrUTC(sData->timeEnd, 0),sData->version);
    if(sData->data  != NULL) FrVectDump (sData->data ,fp, debugLvl);
    if(sData->table != NULL) FrTableDump(sData->table,fp, debugLvl);
    sData = sData->next;}

 return;}
 
/*------------------------------------------------FrDetectorFree------*/
void FrDetectorFree(struct FrDetector *detector)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;

 if(detector == NULL) return;

 sData = detector->sData;
 while(sData != NULL) {sData = FrStatDataFree(sData);}

 if(detector->name != NULL) free(detector->name);
 free(detector);

 return;}

/*-------------------------------------------------- FrDetectorNew----*/
struct FrDetector *FrDetectorNew(char *name)
/*--------------------------------------------------------------------*/
{struct FrDetector *detector;
 
  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL) 
       {return(NULL);}
  else {detector->classe = FrDetectorDef();} 

  FrStrCpy(&detector->name, name);
 
  FrCurDetector = detector;

  return(detector);}
/*-------------------------------------------------- FrDetectorRead---*/
void FrDetectorRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrDetector *detector;
 
  iFile->detectorType = iFile->type;

  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {detector->classe = FrDetectorDef();} 
  
  FrReadHeader(iFile,  detector);
  FrReadSChar (iFile, &detector->name); 
  FrReadShort (iFile, &detector->longitudeD); 
  FrReadShort (iFile, &detector->longitudeM); 
  FrReadFloat (iFile, &detector->longitudeS); 
  FrReadShort (iFile, &detector->latitudeD); 
  FrReadShort (iFile, &detector->latitudeM); 
  FrReadFloat (iFile, &detector->latitudeS); 
  FrReadFloat (iFile, &detector->elevation); 
  FrReadFloat (iFile, &detector->armXazimuth); 
  FrReadFloat (iFile, &detector->armYazimuth); 
  FrReadStruct(iFile, &detector->more); 
  FrReadStruct(iFile, &detector->moreTable);

  FrCurDetector = detector;

  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", detector->name);

  return;}
 
/*------------------------------------------------- FrDetectorWrite---*/
void FrDetectorWrite(struct FrDetector *detector, 
                     struct FrFile *oFile)
                         /* write FrDetector structure on output file */
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;

 oFile->detectorType = FrDetectorDef()->id;

 if(detector == NULL) return;
 	 
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"  Output FrDetector %s\n",detector->name);}
         
 FrPutNewRecord(oFile, detector, FR_YES);
 FrPutSChar (oFile, detector->name);
 FrPutShort (oFile, detector->longitudeD); 
 FrPutShort (oFile, detector->longitudeM); 
 FrPutFloat (oFile, detector->longitudeS); 
 FrPutShort (oFile, detector->latitudeD); 
 FrPutShort (oFile, detector->latitudeM); 
 FrPutFloat (oFile, detector->latitudeS); 
 FrPutFloat (oFile, detector->elevation); 
 FrPutFloat (oFile, detector->armXazimuth); 
 FrPutFloat (oFile, detector->armYazimuth); 
 FrPutStruct(oFile, detector->more); 
 FrPutStruct(oFile, detector->moreTable);
 FrPutWriteRecord(oFile);
 
         /*----------------------- write associated data ---------------*/
 
 for(sData = detector->sData; sData != NULL; sData = sData->next) 
   {if(FrTOCStatD(oFile, sData) == 0) FrStatDataWrite(sData, oFile);}
 
 if(detector->more      != NULL) {FrVectWrite(detector->more, oFile);}
 if(detector->moreTable != NULL) {FrTableWrite(detector->moreTable, oFile);}
  
 return;}

/*------------------------------------------------------ FrDicAddS----*/
struct FrSH *FrDicAddS(char *type, 
                       void  (*funRead)())
/*--------------------------------------------------------------------*/
{struct FrSH *structH;

  structH = FrSHNew(type, "");
  if(structH == NULL)  {return(NULL);}
  FrSHRoot[FrnSH] = structH;
  FrnSH++;

  structH->objRead    = funRead;
  structH->objReadOld = NULL;
  
  return(structH);}
  
/*-------------------------------------------------------- FrDicFree -*/
void FrDicFree(struct FrFile *file)
/*--------------------------------------------------------------------*/
{struct FrSH *sh;
 struct FrSE *nextSE;
 int j;

 for(j=3; j<file->maxSH; j++)
   {sh = file->sh[j];
    if(sh == NULL) continue;

    while(sh->firstE != NULL)
        {nextSE = sh->firstE->next;
         if(sh->firstE->comment != NULL) free(sh->firstE->comment); 
         free(sh->firstE->type);
         free(sh->firstE->name);
         free(sh->firstE); 
         sh->firstE = nextSE;}

    free(sh->name);
    if(sh->comment != NULL) free(sh->comment);
    free(sh);

    file->sh[j] = NULL;}

 return;} 
/*-------------------------------------------------------------- FrDicGetId--*/
int FrDicGetId(struct FrFile *file, 
               unsigned short type, 
               void *address)             
/*---------------------------------------------------------------------------*/
/* This function return the instance number assigned by FrDicAssignId        */
/* It removed the item from the list except for FrDetector                   */
/* since several structures could point to it.                               */
/*---------------------------------------------------------------------------*/
{int i;

 for(i=0; i<file->nRef; i++)
   {if((file->refType[i]  == type) && (file->address[i] == address))
       {if(type != file->detectorType) file->refType[i] = -1;
        return(file->refInstance[i]);}}

  FrError(3,"FrDicGetId","bank not referenced");
  file->error = FR_ERROR_FRSET;
 
  return(0);}

/*------------------------------------------------------------FrDicAssignId--*/
int FrDicAssignId(struct FrFile *file,
                  unsigned short type, 
                  void *address)                
/*---------------------------------------------------------------------------*/
/* This function assigns an instance number to be used by FrDicGetId         */
/*---------------------------------------------------------------------------*/
{unsigned short instance;
 int i;

       /*------ first search for FrDetector if an id is already assigned ----*/

 if(type == file->detectorType)
   {for(i=0; i<file->nRef; i++)
      {if((file->refType[i]  == type) && (file->address[i] == address))
	{return(file->refInstance[i]);}}}
   
      /*------------------- then standard case: assign a new id -------------*/

 instance = file->lastInstance[type];
 file->lastInstance[type]++;

 for(i=0; i<file->nRef; i++)
   {if(file->refType[i]  == -1) break;}

 if(i == file->nRef) 
    {if(file->nRef > FRMAXREF) 
       {FrError(3,"FrDicAssignId", "FRMAXREF need to be increased");
        file->error = FR_ERROR_FRSET;
        return(0);}
     file->nRef++;}

 file->refType[i]     = type;
 file->refInstance[i] = instance;
 file->address[i]     = address;

 return(instance);}
  
/*---------------------------------------------------------------- FrDicIni--*/
void FrDicIni(struct FrFile *file)
/*---------------------------------------------------------------------------*/
{int i;

 for(i=0; i<FrnSH; i++) {file->lastInstance[i] = 0;}

 file->nRef = 0;

 return;} 

/*----------------------------------------------- FrEndOfFileDef ----*/
struct FrSH *FrEndOfFileDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrEndOfFile",FrEndOfFileRead);

  FrSENew(classe, "INT_4U", "nFrames","-");
  FrSENew(classe, "INT_4U", "nBytes","-");
  FrSENew(classe, "INT_4U", "chkFlag","-");
  FrSENew(classe, "INT_4U", "chkSum","-");
  FrSENew(classe, "INT_4U", "seekTOC","-");

  return(classe);}

/*----------------------------------------------------------FrEndOfFileRead--*/
void FrEndOfFileRead(struct FrFile *iFile)
/*---------------------------------------------------------------------------*/
{unsigned int nBytes, nFrames, seekTOC;
 unsigned short instance;
 char message[96];
 FRBOOL chkSumFlag;

  FrReadShortU(iFile, &instance);
  FrReadIntU  (iFile, &nFrames);
  FrReadIntU  (iFile, &nBytes);

           /*----- chcksum value and flag are not included in the checksum --*/

  chkSumFlag = iFile->chkSumFlag;  
  iFile->chkSumFlag = FR_NO;
  FrReadIntU  (iFile, &iFile->chkFlagRead);
  FrReadIntU  (iFile, &iFile->chkSumRead);
  iFile->chkSumFlag = chkSumFlag;

  if(iFile->fmtVersion == 4) 
      {FrReadIntU  (iFile, &seekTOC);}
  else{seekTOC = 0;}

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "End of Files Reached\n  nFrames=%d nBytes=%d"
	     " chkSum=%x(flag=%d) computed=%x seekTOC=%d\n",
               nFrames, nBytes, iFile->chkSumRead, iFile->chkFlagRead, 
                                iFile->chkSum, seekTOC);}

            /*--------- check checksum ----------------------*/

  if((iFile->chkSumRead  != iFile->chkSum) &&
     (iFile->chkFlagRead != 0) &&
     (iFile->chkSumFlag == FR_YES))
    {sprintf(message, "Checksum error: read=%x computed=%x",
                             iFile->chkSumRead,iFile->chkSum);
     FrError(3,"FrEndOfFileRead",message);
     iFile->error = FR_ERROR_CHECKSUM;
     return;}

     /*--- we try to open the next file in the list ----*/

 if(FrFileINext(iFile, 0., 0., NULL) != 0) 
     {iFile->endOfFrame = FR_YES;
      return;}
 
 return;}

/*-------------------------------------------------------- FrEndOfFileWrite--*/
void FrEndOfFileWrite(struct FrFile *oFile)
/*---------------------------------------------------------------------------*/
{static struct FrEndOfFile *eof = NULL;
 unsigned int nBytes, seekTOC, chkSum, chkSumFlag, 
          eofLength = 28;/*end of file bloc size*/

 if(eof == NULL) 
    {eof = (struct FrEndOfFile *) calloc(1,sizeof(struct FrEndOfFile));
     if(eof == NULL) 
       {oFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
     else {eof->classe = FrEndOfFileDef();}}
 
 FrPutNewRecord(oFile, eof, FR_NO);

 nBytes = oFile->nBytes + eofLength; 
 if(oFile->toc != NULL)
     {seekTOC = nBytes - oFile->toc->position;}
 else{seekTOC = 0;}

 FrPutIntU (oFile, oFile->nFrames);
 FrPutIntU (oFile, nBytes);
 FrPutIntU (oFile, 0);
 FrPutIntU (oFile, 0);
 FrPutIntU (oFile, seekTOC);

         /*---------------------------------------- Put checksum info--------*/

 if(oFile->chkSumFlag == FR_YES)
  {memcpy(oFile->pStart, &eofLength, FrSint);
   chkSumFlag = 1;
   chkSum = oFile->chkSum + FrChkSum((FRSCHAR*) oFile->pStart, 
                                          eofLength, oFile->nBytes); 
   memcpy(oFile->pStart+16, &chkSumFlag, FrSint);
   memcpy(oFile->pStart+20, &chkSum, FrSint);}

 FrPutWriteRecord(oFile);

 if(FrDebugLvl > 0) {fprintf(FrFOut,
      "write End of File after %d frames; %d Bytes checksum = %x seekTOC=%d\n",
       oFile->nFrames, nBytes, chkSum, seekTOC);}

 return;}

/*--------------------------------------------------------- FrEndOfFrameDef--*/
struct FrSH *FrEndOfFrameDef()
/*---------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrEndOfFrame",FrEndOfFrameRead);

  FrSENew(classe, "INT_4S", "run","-");
  FrSENew(classe, "INT_4U", "frame","-");

  return(classe);}
/*------------------------------------------------ FrEndOfFrameRead---*/
void FrEndOfFrameRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{unsigned int run,frameNumber;
 unsigned short instance;

  FrReadShortU(iFile, &instance);
  FrReadIntU(iFile, &run);
  FrReadIntU(iFile, &frameNumber);

  if(FrDebugLvl > 0) fprintf(FrFOut, " FrEndOfFrameRead: "
                     " run=%d frame=%d\n", run, frameNumber);

  /*------ check that the frame is not corrupted -----*/

  if(run != iFile->curFrame->run)
     {FrError(3,"FrEndOfFrameRead","run number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  if(frameNumber != iFile->curFrame->frame)
     {FrError(3,"FrEndOfFrameRead","frame number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  iFile->endOfFrame = FR_YES;

  return;}

/*----------------------------------------------- FrEndOfFrameWrite---*/
void FrEndOfFrameWrite(struct FrameH *frameH, 
                       struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{static struct FrEndOfFrame *eof = NULL;
 
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"write eof for frame %d Run:%d \n",
         frameH->frame, frameH->run);}

 if(eof == NULL) 
    {eof = (struct FrEndOfFrame *) calloc(1,sizeof(struct FrEndOfFrame));
     if(eof == NULL) 
       {oFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
     else {eof->classe = FrEndOfFrameDef();}}
 
 FrPutNewRecord(oFile, eof, FR_NO);
 FrPutIntU (oFile, frameH->run);
 FrPutIntU (oFile, frameH->frame);
 FrPutWriteRecord(oFile);

 return;}

/*----------------------------------------------------- FrError ------*/
char *FrError(int level, 
              char *function, 
              char *message)
/*--------------------------------------------------------------------*/
/* handle FrameLib error acording the level of severity.              */
/* input: function: name of the function calling for an error         */
/*        message:  message to by reported                            */
/*        level:    2 = warning,                                      */
/*                  3 = fatal error: requested action could not be    */
/*                                   completed                        */
/* return: a pointer to the string which contains the history of the  */
/*         error messages                                             */
/*--------------------------------------------------------------------*/
{static int errorMsgL = 0;
#define  FRERRORMSGSIZE  500     /* this is used only in this function */
 static char errorMsg[FRERRORMSGSIZE];
 
 if(level == -1) return(errorMsg);

 if(level < 2)
     {sprintf(FrBuf," *** FrInfo: in %s %s\n",function,message);}
 else if(level < 3)
     {sprintf(FrBuf," *** FrWarning: in %s %s\n",function,message);}
 else{sprintf(FrBuf," *** FrError: in %s %s\n",function,message);}
   
 if(errorMsgL < FRERRORMSGSIZE)
   {strncpy(&errorMsg[errorMsgL], FrBuf, FRERRORMSGSIZE-errorMsgL);
    errorMsgL = strlen(FrBuf) + errorMsgL;}
 
 if(FrErrorHandler != NULL) 
   {FrErrorHandler(level, FrBuf);}
 
  return(errorMsg);}

/*---------------------------------------------FrErrorGetHistory------*/
char *FrErrorGetHistory()
/*--------------------------------------------------------------------*/
/* return: a pointer to the string which contains the history of the  */
/*         error messages                                             */
/*--------------------------------------------------------------------*/
{static char *errorMsg = NULL;

 if(errorMsg == NULL)
   {errorMsg = FrError(-1,NULL,NULL);}
 
  return(errorMsg);}
/*----------------------------------------------- FrErrorDefHandler---*/
void FrErrorDefHandler(int level, 
                       char *lastMessage)
/*--------------------------------------------------------------------*/
/* default handler for the FrameLib error.                            */
/* input parameters:                                                  */
/*   lastMessage: the string which contain the last generated message */
/*   level:  2 = warning,                                             */
/*           3 = fatal error: requested action could not be  completed*/
/*--------------------------------------------------------------------*/
{
    if(FrDebugLvl > 0)
       {fprintf(FrFOut,"%s",lastMessage);
        fprintf(stderr,"%s",lastMessage);}
 
    return;}

/*-------------------------------------------------FrErrorSetHandler--*/
void FrErrorSetHandler(void  (*handler)(int, char *))
/*--------------------------------------------------------------------*/
{
 FrErrorHandler = handler;

 return;}
/*----------------------------------------------------------FrFileBreakName--*/
void FrFileBreakName(FrFile *file,
                     char   *fullName)
/*---------------------------------------------------------------------------*/
/* This function is looking for space character to breaks a string in words. */
/* It returns a link list of FrFileHeader structures.                        */
/* We assume that the file names start with a letter                         */
/*---------------------------------------------------------------------------*/
{FrFileH **root, *fileH;
 char  *token;
 FRBOOL ffl;
 FILE  *fp=NULL;
 FrTag *list=NULL, *tag=NULL;
 int length;
 long dirNameL;

 file->current = NULL;
 file->fileH   = NULL;
 root = &file->fileH;

 if(fullName == NULL) return;

                /*----- if the extension is .ffl (frame file list) 
                                          we read the list from  a file ----*/

 if(strstr(fullName, ".ffl") == NULL)
    {ffl = FR_NO;
     list = FrTagNew(fullName);
     tag = list;
     if(tag == NULL) 
          {token = NULL;}
     else {token = tag->start;}
     dirNameL = 0.;}
 else 
   {ffl = FR_YES;
    fp = fopen(fullName,"r");
    if(fp == NULL) return;
    token = FrBuf;
    if(fscanf(fp,"%s",FrBuf) != 1) token = NULL;
    dirNameL = strstr(fullName, ".ffl") - fullName + 1;}

               /*----------------------------- start the loop on each file --*/

 while(token != NULL)
   {fileH = (FrFileH *) malloc(sizeof(FrFile));
    if(fileH == NULL) return;

    if(ffl == FR_NO) 
         length = tag->length;
    else length = dirNameL + strlen(FrBuf);
    fileH->fileName = malloc(length+1);
    if(fileH->fileName == NULL) break;
    
               /*------ for ffl, add ffl path if the file names are local ---*/

    if((ffl == FR_YES) && (token[0] != '/'))
        {strncpy(fileH->fileName, fullName, dirNameL);
	 fileH->fileName[dirNameL-1] = '/';
         strncpy(fileH->fileName+dirNameL, token, length);}
    else	
        {strncpy(fileH->fileName, token, length);}
    fileH->fileName[length] = '\0';

    fileH->tStart = -1.;
    fileH->length = 0;
    fileH->next   = NULL;
    *root = fileH;
    root = &(fileH->next);

               /*----------------------------- get the starting time if any-*/

    if(ffl == FR_NO)
         {if((tag = tag->next) == NULL) break;
          token = tag->start;}
    else {if(fscanf(fp,"%s",FrBuf) != 1) token = NULL;}
    if(token == NULL) break;

    if(token[0] != '-' && isdigit((int)token[0]) == 0) continue;
    fileH->tStart = atof(token);

               /*------------------------------------get the end time if any-*/

    if(ffl == FR_NO)
         {if((tag = tag->next) == NULL) break;
          token = tag->start;}
    else {if(fscanf(fp,"%s",FrBuf) != 1) token = NULL;}
    if(token == NULL) break;

    if(isdigit((int)token[0]) == 0) 
      {fileH->tStart = -1.;
       continue;}
    fileH->length = atof(token);

    if(ffl == FR_NO)
         {if((tag = tag->next) == NULL) break;
          token = tag->start;}
    else {if(fscanf(fp,"%s",FrBuf) != 1) token = NULL;}}

 if(FrDebugLvl > 0)
   {fprintf(FrFOut,"FrFileBreakName: (start/stop time and names)");
    for(fileH = *root; fileH != NULL; fileH = fileH->next)
      {fprintf(FrFOut,"%s\t%f\t%f\n",  fileH->fileName, 
                        fileH->tStart, fileH->length);}}

 file->current = file->fileH;

 if(ffl == FR_NO) 
      {FrTagFree(list);}
 else {fclose(fp);}

 return;}

/*--------------------------------------------------------------- FrFileDbg -*/
void FrFileDbg(struct FrFile *file)
/*---------------------------------------------------------------------------*/
{int i,size;
  char *b;
  unsigned c;
 
  if(FrDebugLvl < 1) return;
  if(file->inMemory == FR_YES)
    {size = file->p - file->buf;
     fprintf(FrFOut," \n Buffer size = %d\n Buffer:\n\n",size);
     b = file->buf;
     for(i=0; i<size; i=i+16)
           {fprintf(FrFOut," %10d  ",i); 
            c = b[i+0]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+1]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+2]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+3]; fprintf(FrFOut,"%2.2x  ",c);
            c = b[i+4]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+5]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+6]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+7]; fprintf(FrFOut,"%2.2x   ",c);
            c = b[i+8]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+9]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+10]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+11]; fprintf(FrFOut,"%2.2x  ",c);
            c = b[i+12]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+13]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+14]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+15]; fprintf(FrFOut,"%2.2x\n",b[i+15]);}} 
  
  return;}

/*-------------------------------------------------------------- FrFileFree--*/
void FrFileFree(struct FrFile *file)
/*---------------------------------------------------------------------------*/
{FrFileH *fileH, *next;

  fileH = file->fileH;
  while(fileH != NULL)
    {free(fileH->fileName);
     next = fileH->next;
     free(fileH);
     fileH = next;}

  FrDicFree(file);

  FrTOCFree(file->toc);

  free(file->sh);

  if(file->historyMsg != NULL) free(file->historyMsg);

  free(file);

  return;
}
/*--------------------------------------------------------- FrFileHeader-----*/
void FrFileHeader(unsigned char *buf)
/*---------------------------------------------- define the format version --*/
/* format version 3 is valid since FrameLib version 3.0 (July 97)            */
/* format version 2 is valid since FrameLib version 2.3 (May 97)             */
/* format version 1 was valid up to the FrameLib version 2.24                */
/*---------------------------------------------------------------------------*/
{unsigned short swapS;
 unsigned int swapI,i;
 FRULONG  swapL;
 double dPi;
 float fPi;
 int formatVersion;
 int libMinorVersion;

 sscanf(FrVersion,"%d.%d",&formatVersion,&libMinorVersion);

 for(i=0; i<40; i++) {buf[i] = 0;}

 strcpy((char *) buf,"IGWD");
 buf[5]  = formatVersion;
 buf[6]  = libMinorVersion;
 buf[7]  = FrSshort;
 buf[8]  = FrSint;
 buf[9]  = 8;
 buf[10] = FrSfloat;
 buf[11] = FrSdouble;
 swapS = 0x1234;         
 swapI = 0x12345678;
 swapL = 0x12345678; 
 swapL = 0;
 for (i=0; i<2*sizeof(long); i++)
    {swapL = swapL*16 + i;}          /*  swapL = 0x123456789abcdef;  */
 fPi = 3.1415926535897932384626; 
 dPi = 3.1415926535897932384626;
 memcpy(&buf[12],&swapS,2);
 memcpy(&buf[14],&swapI,FrSint);
 memcpy(&buf[18],&swapL,FrSlong);
 memcpy(&buf[26],&fPi,FrSfloat);
 memcpy(&buf[30],&dPi,FrSdouble);
 buf[38] = 'A';
 buf[39] = 'Z';
   
 return;}

/*------------------------------------------------------------- FrFileIncSH--*/
void FrFileIncSH(FrFile *iFile,
                 unsigned short id)
/*---------------------------------------------------------------------------*/
{struct FrSH **old;
 int i;

          /*--- check the space for the direct acces table ----*/
          
 if(id < iFile->maxSH) return;
 
 old = iFile->sh;
 iFile->sh = calloc(id+10, sizeof(struct FrSH*));
 if(iFile->sh == NULL)
                {iFile->error = FR_ERROR_MALLOC_FAILED;
                 return;} 
 for(i=0; i<iFile->maxSH; i++)
               {iFile->sh[i] = old[i];}
 iFile->maxSH = id+10;
 free(old);

 return;}

/*----------------------------------------------------------------FrFileNew--*/
FrFile *FrFileNew(char *fileName, 
                  int   compress, 
                  char *buf, 
                  long  bufSize)
/*---------------------------------------------------------------------------*/
{FrFile *file;
 int i;
   
  FrLibShortIni();  /*---- do a short init if needed ---*/
 
  file = (FrFile *) calloc(1,sizeof(FrFile));
  if(file == NULL) 
    {FrError(3,"FrFileNew","malloc struct file failed");
     return(NULL);}

  file->inMemory = FR_YES;

  if(fileName != NULL) 
    {FrFileBreakName(file, fileName);
     if(file->fileH == NULL) FrError(3,"FrFileNew","break name failed");
     if(strcmp(file->fileH->fileName,"STRING") != 0) file->inMemory = FR_NO;}

  file->compress = compress;
  file->gzipLevel = 1;
  file->run = -1;
  file->frfd= NULL;
  file->p   = NULL;
  file->pMax = file->p + 99999999;
  file->bufSize = 0;
  file->buf       = NULL;
  file->sDataSim  = NULL;
  file->sDataProc = NULL;
  file->error = 0;
  file->nBytes  = 0;
  file->nFrames = 0;
  file->relocation = FR_YES;
  file->noTOCts    = FR_NO; 
  file->chkSumFlag = FR_YES;
  file->chkSum     = 0;

  file->maxSH = 10; 
  file->sh = calloc(file->maxSH, sizeof(struct FrSH*));
  if(file->sh == NULL)
    {FrError(3,"FrFileNew","malloc struct sh failed");
     return(NULL);}

  file->sh[1] = FrSHRoot[0];
  file->sh[2] = FrSHRoot[1];     /* the FrSH and FrSE are always 1 and 2*/
  
     /*--- check tempory space  ---*/

  file->buf = buf;
  file->bufSize = bufSize;
  file->p    = file->buf;
  file->pMax = file->p + bufSize;

    /*---- default history message ----*/

  sprintf(FrBuf,"FrameLib:%s",FrVersion);
  FrStrCpy(&(file->historyMsg), FrBuf);
 
     /*---- reset dictionary output ----*/

  for(i=0; i<FRMAPMAXSH; i++)
     {file->dicWrite[i] = FR_NO;}

  file->detectorType = 0;

  return(file);
}
/*------------------------------------------------------FrFileIChannelList--*/
char *FrFileIChannelList(FrFile *iFile, int mode)
/*--------------------------------------------------------------------------*/
/* This function allocate the space and returns the pointer to a string with 
the channel list and frequency information. The user should free the space. 
The variable mode is reserve for futur use. mode=0 is the default value     */
/*--------------------------------------------------------------------------*/
{int i, fill, size, last;
 FrTOCts *ts;
 FrTOC *toc;
 FrAdcData *adc;
 FrSimData *sim;
 FrSerData *ser;
 FrProcData *proc;
 char *buffer, *buf;
               
 if(iFile == NULL) return(NULL);
 if(iFile->toc == NULL)  FrTOCReadFull(iFile);

 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/

 toc = iFile->toc; 
 if(toc == NULL)      return(NULL);
 if(toc->nFrame == 0) return(NULL); 

                     /*----------------- create output buffer ---------------*/

 size = 500;
 buffer = malloc(size);
 if(buffer == NULL) return(NULL);
 buf = buffer;

                             /*-------------- Frame information ----------*/

 buf += sprintf(buf,"FIRSTFRAME %d %d %f %d %d\n",toc->GTimeS[0],
                toc->ULeapS, toc->dt[0],toc->frame[0],toc->runs[0]);
 last = toc->nFrame-1;
 buf += sprintf(buf,"LASTFRAME  %d %d %f %d %d\n",toc->GTimeS[last],
          toc->ULeapS, toc->dt[last],toc->frame[last],toc->runs[last]);

               /*for each ADC, find the first ADC and read it -------------*/

for(ts = toc->adc; ts != NULL; ts = ts->next)
   {for(i=0; i<toc->nFrame; i++) {if(ts->position[i] != 0) break;}

    if(FrTOCSetPos(iFile, ts->position[i]) != 0) continue;
    adc = FrAdcDataRead(iFile);
    if(adc == NULL) continue;

    if((fill = buf - buffer) > size -(50+strlen(adc->name))) 
      {size = 2*size;
       if((buffer  = realloc(buffer,size))== NULL) return(NULL);
       buf = buffer+fill;}

    buf += sprintf(buf,"ADC %s\t%f 1. 0.\n",adc->name, adc->sampleRate);
    adc->data = NULL;
    FrAdcDataFree(adc);}
 
               /*for each Sim, find the first ADC and read it -------------*/

for(ts = toc->sim; ts != NULL; ts = ts->next)
   {for(i=0; i<toc->nFrame; i++) {if(ts->position[i] != 0) break;}

    if(FrTOCSetPos(iFile, ts->position[i]) != 0) continue;
    sim = FrSimDataRead(iFile);
    if(sim == NULL) continue;

    if((fill = buf - buffer) > size -(50+strlen(sim->name))) 
      {size = 2*size;
       if((buffer  = realloc(buffer,size))== NULL) return(NULL);
       buf = buffer+fill;}

    buf += sprintf(buf,"SIM %s\t%f 1. 0.\n",sim->name, sim->sampleRate);
    sim->data = NULL;
    FrSimDataFree(sim);}
 
               /*for each Proc, find the first ADC and read it -------------*/

for(ts = toc->proc; ts != NULL; ts = ts->next)
   {for(i=0; i<toc->nFrame; i++) {if(ts->position[i] != 0) break;}

    if(FrTOCSetPos(iFile, ts->position[i]) != 0) continue;
    proc = FrProcDataRead(iFile);
    if(proc == NULL) continue;

    if((fill = buf - buffer) > size -(50+strlen(proc->name))) 
      {size = 2*size;
       if((buffer  = realloc(buffer,size))== NULL) return(NULL);
       buf = buffer+fill;}

    buf += sprintf(buf,"PROC %s\t%f 1. 0.\n",proc->name, proc->sampleRate);
    proc->data = NULL;
    FrProcDataFree(proc);}
 
               /*for each Sim, find the first ADC and read it -------------*/

for(ts = toc->ser; ts != NULL; ts = ts->next)
   {for(i=0; i<toc->nFrame; i++) {if(ts->position[i] != 0) break;}

    if(FrTOCSetPos(iFile, ts->position[i]) != 0) continue;
    ser = FrSerDataRead(iFile);
    if(ser == NULL) continue;
    if(ser->data == NULL) continue;

    if((fill = buf - buffer) > size -(50+strlen(ser->name)+strlen(ser->data))) 
      {size = 2*size;
       if((buffer  = realloc(buffer,size))== NULL) return(NULL);
       buf = buffer+fill;}

    buf += sprintf(buf,"SER %s\t%f %s\n",ser->name, ser->sampleRate, ser->data);
    ser->data = NULL;
    FrSerDataFree(ser);}
 
 return(buffer);}

/*-------------------------------------------------------------FrFileIClose--*/
void FrFileIClose(FrFile *iFile)
/*---------------------------------------------------------------------------*/
/* Close the current file and free all associated space                      */
/*---------------------------------------------------------------------------*/
{FrStatData *sData;
 
 if(iFile == NULL) return;
  
 if(iFile->frfd != NULL) 
     {FrIOClose(iFile->frfd);
      iFile->frfd = NULL;}

 sData = iFile->sDataSim;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataSim = NULL;

 sData = iFile->sDataProc;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataProc = NULL;

 FrDicFree(iFile);

 FrTOCFree(iFile->toc);
 iFile->toc = NULL;

 return;}
  
/*------------------------------------------------------------ FrFileIDump--*/
void FrFileIDump(FrFile *iFile,
                 FILE *fp,
                 int debugLvl,
                 char *tag) 
/*---------------------------------------------------------------------------*/
/* This function dump a summary of the current file                          */
/*---------------------------------------------------------------------------*/
{FrFileH *fileH;

 if(iFile == NULL) return;

       /*----- This call will scan all the file and build the list of time --*/

 if(debugLvl > 1) 
   {if(iFile->fileH->next != NULL) FrFileIRewind(iFile);
    FrTOCFrameFindT(iFile, 1.e10);}

       /*------------------------- Dump all file names, start and end time --*/

 for(fileH = iFile->fileH; fileH != NULL; fileH = fileH->next)
   {fprintf(fp,"%s\t%.7f\t%.2f\n", fileH->fileName,
                                   fileH->tStart, fileH->length);}

 if(debugLvl < 3) return; 

           /*--------------------------------- Close the previous file ------*/

 if(iFile->current != iFile->fileH) FrFileIClose(iFile);

           /*------------------------------------- Loop over all files ------*/

 for(iFile->current = iFile->fileH; iFile->current != NULL;
     iFile->current = iFile->current->next)
   {fprintf(fp," For file: %s\n",iFile->current->fileName);
    if(iFile->toc == NULL) FrTOCReadFull(iFile);  
    if(iFile->toc == NULL) 
         fprintf(fp," NO TOC available");
    else FrTOCDump(iFile->toc, fp, debugLvl-1, tag);

          /*--------Close the file if we have more than one file-------------*/

    if(iFile->fileH->next != NULL) FrFileIClose(iFile);
    else break;}

 return;
 }
/*---------------------------------------------------------------FrFileIEnd--*/
void FrFileIEnd(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{
 if(iFile == NULL) return;
  
 FrFileIClose(iFile);

 FrFileFree(iFile);
 
 return;}
  
/*--------------------------------------------------------------FrFileIGetV--*/
FrVect *FrFileIGetV(FrFile *iFile,
                    char *name,
                    double tStart,
                    double len)
/*---------------------------------------------------------------------------*/
{FrVect *vect;

 vect = FrFileIGetVType(iFile, name, tStart, len, 1, FRTSADC);
 if(vect != NULL) return(vect);

 vect = FrFileIGetVType(iFile, name, tStart, len, 1, FRTSSIM);
 if(vect != NULL) return(vect);

 vect = FrFileIGetVType(iFile, name, tStart, len, 1, FRTSPROC);
 return(vect);}

/*-----------------------------------------------------------FrFileIGetVAdc--*/
FrVect *FrFileIGetVAdc(FrFile *iFile,
                        char *name,
                        double tStart,
                        double len,
                        int    group)
/*---------------------------------------------------------------------------*/
{
  return(FrFileIGetVType(iFile, name, tStart, len, group, FRTSADC));
}
/*----------------------------------------------------------FrFileIGetVProc--*/
FrVect *FrFileIGetVProc(FrFile *iFile,
                        char *name,
                        double tStart,
                        double len,
                        int    group)
/*---------------------------------------------------------------------------*/
{
  return(FrFileIGetVType(iFile, name, tStart, len, group, FRTSPROC));
}
/*-----------------------------------------------------------FrFileIGetVSim--*/
FrVect *FrFileIGetVSim(FrFile *iFile,
                        char *name,
                        double tStart,
                        double len,
                        int    group)
/*---------------------------------------------------------------------------*/
{
  return(FrFileIGetVType(iFile, name, tStart, len, group, FRTSSIM));
}
/*----------------------------------------------------------FrFileIGetVType--*/
FrVect *FrFileIGetVType(FrFile *iFile,
                        char *name,
                        double tStart,
                        double len,
                        int    group,
                        FRTSTYPE type)
/*---------------------------------------------------------------------------*/
{FrAdcData *adc=NULL;
 FrSimData *sim=NULL;
 FrProcData *proc=NULL;
 FrTOCts *ts, *firstTs=NULL;
 FrVect *vect, *vectRoot, *fullVect;
 FrFileH *firstFileH;
 int i;
 double tEnd, fStart, fEnd;

 if(iFile == NULL) return(NULL);

 firstFileH = iFile->current;

 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/

 tEnd = tStart + len - 1.e-3;/* sub a small number to avoid round off errors*/
 tStart = tStart     + 1.e-3;/* sub a small number to avoid round off errors*/

 vectRoot = NULL;

     /*--- First step, we extract all vectors contained in the time window--*/

 do
   {if(iFile->toc == NULL) FrTOCReadFull(iFile);   /*---- get the TOC----*/
    if(iFile->toc == NULL) return(NULL);
 
                  /*---------Find name in the channel list for this file----*/

    if     (type == FRTSADC)  firstTs = iFile->toc->adc;
    else if(type == FRTSSIM)  firstTs = iFile->toc->sim;
    else if(type == FRTSPROC) firstTs = iFile->toc->proc;
      
    for(ts = firstTs; ts != NULL; ts = ts->next)
      {if(strcmp(name, ts->name) == 0) break;}

    if(ts == NULL) continue;

                  /*-------- if tStart=0, return the first frames ----------*/

    if(tStart < 1.)
      {tStart = iFile->toc->GTimeS[0] + 
	        iFile->toc->GTimeN[0] * 1.e-9 + 1.e-3;
       tEnd = tStart + len - 2.e-3;}

                  /*---------------- read vectors contained in one file ----*/

    for(i=0; i<iFile->toc->nFrame; i++)
      {fStart = iFile->toc->GTimeS[i] + 
	        iFile->toc->GTimeN[i] * 1.e-9;
       if(fStart > tEnd)   continue;
       fEnd   = fStart+iFile->toc->dt[i];
       if(fEnd   < tStart) continue;

       if(ts->position[i] == 0) continue;
       if(FrTOCSetPos(iFile, ts->position[i]) != 0) return(NULL);

       if     (type == FRTSADC)
              {if((adc = FrAdcDataRead (iFile)) == NULL) return(NULL);}
       else if(type == FRTSSIM) 
              {if((sim = FrSimDataRead (iFile)) == NULL) return(NULL);}
       else if(type == FRTSPROC) 
             {if((proc = FrProcDataRead(iFile)) == NULL) return(NULL);}
         
       vect = FrVectReadNext(iFile);
       if(vect->compress != 0) FrVectExpand(vect);

       if((group != 1) &&
          (group != 0)) FrVectDecimate(vect, group, vect);

       vect->GTimeS    = iFile->toc->GTimeS[i];
       vect->GTimeN    = iFile->toc->GTimeN[i];
       vect->localTime = iFile->toc->localTime;
       vect->ULeapS    = iFile->toc->ULeapS;

        /*-Remark: The next check on GTimeS is just to fix a VIRGO DAQ bug -*/

       if(type == FRTSADC && vect->GTimeS > 700000000) 
         {vect->GTimeS += adc->timeOffsetS;
          vect->GTimeN += adc->timeOffsetN;}
       else if(type == FRTSPROC)
         {vect->GTimeS += proc->timeOffsetS;
          vect->GTimeN += proc->timeOffsetN;}

       vect->next = vectRoot;  /*-------------------- build a linked list---*/
       vectRoot = vect;

       if     (type == FRTSADC)  FrAdcDataFree(adc);
       else if(type == FRTSSIM)  FrSimDataFree(sim);
       else if(type == FRTSPROC) FrProcDataFree(proc);}}

  while (FrFileINext(iFile, tStart, len, firstFileH) == 0);  

                      /*--------------------End of the extract vector loop--*/

 if(vectRoot == NULL) return(NULL);

                     /*-------------------- build the output vector --------*/

 fullVect = FrVectConcat(vectRoot, tStart, tEnd-tStart);

 return(fullVect);}

/*---------------------------------------------------------------FrFileINew--*/
FrFile *FrFileINew(char *fileName) 
/*---------------------------------------------------------------------------*/
{FrFile *file;

 file = FrFileNew(fileName, 0, NULL, 0);
 if(file == NULL) return (NULL);

 FrFileIOpen(file);
 if(file->error != FR_OK) 
    {FrFileIEnd(file);
     return(NULL);}

 file->chkSumFlag = FR_NO;

 return(file);
}
/*-------------------------------------------------------------FrFileINewFd--*/
FrFile *FrFileINewFd(struct FrIO *frfd)
/*---------------------------------------------------------------------------*/
{FrFile *file;
 
 file = FrFileNew("open_with_fd", 0, NULL, 0);
 if(file == NULL) return (NULL);

 file->frfd = frfd;

 FrFileIOpen(file);
 if(file->error != FR_OK) return(NULL);

 return(file);
}
/*------------------------------------------------------------- FrFileINext--*/
int FrFileINext(FrFile *iFile,
                double tStart,
                double len,
                FrFileH *firstFileH) 
/*---------------------------------------------------------------------------*/
/* This function open the next file in the list if available. Returns 0 if OK*/
/* IF tStart is not equal to 0, it skeep all file which do not overlap       */
/* tSTart and tStart+len.                                                    */
/*---------------------------------------------------------------------------*/
{double tEnd, fStart, fEnd;

 if(iFile == NULL) return(-1);

 if(iFile->fileH->next == NULL) return(-2);     /*--only one single file ---*/

           /*--------------------------------- Close the previous file ------*/

 FrFileIClose(iFile);

           /*-----------Search for the next file in the list which 
                                              matchs the time conditions ----*/

 tEnd = tStart+len - 1.e-6;   /*--Correct tStart and tEnd --*/
 tStart += 1.e-6;             /*--to avoid round off error--*/

           /*-------------------------------- search the right file header --*/

 for(;;)
   {iFile->current = iFile->current->next;
    if(tStart < 1) break;                   /*----no timing requested -------*/

    if(iFile->current == NULL) iFile->current = iFile->fileH;
    if(iFile->current == firstFileH) return(-1);

    if(iFile->current->tStart == -1.) break;/*----no timing info available --*/
    
    fStart = iFile->current->tStart;
    fEnd   = iFile->current->tStart+iFile->current->length;

    if(tStart > fStart && tStart < fEnd) break;   /*-- search for overlap---*/
    if(tEnd   > fStart && tEnd   < fEnd) break;
    if(fStart > tStart && fStart < tEnd) break;
    if(fEnd   > tStart && fEnd   < tEnd) break;}

           /*--------------------------- Open the next file ----------------*/

 if(iFile->current == NULL) return(-1);

 iFile->error = FR_OK;   /*--- reset the error flag for the next file ------*/
 FrFileIOpen(iFile);

 if(iFile->error != FR_OK) return(-1); 

 return(0);
 }
/*------------------------------------------------------------- FrFileIOpen--*/
void FrFileIOpen(struct FrFile *file)
/*---------------------------------------------------------------------------*/
{char format;
 int i;
 unsigned char *h,l[40];

           /*------- reset error flags (the previous file may be corrupted)--*/

 file->error = FR_OK;

 
           /*----------------------------------------- read the first byte --*/
      
 if(file->frfd != NULL)
      {if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrFileIOpen: open file using existing file descriptor\n");}
 else if(file->inMemory == FR_NO)
      {if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrFileIOpen: open file:%s\n",file->current->fileName); 

       file->frfd = FrIOOpenR(file->current->fileName);
       if(file->frfd == NULL)  
           {FrError(3,"FrFileIOpen"," Open file error");
            file->error = FR_ERROR_OPEN_ERROR;
            return;}}
  
 else
     {if(FrDebugLvl > 0) fprintf(FrFOut,
            "FrFileIOpen: input data from string");} 
 
      /*---------- read the first bytes to determine the format --*/
      
 i = FrRead(file, (char *) &format, 1);
 if(i != 1)  
     {FrError(3,"FrFileIOpen"," Cannot read first byte");
      file->error = FR_ERROR_READ_ERROR;
      return;}
 
 if(format != 'I')	 
      {if(FrDebugLvl > 0) 
           fprintf(FrFOut,"    unknown format: %d\n",format);
       FrError(3,"FrOFileOpen","unknown format"); 
       file->error = FR_ERROR_OPEN_ERROR;
       return;}
 
      /*-------- read header ----------------------------*/

 if(FrRead(file, (char *) file->header+1, 39) != 39)  
      {FrError(3,"FrOFileOpen","read failled"); 
       file->error = FR_ERROR_READ_ERROR;
       return;}

 file->fmtVersion = file->header[5];
   
       /*------------------ Check byte swaping and word lenght-------------*/

 FrFileHeader(l);
 l[9] = FrSlong;   /*-- Remarks: we may be on a 4 bytes long computer-------*/

 h = file->header;
 h[0] = format;
 if(FrDebugLvl > 0)
       {fprintf(FrFOut," Header(local): Originator:%.5s(%.5s)",h,l);
        fprintf(FrFOut," Format version:%d(%d)",h[5],l[5]);
        fprintf(FrFOut," Library version:%d(%d)\n",h[6],l[6]);
        fprintf(FrFOut,
          "  Sizeof: s:%d(%d) i:%d(%d) l:%d(%d) f:%d(%d) d:%d(%d)\n",
              h[7],l[7],h[8],l[8],h[9],l[9],h[10],l[10],h[11],l[11]);
        fprintf(FrFOut,
          "  SwapS:%3x%2x(%2x%2x)  \n",
              h[12],h[13],l[12],l[13]);
        fprintf(FrFOut,
          "  SwapI:%3x%2x%2x%2x(%2x%2x%2x%2x)\n",
              h[14],h[15],h[16],h[17],
              l[14],l[15],l[16],l[17]);
        fprintf(FrFOut,
          "  SwapL:%3x%2x%2x%2x%2x%2x%2x%2x(%2x%2x%2x%2x%2x%2x%2x%2x)\n",
              h[18],h[19],h[20],h[21],h[22],h[23],h[24],h[25],
              l[18],l[19],l[20],l[21],l[22],l[23],l[24],l[25]);
        fprintf(FrFOut,"  FPi:%3x%2x%2x%2x(%2x%2x%2x%2x)\n",
              h[26],h[27],h[28],h[29],
              l[26],l[27],l[28],l[29]);
        fprintf(FrFOut,"  DPi:%3x%2x%2x%2x%2x%2x%2x%2x"
                            "(%2x%2x%2x%2x%2x%2x%2x%2x)\n",
              h[30],h[31],h[32],h[33],h[34],h[35],h[36],h[37],
              l[30],l[31],l[32],l[33],l[34],l[35],l[36],l[37]);}

 file->fmType = FRNATIVE;
 file->fmLong = FRNATIVE;
 if(memcmp(&h[7],&l[7],19) == 0)               
     {if(FrDebugLvl > 0) fprintf(FrFOut," No format conversion is needed\n");}
 else{if(FrDebugLvl > 0) fprintf(FrFOut," Format conversion is needed\n");
      if(h[12] == l[13])
         {file->fmType = FRSWAP;
          file->fmLong = FRSWAP;
          if(FrDebugLvl > 0) fprintf(FrFOut," We will swap bytes\n");}
      if(FrSlong == 8 && h[9] == 4) 
         {if(file->fmLong == FRSWAP) 
              {file->fmLong = FREXPAND_AND_SWAP;}
          else{file->fmLong = FREXPAND;}
          if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 4 bytes word to 8 bytes\n");}
      if(FrSlong == 4 && h[9] == 8) 
         {if(file->fmLong == FRSWAP) 
              {file->fmLong = FRCONTRACT_AND_SWAP;}
          else{file->fmLong = FRCONTRACT;}
          if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 8 bytes word to 4 bytes\n");}
      if(file->fmLong == FRNATIVE) 
        {if(FrDebugLvl > 0) fprintf(FrFOut," Strange format\n");
         FrError(3,"FrOFileOpen","Strange format");}
     }

 return;}

/*---------------------------------------------------------- FrFileIRewind---*/
FrFile *FrFileIRewind(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{
  if(iFile == NULL) return(NULL);
  
  FrFileIClose(iFile);             /*----------------- Close the old file ---*/

  iFile->current = iFile->fileH;   /*---- Set the pointer to the first file -*/

  FrFileIOpen(iFile);              /*----------------------- Open it again---*/

  return(iFile);
}

/*------------------------------------------------------------FrFileITStart--*/
double FrFileITStart(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{FrFileH *fileH;
 double tStart;

 if(iFile == NULL) return(-1.);

           /*----These 2 calls scan the file to extract each start/end time--*/
 
 if(iFile->fileH->next != NULL) FrFileIRewind(iFile);
 FrTOCFrameFindT(iFile, 1.e10);

            /*------------------------------------Loop on all file Heeader --*/
 
 tStart = 1.e+30;           

 for(fileH= iFile->fileH; fileH != NULL; fileH = fileH->next)
   {if(fileH->tStart < tStart) tStart = fileH->tStart;}
    
 return(tStart);}

/*--------------------------------------------------------------FrFileITEnd--*/
double FrFileITEnd(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{FrFileH *fileH;
 double tEnd, fEnd;

 if(iFile == NULL) return(-1.);

          /*----These 2 calls scan the file to extract each start/end time--*/
 
 if(iFile->fileH->next != NULL) FrFileIRewind(iFile);
 FrTOCFrameFindT(iFile, 1.e10);

           /*------------------------------------Loop on all file Heeader --*/

 tEnd = 0.;  

 for(fileH= iFile->fileH; fileH != NULL; fileH = fileH->next)
   {fEnd = fileH->tStart + fileH->length;
   if(fEnd > tEnd) tEnd = fEnd;}

 return(tEnd);}

/*---------------------------------------------------- FrFileOEnd ----*/
int FrFileOEnd(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{long nBytes;
 
  if(oFile == NULL) return(0);

  FrTOCWrite(oFile);
    
  FrEndOfFileWrite(oFile);

  if(oFile->frfd != NULL) {FrIOClose(oFile->frfd);}

  if(oFile->inMemory == FR_NO) free(oFile->buf);

  nBytes = oFile->nBytes;

  FrFileFree(oFile);
 
  return(nBytes);}

/*-------------------------------------------------- FrFileONew -----*/
struct FrFile *FrFileONew(char  *fileName, 
                          int  compress)
/*--------------------------------------------------------------------*/
{struct FrFile *oFile;
 char  *outBuf; 
 int  bufSize;
 
      /*-- first create structure ------*/

 bufSize = 200000;
 outBuf = malloc(bufSize);
 if(outBuf == NULL) return(NULL);
 
 oFile = FrFileNew(fileName, compress, outBuf, bufSize);
 if(oFile == NULL) return(NULL);

     /*----- initialized output file ------*/      

 oFile->frfd = FrIOOpenW(oFile->current->fileName);
 if(oFile->frfd == NULL) 
      {FrError(3,"FrFileONew"," Open file error");
       oFile->error = FR_ERROR_OPEN_ERROR;
       return(NULL);}

    /*---- first write file header ----*/
	 
 FrFileOOpen(oFile);
   
 return(oFile);}

/*-------------------------------------------------------------FrFileONewFd--*/
FrFile *FrFileONewFd(FrIO *frfd, 
                     int compress)
/*---------------------------------------------------------------------------*/
{FrFile *oFile;
 char  *outBuf; 
 int  bufSize;
 
      /*-- first create structure ------*/

 bufSize = 200000;
 outBuf = malloc(bufSize);
 if(outBuf == NULL) return(NULL);

      /*-- first create structure ------*/
      
 oFile = FrFileNew("open_with_fd", compress, outBuf, bufSize);
 if(oFile == NULL) return(NULL);

     /*----- initialized output file ------*/      

 oFile->frfd = frfd;
 if(oFile->frfd == NULL) 
           {FrError(3,"FrFileONewFd"," Open file error");
            oFile->error = FR_ERROR_OPEN_ERROR;
            return(NULL);}

    /*---- first write file header ----*/
	 
 FrFileOOpen(oFile);
 
 return(oFile);}
/*--------------------------------------------------------------FrFileONewH--*/
FrFile *FrFileONewH(char *fileName, 
                    int   compress,
                    char *program)
/*---------------------------------------------------------------------------*/
{FrFile *oFile;

 oFile = FrFileONew(fileName, compress);
 if(oFile == NULL) return(NULL);

 if(program != NULL) {
    free(oFile->historyMsg);
    sprintf(FrBuf,"FrameLib:%s %s",FrVersion,program);
    if(FrStrCpy(&oFile->historyMsg,  FrBuf) == NULL) return (NULL);}

 return(oFile);}

/*------------------------------------------------------------FrFileONewFdH--*/
FrFile *FrFileONewFdH(FrIO *frfd, 
                      int   compress,
                      char  *program)
/*---------------------------------------------------------------------------*/
{FrFile *oFile;

 oFile = FrFileONewFd(frfd, compress);
 if(oFile == NULL) return(NULL);

 if(program != NULL) {
    free(oFile->historyMsg);
    sprintf(FrBuf,"FrameLib:%s %s",FrVersion,program);
    if(FrStrCpy(&oFile->historyMsg,  FrBuf) == NULL) return (NULL);}

 return(oFile);}

/*--------------------------------------------------------------FrFileOOpen--*/
void FrFileOOpen(FrFile *oFile)
/*---------------------------------------------------------------------------*/
{char buf[40];
 FrSH *classe;
 
    /*---- write the file header ----*/
	 
  FrFileHeader((unsigned char*) buf);
     
  if(oFile->inMemory == FR_YES)
          {memcpy(oFile->p, buf, 40);}
  else {if(FrIOWrite(oFile->frfd, buf, 40) != 40) 
                 {FrError(3,"FrOFileIni"," write error");
                  oFile->error = FR_ERROR_WRITE_ERROR;
                  return;}}
  oFile->p += 40;
  oFile->nBytes = 40;

  if(oFile->chkSumFlag == FR_YES)
    {oFile->chkSum = FrChkSum((FRSCHAR*)buf, 40, 0);}

     /*---- we do not write here the minimal dictionnary -----*/

  classe = FrSHDef();
  oFile->dicWrite[classe->id] = FR_YES;	 
  classe = FrSEDef();
  oFile->dicWrite[classe->id] = FR_YES;
   
  return;}

/*----------------------------------------------------FrFileORealloc--*/
int FrFileORealloc(struct FrFile *oFile, char *name, int size)
/*--------------------------------------------------------------------*/
{int offset1, offset2;

 if(oFile->inMemory == FR_YES)
    {FrError(3,name,"Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return(1);} 

 if(FrDebugLvl > 2) printf("FrFileORealloc for %s size=%d\n",name,size);
 offset1 = oFile->p      - oFile->buf;
 offset2 = oFile->pStart - oFile->buf;

 oFile->buf = realloc(oFile->buf, oFile->bufSize + size);
 if(oFile->buf == NULL)
    {FrError(3,name,"Output File buffer overflow (realloc failed)");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return(2);} 
   
 oFile->bufSize += size;
 oFile->p      = oFile->buf + offset1;
 oFile->pStart = oFile->buf + offset2;
 oFile->pMax   = oFile->buf + oFile->bufSize;
 
 return(0);}

/*------------------------------------------------------FrFileOSetGzipLevel--*/
void FrFileOSetGzipLevel(FrFile *oFile, unsigned short level)
/*---------------------------------------------------------------------------*/
{
 if(oFile != NULL) {oFile->gzipLevel = level;}

 return;}

/*------------------------------------------------------------FrFileOSetMsg--*/
void FrFileOSetMsg(FrFile *oFile, char *msg)
/*---------------------------------------------------------------------------*/
{
 if(oFile == NULL) return;

 free(oFile->historyMsg);
 oFile->historyMsg = NULL;

 if(msg != NULL) {
    sprintf(FrBuf,"FrameLib:%s %s",FrVersion,msg);
    FrStrCpy(&oFile->historyMsg,  FrBuf);}

 return;}

/*-------------------------------------------------------------FrHistoryAdd--*/
FrHistory *FrHistoryAdd(FrameH *frame, 
                        char *comment)
/*---------------------------------------------------------------------------*/
{struct FrHistory *history;
 char name[10];
 int i;
 
  history = (struct FrHistory *) calloc(1,sizeof(struct FrHistory));
  if(history == NULL)  
       {return(NULL);}
  else {history->classe = FrHistoryDef();}
 
  history->time = time(NULL) - FRGPSOFF + FRGPSLEAPS;

  if(FrStrCpy(&history->comment, comment) == NULL) return(NULL);
   
  i = 1;
  if(frame != NULL) 
      {if(frame->history != NULL)
	{sscanf(frame->history->name,"%d",&i);}}
         
  sprintf(name,"%d",i+1);
  if(FrStrCpy(&history->name,name) == NULL) return(NULL);
         
     /*----- now store it in the Frame structure -----*/

  if(frame != NULL)
    {history->next = frame->history;
     frame->history = history;}

 return(history);}

/*-------------------------------------------------- FrHistoryDef ----*/
struct FrSH *FrHistoryDef()    
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrHistory",FrHistoryRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4U", "time","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "PTR_STRUCT(FrHistory *)", "next","-");

  return(classe);}
 
/*--------------------------------------------------FrHistoryFree-----*/
FrHistory *FrHistoryFree(FrHistory *history)
/*--------------------------------------------------------------------*/
{struct FrHistory *next;

 if (history==NULL) return(NULL);

 next = history->next;

 if (history->comment != NULL) free(history->comment);
 free(history->name);
 free(history);

 return(next);}

/*--------------------------------------------------- FrHistoryRead---*/
void FrHistoryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrHistory *history;

  history = (struct FrHistory *) calloc(1,sizeof(struct FrHistory));
  if(history == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {history->classe = FrHistoryDef();}
  
  FrReadHeader(iFile,  history);
  FrReadSChar (iFile, &history->name); 
  FrReadIntU  (iFile, &history->time);
  FrReadSChar (iFile, &history->comment);
  FrReadStruct(iFile, &history->next);
   
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", history->name);

return;}

/*------------------------------------------------- FrHistoryWrite---*/
void FrHistoryWrite(struct FrHistory *history, 
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

  FrPutNewRecord(oFile, history, FR_YES);
  FrPutSChar (oFile, history->name);
  FrPutIntU  (oFile, history->time);
  FrPutSChar (oFile, history->comment);
  FrPutStruct(oFile, history->next);
  FrPutWriteRecord(oFile);

  if(history->next != NULL)  {FrHistoryWrite(history->next, oFile);}

  return;}

/*-------------------------------------------------FrMsgAdd ----------*/
struct FrMsg *FrMsgAdd(struct FrameH *frame, 
                       char *alarm,
                       char *message, 
                       unsigned int severity)
/* This function returns NULL in case of errors                       */
/*--------------------------------------------------------------------*/
{struct FrRawData *rawData;
 struct FrMsg *msg;
 
    /*--- first create and fill the structure ---*/

  msg = (struct FrMsg *) calloc(1,sizeof(struct FrMsg));
  if(msg == NULL)  
       {FrError(3,"FrMsgAdd","malloc failed");
        return(NULL);}
  else {msg->classe = FrMsgDef();}
	 
  if(FrStrCpy(&msg->message,message) == NULL) 
       {FrError(3,"FrMsgAdd","malloc failed");
        return(NULL);}
  msg->severity = severity;

  if(FrStrCpy(&msg->alarm, alarm) == NULL)
       {FrError(3,"FrMsgAdd","Cannot malloc alarm name");
        return(NULL);}
  
   /*--- then store it -----*/

  if(frame->rawData == NULL) {FrRawDataNew(frame);}
  rawData = frame->rawData;
  if(rawData == NULL) 
       {FrError(3,"FrMsgAdd","Cannot create FrRawData");
        return(NULL);}
     
  msg->next = rawData->logMsg;
  rawData->logMsg = msg;
  
  return(msg);} 

/*------------------------------------------------------ FrMsgDef ----*/
struct FrSH *FrMsgDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrMsg",FrMsgRead);

  FrSENew(classe, "STRING", "alarm","-");
  FrSENew(classe, "STRING", "message","-");
  FrSENew(classe, "INT_4U", "severity","-");
  FrSENew(classe, "PTR_STRUCT(FrMsg *)", "next","-");

  return(classe);}

/*------------------------------------------------------------- FrMsgDump---*/
void FrMsgDump(FrMsg *msg,
               FILE *fp, 
               int debugLvl)
/*--------------------------------------------------------------------------*/
{
 if(msg->alarm   != NULL) fprintf(fp," Alarm: %s ", msg->alarm);
 if(msg->message != NULL) fprintf(fp,"Message:%s ", msg->message);

 fprintf(fp,"Severity=%d\n", msg->severity);

 return;}

/*------------------------------------------------------FrMsgFree-----*/
void FrMsgFree(struct FrMsg *msg)
/*--------------------------------------------------------------------*/
{ 

 if(msg == NULL) return;

 if(msg->next != NULL) FrMsgFree(msg->next);

 if(msg->alarm   != NULL) free (msg->alarm);
 if(msg->message != NULL) free (msg->message);
 free(msg);

 return;}

/*------------------------------------------------------- FrMsgRead---*/
void FrMsgRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrMsg *msg;

  msg = (struct FrMsg *) calloc(1,sizeof(struct FrMsg));
  if(msg == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {msg->classe = FrMsgDef();}

  FrReadHeader(iFile,  msg);
  FrReadSChar (iFile, &msg->alarm); 
  FrReadSChar (iFile, &msg->message);
  FrReadIntU  (iFile, &msg->severity);
  FrReadStruct(iFile, &msg->next);
    
  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", msg->alarm);

return;}

 /*---------------------------------------------------- FrMsgWrite---*/
void FrMsgWrite(struct FrMsg *msg,
                struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, msg, FR_YES);
  FrPutSChar (oFile, msg->alarm);
  FrPutSChar (oFile, msg->message);
  FrPutIntU  (oFile, msg->severity);
  FrPutStruct(oFile, msg->next);
  FrPutWriteRecord(oFile);
    
 return;}
 
/*--------------------------------------------------- FrObjectDef ----*/
struct FrSH *FrObjectDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrObject",NULL);

  return(classe);}

/*--------------------------------------------------------FrPutChar---*/
void FrPutChar(struct FrFile *oFile,
               char value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+1 > oFile->pMax) 
      {if(FrFileORealloc(oFile, "FrPutChar", 50) != 0) return;}

 *oFile->p++ = value;
    
 return;}
/*-------------------------------------------------------FrPutDouble--*/
void FrPutDouble(struct FrFile *oFile,
                 double value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSdouble > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutDouble", 50) != 0) return;}

 memcpy(oFile->p, &value, FrSdouble); 
 oFile->p += FrSdouble;
    
 return;}

/*---------------------------------------------------------FrPutFloat-*/
void FrPutFloat(struct FrFile *oFile,
                float value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
  
 if(oFile->p+FrSfloat > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutFloat", 50) != 0) return;}

 memcpy(oFile->p, &value, FrSfloat);
 oFile->p += FrSfloat;
     
 return;}

/*--------------------------------------------------------FrPutInt----*/
void FrPutInt(struct FrFile *oFile,
              int value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
 
 if(oFile->p+FrSint > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutInt", 50) != 0) return;}
   
 memcpy(oFile->p, &value, FrSint);
 oFile->p += FrSint;
     
 return;}

/*--------------------------------------------------------FrPutIntU---*/
void FrPutIntU(struct FrFile *oFile,
               unsigned int value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
 
 if(oFile->p+FrSint > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutIntU", 50) != 0) return;}

 memcpy(oFile->p, &value, FrSint);
 oFile->p += FrSint;
     
 return;}

/*-----------------------------------------------------------------FrPutLong--*/
void FrPutLong(FrFile *oFile,
               FRLONG value)
/*----------------------------------------------------------------------------*/
{short ref;
 char *swap;
 FRLONG dummy;

 if(oFile->error != FR_OK) return;

 if(oFile->p+8 > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutLong", 50) != 0) return;}
 
 if(FrSlong == 8)   
   {memcpy(oFile->p, &value, FrSlong);}

       /*--- for computer with 4 bytes long, add 4 more bytes. 
                   There location depends of the bytes ordering---------------*/
 else
   {swap = (char *)&ref;
    ref = 0x1234;
    dummy = 0;
    if(swap[0] == 0x12) memcpy(oFile->p, &dummy, FrSlong);
    memcpy(oFile->p, &value, FrSlong);
    if(swap[0] == 0x34) memcpy(oFile->p, &dummy, FrSlong);}

 oFile->p += 8;
 
 return;}
 
/*---------------------------------------------------FrPutNewRecord---*/
void FrPutNewRecord(struct FrFile *oFile,
                    void *instance,
                    FRBOOL withInstanceId)
/*--------------------------------------------------------------------*/
{short id, type;
 struct FrObject *proto; 
 
 if(oFile->error != FR_OK) return;

 proto = instance;
 if(proto == NULL) {FrError(3,"FrPutNewRecord","instance == NULL");}
 if(proto->classe == NULL) {FrError(3,"FrPutNewRecord","classe == NULL");}

 if(oFile->dicWrite[proto->classe->id] == FR_NO) 
   {oFile->dicWrite[proto->classe->id] = FR_YES; 
    FrSHWrite(proto->classe, oFile);}  
    
 if(oFile->inMemory == FR_NO) {oFile->p = oFile->buf;} 

 oFile->pStart = oFile->p;

 if(oFile->p+2*FrSshort+FrSint > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutNewRecord", 50) != 0) return;}

 oFile->p +=FrSint;

 type = (short) proto->classe->id;
 memcpy(oFile->p, &type, FrSshort);
 oFile->p += FrSshort;

 if(withInstanceId == FR_YES)
      {id = FrDicGetId(oFile, type, instance);}
 else {id = 0;}
 memcpy(oFile->p, &id, FrSshort);
 oFile->p += FrSshort;
     
 return;}
 
/*--------------------------------------------------FrPutStruct-------*/
void FrPutStruct(struct FrFile *oFile,
                 void *address)
/*--------------------------------------------------------------------*/
{short id;
 struct FrObject *example;
 struct FrSH *type;
       
 if(oFile->error != FR_OK) return;

 if(oFile->p+50 > oFile->pMax) 
   {if(FrFileORealloc(oFile, "FrPutStruct", 50) != 0) return;}
    
 if(address == NULL)
   {id = 0; 
    memcpy(oFile->p, &id, FrSshort); 
    oFile->p += FrSshort; 
    memcpy(oFile->p, &id, FrSshort); 
    oFile->p += FrSshort;

    return;}

   /* we assume that the first element of 
    the structure is a name like in FrProto */
    
 example = address;
 type = example->classe;
 if(type == NULL) {FrError(3,"FrPutStruct","classe == NULL");}
       
 id = type->id; 
 memcpy(oFile->p, &id, FrSshort); 
 oFile->p += FrSshort; 

 id = FrDicAssignId(oFile, type->id, address);                
 memcpy(oFile->p, &id, FrSshort); 
 oFile->p += FrSshort;

 return;}

/*--------------------------------------------------------FrPutShort--*/
void FrPutShort(struct FrFile *oFile,
                short value)
/*--------------------------------------------------------------------*/
{   
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSshort > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutShort", FrSshort) != 0) return;}

 memcpy(oFile->p, &value, FrSshort);
 oFile->p += FrSshort;
     
 return;}

/*--------------------------------------------------------FrPutShortU-*/
void FrPutShortU(struct FrFile *oFile,
                 unsigned short value)
/*--------------------------------------------------------------------*/
{   
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSshort > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutShortU", FrSshort) != 0) return;}
 
 memcpy(oFile->p, &value, FrSshort);
 oFile->p += FrSshort;
    
 return;}

/*--------------------------------------------------------FrPutSChar--*/
void FrPutSChar(struct FrFile *oFile,
                char *value)
/*--------------------------------------------------------------------*/
{short slen;
 char *empty="";

 if(oFile->error != FR_OK) return;

 if(value == NULL) 
   {value = empty;}

 slen = strlen(value)+1;
 FrPutShort(oFile,slen);

 if(slen != 0) 
    {if(oFile->p+slen > oFile->pMax) 
       {if(FrFileORealloc(oFile, "FrPutSChar", slen) != 0) return;}

     memcpy(oFile->p, value, slen);
     oFile->p += slen;}
 
 return;}

  
/*-----------------------------------------------------------FrPutVC--*/
void FrPutVC(struct FrFile *oFile,
             char *data,
             int nData)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+nData > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutVC", nData) != 0) return;}
  
 memcpy(oFile->p, data, nData);
 oFile->p += nData;

 return;}

/*-----------------------------------------------------------FrPutVD--*/
void FrPutVD(struct FrFile *oFile, 
             double *data, 
             int nData)
/*--------------------------------------------------------------------*/
{int size;
	
 if(oFile->error != FR_OK) return;

 size = FrSdouble*nData;
 if(oFile->p+size > oFile->pMax) 
   {if(FrFileORealloc(oFile, "FrPutVD", size) != 0) return;}
   
 memcpy(oFile->p, data, size);
 oFile->p += size;

 return;}

/*-----------------------------------------------------------FrPutVF--*/
void FrPutVF(struct FrFile *oFile, 
             float *data, 
             int nData)
/*--------------------------------------------------------------------*/
{int size;

 if(oFile->error != FR_OK) return;

 size = FrSfloat*nData;
 if(oFile->p+size > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutVF", size) != 0) return;}

 memcpy(oFile->p, data, size);
 oFile->p += size;
	
 return;}

/*-------------------------------------------------------------------FrPutVI--*/
void FrPutVI(FrFile *oFile, 
             int *data, 
             int nData)
/*----------------------------------------------------------------------------*/
{int size;

 if(oFile->error != FR_OK) return;

 size = FrSint*nData;
 if(oFile->p+size > oFile->pMax) 
     {if(FrFileORealloc(oFile, "FrPutVI", size) != 0) return;}

 memcpy(oFile->p, data, size);
 oFile->p += size;
	
 return;}

/*-------------------------------------------------------------------FrPutVL--*/
void FrPutVL(FrFile *oFile, 
             FRLONG *data, 
             int nData)
/*----------------------------------------------------------------------------*/
{short ref;
 char *swap;
 int size, i, j;
 FRLONG dummy[2];

 if(oFile->error != FR_OK) return;

 size = 8*nData;
 if(oFile->p+size > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutVL", size) != 0) return;}

 if(FrSlong == 8)   
   {memcpy(oFile->p, data, size);
    oFile->p += size;}

       /*--- for computer with 4 bytes long, add 4 more bytes. 
                   There location depends of the bytes ordering---------------*/
 else
   {swap = (char *)&ref;
    ref = 0x1234;
    if(swap[0] == 0x12)  
         j = 1;
    else j = 0; 
 
    dummy[0] = 0;
    dummy[1] = 0;

    for(i=0; i<nData; i++)
      {dummy[j] = data[i];
       memcpy(oFile->p, dummy, 8);
       oFile->p += 8;}}
	
 return;}
/*-------------------------------------------------------------------FrPutVQ--*/
void FrPutVQ(FrFile *oFile, 
             char **data, 
             int nData)
/*----------------------------------------------------------------------------*/
{int i;

 for(i=0; i<nData; i++)
    {FrPutSChar(oFile, data[i]);}

 return;}

/*-------------------------------------------------------------------FrPutVS--*/
void FrPutVS(FrFile *oFile, 
             short *data, 
             int nData)
/*----------------------------------------------------------------------------*/
{int size;

 if(oFile->error != FR_OK) return;

 size = FrSshort*nData;
 if(oFile->p+size > oFile->pMax) 
    {if(FrFileORealloc(oFile, "FrPutVS", size) != 0) return;}

 memcpy(oFile->p, data, size);
 oFile->p += size;		
	
 return;}

/*--------------------------------------------------FrPutWriteRecord--*/
void FrPutWriteRecord(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{int len;

 if(oFile->error != FR_OK) return;

 len = (int) (oFile->p - oFile->pStart); 
 memcpy(oFile->pStart, &len, FrSint);

 if(oFile->inMemory == FR_NO) 
    {if(FrIOWrite(oFile->frfd,oFile->pStart, len) != len) 
            {FrError(3,"FrPutWriteRecord"," write error");
             oFile->error = FR_ERROR_WRITE_ERROR;}}

 if(oFile->chkSumFlag == FR_YES)
   {oFile->chkSum += FrChkSum((FRSCHAR*)oFile->pStart,len, oFile->nBytes);}
 oFile->nBytes += len;

 return;}

/*-------------------------------------------------- FrRawDataDef ----*/
struct FrSH *FrRawDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrRawData",FrRawDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "PTR_STRUCT(FrSerData *)", "firstSer","-");
  FrSENew(classe, "PTR_STRUCT(FrAdcData *)", "firstAdc","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)", "firstTable","-");
  FrSENew(classe, "PTR_STRUCT(FrMsg *)", "logMsg","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "more","-");

  return(classe);}

/*--------------------------------------------------------- FrRawDataDump---*/
void FrRawDataDump(FrRawData *rawData, 
                   FILE *fp, 
                   int debugLvl)
/*--------------------------------------------------------------------------*/
{FrAdcData *adcData;
 FrMsg     *msg;
 FrSerData *smsData;
 FrTable   *table;

 if(fp      == NULL) return;
 if(rawData == NULL) return;
 if(debugLvl < 1)    return;

 fprintf(fp,"Dump Raw data:\n");

           /*------------------------- dump logMsg data ---------------------*/

 for(msg = rawData->logMsg; msg != NULL; msg = msg->next )
    {FrMsgDump(msg, fp, debugLvl);}

           /*--------------------------- dump adc data ----------------------*/

 for(adcData = rawData->firstAdc; adcData != NULL; adcData = adcData->next) 
    {FrAdcDataDump( adcData, fp, debugLvl);}

            /*---------------------- dump Slow monitoring data --------------*/

 for(smsData = rawData->firstSer; smsData != NULL; smsData = smsData->next) 
    {FrSerDataDump(smsData, fp, debugLvl);}

           /*------------------------------- dump tables data ---------------*/

 for(table = rawData->firstTable; table != NULL; table = table->next) 
    {FrTableDump(table, fp, debugLvl);}

 return;}
  
/*------------------------------------------------------------FrRawDataFree--*/
void FrRawDataFree(FrRawData *rawData)
/*---------------------------------------------------------------------------*/
{
 if(rawData->name     != NULL) free(rawData->name);
 if(rawData->firstSer != NULL) FrSerDataFree(rawData->firstSer);

 if(rawData->firstAdcOld != NULL) FrRawDataUntagAdc(rawData);
 if(rawData->firstSerOld != NULL) FrRawDataUntagSer(rawData);

 if(rawData->firstAdc   != NULL) FrAdcDataFree(rawData->firstAdc);
 if(rawData->firstTable != NULL) FrTableFree  (rawData->firstTable);
 if(rawData->logMsg     != NULL) FrMsgFree    (rawData->logMsg);
 if(rawData->more       != NULL) FrVectFree   (rawData->more);

 free(rawData);

 return;}

/*------------------------------------------------------------FrRawDataNew--*/
struct FrRawData *FrRawDataNew(struct FrameH *frame)
/*--------------------------------------------------------------------------*/
{struct FrRawData *rawData;
  
 rawData = (struct FrRawData *) calloc(1,sizeof(struct FrRawData));
 if(rawData == NULL)  
      {FrError(3,"FrRawData","malloc failed");
       return(NULL);}
 else {rawData->classe = FrRawDataDef();}

 FrStrCpy(&rawData->name,"rawData");
 rawData->firstAdcOld = NULL;
  
 if(frame != NULL) {frame->rawData = rawData;}
  
 return(rawData);}

/*-----------------------------------------------------------FrRawDataRead--*/
void FrRawDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrRawData *rawData;

 rawData = (struct FrRawData *) calloc(1,sizeof(struct FrRawData));
 if(rawData == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {rawData->classe = FrRawDataDef();}
  
 FrReadHeader(iFile,  rawData);
 FrReadSChar (iFile, &rawData->name); 
 FrReadStruct(iFile, &rawData->firstSer);
 FrReadStruct(iFile, &rawData->firstAdc);
 FrReadStruct(iFile, &rawData->firstTable);
 FrReadStruct(iFile, &rawData->logMsg);
 FrReadStruct(iFile, &rawData->more);
  
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", rawData->name);

 return;}
  
/*-------------------------------------------------------FrRawDataUntagAdc---*/
void FrRawDataUntagAdc(FrRawData *rawData)
/*---------------------------------------------------------------------------*/
{
 if(rawData == NULL) return;
 if(rawData->firstAdcOld == NULL) return;

 FrameUntagBasic((FrBasic **)&rawData->firstAdc, 
                 (FrBasic **)&rawData->firstAdcOld);

 return;}
/*-------------------------------------------------------FrRawDataUntagSer---*/
void FrRawDataUntagSer(FrRawData *rawData)
/*---------------------------------------------------------------------------*/
{
 if(rawData == NULL) return;
 if(rawData->firstSerOld == NULL) return;

 FrameUntagBasic((FrBasic **)&rawData->firstSer, 
                 (FrBasic **)&rawData->firstSerOld);

 return;}

/*----------------------------------------------------------FrRawDataWrite--*/
void FrRawDataWrite(struct FrRawData *rawData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 struct FrSerData *serData;
 struct FrMsg     *logMsg;

	    /*-------------------first write rawData struct-----------------*/
 
 FrPutNewRecord(oFile, rawData, FR_YES);
 FrPutSChar (oFile, rawData->name);
 FrPutStruct(oFile, rawData->firstSer);
 FrPutStruct(oFile, rawData->firstAdc);
 FrPutStruct(oFile, rawData->firstTable);
 FrPutStruct(oFile, rawData->logMsg);
 FrPutStruct(oFile, rawData->more);
 FrPutWriteRecord(oFile);   
 
          /*-----------------then write adc data struct--------------------*/

 if((rawData->firstAdc != NULL) && (oFile->toc != NULL))
   {oFile->toc->nFirstADC[oFile->toc->nFrame] = oFile->nBytes;}

 adcData = rawData->firstAdc;
 while(adcData != NULL) 
    {FrAdcDataWrite(adcData, oFile);
     adcData = adcData->next;}
    
           /*------------write the slow monitoring station stuff------------*/
 
 if((rawData->firstSer != NULL) && (oFile->toc != NULL))
   {oFile->toc->nFirstSer[oFile->toc->nFrame] = oFile->nBytes;}

 serData = rawData->firstSer;
 while(serData != NULL) 
    {FrSerDataWrite(serData, oFile);
     serData = serData->next;}


 if(rawData->firstTable != NULL) 
   {if(oFile->toc != NULL)
       oFile->toc->nFirstTable[oFile->toc->nFrame] = oFile->nBytes;
    FrTableWrite(rawData->firstTable, oFile);}
    
          /*---------------------write error messages-----------------------*/

 if((rawData->logMsg != NULL) && (oFile->toc != NULL))
   {oFile->toc->nFirstMsg[oFile->toc->nFrame] = oFile->nBytes;}

 logMsg = rawData->logMsg;
 while(logMsg != NULL) 
    {FrMsgWrite(logMsg, oFile);
     logMsg = logMsg->next;}

          /*-----------------finally write aditional data-------------------*/
   
 if(rawData->more != NULL) {FrVectWrite(rawData->more, oFile);}

 return;}

/*------------------------------------------------------------------FrRead--*/
int FrRead(struct FrFile *iFile,
           char *buf,
           unsigned int n)
/*--------------------------------------------------------------------------*/
{int i,nb;

 if(iFile->inMemory == FR_NO) 
     {i = 0;
      do{nb = FrIORead(iFile->frfd, buf+i, n-i);
         i += nb;
        }while(nb>0 && i<n);
      }
       /*------ the previous logic is complicate since a read may 
        need several calls to deliver all the requested bytes -------*/
         
 else{memcpy(buf,iFile->p,n);
      iFile->p += n;
      i = n;
      if(iFile->p > iFile->pMax) 
         {i = i - (iFile->p - iFile->pMax);}}

      /*----------------- compute checksum if requested--------------*/

 if(iFile->chkSumFlag == FR_YES)
   {iFile->chkSum += FrChkSum((FRSCHAR*)buf, i, iFile->nBytes);
    iFile->nBytes += i;}

 return(i);}  

/*-----------------------------------------------------FrReadDouble---*/
void FrReadDouble(struct FrFile *iFile, 
                  double *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[8];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSdouble);}
  else 
       {i = FrRead(iFile,(char *) local,FrSdouble);
        buf = (unsigned char *) value;
        buf[0] = local[7];
        buf[1] = local[6];
        buf[2] = local[5];
        buf[3] = local[4];
        buf[4] = local[3];
        buf[5] = local[2];
        buf[6] = local[1];
        buf[7] = local[0];}

  if(i == 0) 
    {FrError(3,"FrReadDouble","end of file");
     iFile->error = FR_ERROR_READ_ERROR;}

  return;}

/*-----------------------------------------------------FrReadFloat----*/
void FrReadFloat(struct FrFile *iFile,
                 float *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char local[4], *buf;

  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile, (char *) value, FrSfloat);}
  else 
       {i = FrRead(iFile,(char *) local,FrSfloat);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}
        
  if(i == 0) 
    {FrError(3,"FrReadFloat","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-----------------------------------------------------FrReadHeader---*/
void FrReadHeader(struct FrFile *iFile,
                  void *instance)
/*--------------------------------------------------------------------*/
{unsigned short id;

  FrReadShortU(iFile, &id);

  if(iFile->error == FR_OK)   {FrSetBAT(iFile, id, instance);}
  
  return;}
 
/*-------------------------------------------------------FrReadInt----*/
void FrReadInt(struct FrFile *iFile,
               int *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[4];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSint);}
  else 
       {i = FrRead(iFile,(char *) local,FrSint);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}

  if(i == 0) 
    {FrError(3,"FrReadInt","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-------------------------------------------------------FrReadInt----*/
void FrReadIntU(struct FrFile *iFile,
                unsigned int *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[4];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSint);}
  else 
       {i = FrRead(iFile,(char *) local,FrSint);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}

  if(i == 0) 
    {FrError(1,"FrReadIntU","End of file detected");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-------------------------------------------------------FrReadLong---*/
void FrReadLong(struct FrFile *iFile,
                FRLONG *value)
/*--------------------------------------------------------------------*/
{int i;
 FRLONG *localI;
 unsigned char *buf,local[8];
 
  if(iFile->error != FR_OK) {return;}
   
  if(iFile->fmLong == FRNATIVE)
       {i = FrRead(iFile, (char *) value, FrSlong);}
  else
    {buf = (unsigned char *) value;
     i = FrRead(iFile,(char *) local, iFile->header[9]);
     if((iFile->fmLong == FRSWAP) && (FrSlong == 8))
       {buf[7] = local[0];
        buf[6] = local[1];
        buf[5] = local[2];
        buf[4] = local[3];
        buf[3] = local[4];
        buf[2] = local[5];
        buf[1] = local[6];
        buf[0] = local[7];}
     else if((iFile->fmLong == FRSWAP) && (FrSlong == 4))
       {buf[3] = local[0];
        buf[2] = local[1];
        buf[1] = local[2];
        buf[0] = local[3];}
     else if(iFile->fmLong == FREXPAND)
       {buf[7] = 0;
        buf[6] = 0;
        buf[5] = 0;
        buf[4] = 0;
        buf[3] = local[3];
        buf[2] = local[2];
        buf[1] = local[1];
        buf[0] = local[0];}
     else if(iFile->fmLong == FREXPAND_AND_SWAP)
       {buf[7] = 0;
        buf[6] = 0;
        buf[5] = 0;
        buf[4] = 0;
        buf[3] = local[0];
        buf[2] = local[1];
        buf[1] = local[2];
        buf[0] = local[3];}
     else if(iFile->fmLong == FRCONTRACT)
       {localI = (FRLONG *) local;
        *value = 0;
        if(localI[0] == 0) 
             *value = localI[1];
        else *value = localI[0];}
     else if(iFile->fmLong == FRCONTRACT_AND_SWAP)
       {localI = (FRLONG *) local;
        if(localI[0] == 0) 
           {buf[0] = local[7];
            buf[1] = local[6];
            buf[2] = local[5];
            buf[3] = local[4];}
        else
           {buf[0] = local[3];
            buf[1] = local[2];
            buf[2] = local[1];
            buf[3] = local[0];}}
     else 
       {FrError(3,"FrReadLong","unknown type");}} 

  if(i != iFile->header[9]) 
    {FrError(3,"FrReadLong","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*----------------------------------------------------FrReadRecord----*/
void FrReadRecord(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{
      /*--- try to find a read function for this type of record------*/

 FrSHMatch(iFile);  

 if(iFile->sh[iFile->type]->objRead != FrReadRecord)
   {iFile->sh[iFile->type]->objRead(iFile);
    return;}

     /*----------- well, no match found, skip the record ------------*/

 if(FrDebugLvl > 0) fprintf(FrFOut,"    skip unknown structure. "
                    "type=%d size=%d\n",iFile->type,iFile->length);
 FrError(3,"FrReadRecord","unknown record");

 FrReadSkipRecord(iFile);
             
 return;}
 
/*-------------------------------------------------------FrReadSChar--*/
void FrReadSChar(struct FrFile *iFile,
                 char **value)
/*--------------------------------------------------------------------*/
{short slen;

  if(iFile->error != FR_OK) {return;}
 
  FrReadShort(iFile, &slen); 
  if(iFile->error != FR_OK) {return;}
  if(slen == 0)
    {*value = NULL;}
  else
    {*value = malloc(slen+1); 
     if(*value == NULL) 
        {FrError(3,"FrReadSChar","malloc failed"); 
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;} 
     if(slen != FrRead(iFile,(char *)  *value, slen)) 
        {FrError(3,"FrReadSChar","error reading string");
         iFile->error = FR_ERROR_READ_ERROR;
         return;}}

 return;}

/*-------------------------------------------------------FrReadShort---*/
void FrReadShort(struct FrFile *iFile,
                 short *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf, local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *)  value, FrSshort);}
 else 
       {i = FrRead(iFile,(char *) local, FrSshort);
        buf = (unsigned char *) value;
        buf[0] = local[1];
        buf[1] = local[0];}

 if(i == 0) 
    {FrError(3,"FrReadShort","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

 return;}

/*-------------------------------------------------------FrReadShortU--*/
void FrReadShortU(struct FrFile *iFile,
                  unsigned short *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf, local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *)  value, FrSshort);}
 else 
       {i = FrRead(iFile,(char *) local, FrSshort);
        buf = (unsigned char *) value;
        buf[0] = local[1];
        buf[1] = local[0];}

 if(i == 0) 
    {FrError(3,"FrReadShortU","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

 return;}
/*--------------------------------------------------FrReadSkipRecord--*/
void FrReadSkipRecord(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{unsigned int l1,l2;

 l1 = iFile->length-6;
 while(l1 > 0)
      {l2 = FrBufSize;
       if(l2 > l1) {l2 = l1;}
       if(l2 != FrRead(iFile, FrBuf,  l2)) break;
       l1 = l1-l2;}
            
 return;}
 
/*-------------------------------------------------------FrReadStruct-*/
void FrReadStruct(struct FrFile *iFile,
                  void *address)
/*--------------------------------------------------------------------*/
{unsigned short type, instance;

  if(iFile->error != FR_OK) {return;}
 
  FrReadShortU(iFile, &type); 
  FrReadShortU(iFile, &instance);

                           /* this is for backward compatibility (3.10)*/  
  if(type > 3000) {type = 0;} 

  if(iFile->error != FR_OK) {return;}
  if(type != 0) 
       FrSetBRT(iFile, instance, type, address); 
  else address = NULL;

  return;}
  
/*---------------------------------------------------------FrReadVC --*/
void FrReadVC(struct FrFile *iFile,
              char **data, 
              unsigned int nData)                
/*--------------------------------------------------------------------*/
{unsigned int nread;
 char *buf;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (char *) malloc(nData*sizeof(char));
 *data = buf;
 if(buf == NULL) 
        {FrError(3,"FrReadVC","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;} 
 
 nread = FrRead(iFile,(char *) buf, nData);
 if(nread != nData)
        {FrError(3,"FrReadVC","error reading bank");
         iFile->error = FR_ERROR_READ_ERROR;}
          
 return;}
 
/*---------------------------------------------------------FrReadVD --*/
void FrReadVD(struct FrFile *iFile,
              double **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i,nread;
 double *buf;
 unsigned char *swap,local[4];

 if(iFile->error != FR_OK) {return;}
 
 buf = (double *) malloc(nData*sizeof(double));
 *data = buf;
 if(buf == NULL) 
      {FrError(3,"FrReadVD","malloc failed");
       iFile->error = FR_ERROR_MALLOC_FAILED;
       return;} 
 
 nread = FrRead(iFile,(char *) buf, sizeof(double)*nData);
 if(nread != nData*sizeof(double))
      {FrError(3,"FrReadVD","error reading bank");
       iFile->error = FR_ERROR_READ_ERROR;
       return;} 
   
 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local[0] = swap[7];
           local[1] = swap[6];
           local[2] = swap[5];
           local[3] = swap[4];
           swap[7]  = swap[0];
           swap[6]  = swap[1];
           swap[5]  = swap[2];
           swap[4]  = swap[3];
           swap[3]  = local[3];
           swap[2]  = local[2];
           swap[1]  = local[1];
           swap[0]  = local[0];
           swap = swap + 8;}}

 return;}

/*---------------------------------------------------------FrReadVF --*/
void FrReadVF(struct FrFile *iFile,
              float **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i,nread;
 float *buf;
 unsigned char *swap,local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (float *) malloc(nData*sizeof(float));
 *data = buf;
 if(buf == NULL) 
      {FrError(3,"FrReadVF","malloc failed");
       iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}               
 
 nread = FrRead(iFile,(char *) buf, sizeof(float)*nData);
 if(nread != sizeof(float)*nData)
      {FrError(3,"FrReadVF","error reading bank");
       iFile->error = FR_ERROR_READ_ERROR;
       return;}               

 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local[0] = swap[3];
           local[1] = swap[2];
           swap[3]  = swap[0];
           swap[2]  = swap[1];
           swap[1]  = local[1];
           swap[0]  = local[0];
           swap = swap + 4;}}
        
 return;}
 
/*---------------------------------------------------------FrReadVI --*/
void FrReadVI(struct FrFile *iFile,
              int **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i,nread;
 int *buf;
 unsigned char *swap,local;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (int *) malloc(nData*sizeof(int));
 *data = buf;
 if(buf == NULL) 
        {FrError(3,"FrReadVI","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;}               
 
 nread = FrRead(iFile,(char *) buf, sizeof(int)*nData);
 if(nread != sizeof(int)*nData)
       {FrError(3,"FrReadVI","error reading bank");
        iFile->error = FR_ERROR_READ_ERROR;
        return;}               
 
 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local   = swap[3];
           swap[3] = swap[0];
           swap[0] = local;
           local   = swap[2];
           swap[2] = swap[1];
           swap[1] = local;
           swap = swap + 4;}}
           
 return;}

/*---------------------------------------------------------FrReadVL --*/
void FrReadVL(struct FrFile *iFile,
              FRLONG **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i,nread, nBytes;
 FRLONG *buf, *out;
 unsigned char *swap, *local;
 
 if(iFile->error != FR_OK) {return;}
 
 nBytes = nData * iFile->header[9];  
 buf = (FRLONG *) malloc(nBytes);
 if(buf == NULL) {FrError(3,"FrReadVL","malloc failed");
                  iFile->error = FR_ERROR_MALLOC_FAILED;
                  return;}             

 nread = FrRead(iFile,(char *) buf, nBytes);
 if(nread != nBytes)
              {FrError(3,"FrReadVL","error reading bank");
               iFile->error = FR_ERROR_READ_ERROR;
               return;}
  
 if(iFile->fmLong == FRNATIVE)
    {*data = buf;
     return;}

   /*------ special cases -----------*/

 local = (unsigned char *) buf;
 swap  = (unsigned char *) malloc(nData*sizeof(long));
 if(swap == NULL) {FrError(3,"FrReadVL","malloc failed");
                  iFile->error = FR_ERROR_MALLOC_FAILED;
                  return;}             
 *data = (FRLONG *) swap;

 if((iFile->fmLong == FRSWAP) && (FrSlong == 8))
   {for(i=0; i<nData; i++)
          {swap[7+i*8]  = local[  i*8];
           swap[6+i*8]  = local[1+i*8];
           swap[5+i*8]  = local[2+i*8];
           swap[4+i*8]  = local[3+i*8];
           swap[3+i*8]  = local[4+i*8];
           swap[2+i*8]  = local[5+i*8];
           swap[1+i*8]  = local[6+i*8];
           swap[  i*8]  = local[7+i*8];}}
 else if((iFile->fmLong == FRSWAP) && (FrSlong == 4))
   {for(i=0; i<nData; i++)
          {swap[3+i*4]  = local[  i*4];
           swap[2+i*4]  = local[1+i*4];
           swap[1+i*4]  = local[2+i*4];
           swap[  i*4]  = local[3+i*4];}}
 else if(iFile->fmLong == FREXPAND)
    {for(i=0; i<nData; i++)
          {swap[7+i*8]  = 0;
           swap[6+i*8]  = 0;
           swap[5+i*8]  = 0;
           swap[4+i*8]  = 0;
           swap[3+i*8]  = local[3+i*4];
           swap[2+i*8]  = local[2+i*4];
           swap[1+i*8]  = local[1+i*4];
           swap[  i*8]  = local[  i*4];}}
 else if(iFile->fmLong == FREXPAND_AND_SWAP)
    {for(i=0; i<nData; i++)
          {swap[7+i*8]  = 0;
           swap[6+i*8]  = 0;
           swap[5+i*8]  = 0;
           swap[4+i*8]  = 0;
           swap[3+i*8]  = local[  i*4];
           swap[2+i*8]  = local[1+i*4];
           swap[1+i*8]  = local[2+i*4];
           swap[  i*8]  = local[3+i*4];}}
 else if(iFile->fmLong == FRCONTRACT)
    {out = *data;
     for(i=0; i<nData; i++)
          {out[i] = 0;
           if(buf[2*i] == 0)
                out[i] = buf[2*i+1];
           else out[i] = buf[2*i];}}
 else if(iFile->fmLong == FRCONTRACT_AND_SWAP)
    {out = *data;
     for(i=0; i<nData; i++)
          {if(buf[2*i] == 0)
             {swap[  i*4]  = local[7+i*8];
              swap[1+i*4]  = local[6+i*8];
              swap[2+i*4]  = local[5+i*8];
              swap[3+i*4]  = local[4+i*8];}
           else
             {swap[  i*4]  = local[3+i*8];
              swap[1+i*4]  = local[2+i*8];
              swap[2+i*4]  = local[1+i*8];
              swap[3+i*4]  = local[  i*8];}}}
 
 free(local);

 return;}

/*---------------------------------------------------------FrReadVQ --*/
void FrReadVQ(struct FrFile *iFile, 
              char  ***data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i;
 char **buf;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (char **) malloc(nData*sizeof(char *));
 *data = buf; 
 if(buf == NULL) 
        {FrError(3,"FrReadVQ","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
          return;}               
  
 for(i=0; i<nData; i++)
        {FrReadSChar(iFile, &buf[i]);}

 return;}

/*---------------------------------------------------------FrReadVS --*/
void FrReadVS(struct FrFile *iFile,
              short **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{int i,nread;
 short *buf;
 unsigned char *swap,local;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (short *) malloc(nData*sizeof(short));
 *data = buf;
 if(buf == NULL) 
     {FrError(3,"FrReadVS","malloc failed");
      iFile->error = FR_ERROR_MALLOC_FAILED;
      return;}               

 nread = FrRead(iFile,(char *) buf, sizeof(short)*nData);
 if(nread != sizeof(short)*nData)
     {FrError(3,"FrReadVS","error reading bank");
      iFile->error = FR_ERROR_READ_ERROR;
      return;}               
 
 if(iFile->fmType != FRNATIVE)
     {swap = (unsigned char *) buf;
      for(i=0; i<nData; i++)
          {local   = swap[1];
           swap[1] = swap[0];
           swap[0] = local;
           swap = swap + 2;}}
           
 return;}

/*----------------------------------------------------------- FrProcDataDef--*/
struct FrSH *FrProcDataDef()
/*---------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrProcData",(void (*)())FrProcDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "REAL_8", "sampleRate","-");
  FrSENew(classe, "INT_4U","timeOffsetS","-");
  FrSENew(classe, "INT_4U","timeOffsetN","-");
  FrSENew(classe, "REAL_8","fShift","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "aux","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)",   "table","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "next","-");

  return(classe);}

/*---------------------------------------------------------- FrProcDataDump--*/
void FrProcDataDump(FrProcData *proc, 
                    FILE *fp, 
                    int debugLvl)
/*---------------------------------------------------------------------------*/
{
 if(proc == NULL) return;

 fprintf(fp," Proc:    %s sampleRate=%.4e fShift=%.4e", 
	      proc->name, proc->sampleRate, proc->fShift);

 if(proc->comment != NULL) 
   {if(strlen(proc->comment) > 2) fprintf(fp," comment:%s", proc->comment);}
 fprintf(fp,"\n");
    
 if(proc->data  != NULL) FrVectDump(proc->data,   fp, debugLvl);
 if(proc->aux   != NULL) FrVectDump(proc->aux,    fp, debugLvl);
 if(proc->table != NULL) FrTableDump(proc->table, fp, debugLvl);

 return;}

/*-----------------------------------------------------------FrProcDataFind--*/
FrProcData *FrProcDataFind(FrameH *frame,
                           char *name)
/*---------------------------------------------------------------------------*/
/* Return a pointer to the procData structure or NULL if not found */

{FrProcData *proc;

 if(name  == NULL)              return (NULL);
 if(frame == NULL)              return (NULL);
 if(frame->procData == NULL)    return (NULL);

 for(proc = frame->procData; proc != NULL; proc = proc->next)
   {if(strcmp(proc->name, name) != 0) continue; 
    if(proc->data  != NULL) FrVectExpandF(proc->data);
    if(proc->aux   != NULL) FrVectExpandF(proc->aux);
    if(proc->table != NULL) FrTableExpand(proc->table);
    
    proc->data->GTimeS    = frame->GTimeS+proc->timeOffsetS;
    proc->data->GTimeN    = frame->GTimeN+proc->timeOffsetN;
    proc->data->ULeapS    = frame->ULeapS;
    proc->data->localTime = frame->localTime;

    return(proc);}
  
 return (NULL);}


/*-----------------------------------------------------------FrProcDataFree--*/
void FrProcDataFree(FrProcData *procData)
/*---------------------------------------------------------------------------*/
{
 if(procData == NULL) return;

 if(procData->next != NULL) FrProcDataFree(procData->next);

 if(procData->name    != NULL) free(procData->name);
 if(procData->comment != NULL) free(procData->comment);
 if(procData->data    != NULL) FrVectFree(procData->data);
 if(procData->aux     != NULL) FrVectFree(procData->aux);
 if(procData->table   != NULL) FrTableFree(procData->table);
 
 free(procData);

 return;}
/*-----------------------------------------------------------FrProcDataGetV--*/
FrVect *FrProcDataGetV(FrameH *frame,
                       char *name)
/*---------------------------------------------------------------------------*/
{struct FrProcData *proc;

 proc = FrProcDataFind(frame, name);
 if(proc != NULL) return(proc->data);
  
 return (NULL);}

/*------------------------------------------------FrProcDataNew ------*/
struct FrProcData *FrProcDataNew(struct FrameH *frame,  
                                 char *name, 
                                 double sampleRate, 
                                 int nData, 
                                 int nBits)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;
 double dx;
 int type;
 
 procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
 if(procData == NULL) 
      {return(NULL);} 
 else {procData->classe = FrProcDataDef();}
	 
 if(FrStrCpy(&procData->name,name) == NULL) return(NULL);

 procData->sampleRate = sampleRate;
 
 if(nBits >16)       {type = FR_VECT_4S;}
 else if(nBits >  8) {type = FR_VECT_2S;}
 else if(nBits >  0) {type = FR_VECT_C;}
 else if(nBits >-33) {type = FR_VECT_4R;}
 else                {type = FR_VECT_8R;}

 if(sampleRate == 0.)
      {dx = 0.;}
 else {dx = 1./sampleRate;}

 procData->data = FrVectNew1D(name, type, nData, dx,"time (s)",NULL);
 if(procData->data == NULL) return(NULL);
  
     /*----- now store it in the Frame structures -----*/

 if(frame != NULL) 
    {procData->next = frame->procData;
     frame->procData = procData;}
  
 return(procData);}
  
/*------------------------------------------------- FrProcDataRead---*/
struct FrProcData *FrProcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;

  procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
  if(procData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return(NULL);}
  else {procData->classe = FrProcDataDef();}
  
  FrReadHeader(iFile,  procData);
  FrReadSChar( iFile, &procData->name);
  FrReadSChar( iFile, &procData->comment);
  FrReadDouble(iFile, &procData->sampleRate);
  FrReadIntU  (iFile, &procData->timeOffsetS);
  FrReadIntU  (iFile, &procData->timeOffsetN);
  FrReadDouble(iFile, &procData->fShift);
  FrReadStruct(iFile, &procData->data);
  FrReadStruct(iFile, &procData->aux);
  FrReadStruct(iFile, &procData->table);
  FrReadStruct(iFile, &procData->next);

  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", procData->name);

  return(procData);}

/*--------------------------------------------------------- FrProcDataReadT--*/
FrProcData *FrProcDataReadT(FrFile *iFile,
                            char *name,
                            double gtime)
/*---------------------------------------------------------------------------*/
{FrProcData  **current, *proc, *root;
 FrTOCts *ts;
 FrTag *frtag;
 int index;

                       /*---- find frame(it will read the FrTOC if needed) --*/

 index = FrTOCFrameFindT(iFile, gtime);
 if(index <0) return(NULL);

 if(name == NULL) return(NULL);     /*------------------ build tag object ---*/
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);
                                
                       /*-------------- Extract all the requested channels --*/
 root = NULL;
 current = &root;

 for(ts = iFile->toc->proc; ts != NULL; ts = ts->next)

                       /*---------- check if we need to copy this proc ?-----*/

   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue; 

                       /*---- set the file pointer and read the data -------*/

    if(FrTOCSetPos(iFile, ts->position[index]) != 0) {return (NULL);}
    proc = FrProcDataRead(iFile);
    if(proc == NULL) return(NULL);

    proc->data = FrVectReadNext(iFile);

    proc->data->GTimeS    = iFile->toc->GTimeS[index]+proc->timeOffsetS;
    proc->data->GTimeN    = iFile->toc->GTimeN[index]+proc->timeOffsetN;
    proc->data->ULeapS    = iFile->toc->ULeapS;
    proc->data->localTime = iFile->toc->localTime;

    *current = proc;
    current = &(proc->next);}
 
 FrTagFree(frtag); 

 return(root);}

/*------------------------------------------------ FrProcDataWrite---*/
void FrProcDataWrite(struct FrProcData *procData,
                     struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
	 /* first write procData struct */
 
  FrPutNewRecord(oFile, procData, FR_YES);
  FrPutSChar (oFile, procData->name);
  FrPutSChar (oFile, procData->comment);
  FrPutDouble(oFile, procData->sampleRate);
  FrPutIntU  (oFile, procData->timeOffsetS);
  FrPutIntU  (oFile, procData->timeOffsetN);
  FrPutDouble(oFile, procData->fShift);
  FrPutStruct(oFile, procData->data);
  FrPutStruct(oFile, procData->aux);
  FrPutStruct(oFile, procData->table);
  FrPutStruct(oFile, procData->next);

  if(oFile->toc != NULL) FrTOCtsMark(oFile, &oFile->toc->procH, 
                                      procData->name, 0, 0);

  FrPutWriteRecord(oFile);

           /* data write buffer */

  FrVectWrite (procData->data, oFile);

  if(procData->aux  != NULL) {FrVectWrite (procData->aux,   oFile);}
  if(procData->table!= NULL) {FrTableWrite(procData->table, oFile);}
     
           /* write next struct. if any */

  if(procData->next != NULL)  {FrProcDataWrite(procData->next, oFile);}  

 return;}

/*------------------------------------------------------- FrSEDef ----*/
struct FrSH *FrSEDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSE",FrSERead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "type","-");
  FrSENew(classe, "STRING", "comment","-");

  return(classe);}

/*---------------------------------------------------------- FrSENew-*/
void FrSENew(struct FrSH *structH,
             char *type,
             char  *name,
             char  *comment)
/*--------------------------------------------------------------------*/
{struct FrSE *structE, *last;
 int nTypes = 22, i;
 static char *dataTypes[] = 
   {"UNKNOWN","CHAR","CHAR_U","INT_2S","INT_2U",
    "INT_4S","INT_4U","INT_8S","INT_8U","REAL_4","REAL_8",
    "STRING","PTR_STRUCT","COMPLEX_8","COMPLEX_16","*","INT_4U *",
    "REAL_8 *","STRING *", "INT_8U *","INT_2U *", "INT_4S *"};

  /*----- check the type validity ---------*/

  if(type == NULL) type = dataTypes[0];

  for(i=0; i<nTypes; i++)
    {if(strcmp(type,dataTypes[i]) == 0) break;}
  if(strncmp(type,"PTR_STRUCT",10) == 0) i=13;
  if(i == nTypes)
    {sprintf(FrBuf,"For %s.%s unknown type:%s\n",
                   structH->name,name,type);
     FrError(2,"FrSENew",FrBuf);}

  /*----- fill structure --------*/

  structE = (struct FrSE *) calloc(1,sizeof(struct FrSE));
  if(structE == NULL) 
       {return;}
  else {structE->classe = FrSEDef();}

  if(FrStrCpy(&structE->type    ,type)    == NULL) return;
  if(FrStrCpy(&structE->name    ,name)    == NULL) return;
  if(comment == NULL)
    {structE->comment = NULL;}
  else
    {if(FrStrCpy(&structE->comment ,comment) == NULL) return;}

  structE->next    = NULL;
  
  if(structH->firstE == NULL)
    {structH->firstE = structE;}
  else
   {last = structH->firstE;
    while( last->next != NULL ) {last = last->next;}
    last->next = structE;}

  structH->nSE++;

  return;}

/*-----------------------------------------------------------------FrSERead--*/
void FrSERead(struct FrFile *iFile)
/*---------------------------------------------------------------------------*/
{struct FrSE *se, *last;
 short id;

  se = (struct FrSE *) calloc(1,sizeof(struct FrSE));
  if(se == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {se->classe = FrSEDef();}

  FrReadShort(iFile, &id);
  FrReadSChar(iFile, &se->name); 
  FrReadSChar(iFile, &se->type);
  FrReadSChar(iFile, &se->comment);
  if(FrDebugLvl > 2) 
    {fprintf(FrFOut,"  FrSERead: %16s",se->name);
     if(se->type    != NULL) fprintf(FrFOut," (%s)", se->type);
     if(se->comment != NULL) fprintf(FrFOut," %s"  , se->comment);
     fprintf(FrFOut,"\n");}

                     /*--- in the case of file mark, do not use SH ---*/

  if(iFile->curSH == NULL) 
    {if(se->name    != NULL) free(se->name);
     if(se->type    != NULL) free(se->type);
     if(se->comment != NULL) free(se->comment);
     free(se);
     return;}

                       /*-------- store the SH structure -------------*/

  if(iFile->curSH->firstE == NULL) 
       {iFile->curSH->firstE = se;}
  else {last = iFile->curSH->firstE;
        while(last->next != NULL) {last = last->next;}
        last->next = se;}

  iFile->curSH->nSE++;

return;}
 
/*-------------------------------------------------------- FrSEWrite---*/
void FrSEWrite(struct FrSE *structE,
               struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

 FrPutNewRecord(oFile, structE, FR_NO);
 FrPutSChar(oFile,structE->name);
 FrPutSChar(oFile,structE->type);
 FrPutSChar(oFile,structE->comment);
 FrPutWriteRecord(oFile);

 return;} 


/*------------------------------------------------------ FrSetAll ----*/
void FrSetAll(struct FrFile *file)           /* set all banks address */
/*--------------------------------------------------------------------*/
{int i, nLeft;
 
 nLeft = 0;
 for(i=0; i<file->nRef; i++)
   {if((file->refType[i] != -1) && 
       (file->refType[i] != file->detectorType)) nLeft++;}
 
 if(nLeft != 0) FrError(3,"FrSetAll","Some reference not used");

 return;}
 
/*---------------------------------------------------- FrSetBAT ------*/
void FrSetBAT(struct FrFile *file, 
              unsigned short instance,
              void *address)              /* store address for a bank */
/*--------------------------------------------------------------------*/
{int i;
 void **reference;
                                    /*------ if using mark ---------*/
 if(file->relocation == FR_NO) return;

 for(i=0; i<file->nRef; i++)
   {if((file->refType[i]  == file->type) &&
       (file->refInstance[i] == instance))
     {reference = file->refAddress[i];
      *reference = address;
      if(file->type != file->detectorType) 
          {file->refType[i] = -1;}
      else{file->address[i]= address;}
      return;}}

  FrError(3,"FrSetBAT","bank not referencedd");
 
  return;}

/*------------------------------------------------------ FrSetBRT ----*/
void FrSetBRT(struct FrFile *file,
              unsigned short instance,
              unsigned short type, 
              void *address)                  /* store bank reference */
/*--------------------------------------------------------------------*/
{int i;
 void **reference;

 if(file->relocation == FR_NO)  return;

 if(FrDebugLvl > 3) {fprintf(FrFOut," FrSetBRT: instance=%d type=%d\n",
        instance, type);}
 
    /*------- for FrDetector, search if the structure is already declared ---*/

 if(type == file->detectorType)
   {for(i=0; i<file->nRef; i++)
      {if((file->refType[i]  == type) && (file->refInstance[i] == instance))
        {reference = address;
         *reference = file->address[i];
         return;}}}

     /*----------- regular case: store directly the information -------------*/

 for(i=0; i<file->nRef; i++)
   {if(file->refType[i]  == -1) break;}

 if(i == file->nRef) 
    {if(file->nRef > FRMAXREF) 
       {FrError(3,"FrSetBRT", "FRMAXREF need to be increased");
        return;}
     file->nRef++;}

 file->refType[i]     = type;
 file->refInstance[i] = instance;
 file->refAddress[i]  = address;

 return;}

/*------------------------------------------------------ FrSetIni ----*/
void FrSetIni(struct FrFile *file)  
                               /* init the address relocation package */
/*--------------------------------------------------------------------*/
{
 file->nRef = 0;
 
 file->relocation = FR_YES;      

 return;}

/*------------------------------------------------------- FrSHDef ----*/
struct FrSH *FrSHDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSH",FrSHRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_2U", "classe","-");
  FrSENew(classe, "STRING", "comment","-");

  return(classe);}

/*------------------------------------------------------- FrSHMatch---*/
void FrSHMatch(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSH *sh, *shRef;
 struct FrSE *se, *seRef;
 int i;
 unsigned short id;
           
 id = iFile->type;
 sh = iFile->sh[id]; 
 if(sh == NULL) return;        
                
         /*------ search the reference shRef -----*/
 
 shRef = NULL; 
 for(i=0; i<FrnSH; i++)
   {shRef = FrSHRoot[i];
    if(shRef->name == NULL) continue;
    if(strcmp(sh->name,shRef->name) == 0) {break;}}
 if(i == FrnSH) {shRef = NULL;}
            
 if(shRef == NULL)
      {sh->objRead = NULL;
       if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrSHMatch: unknown bank:%s id=%d\n",sh->name,id);
       return;}
       
 if(iFile->fmtVersion == 4 || shRef->objReadOld == NULL)
      {sh->objRead = shRef->objRead;}
 else {sh->objRead = shRef->objReadOld;}
 
        /*------ check for the data type ------*/

 if(iFile->fmtVersion < 4) return; /*--there are too many differences
                                       for old versions----------------*/
 if(sh->nSE != shRef->nSE)
      {FrError(3,"FrSHMatch","the number of element has changed");
       if(FrDebugLvl > 1) fprintf(FrFOut,
             "FrSHMatch: the number of element has changed" 
             " for:%s (id=%d) (%d %d)\n",
                sh->name,id,sh->nSE,shRef->nSE);
            }
       
 se    = sh->firstE;
 seRef = shRef->firstE;
 while(se != NULL && seRef != NULL)
    {if(strcmp(se->name,seRef->name) != 0) 
        {FrError(3,"FrSHMatch","the element name has changed");
         if(FrDebugLvl > 1) fprintf(FrFOut,
            "FrSHMatch: Element name changed for: %s (id=%d) (%s %s)\n",
                 sh->name,id,se->name,seRef->name);
         if(FrDebugLvl > 1) fprintf(FrFOut,
	     "    file type= %s FrameLib type=%s\n",se->type,seRef->type);}
     if(strcmp(se->type,seRef->type) != 0) 
        {FrError(3,"FrSHMatch","the element type has changed");
         if(FrDebugLvl > 1) fprintf(FrFOut,
            "FrSHMatch: Element type changed for: %s(%s): %s (ref=%s)\n",
                 sh->name,se->name,se->type,seRef->type);}
     se    = se->next;
     seRef = seRef->next;}
              
 return;}

/*------------------------------------------------------------------FrSHNew--*/
struct FrSH *FrSHNew(char *name,
                     char *comment)
/*---------------------------------------------------------------------------*/
{struct FrSH *sh;
 static int id = 1;

  sh = (struct FrSH *) calloc(1,sizeof(struct FrSH));
  if(sh == NULL)   {return(NULL);}

  if(name == NULL)                  {sh->classe = FrSHDef();}
  else if(strcmp(name,"FrSH") == 0) {sh->classe = sh;}
  else                              {sh->classe = FrSHDef();}

  if(name != NULL) 
    {if(FrStrCpy(&sh->name, name)       == NULL) return(NULL);}
  if(comment != NULL)
    {if(FrStrCpy(&sh->comment, comment) == NULL) return(NULL);}

  sh->objRead = FrReadRecord;
  sh->firstE = NULL;
  sh->id = id;
  id++;
  
  return(sh);}

/*-------------------------------------------------------- FrSHRead---*/
void FrSHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSH *sh, *shDup;
 short id0;
 unsigned short id,i;
 char *name, *comment;

 if(iFile->error != FR_OK) return;

 FrReadShort(iFile, &id0);
 FrReadSChar (iFile, &name); 
 FrReadShortU(iFile, &id); 
 FrReadSChar (iFile, &comment); 

                          /*--- check for existing sh structure ----*/
       
 for(i=0; i<iFile->maxSH; i++)
    {shDup = iFile->sh[i];
     if(shDup == NULL)       continue;
     if(shDup->name == NULL) continue;
     if(strcmp(name,shDup->name) == 0) 
       {FrError(1,"FrSHRead","Duplicate FrSH. TOC used or corrupted data");
        if(name    != NULL) free(name);
        if(comment != NULL) free(comment);
        iFile->curSH = NULL;
        return;}}
                                 /*---- add it in the list --------*/
 if(id >= iFile->maxSH) 
      {FrFileIncSH(iFile, id);
       if(iFile->error != FR_OK) return;}

 sh = iFile->sh[id];
 if(sh == NULL)
   {sh = FrSHNew(name,comment);
    sh->id = id;
    iFile->sh[id] = sh;
    if(name    != NULL) free(name);
    if(comment != NULL) free(comment);}
 else
   {sh->name = name;
    sh->comment = comment;}

 iFile->curSH = sh;

 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", sh->name);

 return;}
 
/*-------------------------------------------------------- FrSHWrite---*/
void FrSHWrite(struct FrSH *structH,
               struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{struct FrSE *structE;

 FrPutNewRecord(oFile, structH, FR_NO);
 FrPutSChar    (oFile, structH->name);
 FrPutShortU   (oFile, structH->id);
 FrPutSChar    (oFile, structH->comment);
 FrTOCSH       (oFile, structH->name, structH->id);
 FrPutWriteRecord(oFile);

     /*--- write FrSE structure ------*/
	 
 structE = structH->firstE;
 while(structE != NULL )
       {FrSEWrite(structE, oFile);
        structE = structE->next;}
		 
 return;}


/*------------------------------------------------------------FrSerDataDef--*/
struct FrSH *FrSerDataDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSerData",(void (*)())FrSerDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4U", "timeSec","-");
  FrSENew(classe, "INT_4U", "timeNsec","-");
  FrSENew(classe, "REAL_4", "sampleRate","-");
  FrSENew(classe, "STRING", "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "serial","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)", "table","-");
  FrSENew(classe, "PTR_STRUCT(FrSerData *)", "next","-");

  return(classe);}

/*--------------------------------------------------------- FrSerDataDump---*/
void FrSerDataDump(FrSerData *serData, 
                   FILE *fp, 
                   int debugLvl)
/*--------------------------------------------------------------------------*/
{
 if(fp      == NULL) return;
 if(serData == NULL) return;
 if(debugLvl < 1)    return;

 fprintf(fp," SerData: %s GPS=%d Data:", serData->name, serData->timeSec);
 if(debugLvl == 1) fprintf(fp," %20s...\n", serData->data);
 else              fprintf(fp,    "  %s\n", serData->data);

 if(serData->serial != NULL) FrVectDump(serData->serial, fp, debugLvl);

 return;}  

/*-----------------------------------------------------------FrSerDataFree--*/
void FrSerDataFree(FrSerData *serData)
/*--------------------------------------------------------------------------*/
{
 if(serData == NULL) return;

 if(serData->next   != NULL) FrSerDataFree(serData->next);

 if(serData->serial != NULL) FrVectFree(serData->serial);
 if(serData->table  != NULL) FrTableFree(serData->table);

 if(serData->name   != NULL) free(serData->name);
 if(serData->data   != NULL) free(serData->data);

 free(serData);

 return;}
/*------------------------------------------------- FrSerDataFind----*/
FrSerData *FrSerDataFind(FrameH *frameH,
                         char *smsName,
                         FrSerData *sms)
/*--------------------------------------------------------------------*/
{
 if(frameH == NULL)             return (NULL);
 if(frameH->rawData == NULL)    return (NULL);
 if(smsName == NULL)            return (NULL);

 if(sms == NULL) 
      sms = frameH->rawData->firstSer;
 else sms = sms->next;

 for(; sms != NULL; sms = sms->next)
    {if(strcmp(sms->name, smsName) == 0) break;}

 return (sms);}
  
/*-------------------------------------------------- FrSerDataGet-----*/
int FrSerDataGet(struct FrameH *frameH,
                 char *smsName,
                 char  *smsParam,
                 double *value)
/*--------------------------------------------------------------------*/
/* this function return:
      -2 if the sms is not found
      -1 if the parameters is not found
       0 if everything is ok, the result is put in value */

{struct FrSerData *sms;
 char vName[50], vValue[50], *pointer;
 int l;
 unsigned int i;

 *value = 0;
 if(frameH == NULL)             return (-2);
 if(frameH->rawData == NULL)    return (-2);

 sms = frameH->rawData->firstSer;
 while(sms != NULL)
    {if(strcmp(sms->name, smsName) == 0) break;
     sms = sms->next;}
 
 if(sms == NULL) return(-2);
 
          /*-- here we have found the sms structure ---*/

 /*------- search if the word is the first word ----*/

  strcpy(vName,smsParam);
  l = strlen(smsParam);
  vName[l] = ' ';
  if(strncmp(sms->data, vName, l+1) == 0)
     {pointer = sms->data;}
  else
     {vName[0] = ' ';
      strcpy(&vName[1],smsParam);
      l = strlen(smsParam);
      vName[l+1] = ' ';
      vName[l+2] = '\0';
 
      pointer = strstr(sms->data, vName);
      if(pointer == NULL) return (-1);}

  sscanf(pointer,"%s %s",vName, vValue);
  if(vValue[0] == 'x')
       {sscanf(vValue+1,"%x",&i);
        *value = i;}
  else if(isalpha((int) vValue[0]))
       {sscanf(vValue+1,"%lf",value);}
  else {sscanf(vValue  ,"%lf",value);}

  return (0);}
  
/*----------------------------------------------------FrSerDataNew ---*/
struct FrSerData *FrSerDataNew(struct FrameH *frame,
                               char *smsName,
                               unsigned int serTime,
                               char *data)
/*--------------------------------------------------------------------*/
{struct FrSerData *smsData;

  smsData = (struct FrSerData *) calloc(1,sizeof(struct FrSerData));
  if(smsData == NULL) 
       {return(NULL);}
  else {smsData->classe = FrSerDataDef();}
	 
  if(FrStrCpy(&smsData->name, smsName) == NULL) return(NULL);
  if(FrStrCpy(&smsData->data, data)    == NULL) return(NULL);

  smsData->timeSec    = serTime;
  smsData->timeNsec   = 0;
  smsData->sampleRate = 0.;
  smsData->table      = NULL;

  if(frame != NULL) 
      {if(frame->rawData == NULL) FrRawDataNew(frame);
       if(frame->rawData == NULL) {return(NULL);}
       smsData->next = frame->rawData->firstSer;
       frame->rawData->firstSer = smsData;}
	   
  return(smsData);}

/*--------------------------------------------------- FrSerDataRead---*/
struct FrSerData *FrSerDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSerData *smsData;

  smsData = (struct FrSerData *) calloc(1,sizeof(struct FrSerData));
  if(smsData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return(NULL);}
  else {smsData->classe = FrSerDataDef();}
  
  FrReadHeader(iFile,  smsData);
  FrReadSChar( iFile, &smsData->name);
  FrReadIntU  (iFile, &smsData->timeSec);
  FrReadIntU  (iFile, &smsData->timeNsec);
  FrReadFloat (iFile, &smsData->sampleRate);
  FrReadSChar (iFile, &smsData->data);
  FrReadStruct(iFile, &smsData->serial);
  FrReadStruct(iFile, &smsData->table);
  FrReadStruct(iFile, &smsData->next);
    
  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", smsData->name);

 return(smsData);} 

/*--------------------------------------------------------- FrSerDataReadT--*/
FrSerData *FrSerDataReadT(FrFile *iFile,
                            char *name,
                            double gtime)
/*---------------------------------------------------------------------------*/
{FrSerData  **current, *ser, *root;
 FrTOCts *ts;
 FrTag *frtag;
 int index;
                       /*---- find frame(it will read the FrTOC if needed) --*/

 index = FrTOCFrameFindT(iFile, gtime);
 if(index <0) return(NULL);
                                
 if(name == NULL) return(NULL);    /*-------------------- build tag object---*/
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);
                                
                       /*-------------- Extract all the requested channels --*/
 root = NULL;
 current = &root;

 for(ts = iFile->toc->ser; ts != NULL; ts = ts->next)

                       /*---------- check if we need to copy this ser ?-----*/

   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue; 

                       /*---- set the file pointer and read the data -------*/

    if(FrTOCSetPos(iFile, ts->position[index]) != 0) {return (NULL);}
    ser = FrSerDataRead(iFile);
    if(ser == NULL) return(NULL);

    *current = ser;
    current = &(ser->next);}
 
 FrTagFree(frtag); 

 return(root);}

/*-----------------------------------------------------------FrSerDataWrite--*/
void FrSerDataWrite(FrSerData *serData,
                    FrFile *oFile)
/*---------------------------------------------------------------------------*/
{
  FrPutNewRecord(oFile, serData, FR_YES);
  FrPutSChar (oFile, serData->name);
  FrPutIntU  (oFile, serData->timeSec);
  FrPutIntU  (oFile, serData->timeNsec);
  FrPutFloat (oFile, serData->sampleRate);
  FrPutSChar (oFile, serData->data);
  FrPutStruct(oFile, serData->serial);
  FrPutStruct(oFile, serData->table);
  FrPutStruct(oFile, serData->next);

  if(oFile->toc != NULL) FrTOCtsMark(oFile, &oFile->toc->serH, 
                                    serData->name, 0, 0xffffffff);

  FrPutWriteRecord(oFile);
    
  if(serData->serial != NULL) FrVectWrite(serData->serial, oFile);
  if(serData->table  != NULL) FrTableWrite(serData->table, oFile);

 return;} 
/*------------------------------------------------------------FrSimDataDef--*/
struct FrSH *FrSimDataDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSimData",(void (*)())FrSimDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "REAL_4", "sampleRate","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "input","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)", "table","-");
  FrSENew(classe, "PTR_STRUCT(FrSimData *)", "next","-");

  return(classe);}

/*-----------------------------------------------------------FrSimDataDump--*/
void FrSimDataDump(FrSimData *simData,
                   FILE *fp, 
                   int debugLvl)
/*--------------------------------------------------------------------------*/
{
 if(simData == NULL) return;
 if(fp == NULL)   return;
 if(debugLvl < 0) return;

 fprintf(fp," SimData: %s", simData->name);
 if(simData->comment != NULL) fprintf(fp," (%s)", simData->comment);
 fprintf(fp,"\n");
    
 if(simData->data  != NULL){FrVectDump (simData->data,  fp, debugLvl);}
 if(simData->table != NULL){FrTableDump(simData->table, fp, debugLvl);}

 return;}

/*------------------------------------------------------------FrSimDataFind--*/
FrSimData *FrSimDataFind(FrameH *frame,
                         char *simName)
/*---------------------------------------------------------------------------*/
{FrSimData *sim;

 if(frame == NULL)             return (NULL);
 if(frame->simData == NULL)    return (NULL);
 if(simName == NULL)           return (NULL);

 for(sim = frame->simData; sim != NULL; sim = sim->next)
    {if(strcmp(sim->name, simName) != 0) continue;

     if(sim->data  != NULL) FrVectExpandF(sim->data);
     if(sim->table != NULL) FrTableExpand(sim->table);
        
     sim->data->GTimeS    = frame->GTimeS;
     sim->data->GTimeN    = frame->GTimeN;
     sim->data->ULeapS    = frame->ULeapS;
     sim->data->localTime = frame->localTime;

     return(sim);}
  
 return (NULL);}

/*------------------------------------------------------------FrSimDataFree--*/
void FrSimDataFree(FrSimData *simData)
/*---------------------------------------------------------------------------*/
{
 if(simData == NULL) return;

 if(simData->name    != NULL) free (simData->name);
 if(simData->comment != NULL) free (simData->comment);
 if(simData->data    != NULL) FrVectFree(simData->data);
 if(simData->input   != NULL) FrVectFree(simData->input);
 if(simData->table   != NULL) FrTableFree(simData->table);
 if(simData->next    != NULL) FrSimDataFree(simData->next);
 
 free(simData);

 return;}

/*------------------------------------------------------------FrSimDataGetV--*/
FrVect *FrSimDataGetV(FrameH *frame,
                      char *name)
/*---------------------------------------------------------------------------*/
{FrSimData *sim;

 sim = FrSimDataFind(frame, name);
 if(sim != NULL) return(sim->data);
  
 return (NULL);}

/*------------------------------------------------------------FrSimDataNew--*/
struct FrSimData *FrSimDataNew(struct FrameH *frame,
                               char *name,
                               double sampleRate,
                               int nData,
                               int nBits)
/*--------------------------------------------------------------------------*/
{struct FrSimData *simData;
 double dx;
 int type;
 
  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL) 
       {return(NULL);} 
  else {simData->classe = FrSimDataDef();}
	 
  if(FrStrCpy(&simData->name, name) == NULL) return(NULL); 
	   
  simData->sampleRate = sampleRate;

  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  simData->data = FrVectNew1D(name,type,nData,dx,"time (s)",NULL);
  if(simData->data == NULL)
       {FrError(3,"FrSimDataNew","cannot create vector");
        return(NULL);}

 free(simData->data->name);
 if(FrStrCpy(&simData->data->name,name) == NULL) return(NULL);
 
    /*----- now store it in the Frame structures -----*/

 
  if(frame == NULL) 
       {FrError(2,"FrSimDataNew","No frame struct");}
  else
       {simData->next = frame->simData;
        frame->simData = simData;}

  return(simData);} 

/*-----------------------------------------------------------FrSimDataRead--*/
struct FrSimData *FrSimDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrSimData *simData;

  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return(NULL);}
  else {simData->classe = FrSimDataDef();}
  
  FrReadHeader(iFile,  simData);
  FrReadSChar( iFile, &simData->name);
  FrReadSChar (iFile, &simData->comment);
  FrReadFloat (iFile, &simData->sampleRate);
  FrReadStruct(iFile, &simData->data);
  FrReadStruct(iFile, &simData->input);
  FrReadStruct(iFile, &simData->table);
  FrReadStruct(iFile, &simData->next);
    
  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", simData->name);

return(simData);}

/*---------------------------------------------------------- FrSimDataReadT--*/
FrSimData *FrSimDataReadT(FrFile *iFile,
                          char *name,
                          double gtime)
/*---------------------------------------------------------------------------*/
{FrSimData  **current, *sim, *root;
 FrTOCts *ts;
 FrTag *frtag;
 int index;

 if(name == NULL) return(NULL);
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);

                       /*---- find frame(it will read the FrTOC if needed) --*/

 index = FrTOCFrameFindT(iFile, gtime);
 if(index <0) return(NULL);
                                
                       /*-------------- Extract all the requested channels --*/
 root = NULL;
 current = &root;

 for(ts = iFile->toc->sim; ts != NULL; ts = ts->next)

                       /*---------- check if we need to copy this sim ?-----*/

   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue; 

                       /*---- set the file pointer and read the data -------*/

    if(FrTOCSetPos(iFile, ts->position[index]) != 0) {return (NULL);}
    sim = FrSimDataRead(iFile);
    if(sim == NULL) return(NULL);

    sim->data = FrVectReadNext(iFile);

    sim->data->GTimeS    = iFile->toc->GTimeS[index];
    sim->data->GTimeN    = iFile->toc->GTimeN[index];
    sim->data->ULeapS    = iFile->toc->ULeapS;
    sim->data->localTime = iFile->toc->localTime;

    *current = sim;
    current = &(sim->next);}
 
 FrTagFree(frtag); 

 return(root);}

/*----------------------------------------------------------FrSimDataWrite--*/
void FrSimDataWrite(struct FrSimData *simData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{
  FrPutNewRecord(oFile, simData, FR_YES);
  FrPutSChar (oFile, simData->name);
  FrPutSChar (oFile, simData->comment);
  FrPutFloat (oFile, simData->sampleRate);
  FrPutStruct(oFile, simData->data);
  FrPutStruct(oFile, simData->input);
  FrPutStruct(oFile, simData->table);
  FrPutStruct(oFile, simData->next);

  if(oFile->toc != NULL) FrTOCtsMark(oFile, &oFile->toc->simH, 
                                     simData->name, 0, 0);

  FrPutWriteRecord(oFile);

           /*-------------data write buffer---------------------------------*/

  FrVectWrite(simData->data, oFile);
     
  if(simData->input != NULL){FrVectWrite(simData->input, oFile);}
  if(simData->table != NULL){FrTableWrite(simData->table, oFile);}

  if(simData->next != NULL) {FrSimDataWrite(simData->next, oFile);}

 return;}

/*---------------------------------------------------------- FrSimEventDef--*/
struct FrSH *FrSimEventDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

 if(classe != NULL) return(classe);
 classe = FrDicAddS("FrSimEvent",(void (*)())FrSimEventRead);

 FrSENew(classe, "STRING", "name","-");
 FrSENew(classe, "STRING", "comment","-");
 FrSENew(classe, "STRING", "inputs","-");
 FrSENew(classe, "INT_4U", "GTimeS","-");
 FrSENew(classe, "INT_4U", "GTimeN","-");
 FrSENew(classe, "REAL_4", "timeBefore","-");
 FrSENew(classe, "REAL_4", "timeAfter","-");
 FrSENew(classe, "REAL_4", "amplitude","-");
 FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
 FrSENew(classe, "PTR_STRUCT(FrTable *)",   "table","-");
 FrSENew(classe, "PTR_STRUCT(FrSimEvent *)", "next","-"); 

 return(classe);}

/*----------------------------------------------------------FrSimEventDump--*/
void FrSimEventDump(FrSimEvent *simEvent,
                    FILE *fp, 
                    int debugLvl)
/*--------------------------------------------------------------------------*/
{double t;

 if(simEvent == NULL);
 if(fp == NULL)   return;
 if(debugLvl < 0) return;

 fprintf(fp," SimEvent: %s ",  simEvent->name);
 if(simEvent->comment != NULL) fprintf(fp,"(%s)",simEvent->comment);
 if(simEvent->inputs  != NULL) fprintf(fp,"Inputs:%s",simEvent->inputs);
 fprintf(fp, "\n");

 t = simEvent->GTimeS + 1.e-9*simEvent->GTimeN;
 fprintf(fp,"  Amplitude=%e time=%.4f (s) tBefore=%.3f tAfter=%.3f (s)\n",
           simEvent->amplitude, t, simEvent->timeBefore, simEvent->timeAfter);
     
 if(simEvent->data  != NULL){FrVectDump (simEvent->data,  fp, debugLvl);}
 if(simEvent->table != NULL){FrTableDump(simEvent->table, fp, debugLvl);}

 return;}

/*----------------------------------------------------------FrSimEventFind--*/
FrSimEvent *FrSimEventFind(FrameH *frameH, 
                           char *name,
                           FrSimEvent *simEvt)
/*--------------------------------------------------------------------------*/
{
 if(frameH == NULL)  return(NULL);
 if(name   == NULL)  return(NULL);

 if(simEvt == NULL) 
      simEvt = frameH->simEvent;
 else simEvt = simEvt->next;

 for(; simEvt != NULL; simEvt = simEvt->next)
    {if(strcmp(simEvt->name, name) != 0) continue;

     if(simEvt->data  != NULL) FrVectExpandF(simEvt->data);
     if(simEvt->table != NULL) FrTableExpand(simEvt->table);

     return (simEvt);}
  
 return (NULL);}

/*----------------------------------------------------------FrSimEventFree--*/
void FrSimEventFree(struct FrSimEvent *simEvent)
/*--------------------------------------------------------------------------*/
{
 if(simEvent == NULL) return;

 if(simEvent->next   != NULL) FrSimEventFree(simEvent->next);

 if(simEvent->name       != NULL) free (simEvent->name);
 if(simEvent->comment    != NULL) free (simEvent->comment);
 if(simEvent->inputs     != NULL) free (simEvent->inputs);
 if(simEvent->data       != NULL) FrVectFree (simEvent->data);
 if(simEvent->table      != NULL) FrTableFree(simEvent->table);

 free(simEvent);

 return;}

/*-----------------------------------------------------------FrSimEventNew--*/
struct FrSimEvent *FrSimEventNew(struct FrameH *frameH,  
                                 char *name, 
                                 char *comment, 
                                 char *inputs, 
                                 unsigned int GTimeS,
                                 unsigned int GTimeN,  
                                 float timeBefore,
                                 float timeAfter,
                                 float amplitude)
/*--------------------------------------------------------------------------*/
{struct FrSimEvent *simEvent;
 
 simEvent = (struct FrSimEvent *) calloc(1,sizeof(struct FrSimEvent));
 if(simEvent == NULL) 
      {return(NULL);} 
 else {simEvent->classe = FrSimEventDef();}
	 
 if(FrStrCpy(&simEvent->name,name)       == NULL) return(NULL);
 if(FrStrCpy(&simEvent->comment,comment) == NULL) return(NULL);
 if(FrStrCpy(&simEvent->inputs,inputs)   == NULL) return(NULL);

 simEvent->GTimeS     = GTimeS;
 simEvent->GTimeN     = GTimeN;
 simEvent->timeBefore = timeBefore;
 simEvent->timeAfter  = timeAfter;
 simEvent->amplitude  = amplitude;
  
      /*------------- now store it in the Frame structures ----------------*/

 if(frameH != NULL) 
    {simEvent->next = frameH->simEvent;
     frameH->simEvent = simEvent;}
  
 return(simEvent);} 

/*----------------------------------------------------------FrSimEventRead--*/
struct FrSimEvent *FrSimEventRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrSimEvent *simEvent;

 simEvent = (struct FrSimEvent *) calloc(1,sizeof(struct FrSimEvent));
 if(simEvent == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 else {simEvent->classe = FrSimEventDef();}

 FrReadHeader(iFile,  simEvent);
 FrReadSChar (iFile, &simEvent->name); 
 FrReadSChar (iFile, &simEvent->comment);
 FrReadSChar (iFile, &simEvent->inputs);
 FrReadIntU  (iFile, &simEvent->GTimeS);
 FrReadIntU  (iFile, &simEvent->GTimeN);
 FrReadFloat (iFile, &simEvent->timeBefore);
 FrReadFloat (iFile, &simEvent->timeAfter);
 FrReadFloat (iFile, &simEvent->amplitude);
 FrReadStruct(iFile, &simEvent->data);
 FrReadStruct(iFile, &simEvent->table);
 FrReadStruct(iFile, &simEvent->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", simEvent->name);

 return(simEvent);}

/*--------------------------------------------------------- FrSimEventReadT--*/
FrSimEvent *FrSimEventReadT(FrFile *iFile,
                            char *name,
                            double tStart,
                            double length)
/*---------------------------------------------------------------------------*/
/* Find all the simEven in this window. Do not read associated table         */
/*---------------------------------------------------------------------------*/
{FrSimEvent *root, **simEvt;
 FrTOCevt   *evt;
 FrTag      *frtag;
 FrFileH    *firstFileH;
 double tSimEvt, tEnd;
 int i;

 if(iFile == NULL) return(NULL);
 firstFileH = iFile->current;
 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/

 tEnd = tStart + length;

 if(name == NULL) return(NULL);
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);
                                                 /*--- Loop over all files--*/
 root = NULL;
 simEvt = &root;

 do
   {if(iFile->toc == NULL) FrTOCReadFull(iFile); /*--------- get the TOC----*/
    if(iFile->toc == NULL) return(NULL);
 
                  /*---------Find name in the channel list for this file----*/

    evt = iFile->toc->simEvt;
    if(evt == NULL)      return(NULL);
    if(evt->nEvent == 0) return(NULL);

    for(i=0; i<evt->nEvent; i++)
      {tSimEvt = evt->GTimeS[i]+1.e-9*evt->GTimeN[i];
       if(tSimEvt < tStart) continue;
       if(tSimEvt > tEnd)   continue; 
       if(FrTagMatch(frtag, evt->name[i]) == FR_NO) continue; 

       if(FrTOCSetPos(iFile, evt->position[i]) != 0) {return (NULL);}
       *simEvt = FrSimEventRead(iFile);
       (*simEvt)->table = NULL;
       (*simEvt)->data  = FrVectReadNext(iFile);
       (*simEvt)->next  = NULL;
       simEvt = &((*simEvt)->next);}}

  while (FrFileINext(iFile, tStart, length, firstFileH) == 0);  

 FrTagFree(frtag); 

 return(root);}

/*---------------------------------------------------------FrSimEventWrite--*/
void FrSimEventWrite(struct FrSimEvent *simEvent,
                     struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{
 if(oFile->toc != NULL) FrTOCevtMark(oFile, oFile->toc->simEvt, 
                   simEvent->name, simEvent->GTimeS, simEvent->GTimeN);

 FrPutNewRecord(oFile, simEvent, FR_YES);
 FrPutSChar (oFile, simEvent->name);
 FrPutSChar (oFile, simEvent->comment);
 FrPutSChar (oFile, simEvent->inputs);
 FrPutIntU  (oFile, simEvent->GTimeS);
 FrPutIntU  (oFile, simEvent->GTimeN);
 FrPutFloat (oFile, simEvent->timeBefore);
 FrPutFloat (oFile, simEvent->timeAfter);
 FrPutFloat (oFile, simEvent->amplitude);
 FrPutStruct(oFile, simEvent->data);
 FrPutStruct(oFile, simEvent->table);
 FrPutStruct(oFile, simEvent->next);
 FrPutWriteRecord(oFile);

           /*write the data */

 FrVectWrite(simEvent->data, oFile);
 FrTableWrite(simEvent->table, oFile);

           /* write next data bloc if any */

 if(simEvent->next != NULL) FrSimEventWrite(simEvent->next, oFile);
  
 return;}

/*-----------------------------------------------------------FrStatDataAdd--*/
void FrStatDataAdd(struct FrDetector *detector,
                   struct FrStatData *sData)
/* There should be only one static data with a given name and 
   time boundaries in the program. 
   This function remove the existing static data structure.                 */
/*--------------------------------------------------------------------------*/
{ 	 
 if(detector  == NULL) 
     {FrStatDataFree(sData);
      return;}
      
 if(sData == NULL) {return;}
 sData->detector = detector;
 
 FrStatDataAddR(&(detector->sData), sData);

 return;}
/*----------------------------------------------------------FrStatDataAddR-*/
void FrStatDataAddR(struct FrStatData **root,
                    struct FrStatData *sData)
/* There should be only one static data with a given name and 
   time boundaries in the list starting by root. 
   This function remove the existing static data structure.                 */
/*--------------------------------------------------------------------------*/
{struct FrStatData **cur;
 	 
 if(sData == NULL) {return;}
 
 for(cur = root; *cur != NULL; cur = &((*cur)->next))
   {if(strcmp((*cur)->name, sData->name) != 0) continue;
    if((*cur)->timeStart != sData->timeStart)  continue;
    if((*cur)->timeEnd   != sData->timeEnd)    continue;
    if(sData->version > (*cur)->version) 
          {sData->next = FrStatDataFree(*cur);
           *cur = sData;}
    else
          {FrStatDataFree(sData);}
    return;}

 sData->next = *root;
 *root = sData;

 return;}

/*----------------------------------------------------------FrStatDataChkT--*/
void FrStatDataChkT(struct FrStatData **root,
                    unsigned int timeStart,
                    unsigned int timeEnd)
/*--------------------------------------------------------------------------*/
/* This function remove all static data which are not valid for 
   requested validity range (RVR). The rule is the following:
     -remove all data with a validy range not overlapping the RVR
     -keep all data with a validy range partially overlapping the RVR 
     -keep the latest (ie with the latest starting time) data 
      with a validy range fully overlapping the RVR
   Note that timeEnd == 0 means no upper bound limit.
----------------------------------------------------------------------------*/
{struct FrStatData **current, **name;
 unsigned int cts,cte;
 	 
  if(root == NULL) return;
     
    /*-- we first remove all data not in the validity range ----------------*/
    /*-- and we flag all the data with full overlapp. ----------------------*/

 for(current = root; *current != NULL;)
   {cts = (*current)->timeStart;
    cte = (*current)->timeEnd;
    if(cte == 0) cte = timeEnd; 

    /*-- we first remove all data not in the validity range ----------------*/

    if     (timeEnd   < cts) {*current = FrStatDataFree(*current);}
    else if(timeStart > cte) {*current = FrStatDataFree(*current);}

    /*-- then we flag all the data with full overlapp. ---------------------*/

    else
      {if((timeStart > cts) && (timeEnd   < cte))
          {(*current)->overlap = 1;}
      else{(*current)->overlap = 0;}
      current = &(*current)->next;}}

      /*------ then we loop on all possible names --------------------------*/
      
 for(name = root; *name != NULL; name = &(*name)->next)
   {if((*name)->overlap != 1) continue; 

      /*------ we search for the latest fully overlapping  -----------------*/

    for(current = &((*name)->next); 
        *current != NULL; 
        current = &(*current)->next)
      {if((*current)->overlap != 1)                      continue;
       if(strcmp((*current)->name, (*name)->name) != 0)  continue;
       if((*name)->timeStart < (*current)->timeStart) 
                {(*name)->overlap = 2;}
       else  {(*current)->overlap = 2;}}}

      /*--------------- now remove the tagged blocs ------------------------*/

 for(current = root; *current != NULL;)
      {if((*current)->overlap == 2)
            {*current = FrStatDataFree(*current);}
       else  {current = &(*current)->next;}} 
 
 return;}

/*----------------------------------------------------------FrStatDataCopy--*/
struct FrStatData *FrStatDataCopy(struct FrStatData *sData,
                                  struct FrDetector *detector)
/*--------------------------------------------------------------------------*/
{struct FrStatData *copy;

 if(sData == NULL) return(NULL);

 copy = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
 if(copy == NULL)  
      {return(NULL);}
 else {copy->classe = FrStatDataDef();}

 memcpy(copy, sData, sizeof(struct FrStatData));
 copy->detector = detector;

 if(FrStrCpy(&copy->name,    sData->name)    == NULL) return(NULL);
 if(FrStrCpy(&copy->comment, sData->comment) == NULL) return(NULL);
 if(FrStrCpy(&copy->representation, 
             sData->representation) == NULL) return(NULL);

 if(sData->data  != NULL) {copy->data  = FrVectCopy(sData->data);}
 if(sData->table != NULL) {copy->table = FrTableCopy(sData->table);}
        
 return(copy);}

/*-----------------------------------------------------------FrStatDataDef--*/
struct FrSH *FrStatDataDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

 if(classe != NULL) return(classe);
 classe = FrDicAddS("FrStatData",(void (*)())FrStatDataRead);

 FrSENew(classe, "STRING", "name","-");
 FrSENew(classe, "STRING", "comment","-");
 FrSENew(classe, "STRING", "representation","-"); 
 FrSENew(classe, "INT_4U", "timeStart","-"); 
 FrSENew(classe, "INT_4U", "timeEnd","-"); 
 FrSENew(classe, "INT_4U", "version","-"); 
 FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detector","-"); 
 FrSENew(classe, "PTR_STRUCT(FrVect *)", "data","-"); 
 FrSENew(classe, "PTR_STRUCT(FrTable *)", "table","-"); 

 return(classe);}

/*----------------------------------------------------------FrStatDataFind--*/
struct FrStatData *FrStatDataFind(struct FrDetector *detector,
                                  char *name, 
                                  unsigned int timeNow)
/*--------------------------------------------------------------------------*/
{struct FrStatData *current, *latest;
 	 
 if(detector == NULL) return(NULL);
 if(name     == NULL) return(NULL);
 
 latest = NULL;
 current = detector->sData;
 while(current != NULL)
   {if(strcmp(current->name, name) == 0)
     {if(timeNow == 0) {return(current);}
      if(current->timeStart <= timeNow)
         {if(latest == NULL) {latest = current;}
          if(latest->timeStart < current->timeStart) {latest = current;}}}

    current = current->next;}
 
 return(latest);} 

/*----------------------------------------------------------FrStatDataFree--*/
struct FrStatData *FrStatDataFree(struct FrStatData *sData)
/*--------------------------------------------------------------------------*/
{struct FrStatData *next;

 if(sData == NULL) return(NULL);
 next = sData->next;

 if(sData->name           != NULL) {free(sData->name);}
 if(sData->comment        != NULL) {free(sData->comment);}
 if(sData->representation != NULL) {free(sData->representation);}
 
 if(sData->data  != NULL) FrVectFree(sData->data);
 if(sData->table != NULL) FrTableFree(sData->table);
   
 free(sData);

 return(next);}

/*-----------------------------------------------------------FrStatDataGetV--*/
FrVect *FrStatDataGetV(FrameH *frame, 
                       char * name)
/*---------------------------------------------------------------------------*/
{FrStatData *stat;

 if(frame == NULL) return(NULL);

 stat = FrStatDataFind(frame->detectProc, name, 0); 
 if(stat == NULL) return(NULL);

 return(stat->data);
}

/*-----------------------------------------------------------FrStatDataNew--*/
struct FrStatData *FrStatDataNew(char *name,
                                 char *comment,
                                 char *representation,
                                 unsigned int tStart,
                                 unsigned int tEnd,
                                 unsigned int version,
                                 struct FrVect *data,
                                 struct FrTable *table)
/*--------------------------------------------------------------------------*/
{struct FrStatData *sData;

  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {return(NULL);}
  else {sData->classe = FrStatDataDef();}

 if(FrStrCpy(&sData->name, name)                     == NULL) return(NULL);
 if(FrStrCpy(&sData->comment, comment)               == NULL) return(NULL);
 if(FrStrCpy(&sData->representation, representation) == NULL) return(NULL);

 sData->timeStart = tStart;
 sData->timeEnd   = tEnd;
 sData->version   = version;
 sData->data      = data;
 sData->table     = NULL;
   
 return(sData);}

/*----------------------------------------------------------FrStatDataRead--*/
struct FrStatData *FrStatDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrStatData *sData;
 unsigned short id;
 
 sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
 if(sData == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 else {sData->classe = FrStatDataDef();}

 FrReadShortU(iFile, &id);  /*statData are not referenced by pointer*/
 FrReadSChar( iFile, &sData->name);
 FrReadSChar (iFile, &sData->comment); 
 FrReadSChar (iFile, &sData->representation); 
 FrReadIntU  (iFile, &sData->timeStart); 
 FrReadIntU  (iFile, &sData->timeEnd); 
 FrReadIntU  (iFile, &sData->version); 
 FrReadStruct(iFile, &sData->detector); 
 FrReadStruct(iFile, &sData->data);
 FrReadStruct(iFile, &sData->table);

 sData->next = iFile->sDataCur;
 iFile->sDataCur = sData;

 if(FrDebugLvl > 2) fprintf(FrFOut, " %s\n", sData->name);

 return(sData);}
 
/*--------------------------------------------------------FrStatDataRemove--*/
void FrStatDataRemove(struct FrDetector *detector,
                      char *name) 
/*--------------------------------------------------------------------------*/
{struct FrStatData **current;

 if(detector == NULL) return;
 if(name     == NULL) return;
  
         /*-------------- search for an existing structure -----------------*/

 current = &detector->sData;
 while(*current != NULL)
   {if(strcmp((*current)->name, name) == 0)
       {*current = FrStatDataFree(*current);}
    else
       {current = &(*current)->next;}}
 
 return;}

/*---------------------------------------------------------FrStatDataTouch--*/
void FrStatDataTouch(struct FrStatData * sData)
/*--------------------------------------------------------------------------*/
{
 sData->version++;
   
 return;}

/*---------------------------------------------------------FrStatDataWrite--*/
void FrStatDataWrite(struct FrStatData *sData,
                     struct FrFile *oFile)
/*---------------------------------------------------------------------------*/
{
 if(sData == NULL) return;
 	  
         /*--------------- write the bloc ----------------------------------*/
    
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"  Output FrStatData %s\n",sData->name);}

 FrPutNewRecord(oFile, sData, FR_NO);
 FrPutSChar (oFile, sData->name);
 FrPutSChar (oFile, sData->comment); 
 FrPutSChar (oFile, sData->representation); 
 FrPutIntU  (oFile, sData->timeStart); 
 FrPutIntU  (oFile, sData->timeEnd); 
 FrPutIntU  (oFile, sData->version); 
 FrPutStruct(oFile, sData->detector); 
 FrPutStruct(oFile, sData->data);
 FrPutStruct(oFile, sData->table);
 FrPutWriteRecord(oFile);
  
          /*-------------write the sData components ------------------------*/
 
 if(sData->data  != NULL) FrVectWrite( sData->data,  oFile);
 if(sData->table != NULL) FrTableWrite(sData->table, oFile);
  
 return;}

/*----------------------------------------------------------------FrStrCpy--*/
char *FrStrCpy(char **copy,
               char *old)
/*--------------------------------------------------------------------------*/
{
 if(old == NULL) 
    {*copy = NULL;
     return((char *) 1);}
 
 *copy = (char *) malloc(strlen(old)+1);  
 if(*copy == NULL) 
     {FrError(3,"FrStrCpy","malloc failed at line");} 
 else{strcpy(*copy ,old);}
 
 return(*copy);}

/*--------------------------------------------------------------FrStrGTime--*/
char *FrStrGTime(unsigned int in)
/*--------------------------------------------------------------------------*/
/* this function format a GPS time                                          */
/* the GPS time origin is Sun Jan  6 00:00:00 1980                          */
/* the C function time origin is Jan 1 00:00:00 1970 (no leap seconds)      */
/* (C time - GPS time = 3600*24*3567 = 315964800 seconds = FRGPSOFF)        */
/*--------------------------------------------------------------------------*/
{static char stringTime[30];
 time_t tp;
 
 tp = in + FRGPSOFF;
 strncpy(stringTime,asctime(gmtime(&tp)),24);

 return(stringTime);}

/*----------------------------------------------------------------FrStrUTC--*/
char *FrStrUTC(unsigned int gps,
               int uLeapS)
/*--------------------------------------------------------------------------*/
/* this function format a GPS time to a UTC time (string)                   */
/* the GPS time origin is Sun Jan  6 00:00:00 1980                          */
/* the C function time origin is Jan 1 00:00:00 1970 (no leap seconds)      */
/* (C time - GPS time = 3600*24*3567 = 315964800 seconds = FRGPSOFF)        */
/*--------------------------------------------------------------------------*/
{static char stringTime[30];
 time_t utc;
 
 if(uLeapS == 0) uLeapS = 32;           /*-- current best guess ---*/

    /*---- update leap second according the table if available ----*/

 if     (gps > 709516813);              /* Mon Jul  1 00:00:00 2002*/
 else if(gps > 599184012) uLeapS = 32;  /* Fri Jan  1 00:00:00 1999*/
 else if(gps > 551750411) uLeapS = 31;  /* Tue Jul  1 00:00:00 1997*/
 else if(gps > 504489610) uLeapS = 30;  /* Mon Jan  1 00:00:00 1996*/
 else if(gps > 457056009) uLeapS = 29;  /* Fri Jul  1 00:00:00 1994*/
 else if(gps > 425520008) uLeapS = 28;  /* Thu Jul  1 00:00:00 1993*/

 utc = gps + FRGPSTAI - uLeapS + FRGPSOFF;
 strncpy(stringTime,asctime(gmtime(&utc)),24);

 return(stringTime);}

/*------------------------------------------------------------FrSummaryDef--*/
FrSH *FrSummaryDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

 if(classe != NULL) return(classe);
 classe = FrDicAddS("FrSummary",(void (*)())FrSummaryRead);

 FrSENew(classe, "STRING", "name","-");
 FrSENew(classe, "STRING", "comment","-");
 FrSENew(classe, "STRING", "test","-");
 FrSENew(classe, "PTR_STRUCT(FrVect *)",   "moments","-");
 FrSENew(classe, "PTR_STRUCT(FrTable *)","table","-");
 FrSENew(classe, "PTR_STRUCT(FrSummary *)", "next","-"); 

 return(classe);}

/*------------------------------------------------------------FrSummaryDump--*/
void FrSummaryDump(FrSummary *summary,
                   FILE *fp, 
                   int debugLvl)
/*---------------------------------------------------------------------------*/
{
 if(summary == NULL) return;
 if(fp == NULL)   return;
 if(debugLvl < 0) return;

 fprintf(fp," Summary: %s ",  summary->name);
 if(summary->comment != NULL) fprintf(fp,"(%s)",summary->comment);
 if(summary->test    != NULL) fprintf(fp,"Test:%s",summary->test);
 fprintf(fp, "\n");

 if(summary->moments != NULL){FrVectDump (summary->moments,  fp, debugLvl);}
 if(summary->table   != NULL){FrTableDump(summary->table,    fp, debugLvl);}

 return;}

/*-----------------------------------------------------------FrSummaryFind--*/
struct FrSummary *FrSummaryFind(struct FrameH *frameH, 
                                char *name)
/*--------------------------------------------------------------------------*/
{struct FrSummary *sum;

 if(frameH == NULL) return(NULL);
 if(name   == NULL) return(NULL);

 sum = frameH->summaryData;
 while(sum != NULL)
    {if(strcmp(sum->name, name) == 0) return (sum);
     sum = sum->next;}
  
 return (NULL);}

/*-----------------------------------------------------------FrSummaryFree--*/
void FrSummaryFree(struct FrSummary *summary)
/*--------------------------------------------------------------------------*/
{
 if(summary == NULL) return;

 if(summary->next != NULL) FrSummaryFree(summary->next);

 if(summary->name    != NULL) free (summary->name);
 if(summary->comment != NULL) free (summary->comment);
 if(summary->test    != NULL) free (summary->test);
 if(summary->moments != NULL) FrVectFree (summary->moments);
 if(summary->table   != NULL) FrTableFree(summary->table);

 free(summary);

 return;}

/*------------------------------------------------------------FrSummaryGetV--*/
FrVect *FrSummaryGetV(FrameH *frame, 
                      char * name)
/*---------------------------------------------------------------------------*/
{FrSummary *sum;

 sum = FrSummaryFind(frame, name); 
 if(sum == NULL) return(NULL);

 return(sum->moments);
}
/*------------------------------------------------------------FrSummaryNew--*/
struct FrSummary *FrSummaryNew(struct FrameH *frameH,  
                               char *name, 
                               char *comment, 
                               char *test, 
                               struct FrVect *moments,
                               struct FrTable *table)
/*--------------------------------------------------------------------------*/
{struct FrSummary *summary;
 
 summary = (struct FrSummary *) calloc(1,sizeof(struct FrSummary));
 if(summary == NULL) 
      {return(NULL);} 
 else {summary->classe = FrSummaryDef();}
	 
 if(FrStrCpy(&summary->name,name)       == NULL) return(NULL);
 if(FrStrCpy(&summary->comment,comment) == NULL) return(NULL);
 if(FrStrCpy(&summary->test,test)       == NULL) return(NULL);

 summary->moments = moments;
 summary->table   = table;
 
             /*-------------- now store it in the Frame structures ---------*/

 if(frameH != NULL) 
    {summary->next = frameH->summaryData;
     frameH->summaryData = summary;}
  
 return(summary);} 

/*-----------------------------------------------------------FrSummaryRead--*/
FrSummary *FrSummaryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{FrSummary *summary;

 summary = (struct FrSummary *) calloc(1,sizeof(struct FrSummary));
 if(summary == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 else {summary->classe = FrSummaryDef();}

 FrReadHeader(iFile,  summary);
 FrReadSChar (iFile, &summary->name); 
 FrReadSChar (iFile, &summary->comment);
 FrReadSChar (iFile, &summary->test);
 FrReadStruct(iFile, &summary->moments);
 FrReadStruct(iFile, &summary->table);
 FrReadStruct(iFile, &summary->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", summary->name);

 return(summary);}

/*---------------------------------------------------------- FrSummaryReadT--*/
FrSummary *FrSummaryReadT(FrFile *iFile,
                          char *name,
                          double gtime)
/*---------------------------------------------------------------------------*/
{FrSummary  **current, *sum, *root;
 FrTOCts *ts;
 FrTag *frtag;
 int index;

 if(name == NULL) return(NULL);
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);

      /*------- find frame(it will read the FrTOC if needed) ------------*/

 index = FrTOCFrameFindT(iFile, gtime);
 if(index <0) return(NULL);
                                    /*------ find sum mark ---------*/

 root = NULL;
 current = &root;

 for(ts = iFile->toc->summary; ts != NULL; ts = ts->next)

                 /*-------- check if we need to copy this sum ?-----*/

   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue; 

                  /*---- set the file pointer and read the data -------*/

    if(FrTOCSetPos(iFile, ts->position[index]) != 0) {return (NULL);}
    sum = FrSummaryRead(iFile);
    if(sum == NULL) return(NULL);

    sum->moments = FrVectReadNext(iFile);

    if(sum->moments != NULL)
      {sum->moments->GTimeS    = iFile->toc->GTimeS[index];
       sum->moments->GTimeN    = iFile->toc->GTimeN[index];
       sum->moments->ULeapS    = iFile->toc->ULeapS;
       sum->moments->localTime = iFile->toc->localTime;}

    *current = sum;
    current = &(sum->next);}

 FrTagFree(frtag); 

 return(root);}

/*----------------------------------------------------------FrSummaryWrite--*/
void FrSummaryWrite(struct FrSummary *summary,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{
 FrPutNewRecord(oFile, summary, FR_YES);
 FrPutSChar (oFile, summary->name);
 FrPutSChar (oFile, summary->comment);
 FrPutSChar (oFile, summary->test);
 FrPutStruct(oFile, summary->moments);
 FrPutStruct(oFile, summary->table);
 FrPutStruct(oFile, summary->next);

 if(oFile->toc != NULL) FrTOCtsMark(oFile, &oFile->toc->summaryH,
                                             summary->name, 0, 0xffffffff);

 FrPutWriteRecord(oFile);

 if(summary->moments) FrVectWrite(summary->moments, oFile);
 if(summary->table)   FrTableWrite(summary->table, oFile);

 if(summary->next != NULL) FrSummaryWrite(summary->next, oFile);
 
 return;}

/*-------------------------------------------------------------FrTableCopy--*/
struct FrTable *FrTableCopy(struct FrTable *in)
/*--------------------------------------------------------------------------*/
{struct FrTable *table;
 int i;
 
 table = (struct FrTable *) calloc(1,sizeof(struct FrTable));
 if(table == NULL) 
      {return(NULL);} 
 else {table->classe = FrTableDef();}

	 
 if(FrStrCpy(&table->name,      in->name)       == NULL) return(NULL);
 if(FrStrCpy(&table->comment,   in->comment)    == NULL) return(NULL);

 table->nColumn = in->nColumn;
 table->nRow    = in->nRow;

 table->columnName = (char **) calloc(in->nColumn, sizeof(char *));
 if(table->column == NULL) return(NULL);

 for(i=0; i<table->nColumn; i++)
   {if(FrStrCpy(&table->columnName[i],in->columnName[i])==NULL) return(NULL);}

 table->column = FrVectCopy(in->column);
 if(table->column == NULL) return (NULL);
  
 return(table);} 
/*------------------------------------------------------------- FrTableDef--*/
struct FrSH *FrTableDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

 if(classe != NULL) return(classe);
 classe = FrDicAddS("FrTable",FrTableRead);

 FrSENew(classe, "STRING", "name","-");
 FrSENew(classe, "STRING", "comment","-");
 FrSENew(classe, "INT_2U", "nColumn","-");
 FrSENew(classe, "INT_4U", "nRow","-");
 FrSENew(classe, "STRING *", "columnName", "-");
 FrSENew(classe, "PTR_STRUCT(FrVect *)",   "column","-");
 FrSENew(classe, "PTR_STRUCT(FrTable *)", "next","-"); 

 return(classe);}
  
/*--------------------------------------------------------------FrTableDump--*/
void FrTableDump(struct FrTable *table,
                 FILE *fp, 
                 int debugLvl)
/*--------------------------------------------------------------------------*/
{struct FrVect *col;
 int i;
 char *dC, **dSt;
 short  *dS;
 int    *dI;  
 FRLONG *dL; 
 float  *dF;  
 double *dD;
 unsigned char   *dU;
 unsigned short  *dUS;
 unsigned int    *dUI;
 FRULONG *dUL;
 
 if(table == NULL) return;
 if(fp == NULL)    return;
 if(debugLvl < 0)  return;

 fprintf(fp," Table: %s (%s) \n   nRow=%d nColumn=%d:", 
	 table->name, table->comment, table->nRow, table->nColumn);
 for(i=0; i<table->nColumn; i++)
   {fprintf(fp," %s,",table->columnName[i]);}
 fprintf(fp,"\n");
 
     /*------ dump each column---------------*/

 col = table->column;
 while(col != NULL)
 
   {fprintf(fp,"  col:%s",col->name);
    if     (col->type == FR_VECT_4R) 
      {dF = (float *) col->data;
       fprintf(fp,"(F) %e %e %e ...\n", dF[0],dF[1],dF[2]);}
    else if(col->type == FR_VECT_8R)  
      {dD = (double *) col->data;
       fprintf(fp,"(D) %e %e %e ...\n", dD[0],dD[1],dD[2]);}
    else if(col->type == FR_VECT_C)  
      {dC = col->data;
       fprintf(fp,"(C) %d %d %d %d %d ...\n", 
                             dC[0],dC[1],dC[2],dC[3],dC[4]);}
    else if(col->type == FR_VECT_2S)  
      {dS = (short *) col->data;
       fprintf(fp,"(S) %d %d %d %d ...\n",dS[0],dS[1],dS[2],dS[3]);}
    else if(col->type == FR_VECT_8S)  
      {dL = (FRLONG *) col->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dL[0],dL[1],dL[2]);}
    else if(col->type == FR_VECT_4S)  
      {dI = (int *) col->data;
       fprintf(fp,"(I) %d %d %d ...\n", dI[0],dI[1],dI[2]);}
    else if(col->type == FR_VECT_1U)  
      {dU = (unsigned char *)col->dataU;
       fprintf(fp,"(C) %d %d %d ...\n", dU[0],dU[1],dU[2]);}
    else if(col->type == FR_VECT_2U)  
      {dUS = (unsigned short *) col->data;
       fprintf(fp,"(S) %d %d %d ...\n", dUS[0],dUS[1],dUS[2]);}
    else if(col->type == FR_VECT_8U)  
      {dUL = (FRULONG *) col->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dUL[0],dUL[1],dUL[2]);}
    else if(col->type == FR_VECT_4U)  
      {dUI = (unsigned int *) col->data;
       fprintf(fp,"(I) %d %d %d ...\n", dUI[0],dUI[1],dUI[2]);}
    else if(col->type == FR_VECT_C8) 
      {dF = (float *) col->data;
       fprintf(fp,"(CF) (%e,%e) (%e,%e) ...\n", dF[0],dF[1],dF[2],dF[3]);}
    else if(col->type == FR_VECT_C16) 
      {dD = (double *) col->data;
       fprintf(fp,"(CD) (%e,%e) (%e,%e) ...\n", dD[0],dD[1],dD[2],dD[3]);}
    else if(col->type == FR_VECT_STRING) 
      {dSt = (char **) col->data;
       fprintf(fp,"(STRING) ");
       if((dSt[0] != NULL) &&
          (dSt[1] != NULL)) fprintf(fp,"%s, %s,...", dSt[0], dSt[1]);
        fprintf(fp,"\n");}
    else 
      {fprintf(fp," unknown type: %d \n",col->type );}

   col = col->next;}

 return;}

/*------------------------------------------------------------FrTableExpand--*/
void FrTableExpand(FrTable *table)
/*---------------------------------------------------------------------------*/
{
 if(table == NULL) return;

 if(table->next != NULL) FrTableExpand(table->next);

 FrVectExpandF(table->column);

 return;}

/*-------------------------------------------------------------FrTableFree--*/
void FrTableFree(struct FrTable *table)
/*--------------------------------------------------------------------------*/
{int i;

 if(table == NULL) return;

 if(table->next != NULL) FrTableFree(table->next);

 if(table->name       != NULL) free (table->name);
 if(table->comment    != NULL) free (table->comment);

 for(i=0; i<table->nColumn; i++)
    {if(table->columnName[i] != NULL) free(table->columnName[i]);}
 free(table->columnName);
 
 FrVectFree(table->column);

 free(table);

 return;}

/*-------------------------------------------------------------FrTableGetCol--*/
FrVect* FrTableGetCol(FrTable *table,
                      char *colName)
/*--------------------------------------------------------------------------*/
{struct FrVect *col;
 
 if(table == NULL) return(NULL);
 if(colName == NULL) return(NULL); 

 for(col = table->column; col!= NULL; col = col->next)
   {if(strcmp(col->name,colName) == 0) return(col);}

 return(NULL);
}
/*--------------------------------------------------------------FrTableNew--*/
struct FrTable *FrTableNew(char *name, 
                           char *comment,
                           int  nRow,
                           int  nColumn,
                           ...)
/*--------------------------------------------------------------------------*/
{struct FrTable *table;
 struct FrVect *vect, *last;
 va_list ap;
 int type, i;
 char *colName;
 
 table = (struct FrTable *) calloc(1,sizeof(struct FrTable));
 if(table == NULL) 
      {return(NULL);} 
 else {table->classe = FrTableDef();}
 table->next = NULL;

 if(FrStrCpy(&table->name,name)           == NULL) return(NULL);
 if(FrStrCpy(&table->comment,comment)     == NULL) return(NULL);

 table->nColumn = nColumn;
 table->nRow    = nRow;

 table->columnName = (char **) calloc(nColumn, sizeof(char *));
 if(table->columnName == NULL) return(NULL);

 last = NULL;
 va_start(ap,nColumn);
 for(i=0; i<nColumn; i++)
    {type    = va_arg(ap, int);
     colName = va_arg(ap, char *);
     vect = FrVectNew1D(colName, type, nRow, 0., "NONE", "NONE");
     if(vect == NULL) return(NULL);
     if(colName != NULL)
       {if(FrStrCpy(&table->columnName[i],colName) == NULL) return(NULL);}
     vect->next = last;
     last = vect;}

 table->column = last;

 return(table);} 

/*-------------------------------------------------------------FrTableRead--*/
void FrTableRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrTable *table;

 table = (struct FrTable *) calloc(1,sizeof(struct FrTable));
 if(table == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {table->classe = FrTableDef();}

 FrReadHeader(iFile,  table);
 FrReadSChar (iFile, &table->name); 
 FrReadSChar (iFile, &table->comment);
 FrReadShortU(iFile, &table->nColumn);
 FrReadIntU  (iFile, &table->nRow);
 FrReadVQ    (iFile, &table->columnName, table->nColumn);
 FrReadStruct(iFile, &table->column);
 FrReadStruct(iFile, &table->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", table->name);

 return;}

/*------------------------------------------------------------FrTableWrite--*/
void FrTableWrite(struct FrTable *table,
                  struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{
 if(table == NULL) return;

 FrPutNewRecord(oFile, table, FR_YES);
 FrPutSChar (oFile, table->name);
 FrPutSChar (oFile, table->comment);
 FrPutShortU(oFile, table->nColumn);
 FrPutIntU  (oFile, table->nRow);
 FrPutVQ    (oFile, table->columnName, table->nColumn);
 FrPutStruct(oFile, table->column);
 FrPutStruct(oFile, table->next);
 FrPutWriteRecord(oFile);

 FrVectWrite(table->column, oFile);

 if(table->next != NULL) FrTableWrite(table->next, oFile);
  
 return;}

/*---------------------------------------------------------------FrTagFree--*/
void FrTagFree(FrTag *tag)
/*--------------------------------------------------------------------------*/
/* This function free all the space alocated for the tag structure          */
/*--------------------------------------------------------------------------*/
{FrTag *next;

 while(tag != NULL)
   {next = tag->next;
    free(tag);
    tag = next;}
 
 return;}

/*----------------------------------------------------------------FrTagNew--*/
FrTag *FrTagNew(char *string)
/*--------------------------------------------------------------------------*/
/* This function is looking for space character to breaks a string in words.*/
/* It returns a link list of FrTag structures.                              */
/*--------------------------------------------------------------------------*/
{int i, slen, nWord;
 FrTag *root, *tag, **current;

 if(string == NULL) return(NULL);

 slen  = strlen(string);
 nWord = 0;
 root  = NULL;
 tag   = NULL;
 current = &root;

 for(i=0; i<slen; i++)
   {if(isspace((int)string[i]) != 0)
       {tag = NULL;}
    else
       {if(tag == NULL)
            {tag = (FrTag *) malloc(sizeof(FrTag));
	     if(tag == NULL) return(NULL);
             tag->next = NULL;
             *current = tag;
             current = &(tag->next);

             if(string[i] == '-')
	          {tag->start  = string+i+1;
                   tag->length = 0; 
                   tag->returnValue = FR_NO;}
	     else {tag->start  = string+i;
                   tag->length = 1; 
                   tag->returnValue = FR_YES;}}

        else{tag->length++;}}}
 
 return(root);}

/*---------------------------------------------------------------FrTagMatch--*/
FRBOOL FrTagMatch(FrTag *tag,
                  char *name)
/*---------------------------------------------------------------------------*/
/* this function returns FR_YES if the name match the tags. (FR_NO otherwise)*/
{int slen, match;

 if(tag  == NULL) return(FR_YES);
 if(name == NULL) return(FR_YES);
 slen = strlen(name);

 for(;tag != NULL; tag = tag->next) {

   if(tag->length == 0) continue;

   match = FrTagMatch1(name, slen, tag->start, tag->length);
   if(match == FR_YES) return(tag->returnValue);}

 return(FR_NO);}

/*--------------------------------------------------------------FrTagMatch1--*/
FRBOOL FrTagMatch1(char *name, 
                   int   nameL, 
                   char *tag, 
                   int   tagL)
/*---------------------------------------------------------------------------*/
/* this function returns FR_YES if the name match the tags. (FR_NO otherwise)*/
{int i, j, jStart, iStart;

         /*----loop over the string: we compare each character and 
                      stops the loop as soon as it founds a difference ------*/

 jStart = -1;
 iStart = -1;
 j = 0;

 for(i=0; i<nameL; i++)
   {if(tag[j] != '*')                   /*-------- case without wild card ---*/
      {if(name[i] != tag[j]) 
            {if(jStart >= 0)
                   {j = jStart;
                    i = iStart;}
	      else {return(FR_NO);}}
       else {j++;
             if(j >= tagL)
               {if(i == nameL-1) return(FR_YES);
                else             return(FR_NO);}}}
    
    else 
      {if(j+1 == tagL) return(FR_YES);    /*------- tag end by a '*' --------*/

       if(tag[j+1] == name[i]) {jStart = j;
                                iStart = i;
                                j++;
                                i--;}}}

 if(tagL - j != 0) return(FR_NO);         /*---still some character in tag---*/

 return(FR_YES);}

/*---------------------------------------------------------------- FrTOCDef--*/
struct FrSH *FrTOCDef()    
/*---------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrTOC", FrReadSkipRecord);  

      /*---- remark: in standard read we always skip the FrTOC -----*/

  FrSENew(classe, "INT_2S","ULeapS","-");
  FrSENew(classe, "INT_4S","localTime","-");
  FrSENew(classe, "INT_4U","nFrame","-");
  FrSENew(classe, "INT_4U *","GTimeS","-");
  FrSENew(classe, "INT_4U *","GTimeN","-");
  FrSENew(classe, "REAL_8 *","dt","-");
  FrSENew(classe, "INT_4S *","runs","-");
  FrSENew(classe, "INT_4U *","frame","-");
  FrSENew(classe, "INT_8U *","positionH","-");
  FrSENew(classe, "INT_8U *","nFirstADC","-");
  FrSENew(classe, "INT_8U *","nFirstSer","-");
  FrSENew(classe, "INT_8U *","nFirstTable","-");
  FrSENew(classe, "INT_8U *","nFirstMsg","-");
  FrSENew(classe, "INT_4U","nSH","-");
  FrSENew(classe, "INT_2U *","SHid","-");
  FrSENew(classe, "STRING *","SHname","-");
  FrSENew(classe, "INT_4U","nStatType","-");
  FrSENew(classe, "STRING","nameStat","-");
  FrSENew(classe, "STRING","detector","-");
  FrSENew(classe, "INT_4U","nStatInstance","-");
  FrSENew(classe, "INT_4U *","tStart","-");
  FrSENew(classe, "INT_4U *","tEnd","-");
  FrSENew(classe, "INT_4U *","version","-");
  FrSENew(classe, "INT_8U *","positionStat","-");
  FrSENew(classe, "INT_4U","nADC","-");
  FrSENew(classe, "STRING *","name","-");
  FrSENew(classe, "INT_4U *","channelID","-");
  FrSENew(classe, "INT_4U *","groupID","-");
  FrSENew(classe, "INT_8U *","positionADC","-");
  FrSENew(classe, "INT_4U","nProc","-");
  FrSENew(classe, "STRING *","nameProc","-");
  FrSENew(classe, "INT_8U *","positionProc","-");
  FrSENew(classe, "INT_4U","nSim","-");
  FrSENew(classe, "STRING *","nameSim","-");
  FrSENew(classe, "INT_8U *","positionSim","-");
  FrSENew(classe, "INT_4U","nSer","-");
  FrSENew(classe, "STRING *","nameSer","-");
  FrSENew(classe, "INT_8U *","positionSer","-");
  FrSENew(classe, "INT_4U","nSummary","-");
  FrSENew(classe, "STRING *","nameSum","-");
  FrSENew(classe, "INT_8U *","positionSum","-");
  FrSENew(classe, "INT_4U","nTrig","-");
  FrSENew(classe, "STRING *","nameTrig","-");
  FrSENew(classe, "INT_4U *","GTimeSTrig","-");
  FrSENew(classe, "INT_4U *","GTimeNTrig","-");
  FrSENew(classe, "INT_8U *","positionTrig","-");
  FrSENew(classe, "INT_4U","nSimEvt","-");
  FrSENew(classe, "STRING *","nameSimEvt","-");
  FrSENew(classe, "INT_4U *","GTimeSSim","-");
  FrSENew(classe, "INT_4U *","GTimeNSim","-");
  FrSENew(classe, "INT_8U *","positionSimEvt","-");

  return(classe);}
/*---------------------------------------------------------------FrTOCDump--*/
void FrTOCDump(FrTOC *toc,
               FILE *fp,
               int debugLvl,
               char *tag)
/*--------------------------------------------------------------------------*/
{int size, gts, t0, tend;
 int i;
 struct FrStatMark *sm;

 if(toc == NULL)    return;

 printf(" Dump file TOC: %d Frames; ULeaps=%d localTime=%d\n",
          toc->nFrame, toc->ULeapS,toc->localTime);
 if(toc->nFrame == 0) return; 

                        /*-------------- Frame information ----------*/

 t0 = toc->GTimeS[0];
 tend = toc->GTimeS[toc->nFrame-1];
 printf("  First frame GPS=%d (UTC:%s) (t0)\n",t0, FrStrUTC(t0,  toc->ULeapS));
 printf("  Last  frame GPS=%d (UTC:%s)\n"   ,tend, FrStrUTC(tend,toc->ULeapS));
 if(debugLvl <1) return;

 printf("        run# frame#  t-t0(s)"
        "  position  firstADC first ser  f. table   size(B)\n");
 size = 0;
 for(i=0; i<toc->nFrame; i++)
    {if((i < 5) || (i>toc->nFrame -3))
       {gts = toc->GTimeS[i];
        printf("%5d%7d%7d%9d%10ld%10ld%10ld%10ld", 
                    i, toc->runs[i],toc->frame[i],toc->GTimeS[i]-t0, 
            toc->positionH[i],toc->nFirstADC[i],toc->nFirstSer[i],
         toc->nFirstTable[i]);
        if(i < toc->nFrame -1)
             {size = toc->positionH[i+1] - toc->positionH[i];
              printf(" %8d\n",size);}
        else {printf("\n");}}
     else if(i == 5)
       {printf(" ....   ....\n");}}

 if(debugLvl < 2) return;

                        /*--------- Static Data information ---------*/

 printf(" Number of static data blocks: %d\n",toc->nStatType);
 sm = toc->statMark;
 while(sm != NULL)
   {printf(" For Static Data:%s   detector:%s    %d instances\n",
         sm->name, sm->detector, sm->nStat);
    printf("     TStart      TEnd      version      position\n");
    for(i=0; i<sm->nStat; i++)
      {if(i < 3 || i == sm->nStat-1) 
          {printf("     %9d %9d %7d %14ld\n",sm->tStart[i],sm->tEnd[i],
                 sm->version[i],sm->position[i]);}
       else if(i == 3) {printf("       .......\n");}}

    sm = sm->next;}
                           /*--------- time serie information ---------*/

 FrTOCtsDump(toc->adc,    fp,     "ADC", tag, toc->nFrame);
 FrTOCtsDump(toc->proc,   fp,    "proc", tag, toc->nFrame);
 FrTOCtsDump(toc->sim,    fp,     "sim", tag, toc->nFrame);
 FrTOCtsDump(toc->ser,    fp,     "ser", tag, toc->nFrame);
 FrTOCtsDump(toc->summary,fp, "summary", tag, toc->nFrame);

 FrTOCevtDump(toc->trig,  fp, "FrTrigData");
 FrTOCevtDump(toc->simEvt,fp, "FrSimEvt");

                            /*------------ SH information -------------------*/

 if(debugLvl < 3) return; 

 printf("  Number of SH structure: %d\n",toc->nSH);
 for(i=0; i<toc->nSH; i++)
   {printf("    id=%4d for:%s\n",toc->SHid[i],toc->SHname[i]);}

 return;}

/*------------------------------------------------------------FrTOCevtDump--*/
void FrTOCevtDump(FrTOCevt *evt, 
                  FILE *fp,
                  char *type)
/*--------------------------------------------------------------------------*/
{int i, gts;
 double gps;

 if(evt == NULL) return;
 if(evt->nEvent == 0) return;

 fprintf(fp," %s: %d event(s):\n  #          GPS       UTC time     "
          "               Position  Name", type, evt->nEvent);

 for(i=0; i<evt->nEvent; i++)
   {if(i > 4) 
      {fprintf(fp,"\n ....\n");
       break;}
    gts = evt->GTimeS[i];
    gps = evt->GTimeS[i]+1.e-9*evt->GTimeN[i];
    fprintf(fp,"\n%5d%16.4f%25s %12ld",i, gps, 
                             FrStrUTC(gts,0), evt->position[i]);
    if(evt->name[i] != NULL) fprintf(fp," %s",evt->name[i]);}

 return;}

/*-------------------------------------------------------------FrTOCevtFree--*/
void FrTOCevtFree(FrTOCevt *evt)
/*---------------------------------------------------------------------------*/
{int i;

 if(evt == NULL)   return;

 if(evt->maxEvent > 0)
   {free(evt->GTimeS);
    free(evt->GTimeN);
    free(evt->position);

    for(i=0; i<evt->nEvent; i++)
       {free(evt->name[i]);}
    free(evt->name);}

 free(evt);

 return;}

/*-------------------------------------------------------------FrTOCevtMark--*/
void FrTOCevtMark(struct FrFile *oFile,
                  struct FrTOCevt *evt,
                  char *name,
                  unsigned int GTimeS,
                  unsigned int GTimeN)
/*---------------------------------------------------------------------------*/
{
 if(evt == NULL)  return;

 if(evt->nEvent > evt->maxEvent - 2)
   {evt->maxEvent = 2 * evt->maxEvent;
    evt->name =(char **)realloc(evt->name,         sizeof(char *) * evt->maxEvent);
    evt->GTimeS =(unsigned int *)realloc(evt->GTimeS, sizeof(int) * evt->maxEvent);
    evt->GTimeN =(unsigned int *)realloc(evt->GTimeN, sizeof(int) * evt->maxEvent);
    evt->position =(FRULONG *)realloc(evt->position,sizeof(FRULONG)*evt->maxEvent);

    if((evt->name     == NULL) || 
       (evt->GTimeS   == NULL) || 
       (evt->GTimeN   == NULL) || 
       (evt->position == NULL))
      {evt->maxEvent = 0;
       return;}}
                             /*-------------- fill information--------------*/

 FrStrCpy(&evt->name[evt->nEvent], name);
 evt->GTimeS[evt->nEvent] = GTimeS;
 evt->GTimeN[evt->nEvent] = GTimeN;
 evt->position[evt->nEvent]= oFile->nBytes;

 evt->nEvent++;

 return;}
/*-------------------------------------------------------------FrTOCevtNew--*/
struct FrTOCevt *FrTOCevtNew()
/*---------------------------------------------------------------------------*/
{struct FrTOCevt *evt;

 evt = (struct FrTOCevt *) malloc(sizeof(struct FrTOCevt));
 if(evt == NULL)  return(NULL);

 evt->maxEvent = 4;
 
 evt->name     =       (char **)malloc(sizeof(char *) * evt->maxEvent);
 evt->GTimeS   =(unsigned int *)malloc(sizeof(int)    * evt->maxEvent);
 evt->GTimeN   =(unsigned int *)malloc(sizeof(int)    * evt->maxEvent);
 evt->position =     (FRULONG *)malloc(sizeof(FRULONG)* evt->maxEvent);

 if((evt->name     == NULL) || 
    (evt->GTimeS   == NULL) || 
    (evt->GTimeN   == NULL) ||
    (evt->position == NULL))
    {evt->maxEvent = 0;
     return(NULL);}

 evt->nEvent = 0;

 return(evt);}

/*------------------------------------------------------------FrTOCevtRead--*/
struct FrTOCevt *FrTOCevtRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrTOCevt *evt;
 unsigned int nEvent;
    
 FrReadIntU(iFile, &nEvent);
 if(nEvent == 0xffffffff) return(NULL);

 evt = (struct FrTOCevt *) malloc(sizeof(struct FrTOCevt));
 if(evt == NULL) return(NULL);

 evt->nEvent   = nEvent;
 evt->maxEvent = nEvent;

 if(FrDebugLvl > 1) fprintf(FrFOut," nEvent=%d\n",evt->nEvent);
 if(evt->nEvent > 0)
   {FrReadVQ (iFile,            &evt->name,     evt->nEvent);
    FrReadVI (iFile, (int **)   &evt->GTimeS,   evt->nEvent);
    FrReadVI (iFile, (int **)   &evt->GTimeN,   evt->nEvent);
    FrReadVL (iFile, (FRLONG **)&evt->position, evt->nEvent);}
 else
   {evt->name     = NULL;
    evt->GTimeS   = NULL;
    evt->GTimeN   = NULL;
    evt->position = NULL;
    evt->maxEvent = 0;}

 return(evt);}

/*------------------------------------------------------------FrTOCevtWrite-*/
void FrTOCevtWrite(struct FrFile *oFile,
                   struct FrTOCevt *evt)
/*--------------------------------------------------------------------------*/
{
 if(evt == NULL) 
    {FrPutInt  (oFile, 0);
     return;}

 FrPutInt  (oFile, evt->nEvent);
 if(evt->nEvent > 0)
   {FrPutVQ (oFile,           evt->name,     evt->nEvent);
    FrPutVI (oFile,    (int *)evt->GTimeS,   evt->nEvent);
    FrPutVI (oFile,    (int *)evt->GTimeN,   evt->nEvent);
    FrPutVL (oFile, (FRLONG *)evt->position, evt->nEvent);}
 
 return;}

/*--------------------------------------------------------FrTOCFree--*/
void FrTOCFree(struct FrTOC *toc)
/*--------------------------------------------------------------------*/
{int i;
 struct FrStatMark *sm, *nextSm;

 if(toc == NULL)   return;

 free(toc->GTimeS);
 free(toc->GTimeN);
 free(toc->dt);
 free(toc->runs);
 free(toc->frame);
 free(toc->positionH);
 free(toc->nFirstADC);
 free(toc->nFirstSer);
 free(toc->nFirstTable);
 free(toc->nFirstMsg);

 free(toc->SHid);
 for(i=0; i<toc->nSH; i++)
    {free(toc->SHname[i]);}
 free(toc->SHname);

                        /*--------- Static Data information ---------*/

 sm = toc->statMark;
 while(sm != NULL)
   {nextSm = sm->next;
    free(sm->name);
    free(sm->detector);
    free(sm->tStart);
    free(sm->tEnd);
    free(sm->version);
    free(sm->position);
    free(sm);
    sm = nextSm;}
                              /*--------- free time series  ---------*/

 FrTOCtsFree(toc->adc);
 FrTOCtsFree(toc->proc);
 FrTOCtsFree(toc->sim);
 FrTOCtsFree(toc->ser);
 FrTOCtsFree(toc->summary);

 FrTOCtsHFree(toc->adcH);
 FrTOCtsHFree(toc->procH);
 FrTOCtsHFree(toc->simH);
 FrTOCtsHFree(toc->serH);
 FrTOCtsHFree(toc->summaryH);

 FrTOCevtFree(toc->trig);
 FrTOCevtFree(toc->simEvt);

 free(toc);

 return;
}
/*-------------------------------------------------------FrTOCFrame--*/
void FrTOCFrame(struct FrFile *oFile,
                struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrTOC *toc;
 int max;
  
 if(oFile->toc == NULL) FrTOCNew(oFile, frame);
 toc = oFile->toc; 
 if(toc == NULL) return;
 toc->nFrame++;

                       /*-------- increase space if needed -----------*/

 if(toc->nFrame+1 >= toc->maxFrame)
   {toc->maxFrame = 2 * toc->maxFrame;
    max = toc->maxFrame;

    toc->GTimeS =(unsigned int *)realloc(toc->GTimeS,     sizeof(int)    *max);
    toc->GTimeN =(unsigned int *)realloc(toc->GTimeN,     sizeof(int)    *max);
    toc->dt         = (double *) realloc(toc->dt,         sizeof(double) *max);
    toc->runs       =    (int *) realloc(toc->runs,       sizeof(int)    *max);
    toc->frame      =    (int *) realloc(toc->frame,      sizeof(int)    *max);
    toc->positionH  =(FRULONG *) realloc(toc->positionH,  sizeof(FRULONG)*max);
    toc->nFirstADC  =(FRULONG *) realloc(toc->nFirstADC,  sizeof(FRULONG)*max);
    toc->nFirstSer  =(FRULONG *) realloc(toc->nFirstSer,  sizeof(FRULONG)*max);
    toc->nFirstTable=(FRULONG *) realloc(toc->nFirstTable,sizeof(FRULONG)*max);
    toc->nFirstMsg  =(FRULONG *) realloc(toc->nFirstMsg,  sizeof(FRULONG)*max);

    if((toc->GTimeS      == NULL) ||
       (toc->GTimeN      == NULL) ||
       (toc->dt          == NULL) ||
       (toc->runs        == NULL) ||
       (toc->frame       == NULL) ||
       (toc->positionH   == NULL) ||
       (toc->nFirstADC   == NULL) ||
       (toc->nFirstSer   == NULL) ||
       (toc->nFirstTable == NULL) ||
       (toc->nFirstMsg   == NULL))
           {FrError(3,"FrTOCFrame"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}

                 /*-------- increase storage for time series ----*/

    FrTOCtsRealloc(toc->adcH,     oFile, max/2);
    FrTOCtsRealloc(toc->procH,    oFile, max/2);
    FrTOCtsRealloc(toc->simH,     oFile, max/2);
    FrTOCtsRealloc(toc->serH,     oFile, max/2);
    FrTOCtsRealloc(toc->summaryH, oFile, max/2);
    }

                       /*-------------- fill information--------------*/

 toc->GTimeS   [toc->nFrame] = frame->GTimeS;
 toc->GTimeN   [toc->nFrame] = frame->GTimeN;
 toc->dt       [toc->nFrame] = frame->dt;
 toc->runs     [toc->nFrame] = frame->run;
 toc->frame    [toc->nFrame] = frame->frame;
 toc->positionH[toc->nFrame] = oFile->nBytes;

 toc->nFirstADC  [toc->nFrame] = 0;
 toc->nFirstSer  [toc->nFrame] = 0;
 toc->nFirstTable[toc->nFrame] = 0;
 toc->nFirstMsg  [toc->nFrame] = 0;
 
 return;}

/*--------------------------------------------------------- FrTOCFrameFindN--*/
int FrTOCFrameFindN(FrFile *iFile,
                    int run,
                    int frame)
/*---------------------------------------------------------------------------*/
/* This function search the frame index in the Table Of Content. It returns  */
/* -2 if no TOC is available, and -1 if the frame is not in the file         */
/*---------------------------------------------------------------------------*/
{FrTOC *toc;
 int i;

 if(iFile == NULL) return(-1);
 if(iFile->toc == NULL)  FrTOCReadFull(iFile);

 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/
 
 toc = iFile->toc;
 if(toc == NULL) return(-2);

 for(i=0; i<toc->nFrame; i++)
   {if(frame != toc->frame[i]) continue;
    if(run   != toc->runs [i]) continue;
    return(i);}

 return(-1);}

/*------------------------------------------------------ FrTOCFrameFindNext--*/
int FrTOCFrameFindNext(FrFile *iFile,
                       double gtime)
/*---------------------------------------------------------------------------*/
/* This function search the frame index in the Table Of Content. It returns  */
/* a negative value if the frame could not be found                          */
/*---------------------------------------------------------------------------*/
{int position;

 if(iFile == NULL) return(-1);
 position = FrTOCFrameFindT(iFile, gtime);
 if(position < 0) return(-2);

 if(position+1 < iFile->toc->nFrame) return(position+1);
 
            /*------------ the next frame is in the next file. Go get it ---*/

 FrFileIClose(iFile);
 iFile->current = iFile->current->next;
 if(iFile->current == NULL) return(-3);     /*------------- no more file ---*/

 iFile->error = FR_OK;   /*--- reset the error flag for the next file ------*/
 FrFileIOpen(iFile);
 if(iFile->error != FR_OK) return(-4); 

 return(0);}
/*----------------------------------------------------- FrTOCFrameFindNextT--*/
double FrTOCFrameFindNextT(FrFile *iFile,
                           double gtime)
/*---------------------------------------------------------------------------*/
/* This function return the GPS time for the next frame.                     */
/* It returns  a negative value if the frame could not be found              */
/*---------------------------------------------------------------------------*/
{int position;
 double GTimeS, GTimeN;

 if(iFile == NULL) return(-1.);
 position = FrTOCFrameFindNext(iFile, gtime);
 if(position < 0) return(-2.);
 
 if(iFile->toc == NULL)  FrTOCReadFull(iFile);
 if(iFile->toc == NULL) return(-3.);

 GTimeS = iFile->toc->GTimeS[position];
 GTimeN = iFile->toc->GTimeN[position];

 return(GTimeS + 1.e-9*GTimeN);}

/*--------------------------------------------------------- FrTOCFrameFindT--*/
int FrTOCFrameFindT(FrFile *iFile,
                    double gtime)
/*---------------------------------------------------------------------------*/
/* This function search the frame index in the Table Of Content. It returns  */
/* -2 if no TOC is available, and -1 if the frame is not in the file         */
/*---------------------------------------------------------------------------*/
{int position;
 FrFileH *firstFileH;;

 if(iFile == NULL) return(-1);

                    /*--- We loop on all possible files ---------------------*/

 while(1)
   {firstFileH = iFile->current;
    
    position = FrTOCFrameFindT1(iFile, gtime);
    if(position >= 0) return(position);
 
    if(FrFileINext(iFile, gtime, 0., firstFileH) != 0) return(-3);}

 return(-4);}

/*--------------------------------------------------------- FrTOCFrameFindT--*/
int FrTOCFrameFindT1(FrFile *iFile,
                    double gtime)
/*---------------------------------------------------------------------------*/
/* This function search the frame index in the Table Of Content. It returns  */
/* -2 if no TOC is available, and -1 if the frame is not in the file         */
/* It works for a single file                                                */
/*---------------------------------------------------------------------------*/
{FrTOC *toc;
 int i, delta, ilast, nLoop;
 double t1;

 if(iFile == NULL) return(-1);

 if(iFile->toc == NULL)  FrTOCReadFull(iFile);

 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/
 
 toc = iFile->toc;
 if(toc == NULL) return(-2);

 if(toc->nFrame == 0) return(-1);

 if(gtime == 0.)      return(0);   /*--- return the first frame is gtime == 0*/

 gtime += 1.e-6; /* we add a small offset to avoid round problems when using
                 the starting time of the frame as requested time (for instance
                 1 may be converted to 0.999999 instead of 1.0000) ----------*/

 delta = toc->nFrame;
 i =  delta - delta/2;
 ilast = -1;

 nLoop = 0;
 while(delta > 0)
   {if(nLoop++ > 80) return(-4);  /*-- the frame is probably not here ---*/
    if(i < 0) i = 0;
    if(i > toc->nFrame-1) i = toc->nFrame-1;
    delta = delta-delta/2;

    if(ilast == i) break;
    ilast = i;

    t1 =  toc->GTimeS[i]+1.e-9*toc->GTimeN[i];
    if     (gtime < t1)              {i = i - delta;}
    else if(gtime > t1 + toc->dt[i]) {i = i + delta;}
    else {return(i);}}

     /*--- the event was not found,we try to open the next file in the list -*/

 return(-3);
}
/*------------------------------------------------------------FrTOCGetTimes--*/
void FrTOCGetTimes(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{
 double tEvent, tStart, tEnd, fStart, fEnd;
 FrTOCevt *evt;
 int i;

 if(iFile->toc == NULL) return;
 if(iFile->current == NULL) return;
 
                     /*------------------------ Get time limits for frames --*/

 tStart = 1.e+20;
 tEnd   = 0.;

 for(i=0; i<iFile->toc->nFrame; i++)
   {fStart = iFile->toc->GTimeS[i] + 1.e-9*iFile->toc->GTimeN[i];
    if(fStart < tStart) tStart = fStart;
    fEnd = fStart + iFile->toc->dt[i];
    if(fEnd > tEnd) tEnd = fEnd;}
 
                    /*---------------------------Find time limit for events--*/

 evt = iFile->toc->trig;
 if(evt != NULL)
   {for(i=0; i<evt->nEvent; i++)
      {tEvent = evt->GTimeS[i]+1.e-9*evt->GTimeN[i];
       if(tEvent < tStart) tStart = tEvent;
       if(tEvent > tEnd)   tEnd   = tEvent;}}

 evt = iFile->toc->simEvt;
 if(evt != NULL)
   {for(i=0; i<evt->nEvent; i++)
      {tEvent = evt->GTimeS[i]+1.e-9*evt->GTimeN[i];
       if(tEvent < tStart) tStart = tEvent;
       if(tEvent > tEnd)   tEnd   = tEvent;}}

 iFile->current->tStart = tStart;
 iFile->current->length = tEnd-tStart;

 return;}

/*----------------------------------------------------------------FrTOCNew--*/
void FrTOCNew(struct FrFile *oFile, 
              struct FrameH *frame)
/*--------------------------------------------------------------------------*/
{struct FrTOC   *toc;
 int max;

toc = malloc(sizeof(struct FrTOC));
 if(toc == NULL)
           {FrError(3,"FrTOCNew"," malloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}
 else {toc->classe = FrTOCDef();} 

 oFile->toc = toc;

 toc->ULeapS    = frame->ULeapS;
 toc->localTime = frame->localTime;
 toc->nFrame    = -1;
 toc->maxFrame  = 4;
 max = toc->maxFrame;

 toc->GTimeS =(unsigned int *)malloc(sizeof(double)  * max);
 toc->GTimeN =(unsigned int *)malloc(sizeof(double)  * max);
 toc->dt         = (double *) malloc(sizeof(double)  * max);
 toc->runs       =    (int *) malloc(sizeof(int)     * max);
 toc->frame      =    (int *) malloc(sizeof(int)     * max);
 toc->positionH  =(FRULONG *) malloc(sizeof(FRULONG) * max);
 toc->nFirstADC  =(FRULONG *) malloc(sizeof(FRULONG) * max);
 toc->nFirstSer  =(FRULONG *) malloc(sizeof(FRULONG) * max);
 toc->nFirstTable=(FRULONG *) malloc(sizeof(FRULONG) * max);
 toc->nFirstMsg  =(FRULONG *) malloc(sizeof(FRULONG) * max);

 if((toc->GTimeS      == NULL) ||
    (toc->GTimeN      == NULL) ||
    (toc->dt          == NULL) ||
    (toc->runs        == NULL) ||
    (toc->frame       == NULL) ||
    (toc->positionH   == NULL) ||
    (toc->nFirstADC   == NULL) ||
    (toc->nFirstSer   == NULL) ||
    (toc->nFirstTable == NULL) ||
    (toc->nFirstMsg   == NULL))
           {FrError(3,"FrTOCNew"," malloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}


 toc->nSH    = 0;
 toc->SHid   = (unsigned short *)malloc(FRMAPMAXSH*sizeof(short));
 toc->SHname = (char **)         malloc(FRMAPMAXSH*sizeof(char *));

 toc->nStatType = 0;
 toc->statMark  = NULL;

 toc->adc     = NULL;
 toc->proc    = NULL;
 toc->sim     = NULL;
 toc->ser     = NULL;
 toc->summary = NULL;

 toc->adcH     = NULL;
 toc->procH    = NULL;
 toc->simH     = NULL;
 toc->serH     = NULL;
 toc->summaryH = NULL;

 toc->trig    = FrTOCevtNew();
 toc->simEvt  = FrTOCevtNew();

 return;}
/*---------------------------------------------------------------FrTOCRead--*/
FrTOC *FrTOCRead(FrFile *iFile)
/*--------------------------------------------------------------------------*/
{
  return(FrTOCReadCheck(iFile, -1));
}
/*---------------------------------------------------------------FrTOCRead--*/
FrTOC *FrTOCReadCheck(FrFile *iFile, 
                      int nFrame)
/*--------------------------------------------------------------------------*/
{struct FrTOC *toc;
 struct FrStatMark *sm;
 int i;
 unsigned short id;
    
 toc = (struct FrTOC *) calloc(1,sizeof(struct FrTOC));
 if(toc == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}

 FrReadShortU(iFile, &id);
 if(FrDebugLvl > 0) fprintf(FrFOut,"FrTOCRead: for id=%d\n",id);

 FrReadShort (iFile, &toc->ULeapS);
 FrReadInt   (iFile, &toc->localTime);
 FrReadInt   (iFile, &toc->nFrame);
 if(FrDebugLvl > 1) fprintf(FrFOut," nFrame=%d\n",toc->nFrame);

 if((nFrame >= 0) && (nFrame != toc->nFrame))
   {if(FrDebugLvl > 0) fprintf(FrFOut,"FrTOCRead: ERROR: # of frame missmatch"
               " (%d %d). Corrupted TOC. Do not use it\n",nFrame,toc->nFrame);
    free(toc);
    return(NULL);}

 if(toc->nFrame > 0)
  {FrReadVI  (iFile, (int **)&toc->GTimeS, toc->nFrame);
   FrReadVI  (iFile, (int **)&toc->GTimeN, toc->nFrame);
   FrReadVD  (iFile, &toc->dt,                     toc->nFrame);
   FrReadVI  (iFile, &toc->runs,                   toc->nFrame);
   FrReadVI  (iFile, (int **)&toc->frame,          toc->nFrame);
   FrReadVL  (iFile, (FRLONG **)&toc->positionH,   toc->nFrame);
   FrReadVL  (iFile, (FRLONG **)&toc->nFirstADC,   toc->nFrame);
   FrReadVL  (iFile, (FRLONG **)&toc->nFirstSer,   toc->nFrame);
   FrReadVL  (iFile, (FRLONG **)&toc->nFirstTable, toc->nFrame);
   FrReadVL  (iFile, (FRLONG **)&toc->nFirstMsg,   toc->nFrame);}

 FrReadIntU  (iFile, &toc->nSH);
 if(FrDebugLvl > 1) fprintf(FrFOut," nSH=%d\n",toc->nSH);
 FrReadVS    (iFile, (short **)&toc->SHid, toc->nSH);
 FrReadVQ    (iFile, &toc->SHname, toc->nSH);

          /*-------------- get SHid for FrVect ------------------*/

 for(i=0; i<toc->nSH; i++)
    {if(strcmp(toc->SHname[i], "FrVect") != 0) continue;
     iFile->FrVectId = toc->SHid[i];
     break;}

         /*--------------- get Static data ----------------------*/

 FrReadInt   (iFile, &toc->nStatType);
 toc->statMark = NULL;
 if(FrDebugLvl > 1) fprintf(FrFOut," nStatType=%d\n",toc->nStatType);
 for(i=0; i<toc->nStatType; i++)
   {sm = (struct FrStatMark *) malloc(sizeof(struct FrStatMark));
    if(sm == NULL)
       {FrError(3,"FrTOCRead"," malloc failed");
        iFile->error = FR_ERROR_MALLOC_FAILED; 
        return(NULL);}
     FrReadSChar(iFile, &sm->name);
     FrReadSChar(iFile, &sm->detector);
     FrReadInt (iFile,  &sm->nStat);
     sm->maxStat = sm->nStat;
     FrReadVI (iFile, (int **) &sm->tStart,   sm->nStat);
     FrReadVI (iFile, (int **) &sm->tEnd,     sm->nStat);
     FrReadVI (iFile, (int **) &sm->version,  sm->nStat);
     FrReadVL (iFile,          &sm->position, sm->nStat);
     sm->next = toc->statMark;
     toc->statMark = sm;}

          /*------------------- read time series part --------------*/

 toc->adc     = FrTOCtsRead(iFile,     "ADC", toc->nFrame);
 toc->proc    = FrTOCtsRead(iFile,    "proc", toc->nFrame);
 toc->sim     = FrTOCtsRead(iFile,     "sim", toc->nFrame);
 toc->ser     = FrTOCtsRead(iFile,     "ser", toc->nFrame);
 toc->summary = FrTOCtsRead(iFile, "summary", toc->nFrame);

          /*---------------------- read event part -----------------*/

 toc->trig   = FrTOCevtRead(iFile);
 toc->simEvt = FrTOCevtRead(iFile);

 if(FrDebugLvl > 0) FrTOCDump(toc, FrFOut, FrDebugLvl-1, NULL);
 iFile->toc = toc;

 return(toc);}

/*---------------------------------------------------FrTOCReadFull --*/
struct FrTOC *FrTOCReadFull(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{unsigned int offset, i, j, type, nFrames, nBytes, chkSumFlag, chkSum;
 FRLONG off;
 struct FrTOC *toc;

 if(iFile->frfd == NULL) FrFileIOpen(iFile);   /*--Open the file if needed --*/

 if(iFile->toc != NULL) return(iFile->toc);

         /*--- do not compute checksum when using random access ----*/

 iFile->chkSumFlag = FR_NO;

        /*--------first determine the offset for the file marks ----*/

 if(FrIOSetFromEnd(iFile->frfd, -5*sizeof(int)) == -1) {return(NULL);}

 FrReadIntU (iFile, &nFrames);
 FrReadIntU (iFile, &nBytes);
 FrReadIntU (iFile, &chkSumFlag);
 FrReadIntU (iFile, &chkSum);
 FrReadIntU (iFile, &offset);

 if(chkSumFlag > 1)                    /*---- this is a corrupted TOC-------*/
   {if(FrDebugLvl > 0) fprintf(FrFOut,"FrTOCReadFull: ERROR: Wrong"
         " chksum flag (%d). Corrupted TOC. Do not use it\n",chkSumFlag);
    return(NULL);}

 if(offset == 0) {return(NULL);}
 off = offset-6;          /*--- skip the record length(INT4) and type(INT2) */
 if(FrIOSetFromEnd(iFile->frfd, -off) == -1) {return(NULL);}
 
                   /*---- create the file mark and read it ----------*/
 FrTOCReadCheck(iFile, nFrames);

     /*---------- set SH pointer for direct read function access ---*/

 toc = iFile->toc;
 if(toc == NULL) return(NULL);

 for(i=0; i<toc->nSH; i++)
   {for(j=0; j<FrnSH; j++)
     {if(strcmp(toc->SHname[i],FrSHRoot[j]->name) == 0) break;}
    if (j==FrnSH) {return(NULL);}

    type = toc->SHid[i];
    if(type >= iFile->maxSH) 
       {FrFileIncSH(iFile,type);
        if(iFile->error != FR_OK) return(NULL);}
     
    iFile->sh[type] =  FrSHNew(FrSHRoot[j]->name,NULL);
    iFile->sh[type]->objRead = FrSHRoot[j]->objRead;}

      /*----- set the pointer to the first frame, so the file could be used--*/

 if(toc->nFrame > 0) FrIOSet(iFile->frfd, toc->positionH[0]);

 FrTOCGetTimes(iFile);       /*------------------------Save start/end time --*/

 FrTOCSort(iFile);           /*--------------------------- check time order--*/

 return(toc);}

/*--------------------------------------------------------------FrTOCSetPos--*/
int FrTOCSetPos(FrFile *iFile,
                long position)
/*---------------------------------------------------------------------------*/
/* this function set the file pointer position to the first bytes            */
{
 if(iFile == NULL) return(1);
 if(position == 0) return(1);

 if(FrIOSet(iFile->frfd, position) == -1) return (2);

 while((iFile->error == FR_OK))
     {FrReadInt(  iFile,  (int *) &iFile->length);
      FrReadShort(iFile,(short *) &iFile->type);
      if(iFile->error != FR_OK) return(3);

      if(FrDebugLvl > 2) 
         {fprintf(FrFOut," length: %8d type=%4d ",iFile->length,iFile->type);}
                             
      if(iFile->type > 2) return(0);

      FrReadSkipRecord(iFile);}

 return(4);}

/*-----------------------------------------------------------------FrTOCSH--*/
void FrTOCSH(struct FrFile *oFile, 
             char *name, 
             unsigned short id)
/*--------------------------------------------------------------------------*/
{struct FrTOC *toc;
 
 toc = oFile->toc;
 if(toc == NULL) return;

 if(toc->nSH >= FRMAPMAXSH) return;
 toc->SHid[toc->nSH] = id;
 FrStrCpy(&toc->SHname[toc->nSH], name);
 toc->nSH ++;

 return;}

/*---------------------------------------------------------------FrTOCSort--*/
void FrTOCSort(struct FrFile *file)
/*--------------------------------------------------------------------------*/
/* This function sort the frame by increasing GPS time                      */
/*--------------------------------------------------------------------------*/
{FrTOC *toc;
 FrTOCts *ts;
 double previous, t, *gps, min;
 int i, j, first=0, *index, nFr;

 toc = file->toc;     
 if(toc->nFrame == 0) return;

                 /*------------ first check if we have to do something ----*/

 previous = 0.;
 for(i=0; i<toc->nFrame; i++)
   {t = toc->GTimeS[i] + 1.e-9*toc->GTimeN[i];
    if(previous >= t) break;
    previous = t;}
 if(i == toc->nFrame) return;

        /*------ We need to sort the TOC. The algorithm is not efficient, 
                             but usually the TOC is already ordered---------*/

 if(FrDebugLvl > 0) 
       printf("FrTOCSort: start sorting for nFrame=%d\n",toc->nFrame);

              /*------------------ first we get the right frame order ------*/

 index = (int *)    malloc(toc->nFrame*sizeof(int));
 gps   = (double *) malloc(toc->nFrame*sizeof(double));
 if (index == NULL || gps == NULL) return;

 for(i=0; i<toc->nFrame; i++)
   {gps[i] = toc->GTimeS[i] + 1.e-9*toc->GTimeN[i];}

 for(i=0; i<toc->nFrame; i++)
   {min = 1.e+20;
    for(j=0; j<toc->nFrame; j++)
      {if(gps[j] < min)
        {min = gps[j];
         first = j;}}
    index[i] = first;
    gps[first] = 1.e+30;}

           /*----- then we copy all the frame array with the right order ----*/

 nFr = toc->nFrame;
 j  = FrTOCSort1((char **) &(toc->GTimeS),      index, nFr, sizeof(int));
 j += FrTOCSort1((char **)&(toc->GTimeN),      index, nFr, sizeof(int));
 j += FrTOCSort1((char **)&(toc->dt),          index, nFr, sizeof(double));
 j += FrTOCSort1((char **)&(toc->runs),        index, nFr, sizeof(int));
 j += FrTOCSort1((char **)&(toc->frame),       index, nFr, sizeof(int));
 j += FrTOCSort1((char **)&(toc->positionH),   index, nFr, sizeof(FRLONG));
 j += FrTOCSort1((char **)&(toc->nFirstADC),   index, nFr, sizeof(FRLONG));
 j += FrTOCSort1((char **)&(toc->nFirstSer),   index, nFr, sizeof(FRLONG));
 j += FrTOCSort1((char **)&(toc->nFirstTable), index, nFr, sizeof(FRLONG));
 j += FrTOCSort1((char **)&(toc->nFirstMsg),   index, nFr, sizeof(FRLONG));

          /*------------------- read time series part --------------*/

 for(ts = toc->adc; ts != NULL; ts = ts->next)
   {j += FrTOCSort1((char **)&(ts->position), index, nFr, sizeof(FRLONG));}
 for(ts = toc->proc; ts != NULL; ts = ts->next)
   {j += FrTOCSort1((char **)&(ts->position), index, nFr, sizeof(FRLONG));}
 for(ts = toc->sim; ts != NULL; ts = ts->next)
   {j += FrTOCSort1((char **)&(ts->position), index, nFr, sizeof(FRLONG));}
 for(ts = toc->ser; ts != NULL; ts = ts->next)
   {j += FrTOCSort1((char **)&(ts->position), index, nFr, sizeof(FRLONG));}
 for(ts = toc->summary; ts != NULL; ts = ts->next)
   {j += FrTOCSort1((char **)&(ts->position), index, nFr, sizeof(FRLONG));}

 if(j > 0)  
   {fprintf(FrFOut,"FrTOCSort: sorting error, malloc failed\n");
    file->toc = NULL;}

 free(gps);
 free(index);

 return;}

/*--------------------------------------------------------------FrTOCSort1--*/
int FrTOCSort1(char **dataIn, int *index, int nData, int size)
/*--------------------------------------------------------------------------*/
/* This function sort on array by increasing index                          */
/*--------------------------------------------------------------------------*/
{int i;
 char *new;

 new = malloc(nData*size);
 if(new == NULL) return(1);

 for(i=0; i<nData; i++)
   {memcpy(new+i*size, (*dataIn)+index[i]*size, size);}

 free(*dataIn);
 *dataIn = new;

 return(0);}

/*-------------------------------------------------------------- FrTOCStatD--*/
int FrTOCStatD(struct FrFile *oFile,
                struct FrStatData *sData)
/*---------------------------------------------------------------------------*/
{struct FrStatMark *sm;
 int i;
                               /*-------- find MarkSD structure -------------*/

 if(sData == NULL)      return(2);
 if(oFile->toc == NULL) return(2);

 sm = oFile->toc->statMark;
 while(sm != NULL)
   {if((strcmp(sData->detector->name, sm->detector) == 0) &&
       (strcmp(sData->name,           sm->name) == 0)) break;
    sm = sm->next;}

                       /*----- create a new FrStatMark if needed ----*/
 if(sm == NULL) 
   {sm = (struct FrStatMark *) malloc(sizeof(struct FrStatMark));
    if(sm == NULL)
       {FrError(3,"FrTOCStatD"," malloc failed");
        oFile->error = FR_ERROR_MALLOC_FAILED; 
        return(2);}
    FrStrCpy(&sm->detector, sData->detector->name);
    FrStrCpy(&sm->name, sData->name);
    sm->maxStat = 4;
    sm->nStat = 0;
    sm->version = (unsigned  int *)malloc(sizeof(int)   * sm->maxStat);
    sm->tStart  = (unsigned  int *)malloc(sizeof(int)   * sm->maxStat);
    sm->tEnd    = (unsigned  int *)malloc(sizeof(int)   * sm->maxStat);
    sm->position= (       FRLONG *)malloc(sizeof(FRLONG)* sm->maxStat);
    if((sm->detector  == NULL) ||
       (sm->name      == NULL) ||
       (sm->version   == NULL) ||
       (sm->tStart    == NULL) ||
       (sm->tEnd      == NULL) ||
       (sm->position== NULL))
         {FrError(3,"FrTOCStatD"," malloc failed");
          oFile->error = FR_ERROR_MALLOC_FAILED; 
          return(2);}
    sm->next = oFile->toc->statMark;
    oFile->toc->statMark = sm;
    oFile->toc->nStatType++;}

            /*-------- check if the Static datais already there -----*/

 for(i=0; i<sm->nStat; i++)        
   {if(sm->version[i] != sData->version)   continue;
    if(sm->tStart[i]  != sData->timeStart) continue;
    if(sm->tEnd[i]    != sData->timeEnd)   continue;
    return(1);}

                       /*-------- increase space if needed -----------*/

 if(sm->nStat+1 >= sm->maxStat)
   {sm->maxStat = 2 * sm->maxStat;

    sm->version = (unsigned  int *)realloc(sm->version,
                             sizeof(int) * sm->maxStat);
    sm->tStart  = (unsigned  int *)realloc(sm->tStart,
                             sizeof(int) * sm->maxStat);
    sm->tEnd    = (unsigned  int *)realloc(sm->tEnd,
                             sizeof(int) * sm->maxStat);
    sm->position= (       FRLONG *)realloc(sm->position,
                          sizeof(FRLONG) * sm->maxStat);
    if((sm->version == NULL) ||
       (sm->tStart  == NULL) ||
       (sm->tEnd    == NULL) ||
       (sm->position== NULL))
           {FrError(3,"FrTOCStatD"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return(2);}}
                       /*-------------- fill information--------------*/

 sm->version[sm->nStat] = sData->version;
 sm->tStart[sm->nStat]  = sData->timeStart;
 sm->tEnd[sm->nStat]    = sData->timeEnd;
 sm->position[sm->nStat]= oFile->nBytes;
 sm->nStat++;

 return(0);}

/*-----------------------------------------------------FrTOCStatDGet--*/
void FrTOCStatDGet(struct FrFile *iFile,
                   struct FrameH *frame)
/*--------------------------------------------------------------------*/
/* This function read all the static data valid for this frame        */
{struct FrStatData *sData, *copy;
 struct FrStatMark *sm;
 struct FrDetector *detector;
 unsigned short type;
 unsigned int length, i;
 long position;

  if(frame == NULL) return;

  position = 0;
  sm = iFile->toc->statMark;
  while(sm != NULL)
    {for(i=0; i<sm->nStat; i++)
      {if(sm->tStart[i] > frame->GTimeS) continue;
       if(sm->tEnd[i]   < frame->GTimeS) continue;

       iFile->relocation = FR_NO;   /*-to avoid relloaction problems---*/
 
             /*--- the validity range is ok, read this static data ---*/

       if(position == 0) position = FrIOTell(iFile->frfd);

       if(FrIOSet(iFile->frfd, sm->position[i]) == -1) {return;}

                /*-----search for FrStatData (skip type 1 or 2 records)----*/

       while(iFile->error == FR_OK)
         {FrReadInt(  iFile,(int *) &length);
          FrReadShort(iFile,(short *) &type);
          if((type != 1) && (type != 2))  break;
          FrIOSetFromCur(iFile->frfd, (long) length-6);}

       sData = FrStatDataRead(iFile);

                /*--------search for FrVect (skip type 1 or 2 records)----*/

       while(iFile->error == FR_OK)
         {FrReadInt(  iFile,(int *) &length);
          FrReadShort(iFile,(short *) &type);
          if((type != 1) && (type != 2))  break;
          FrIOSetFromCur(iFile->frfd, (long) length-6);}

       sData->data = FrVectRead(iFile); 

       iFile->relocation = FR_YES; 

                   /*------- attache it to the right detector --------*/

       detector = frame->detectProc;
       if(frame->detectSim != NULL)
          {if(strcmp(sm->name,frame->detectSim->name) == 0) 
	    {detector = frame->detectSim;}}

       FrStatDataAdd(detector, sData);

       /*-------- check the validity range -------*/

       if(frame->detectSim != NULL)
           {FrStatDataChkT(&frame->detectSim->sData,
			    frame->GTimeS, frame->GTimeS + frame->dt);}
       if(frame->detectProc != NULL)
           {FrStatDataChkT(&frame->detectProc->sData,
			    frame->GTimeS, frame->GTimeS + frame->dt);}
       }

    sm = sm->next;}

  if(position != 0) FrIOSet(iFile->frfd, position);

        /*------- copy the stat data to the file structure ---*/

 sData = iFile->sDataSim;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataSim = NULL;

 sData = iFile->sDataProc;
 while(sData != NULL) {sData = FrStatDataFree(sData);}
 iFile->sDataProc = NULL;

 if(frame->detectSim != NULL)
    {for(sData = frame->detectSim->sData; sData != NULL; sData = sData->next)
       {copy = FrStatDataCopy(sData,frame->detectSim);
        if(copy == NULL) break;
        copy->next = iFile->sDataSim;
        iFile->sDataSim = copy;}}

  if(frame->detectProc != NULL)
    {for(sData = frame->detectProc->sData; sData != NULL; sData = sData->next)
       {copy = FrStatDataCopy(sData, frame->detectProc);
        if(copy == NULL) break;
        copy->next = iFile->sDataProc;
        iFile->sDataProc = copy;}}
            
  return;}


/*-------------------------------------------------------------FrTOCtsDump--*/
void FrTOCtsDump(FrTOCts *root,
                 FILE *fp,
                 char *type,
                 char *tag,
                 int nFrame)
/*--------------------------------------------------------------------------*/
{int i, count;
 FrTOCts *ts;
 FrTag *frtag;

 if(tag == NULL) 
      {frtag = NULL;}
 else {frtag = FrTagNew(tag);}

 if(root == NULL)    return;
 fprintf(fp," Positions for %s:\n",type);

 for(ts = root; ts != NULL; ts = ts->next)
   {if(FrTagMatch(frtag, ts->name) == FR_NO) continue;

    if(type[0]=='A')
        {fprintf(fp,"   (channel=%d group=%d) %s:", 
	              ts->channelID, ts->groupID, ts->name);}
    else{fprintf(fp,"    %s:", ts->name);}
 
   count = 0;
    for(i=0; i<nFrame; i++)
      {if(i  < 4) fprintf(fp," %ld",ts->position[i]);
       if(i == 4) fprintf(fp," ....");
       if(ts->position[i] != 0) count++;}
    fprintf(fp,"(in %d frames)\n", count);}

 if(frtag != NULL) FrTagFree(frtag);

 return;}
/*------------------------------------------------------FrTOCtsFree--*/
void FrTOCtsFree(struct FrTOCts *ts)
/*--------------------------------------------------------------------*/
{struct FrTOCts *next;

 while(ts != NULL)
   {next = ts->next;
    free(ts->name);
    free(ts->position);
    free(ts);
    ts = next;}

 return;}

/*-------------------------------------------------------------FrTOCtsHFree--*/
void FrTOCtsHFree(struct FrTOCtsH *tsh)
/*---------------------------------------------------------------------------*/
{struct FrTOCtsH *next;

 while(tsh != NULL)
   {next = tsh->next;
    FrTOCtsFree(tsh->first);
    free(tsh);
    tsh = next;}

 return;}

/*--------------------------------------------------------------FrTOCtsMark--*/
void FrTOCtsMark(struct FrFile *oFile,
                 struct FrTOCtsH **root,
                 char *name,
                 unsigned int groupID,
                 unsigned int channelID)
/*---------------------------------------------------------------------------*/
{FrTOCts  *ts, *ts2, **tsp;
 FrTOCtsH *tsh, *last;
 int threshold, th, n, nts, test;
 
 if(oFile->noTOCts == FR_YES) return;

 if(name == NULL)  return;

        /*------------- create at least one header structure-----------------*/

 if(*root == NULL)
    {tsh = (FrTOCtsH *) calloc(1, sizeof(FrTOCtsH));
     if(tsh == NULL) return;
     *root = tsh;}

       /*--------------- search the header structure which own this ts-------*/

 last = *root; 
 for(tsh = *root; tsh != NULL; tsh = tsh->next)
   {if(tsh->first == NULL) break;
    if(strcmp(tsh->first->name, name) > 0) break;
    last = tsh;}

        /*----------- search the slot where the ts should be included--------*/

 ts = NULL;
 for(tsp = &(last->first); *tsp != NULL; tsp = &((*tsp)->next))
   {test = strcmp((*tsp)->name, name);
    if(test < 0) continue; 
    if(test == 0) {ts = *tsp;}
    break;}

        /*--------- if no ts structure existe create a new one --------------*/

 if(ts == NULL)
   {ts = (FrTOCts *) malloc(sizeof(FrTOCts));
    if(ts == NULL) return;

    FrStrCpy(&ts->name, name);
    ts->channelID = channelID;
    ts->groupID   = groupID;
    ts->position  = (FRULONG *)calloc(oFile->toc->maxFrame,sizeof(FRULONG));
    if(ts->position == NULL)
        {FrError(3,"FrTOCtsMark"," malloc buffer failed");
         oFile->error = FR_ERROR_MALLOC_FAILED;
         return;}
                              /*----------- insert it in the link list -----*/
    ts->next = *tsp;
    *tsp = ts;
    last->nElement++;

         /*---------------- should be split the list in two?-----------------*/

    nts = 0;
    for(tsh = *root; tsh != NULL; tsh = tsh->next) {nts += tsh->nElement;}
    threshold = 1.5*sqrt((double)nts);
    if(threshold < 15) threshold = 15;

    if(last->nElement > threshold)
      {n = 0;
       th = threshold/2;
       for(ts2 = last->first; ts2 != NULL; ts2 = ts2->next) 
          {n++;
           if(n > th) break;}

       tsh = (FrTOCtsH *) calloc(1, sizeof(FrTOCtsH));
       if(tsh == NULL) return;

       tsh->next = last->next;
       last->next = tsh;
   
       tsh->first = ts2->next;
       ts2->next = NULL;
       tsh->nElement = last->nElement - n;  
       last->nElement = n;}}

       /*------ check that the name is unique for ADC, sim and proc data----*/

 if((ts->position[oFile->toc->nFrame] != 0) && (channelID != 0xffffffff))
   {if(FrDebugLvl > 1) fprintf(FrFOut, 
         " FrTOCtsMark: Duplicate channel: %s !!! WARNING !!!\n",name);}

       /*-------------- fill information------------------------------------*/

 ts->position[oFile->toc->nFrame]= oFile->nBytes;

 return;}

/*--------------------------------------------------------------FrTOCtsRead--*/
struct FrTOCts *FrTOCtsRead(struct FrFile *iFile,
                            char *type,
                            int nFrame)
/*---------------------------------------------------------------------------*/
{struct FrTOCts *ts;
 struct FrTOCts *root;
 unsigned int i, nInstance;

 root= NULL;
 FrReadIntU(iFile, &nInstance);
 if(FrDebugLvl > 1) fprintf(FrFOut," nInstance=%d for %s\n",nInstance,type);

 if(nInstance == 0xffffffff) return(NULL);

 for(i=0; i<nInstance; i++)
   {ts = (struct FrTOCts*)malloc(sizeof(struct FrTOCts));
    if(ts == NULL) 
       {FrError(3,"FrTOCtsRead"," malloc adcfailed");
        iFile->error = FR_ERROR_MALLOC_FAILED; 
        return(NULL);}
    ts->next = root;
    root = ts;}

 ts = root;
 while(ts != NULL)
   {FrReadSChar(iFile, &ts->name);
    ts = ts->next;}

 if(type[0] == 'A')
   {ts = root;
    while(ts != NULL)
      {FrReadIntU(iFile, &ts->channelID);
       ts = ts->next;}
    ts = root;
    while(ts != NULL)
      {FrReadIntU(iFile, &ts->groupID);
      ts = ts->next;}}

 ts = root;
 while(ts != NULL)
   {FrReadVL (iFile, (FRLONG **)&ts->position, nFrame);
    ts = ts->next;}
 
 return(root);}

/*-----------------------------------------------------------FrTOCtsRealloc--*/
void FrTOCtsRealloc(FrTOCtsH *tsh,
                    FrFile   *oFile,
                    int       oldSize)
/*---------------------------------------------------------------------------*/
{FrTOCts  *ts;
 FRULONG *newP;

 for(; tsh != NULL; tsh = tsh->next)
   {for(ts = tsh->first; ts != NULL; ts = ts->next)
     {if(FrDebugLvl > 2) printf("FrTOCtsHRealloc for %s maxFrame=%d\n",
                                       ts->name,oFile->toc->maxFrame);
      newP  = (FRULONG *)calloc(oFile->toc->maxFrame,sizeof(FRULONG));
      if(newP == NULL)
           {FrError(3,"FrTOCtsHRealloc"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}

      memcpy(newP, ts->position, oldSize*sizeof(FRULONG)); 
      free(ts->position);
      ts->position = newP;}}

 return;}

/*-------------------------------------------------------------FrTOCtsWrite--*/
void FrTOCtsWrite(struct FrFile  *oFile,
                  struct FrTOCtsH *root,
                  char *type,
                  int nFrame)
/*---------------------------------------------------------------------------*/
{FrTOCts *ts;
 FrTOCtsH *tsh;
 unsigned int nInstance;

 if(oFile->noTOCts == FR_YES) 
    {FrPutIntU(oFile, 0xffffffff);
     return;}

 nInstance = 0;
 for(tsh = root; tsh != NULL; tsh = tsh->next) {nInstance += tsh->nElement;}

 FrPutIntU(oFile, nInstance);
 
 for(tsh = root; tsh != NULL; tsh = tsh->next)
   {for(ts = tsh->first; ts != NULL; ts = ts->next)
     {FrPutSChar(oFile, ts->name);}}

 if(type[0] == 'A')
   {for(tsh = root; tsh != NULL; tsh = tsh->next)
      {for(ts = tsh->first; ts != NULL; ts = ts->next)
	{FrPutIntU(oFile, ts->channelID);}}
    for(tsh = root; tsh != NULL; tsh = tsh->next)
      {for(ts = tsh->first; ts != NULL; ts = ts->next)
	{FrPutIntU(oFile, ts->groupID);}}}

 for(tsh = root; tsh != NULL; tsh = tsh->next)
   {for(ts = tsh->first; ts != NULL; ts = ts->next)
     {FrPutVL (oFile, (FRLONG *) ts->position, nFrame);}}
  
 return;}

/*------------------------------------------------------ FrTOCWrite---*/
void FrTOCWrite(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{struct FrTOC *toc;
 struct FrStatMark *sm;

 toc = oFile->toc;
 if(toc == NULL) return;

 if(FrDebugLvl > 1) FrTOCDump(oFile->toc, FrFOut, FrDebugLvl-1, NULL);

   /*--- write first the dictionary to get the real header position--*/

 if(oFile->dicWrite[toc->classe->id] == FR_NO) 
   {oFile->dicWrite[toc->classe->id] = FR_YES; 
    FrSHWrite(toc->classe, oFile);}  

 toc->position = oFile->nBytes;
 
            /*---------- write now the data bloc --------------------*/

 FrPutNewRecord(oFile, toc, FR_NO);
 FrPutShortU   (oFile, toc->ULeapS);
 FrPutInt      (oFile, toc->localTime);
 FrPutInt      (oFile, toc->nFrame+1);
 FrPutVI       (oFile,     (int *) toc->GTimeS,     toc->nFrame+1);
 FrPutVI       (oFile,     (int *) toc->GTimeN,     toc->nFrame+1);
 FrPutVD       (oFile,             toc->dt,         toc->nFrame+1);
 FrPutVI       (oFile,             toc->runs,       toc->nFrame+1);
 FrPutVI       (oFile,     (int *) toc->frame,      toc->nFrame+1);
 FrPutVL       (oFile, (FRLONG *)  toc->positionH,  toc->nFrame+1);
 FrPutVL       (oFile, (FRLONG *)  toc->nFirstADC,  toc->nFrame+1);
 FrPutVL       (oFile, (FRLONG *)  toc->nFirstSer,  toc->nFrame+1);
 FrPutVL       (oFile, (FRLONG *)  toc->nFirstTable,toc->nFrame+1);
 FrPutVL       (oFile, (FRLONG *)  toc->nFirstMsg,  toc->nFrame+1);

 FrPutInt      (oFile, toc->nSH);
 FrPutVS       (oFile, (short *) toc->SHid,   toc->nSH);
 FrPutVQ       (oFile,           toc->SHname, toc->nSH);

                        /*------------ Static data part--------------*/
 
 FrPutInt (oFile, toc->nStatType);
 sm = toc->statMark;
 while(sm != NULL)
    {FrPutSChar (oFile, sm->name); 
     FrPutSChar (oFile, sm->detector); 
     FrPutInt   (oFile, sm->nStat);
     FrPutVI    (oFile, (int*) sm->tStart,   sm->nStat);
     FrPutVI    (oFile, (int*) sm->tEnd,     sm->nStat);
     FrPutVI    (oFile, (int*) sm->version,  sm->nStat);
     FrPutVL    (oFile,        sm->position, sm->nStat);
     sm = sm->next;}

                         /*------------ Time series part--------------*/
 
 FrTOCtsWrite(oFile, toc->adcH,         "ADC", toc->nFrame+1);
 FrTOCtsWrite(oFile, toc->procH,       "proc", toc->nFrame+1);
 FrTOCtsWrite(oFile, toc->simH,         "sim", toc->nFrame+1);
 FrTOCtsWrite(oFile, toc->serH,         "ser", toc->nFrame+1);
 FrTOCtsWrite(oFile, toc->summaryH, "summary", toc->nFrame+1);

 FrTOCevtWrite(oFile, toc->trig);
 FrTOCevtWrite(oFile, toc->simEvt);
 
              /*--------------- store the marks length -------------*/

 FrPutWriteRecord(oFile);

 return;}

/*-----------------------------------------------------------FrTrigDataDef--*/
struct FrSH *FrTrigDataDef()
/*--------------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrTrigData",(void (*)())FrTrigDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "STRING", "inputs","-");
  FrSENew(classe, "INT_4U", "GTimeS","-");
  FrSENew(classe, "INT_4U", "GTimeN","-");
  FrSENew(classe, "REAL_4", "timeBefore","-");
  FrSENew(classe, "REAL_4", "timeAfter","-");
  FrSENew(classe, "INT_4U", "triggerStatus","-");
  FrSENew(classe, "REAL_4", "amplitude","-");
  FrSENew(classe, "REAL_4", "probability","-");
  FrSENew(classe, "STRING", "statistics","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",  "data","-");
  FrSENew(classe, "PTR_STRUCT(FrTable *)",  "table","-");
  FrSENew(classe, "PTR_STRUCT(FrTrigData *)", "next","-"); 

  return(classe);}

/*-----------------------------------------------------------FrTrigDataDump--*/
void FrTrigDataDump(FrTrigData *trig,
                    FILE *fp,
                    int debugLvl)
/*---------------------------------------------------------------------------*/
{ 
 if(fp   == NULL) return;
 if(trig == NULL) return;
 if(debugLvl < 1) return;

 fprintf(fp," TrigData: %s (%s) Inputs:%s\n", 
          trig->name, trig->comment, trig->inputs);
 fprintf(fp,"  Amplitude=%e time=%.4f (s) tBefore=%.3f tAfter=%.3f (s)\n",
           trig->amplitude, trig->GTimeS+1.e-9*trig->GTimeN, 
           trig->timeBefore, trig->timeAfter);
 if(trig->statistics != NULL) fprintf(fp,"  Statistics:%s\n",trig->statistics);
 fprintf(fp,"  triggerStatus=%x probability=%e\n",
	 trig->triggerStatus, trig->probability);

 if(trig->data  != NULL){FrVectDump (trig->data,  fp, debugLvl);}
 if(trig->table != NULL){FrTableDump(trig->table, fp, debugLvl);}

 return;}

/*----------------------------------------------------------FrTrigDataFind--*/
FrTrigData *FrTrigDataFind(FrameH *frameH, 
                           char *name,
                           FrTrigData *trig)
/*--------------------------------------------------------------------------*/
{
 if(frameH == NULL) return(NULL);
 if(name   == NULL) return(NULL);

 if(trig == NULL) 
      trig = frameH->trigData;
 else trig = trig->next;

 for(; trig != NULL;  trig = trig->next)
   {if(strcmp(trig->name, name) != 0) continue;

    if(trig->data  != NULL) FrVectExpandF(trig->data);
    if(trig->table != NULL) FrTableExpand(trig->table);

    return (trig);}

 return (NULL);}

/*----------------------------------------------------------FrTrigDataFree--*/
void FrTrigDataFree(FrTrigData *trigData)
/*--------------------------------------------------------------------------*/
{
 if(trigData == NULL) return;

 if(trigData->next != NULL) FrTrigDataFree(trigData->next);

 if(trigData->name       != NULL) free (trigData->name);
 if(trigData->comment    != NULL) free (trigData->comment);
 if(trigData->inputs     != NULL) free (trigData->inputs);
 if(trigData->statistics != NULL) free (trigData->statistics);
 if(trigData->data       != NULL) FrVectFree (trigData->data);
 if(trigData->table      != NULL) FrTableFree(trigData->table);
 
 free(trigData);

 return;}

/*------------------------------------------------------------FrTrigDataNew--*/
FrTrigData *FrTrigDataNew(FrameH *frameH,  
                          char *name, 
                          char *comment, 
                          char *inputs, 
                          unsigned int GTimeS,
                          unsigned int GTimeN,
                          float  timeBefore,
                          float  timeAfter,
                          float  amplitude,
                          float  probability,
                          char   *stat,
                          FrVect *data)
/*---------------------------------------------------------------------------*/
{FrTrigData *trigData;
 
 trigData = (FrTrigData *) calloc(1,sizeof(FrTrigData));
 if(trigData == NULL) 
      {return(NULL);} 
 else {trigData->classe = FrTrigDataDef();}
	 
 if(FrStrCpy(&trigData->name,name)       == NULL) return(NULL);
 if(FrStrCpy(&trigData->comment,comment) == NULL) return(NULL);
 if(FrStrCpy(&trigData->inputs,inputs)   == NULL) return(NULL);
 if(FrStrCpy(&trigData->statistics,stat) == NULL) return(NULL);

 trigData->GTimeS = GTimeS;
 trigData->GTimeN = GTimeN;
 trigData->timeBefore = timeBefore;
 trigData->timeAfter  = timeAfter;
 trigData->amplitude = amplitude;
 trigData->probability = probability;
 trigData->data = data;
  
          /*----- now store it in the Frame structures ---------------------*/

 if(frameH != NULL) 
     {trigData->next = frameH->trigData;
      frameH->trigData = trigData;}
  
 return(trigData);} 

/*-----------------------------------------------------------FrTrigDataRead--*/
FrTrigData *FrTrigDataRead(FrFile *iFile)
/*---------------------------------------------------------------------------*/
{FrTrigData *trigData;

 trigData = (FrTrigData *) calloc(1,sizeof(FrTrigData));
 if(trigData == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 else {trigData->classe = FrTrigDataDef();}

 FrReadHeader(iFile,  trigData);
 FrReadSChar (iFile, &trigData->name); 
 FrReadSChar (iFile, &trigData->comment);
 FrReadSChar (iFile, &trigData->inputs);
 FrReadIntU  (iFile, &trigData->GTimeS);
 FrReadIntU  (iFile, &trigData->GTimeN);
 FrReadFloat (iFile, &trigData->timeBefore);
 FrReadFloat (iFile, &trigData->timeAfter);
 FrReadIntU  (iFile, &trigData->triggerStatus);
 FrReadFloat (iFile, &trigData->amplitude);
 FrReadFloat (iFile, &trigData->probability);
 FrReadSChar (iFile, &trigData->statistics);
 FrReadStruct(iFile, &trigData->data);
 FrReadStruct(iFile, &trigData->table);
 FrReadStruct(iFile, &trigData->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", trigData->name);

 return(trigData);}

/*--------------------------------------------------------- FrTrigDataReadT--*/
FrTrigData *FrTrigDataReadT(FrFile *iFile,
                            char *name,
                            double tStart,
                            double length)
/*---------------------------------------------------------------------------*/
/* Find all the trig data in this window. Do not read associated table       */
/*---------------------------------------------------------------------------*/
{FrTrigData *root, **trig;
 FrTOCevt   *evt;
 FrTag      *frtag;
 FrFileH    *firstFileH;
 double tTrig, tEnd;
 int i;

 if(iFile == NULL) return(NULL);
 firstFileH = iFile->current;
 iFile->relocation = FR_NO;            /*--- to avoid relloaction problems---*/

 tEnd = tStart + length;

 if(name == NULL) return(NULL);
 frtag = FrTagNew(name);
 if(frtag == NULL) return(NULL);
                                                 /*--- Loop over all files--*/
 root = NULL;
 trig = &root;

 do
   {if(iFile->toc == NULL) FrTOCReadFull(iFile); /*--------- get the TOC----*/
    if(iFile->toc == NULL) return(NULL);
 
                  /*---------Find name in the channel list for this file----*/

    evt = iFile->toc->trig;
    if(evt == NULL)      return(NULL);
    if(evt->nEvent == 0) return(NULL);

    for(i=0; i<evt->nEvent; i++)
      {tTrig = evt->GTimeS[i]+1.e-9*evt->GTimeN[i];
       if(tTrig < tStart) continue;
       if(tTrig > tEnd)   continue; 
       if(FrTagMatch(frtag, evt->name[i]) == FR_NO) continue; 

       if(FrTOCSetPos(iFile, evt->position[i]) != 0) {return (NULL);}
       *trig = FrTrigDataRead(iFile);
       (*trig)->table = NULL;
       (*trig)->data  = FrVectReadNext(iFile);
       (*trig)->next  = NULL;
       trig = &((*trig)->next);}}

  while (FrFileINext(iFile, tStart, length, firstFileH) == 0);  

 FrTagFree(frtag); 

 return(root);}

/*---------------------------------------------------------FrTrigDataWrite--*/
void FrTrigDataWrite(struct FrTrigData *trigData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{
 if(oFile->toc != NULL) FrTOCevtMark(oFile, oFile->toc->trig, 
                   trigData->name, trigData->GTimeS, trigData->GTimeN);

 FrPutNewRecord(oFile, trigData, FR_YES);
 FrPutSChar (oFile, trigData->name);
 FrPutSChar (oFile, trigData->comment);
 FrPutSChar (oFile, trigData->inputs);
 FrPutIntU  (oFile, trigData->GTimeS);
 FrPutIntU  (oFile, trigData->GTimeN);
 FrPutFloat (oFile, trigData->timeBefore);
 FrPutFloat (oFile, trigData->timeAfter);
 FrPutIntU  (oFile, trigData->triggerStatus);
 FrPutFloat (oFile, trigData->amplitude);
 FrPutFloat (oFile, trigData->probability);
 FrPutSChar (oFile, trigData->statistics);
 FrPutStruct(oFile, trigData->data);
 FrPutStruct(oFile, trigData->table);
 FrPutStruct(oFile, trigData->next);
 FrPutWriteRecord(oFile);

 if(trigData->data != NULL) FrVectWrite(trigData->data, oFile);
 if(trigData->table!= NULL) FrTableWrite(trigData->table, oFile);

 if(trigData->next != NULL) FrTrigDataWrite(trigData->next, oFile);
  
 return;}

/*----------------------------------------------------------FrVectCompData---*/
unsigned short FrVectCompData(struct FrVect *vect,
                              int compType,
                              int gzipLevel,
                              unsigned char **result,
                              unsigned int *nBytes)
/*---------------------------------------------------------------------------*/
/* compType = 1 -> gzip
            = 3 -> differentiate + gzip
            = 5 -> differentiate + Zcomp for short and int
            = 6 -> differentiate + Zcomp for short and int, gzip for others
            = 7 -> differentiate + Zcomp for short, int and float to integer
            = 8 -> differentiate + Zcomp for short, int and float.
            = 255->User define compression code
  This function returns the compression code used.                           */
/*---------------------------------------------------------------------------*/
{int err, compValue, compVect, oldType;
 short ref;
 unsigned char *compr;
 unsigned long comprLen;
 char *swap, *dataIn;

      /*-------- first check if we need/can do the compression---------------*/

 if(vect == NULL)                 return(0);
 if(vect->type == FR_VECT_STRING) return(0);
 if(vect->nData < 8)              return(0);

     /*-------- determine and check the type of compression requested -------*/

 if(compType == 3) 
   {if(vect->type != FR_VECT_C && vect->type != FR_VECT_1U &&
       vect->type != FR_VECT_2S&& vect->type != FR_VECT_2U &&
       vect->type != FR_VECT_4S&& vect->type != FR_VECT_4U) compType = 1;}  

 else if(compType == 4)
   {if     (vect->type == FR_VECT_2S) compType = 3;
    else if(vect->type == FR_VECT_2U) compType = 3;
    else compType = 0;}

 else if(compType == 5)
   {if((vect->type != FR_VECT_2S && 
        vect->type != FR_VECT_2U)) compType = 0;}

 else if(compType == 6)
   {if     (vect->type == FR_VECT_2S) compType = 5;
    else if(vect->type == FR_VECT_2U) compType = 5;
    else compType = 1;}

 else if(compType == 7)
   {if     (vect->type == FR_VECT_2S) compType = 5;
    else if(vect->type == FR_VECT_2U) compType = 5;
    else if(vect->type == FR_VECT_4R) compType = 7;
    else compType = 0;}

 else if(compType == 8)
   {if     (vect->type == FR_VECT_2S) compType = 5;
    else if(vect->type == FR_VECT_2U) compType = 5;
    else if(vect->type == FR_VECT_4R) compType = 8;
    else if(vect->type == FR_VECT_4S) compType = 8;
    else if(vect->type == FR_VECT_4U) compType = 8;
    else compType = 0;}

 else if((compType != 0) &&(compType != 255)) /*-- unknown compression type--*/
   {return(0);}

    /*------ determine the type of compression for this vector -------*/

 compVect = vect->compress;     /*--- this is for backward compatibility */
 if(compVect == 6)   
   {if((vect->type == FR_VECT_2S || 
        vect->type == FR_VECT_2U)) compVect = 5;
    else compVect = 1;}

 if(compType == compVect) return(0);

         /*----- if the vector is already compress, first expand it---*/

 if(vect->compress != 0)  FrVectExpand(vect);
 if(compType == 0) return(0);

         /*--------------- reserve the output space ------------------*/

 comprLen = vect->nBytes;
 compr    = malloc(comprLen);
 if(compr == NULL) 
    {FrError(3,"FrCompress","malloc failed");
     return(0);}

        /*--------------------- do compression -----------------------*/

 err = 0;

 if(compType == 1)            /*--------------------- plain gzip -----*/
   {err = Frz_compress(compr, &comprLen, vect->data,
		   (unsigned long) vect->nBytes,gzipLevel);}

 else if(compType == 3)       /*---------------------- diff + gzip ----*/
   {dataIn = FrVectDiff(vect);
    if(dataIn == NULL) return(0);
    err = Frz_compress(compr, &comprLen, dataIn,
		   (unsigned long) vect->nBytes,gzipLevel);}

 else if(compType == 5)      /*---- diff + zero supress (2 bytes words)---*/
   {dataIn = FrVectDiff(vect);
    if(dataIn == NULL) return(0);
    err = FrVectZComp((unsigned short *)compr, &comprLen, 
                          (short *) dataIn, vect->nData,12);}

 else if(compType == 7)    /*----- float to integer conversion (test only)--*/
   {err = FrVectFComp((short *)compr, &comprLen, 
		      vect->dataF, vect->nData,17-gzipLevel);}
 
 else if(compType == 8)    /*---- diff + zero supress (4 bytes words)---*/
   {oldType = vect->type;
    vect->type = FR_VECT_4S;
    dataIn = FrVectDiff(vect);
    if(dataIn == NULL) 
      {return(0);
       vect->type = oldType;}
    err = FrVectZCompI((unsigned int *)compr, &comprLen, 
	                (int *) dataIn, vect->nData,8);
    vect->type = oldType;}

 else if(compType == 255)  /*----------- user defined code (test only) ---*/
   {err = FrVectUComp(vect, compr, &comprLen, &compType);}

         /*------------- check error code --------------------------------*/

 if (err != 0) 
    {if(FrDebugLvl > 1) fprintf(FrFOut,
        "FrVectCompData: compression failed for vector:%s\n",vect->name);
     free(compr);
     return(0);}

              /*------------ prepared the returned arguments----------*/

 *result = compr;
 *nBytes = comprLen;

 compValue = compType;

 swap = (char *)&ref;
 ref = 0x1234;
 if(swap[0] == 0x34) compValue = 256+compValue;

 return(compValue);}

/*---------------------------------------------------FrVectCompress---*/
void FrVectCompress(struct FrVect *vect,
                    int compType,
                    int gzipLevel)
/*--------------------------------------------------------------------*/
{unsigned char *data;
 unsigned int nBytes, compress;

 if(compType == vect->compress) return;

 compress = FrVectCompData(vect, compType, gzipLevel,&data, &nBytes);
    
 if(compress == 0) return;

 free(vect->data);
 vect->data     = (char *) data;
 vect->nBytes   = nBytes;
 vect->compress = compress;
 FrVectMap(vect);

 return;}

/*-------------------------------------------------------------FrVectConcat--*/
FrVect *FrVectConcat(FrVect *vectIn,
                     double tStart,
                     double len)
/*---------------------------------------------------------------------------*/
/* This function takes a link list of vector and convert it to a single      */
/* vector starting at tStart (GPS time in second) of length len (in second). */
/* The final vector is aligned to the initial vector boundaries.             */
/* The input vector list is free in case of success                          */
/* Remark: all vectors are assumed to have the same size/length and to have  */
/* aligned starting time                                                     */
/*-------------------------------------------------------------------------- */
{FrVect *vect, *output, *isThere;
 int nData, nData0, nBefore, nAfter, nVect, iVect, i, wSize, iStart, iEnd;
 long nValues, type;
 double dx0, sum, t0, tS, tE, vectorL;
 double rounding = 1.e-6;    /* used to avoid rounding problems */

          /*-------------------- create the output vectors -----------------*/

 vect = vectIn;
 t0      = vect->GTimeS + 1.e-9*vect->GTimeN;
 tS      = tStart;
 tE      = tStart+len;
 vectorL = vect->dx[0]*vect->nData;
 nBefore = (t0 - tS - rounding)/vectorL + 1; 
 nAfter  = (tE - t0 - rounding)/vectorL + 1;            

 nData0 = vect->nData;
 dx0    = vect->dx[0];
 nVect  = nBefore+nAfter;
 nData  = nVect*nData0;
 wSize  = vect->wSize;

 output  = FrVectNew1D(vect->name,     vect->type, nData, vect->dx[0], 
                       vect->unitX[0], vect->unitY);
 sprintf(FrBuf,"Available_data_for_%s",vect->name);
 isThere = FrVectNew1D(FrBuf,  FR_VECT_C,  nVect, vect->dx[0]*nData0,
                       vect->unitX[0], "1 if data is there");
 if(output  == NULL) return(NULL);
 if(isThere == NULL) return(NULL);

 tS = t0 - nBefore*vectorL; 
 output->GTimeS =  tS+rounding;
 output->GTimeN = (tS-output->GTimeS)*1.e9;
 output->localTime= vect->localTime;
 output->ULeapS = vect->ULeapS;

 for(i=0; i<nVect; i++) {isThere->data[i] = 0.;}

      /*----------------------------- copy each vector in the output vector--*/

while(vect != NULL)
   {t0 = vect->GTimeS + 1.e-9*vect->GTimeN;
    iVect = (t0 - tS + rounding)/vectorL;
    if(iVect < 0 || iVect > nVect) 
       {printf("FrVectConcat: Boundary Error, iVect=%d nVect=%d\n"
               "  tO=%f tS=%f vectorL=%f\n",iVect, nVect, t0, tS, vectorL);
        return(NULL);}
    if(dx0 != vect->dx[0] || nData0 != vect->nData)
      {printf("FrVectConcat: Length Error, dx0=%e dx=%e,"
                " nData0=%d nData=%d\n",dx0,vect->dx[0], nData0, vect->nData);
       return(NULL);}
    if(vect->wSize != wSize) 
      {printf("FrVectConcat: Size Error: wSize0=%d wSize=%d\n",
             wSize, vect->wSize);
       return(NULL);}

    memcpy(output->data + iVect*wSize*nData0, vect->data, wSize*nData0);
    ++(isThere->data[iVect]);

    vect = vect->next;}

       /*--------------------------- Search for drop out, if no, return-----*/

 for(i=0; i<nVect; i++) {if(isThere->data[i] == 0) break;}

 if(i == nVect)
   {FrVectFree(isThere);
    FrVectFree(vectIn);
    return(output);}
 
       /*--------------------------------- Fill gap with the mean value-----*/

 output->next = isThere;

 sum    = 0.;
 nValues = 0;
 type = output->type;
 
 for(iVect=0; iVect<nVect; iVect++) 
   {if(isThere->data[iVect] == 0) continue;
    nValues += nData0;
    iStart = iVect*nData0;
    iEnd   = iStart+nData0;
    if(type == FR_VECT_C)  for(i=iStart;i<iEnd;i++) {sum += output->data[i];}
    if(type == FR_VECT_2S) for(i=iStart;i<iEnd;i++) {sum += output->dataS[i];}
    if(type == FR_VECT_8R) for(i=iStart;i<iEnd;i++) {sum += output->dataD[i];}
    if(type == FR_VECT_4R) for(i=iStart;i<iEnd;i++) {sum += output->dataF[i];}
    if(type == FR_VECT_4S) for(i=iStart;i<iEnd;i++) {sum += output->dataI[i];}
    if(type == FR_VECT_8S) for(i=iStart;i<iEnd;i++) {sum += output->dataL[i];}
    if(type == FR_VECT_2U) for(i=iStart;i<iEnd;i++) {sum += output->dataUS[i];}
    if(type == FR_VECT_4U) for(i=iStart;i<iEnd;i++) {sum += output->dataUI[i];}
    if(type == FR_VECT_8U) for(i=iStart;i<iEnd;i++) {sum += output->dataUL[i];}
    if(type == FR_VECT_1U) for(i=iStart;i<iEnd;i++) {sum += output->dataU[i];}}

 if(nValues > 0) sum =sum/nValues;

 for(iVect=0; iVect<nVect; iVect++) 
   {if(isThere->data[iVect] != 0) continue;
    iStart = iVect*nData0;
    iEnd   = iStart+nData0;
    if(type == FR_VECT_C)  for(i=iStart;i<iEnd;i++) {output->data[i]   = sum;}
    if(type == FR_VECT_2S) for(i=iStart;i<iEnd;i++) {output->dataS[i]  = sum;}
    if(type == FR_VECT_8R) for(i=iStart;i<iEnd;i++) {output->dataD[i]  = sum;}
    if(type == FR_VECT_4R) for(i=iStart;i<iEnd;i++) {output->dataF[i]  = sum;}
    if(type == FR_VECT_4S) for(i=iStart;i<iEnd;i++) {output->dataI[i]  = sum;}
    if(type == FR_VECT_8S) for(i=iStart;i<iEnd;i++) {output->dataL[i]  = sum;}
    if(type == FR_VECT_2U) for(i=iStart;i<iEnd;i++) {output->dataUS[i] = sum;}
    if(type == FR_VECT_4U) for(i=iStart;i<iEnd;i++) {output->dataUI[i] = sum;}
    if(type == FR_VECT_8U) for(i=iStart;i<iEnd;i++) {output->dataUL[i] = sum;}
    if(type == FR_VECT_1U) for(i=iStart;i<iEnd;i++) {output->dataU[i]  = sum;}}

 FrVectFree(vectIn);

 return(output);}

/*----------------------------------------------------FrVectCopy -----*/
struct FrVect *FrVectCopy(struct FrVect *vectin)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 int i;

 if(vectin == NULL) return(NULL);

   vect = (struct FrVect *) calloc(1,sizeof(struct FrVect));
   if(vect == NULL)  
        {return(NULL);}
   else {vect->classe = FrVectDef();}

   if(FrStrCpy(&vect->name, vectin->name) == NULL) return(NULL); 

   vect->compress = vectin->compress;
   vect->type     = vectin->type;
   vect->nData    = vectin->nData;
   vect->nBytes   = vectin->nBytes;
   vect->nDim     = vectin->nDim;
   vect->nx    = malloc(vectin->nDim*sizeof(int));
   vect->unitX = malloc(vectin->nDim*sizeof(char *));
   vect->dx    = malloc(vectin->nDim*sizeof(double));
   vect->startX= malloc(vectin->nDim*sizeof(double));
   if(vect->nx    == NULL || 
      vect->unitX == NULL || 
      vect->dx    == NULL || 
      vect->startX== NULL) return(NULL);

   for(i=0; i<vectin->nDim; i++)
     {vect->nx[i]     = vectin->nx[i];
      vect->dx[i]     = vectin->dx[i];
      vect->startX[i] = vectin->startX[i];
      FrStrCpy(&vect->unitX[i], vectin->unitX[i]);
      if(vect->unitX[i] == NULL && vectin->unitX[i] != NULL) return(NULL);}


   FrStrCpy(&vect->unitY, vectin->unitY);

   vect->wSize = vectin->wSize;
   vect->size = vectin->size;
   vect->data = malloc(vect->nBytes);
   if(vect->data == NULL) 
      {FrError(3,"FrVectCopy","malloc failed");
       return(NULL);}

   if(vect->type == FR_VECT_STRING)
     {vect->dataQ = (char **) vect->data;
      for(i=0; i<vect->nData; i++) 
        {if(FrStrCpy(&vect->dataQ[i],vectin->dataQ[i]) == NULL) return(NULL);}}
   else{memcpy(vect->data, vectin->data, vect->nBytes);}

   FrVectMap(vect);

   if(vectin->next != NULL) 
        {vect->next = FrVectCopy(vectin->next);}
   else {vect->next = NULL;}

   vect->GTimeS = vectin->GTimeS;
   vect->GTimeN = vectin->GTimeN;

   return(vect);
}

/*---------------------------------------------------------- FrVectDecimate--*/
FrVect *FrVectDecimate(FrVect *vect,
                       int nGroup,
                       FrVect *outVect)
/*---------------------------------------------------------------------------*/
/* This function decimates the data from the vector vect by averaging nGroup */
/* values togehter. The result is put in the vector outVect. The size of     */
/* outVect should be nGroup time smaller than the size of vect.              */
/*---------------------------------------------------------------------------*/
{int i, j, off;
 double sum, coef;

 if(vect == NULL) return(NULL);
 if(nGroup <= 0)  return(NULL);
 
 if(vect->nData % nGroup != 0) return(NULL);

 if(outVect == NULL) outVect = vect;

           /*-- check that there is enough output space for the output data--*/
   
 if(outVect->nData < vect->nData/nGroup) return(NULL);

           /*------------ adjust parameter for the output vector ------------*/

 outVect->nData  = vect->nData/nGroup;
 outVect->size   = vect->size /nGroup;
 outVect->nx[0]  = vect->nx[0]/nGroup;
 outVect->nBytes = outVect->wSize * outVect->nData;
 outVect->dx[0]  = vect->dx[0]*nGroup;

           /*----------------- do the decimation ----------------------------*/

 coef = 1./nGroup;
 off = 0;

 for(i=0; i < outVect->nData; i++)
  {sum = 0.;

   if     (vect->type == FR_VECT_2S) 
            for(j=off; j<off+nGroup; j++) {sum += vect->dataS[j];}
   else if(vect->type == FR_VECT_4S)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataI[j];}
   else if(vect->type == FR_VECT_4R)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataF[j];}
   else if(vect->type == FR_VECT_8R)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataD[j];}   
   else if(vect->type == FR_VECT_C)
            for(j=off; j<off+nGroup; j++) {sum += vect->data[j];}
   else if(vect->type == FR_VECT_8S)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataL[j];}
   else if(vect->type == FR_VECT_2U)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataUS[j];}
   else if(vect->type == FR_VECT_4U)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataUI[j];}
   else if(vect->type == FR_VECT_8U)
            for(j=off; j<off+nGroup; j++) {sum += vect->dataUL[j];}
       
   if     (outVect->type == FR_VECT_4R) outVect->dataF[i] = sum*coef;
   else if(outVect->type == FR_VECT_8R) outVect->dataD[i] = sum*coef;
   else if(outVect->type == FR_VECT_2S) outVect->dataS[i] = sum*coef;
   else if(outVect->type == FR_VECT_4S) outVect->dataI[i] = sum*coef;
   else if(outVect->type == FR_VECT_8S) outVect->dataL[i] = sum*coef;
   else if(outVect->type == FR_VECT_C)  outVect->data[i]  = sum*coef;
   else if(outVect->type == FR_VECT_2U) outVect->dataUS[i]= sum*coef;
   else if(outVect->type == FR_VECT_4U) outVect->dataUI[i]= sum*coef;
   else if(outVect->type == FR_VECT_8U) outVect->dataUL[i]= sum*coef;

   off += nGroup;}

                 /*------------- free the unused space ---------------*/

 if(outVect == vect) 
    {vect->data = realloc(vect->data, vect->size);
     FrVectMap(vect);}

 return(outVect);}
/*---------------------------------------------------- FrVectDef -----*/
struct FrSH *FrVectDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrVect",(void (*)())FrVectRead);

  FrSENew(classe, "STRING",  "name","-");
  FrSENew(classe, "INT_2U",   "compress","-");
  FrSENew(classe, "INT_2U",   "type","-");
  FrSENew(classe, "INT_4U",   "nData","-");
  FrSENew(classe, "INT_4U",   "nBytes","-");
  FrSENew(classe, "*",        "data","-");
  FrSENew(classe, "INT_4U",   "nDim","-");
  FrSENew(classe, "INT_4U *", "nx","-");
  FrSENew(classe, "REAL_8 *", "dx","-");
  FrSENew(classe, "REAL_8 *", "startX","-");
  FrSENew(classe, "STRING *", "unitX", NULL);
  FrSENew(classe, "STRING",   "unitY", NULL);
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "next", NULL);
 
  return(classe);}

/*-------------------------------------------------------FrVectDiff---*/
char *FrVectDiff(struct FrVect *vect)
/*--------------------------------------------------------------------*/
/* This function return a pointer to the array of differented values  */
/* The input vector is unchanged                                      */
{int i,err;
 static char  *data, last;
 static short *dataS, lastS;
 static int  *dataI, lastI, localBytes = 0;
 static unsigned char  *dataU,  lastU;
 static unsigned short *dataUS, lastUS;
 static unsigned int   *dataUI, lastUI;

 if(vect == NULL) return(NULL);
 if(vect->nBytes > localBytes)
    {if(localBytes != 0) free(data);
     localBytes = vect->nBytes;
     data = (char *) malloc(localBytes);
     if(data == NULL) 
        {localBytes = 0;
         return(NULL);}

     dataS  = (short          *)data;
     dataI  = (int            *)data;
     dataU  = (unsigned char  *)data;
     dataUS = (unsigned short *)data;
     dataUI = (unsigned int   *)data;}

            /*----- differentiate and check ----*/
 err = 0;
 if(vect->type == FR_VECT_C)
   {data[0] = vect->data[0];
    last    =       data[0];
    for(i=1; i<vect->nData; i++)
      {data[i] = vect->data[i] - vect->data[i-1];
       last   +=       data[i];
       if(last != vect->data[i]) err = 1;}}

 else if(vect->type == FR_VECT_2S)
   {dataS[0] = vect->dataS[0];
    lastS    =       dataS[0];
    for(i=1; i<vect->nData; i++)
      {dataS[i] = vect->dataS[i] - vect->dataS[i-1];
       lastS   +=       dataS[i];
       if(lastS != vect->dataS[i]) err = 1;}}

 else if(vect->type == FR_VECT_4S) 
   {dataI[0] = vect->dataI[0];
    lastI    =       dataI[0];
    for(i=1; i<vect->nData; i++)
      {dataI[i] = vect->dataI[i] - vect->dataI[i-1];
       lastI   +=       dataI[i];
       if(lastI != vect->dataI[i]) err = 1;}}

 else if(vect->type == FR_VECT_1U) 
   {dataU[0] = vect->dataU[0];
    lastU    =       dataU[0];
    for(i=1; i<vect->nData; i++)
      {dataU[i] = vect->dataU[i] - vect->dataU[i-1];
       lastU   +=       dataU[i];
       if(lastU != vect->dataU[i]) err = 1;}}

 else if(vect->type == FR_VECT_2U)
   {dataUS[0] = vect->dataUS[0];
    lastUS    =       dataUS[0];
    for(i=1; i<vect->nData; i++)
      {dataUS[i] = vect->dataUS[i] - vect->dataUS[i-1];
       lastUS   +=       dataUS[i];
       if(lastUS != vect->dataUS[i]) err = 1;}}

 else if(vect->type == FR_VECT_4U) 
   {dataUI[0] = vect->dataUI[0];
    lastUI    =       dataUI[0];
    for(i=1; i<vect->nData; i++)
      {dataUI[i] = vect->dataUI[i] - vect->dataUI[i-1];
       lastUI   +=       dataUI[i];
       if(lastUI != vect->dataUI[i]) err = 1;}}

 else  {err = 2;}

           /*------ set the compress flag if ok ------*/

 if(err == 0)  {return (data);}

return(NULL);}

/*----------------------------------------------------- FrVectDump----*/
void FrVectDump(struct FrVect *vect,
                FILE *fp,
                int debugLvl)
/*--------------------------------------------------------------------*/
{int i;
 char *dC, **dSt;
 short  *dS;
 int    *dI;  
 FRLONG *dL; 
 float  *dF, ratio;  
 double *dD;
 unsigned char   *dU;
 unsigned short  *dUS;
 unsigned int    *dUI;
 FRULONG *dUL;

 if(fp   == NULL) return;
 if(vect == NULL) return;
 if(debugLvl < 1) return;

 if(vect->name == NULL)
      {fprintf(fp,"  Vector:- ndata=%d ",              vect->nData);}
 else {fprintf(fp,"  Vector:%s ndata=%d ", vect->name, vect->nData);}

 if(vect->GTimeS != 0) fprintf(fp," GTimeS=%d",vect->GTimeS);
 if(vect->GTimeN != 0) fprintf(fp,"(N=%d)",    vect->GTimeN);

 if(vect->unitY != NULL) 
         {fprintf(fp," unitY=%s", vect->unitY);}
 
 if(vect->nDim == 1)
   {if(vect->unitX[0] != NULL) fprintf(fp," unitX=%s", vect->unitX[0]);
    fprintf(fp,"  startX=%.2e dx=%.2e\n", vect->startX[0], vect->dx[0]);}
 else
   {fprintf(fp," nDim=%d", vect->nDim);
    for(i=0; i<vect->nDim; i++)
      {if(vect->unitX[i] != NULL) fprintf(fp," unit=%s", vect->unitX[i]);
       fprintf(fp,"      Dimension=%i nx=%10d startX=.2%e dx=%.2e\n",
              i,vect->nx[i], vect->startX[i], vect->dx[i]);}}

           /*-------------------------------------- data part ---------------*/

 fprintf(fp,"   Data");
 if(vect->compress == 0)
   {if     (vect->type == FR_VECT_4R)  /*----------------- float-------------*/
      {dF = (float *) vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(F) %e %e %e ...%e \n    %s\n", 
                   dF[0],dF[1],dF[2],dF[vect->nData-1],FrVectStat(vect));}
       else
         {fprintf(fp,"(F) %s",FrVectStat(vect));
          for(i=0; i<vect->nData; i++)
            {if(i%10 == 0) fprintf(fp,"\n%6d:",i);
             fprintf(fp,"%12.5e",dF[i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_8R)  /*---------------- double ------------*/
      {dD = (double *) vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(D) %e %e %e ... %e \n    %s\n", 
                   dD[0],dD[1],dD[2],dD[vect->nData-1],FrVectStat(vect));}
       else
         {fprintf(fp,"(D) %s",FrVectStat(vect));
          for(i=0; i<vect->nData; i++)
            {if(i%10 == 0) fprintf(fp,"\n%6d:",i);
             fprintf(fp,"%12.5e",dD[i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_C)   /*---------------one byte integer-----*/
      {dC = vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(C) %d %d %d %d %d ...%d %s\n", 
            dC[0],dC[1],dC[2],dC[3],dC[4],dC[vect->nData-1],FrVectStat(vect));}
       else
         {fprintf(fp,"(C) %s",FrVectStat(vect));
          for(i=0; i<vect->nData; i++)
            {if(i%20 == 0) fprintf(fp,"\n%6d:",i);
             fprintf(fp,"%4d",dC[i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_2S)  /*-------------- short integer -------*/
      {dS = (short *) vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(S) %d %d %d %d ... %d %s\n", 
               dS[0],dS[1],dS[2],dS[3],dS[vect->nData-1],FrVectStat(vect));}
       else
         {fprintf(fp,"(S) %s",FrVectStat(vect));
          for(i=0; i<vect->nData; i++)
            {if(i%10 == 0) fprintf(fp,"\n%6d:",i);
             fprintf(fp," %6d",dS[i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_8S)  /*---------------long integer---------*/
      {dL = (FRLONG *) vect->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dL[0],dL[1],dL[2]);}

    else if(vect->type == FR_VECT_4S)  /*------------- signed integer -------*/
      {dI = (int *) vect->data;
       if(debugLvl <3)
          {fprintf(fp,"(I) %d %d %d ... %d %s\n", 
                    dI[0],dI[1],dI[2],dI[vect->nData-1],FrVectStat(vect));}
       else
         {fprintf(fp,"(I) %s",FrVectStat(vect));
          for(i=0; i<vect->nData; i++)
            {if(i%10 == 0) fprintf(fp,"\n%6d:",i);
             fprintf(fp," %8d",dI[i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_1U)   /*------- unsigned  character----*/
      {dU = (unsigned char *)vect->dataU;
       fprintf(fp,"(C) %d %d %d ...\n", dU[0],dU[1],dU[2]);}
    else if(vect->type == FR_VECT_2U)  
      {dUS = (unsigned short *) vect->data;
       fprintf(fp,"(S) %d %d %d ...\n", dUS[0],dUS[1],dUS[2]);}
    else if(vect->type == FR_VECT_8U)  
      {dUL = (FRULONG *) vect->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dUL[0],dUL[1],dUL[2]);}
    else if(vect->type == FR_VECT_4U)  
      {dUI = (unsigned int *) vect->data;
       fprintf(fp,"(I) %d %d %d ...\n", dUI[0],dUI[1],dUI[2]);}
    else if(vect->type == FR_VECT_C8) 
      {dF = (float *) vect->data;
       fprintf(fp,"(CF) (%e,%e) (%e,%e) ...\n", dF[0],dF[1],dF[2],dF[3]);}
    else if(vect->type == FR_VECT_C16) 
      {dD = (double *) vect->data;
       fprintf(fp,"(CD) (%e,%e) (%e,%e) ...\n", dD[0],dD[1],dD[2],dD[3]);}
    else if(vect->type == FR_VECT_H8)  /*------------ complex float -------*/
      {dF = (float *) vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(CFF) %e, (%e,%e) ... %e  %s\n", 
              dF[0],dF[1],dF[2*vect->nData-1],dF[vect->nData+1],FrVectStat(vect));}
       else
         {fprintf(fp,"(CFF) Mean=%e At Niquiest:%e  %s",
              dF[0],dF[vect->nData+1],FrVectStat(vect));
          for(i=1; i<vect->nData; i++)
            {if(i%5 == 1) fprintf(fp,"\n%6d:",i);
             fprintf(fp,"(%12.5e %12.5e)",dF[i],dF[2*vect->nData-i]);}
          fprintf(fp,"\n");}}
    else if(vect->type == FR_VECT_H16) /*--------complex double -------*/ 
      {dD = (double *) vect->data;
       if(debugLvl <3)
         {fprintf(fp,"(CFD) %e, (%e,%e) ... %e  %s\n", 
              dD[0],dD[1],dD[2*vect->nData-1],dD[vect->nData+1],FrVectStat(vect));}
       else
         {fprintf(fp,"(CFD) Mean=%e At Niquiest:%e  %s",
              dD[0],dD[vect->nData+1],FrVectStat(vect));
          for(i=1; i<vect->nData; i++)
            {if(i%5 == 1) fprintf(fp,"\n%6d:",i);
             fprintf(fp,"(%12.5e %12.5e)",dD[i],dD[2*vect->nData-i]);}
          fprintf(fp,"\n");}}

    else if(vect->type == FR_VECT_STRING) 
      {dSt = (char **) vect->data;
       fprintf(fp,"(STRING)");
       if(dSt[0] != NULL) fprintf(fp," \"%s\"", dSt[0]);
       if(dSt[1] != NULL) fprintf(fp," \"%s\"", dSt[1]);
       fprintf(fp,"...\n");}
    else 
      {fprintf(fp," unknown type: %d \n",vect->type );}}
  else 
    {ratio = ((float) vect->nBytes) /(vect->nData*vect->wSize);
     fprintf(fp,"\n     the vector is %4.2f compressed (%x)"
                " nBytes=%d wSize=%d\n",
            ratio,vect->compress,vect->nBytes, vect->wSize);}

 if(vect->next != NULL)
   {fprintf(fp,"  Attached information:\n");
    FrVectDump(vect->next, fp, debugLvl) ;}

 return;}

/*---------------------------------------------------FrVectExpand-----*/
void FrVectExpand(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{int err;
 unsigned int i, nData, compress, oldType;
 unsigned char *buf, local0, local1, local2, local3, *uncompr;
 unsigned long uncomprLen;
 char *refC;
 short ref, swap;

 if(vect == NULL) return;
 if(vect->compress == 0) return;
 
   /*---- do we have to swap the bytes ?---*/

 refC = (char *)&ref;
 ref = 0x1234;

 swap = (refC[0] == 0x34 && vect->compress < 255) ||
        (refC[0] == 0x12 && vect->compress > 255);
 compress = vect->compress & 0xff;
 if(compress == 6) compress = 5;

   /*----------------------- first expand the data ---*/

 uncomprLen = vect->nData * vect->wSize;
 uncompr    = (unsigned char*)calloc((int)uncomprLen, 1);
 if(uncompr == NULL) 
    {FrError(3,"FrVectExpand","malloc failed");
     return;}

 if(compress == 1 || compress == 3)
    {err = Frz_uncompress(uncompr, &uncomprLen, vect->data, vect->nBytes);
     if(err != 0) 
          {FrError(3,"FrVectExpand","uncompress failed");
	   return;}}

 else if(compress == 5)
      {if(swap)
          {buf = vect->dataU;
           for(i=0; i<vect->nBytes-1; i=i+2)
              {local0   = buf[i];
               buf[i]   = buf[i+1];
               buf[i+1] = local0;}}
       FrVectZExpand((short *) uncompr,
                     (unsigned short *)vect->data, vect->nData);}

 else if(compress == 7)
      {if(swap)
          {buf = vect->dataU;
	   local0 = buf[3];
           buf[3] = buf[0];
	   buf[0] = local0;
           local0 = buf[2];
           buf[2] = buf[1];
	   buf[1] = local0;
           local0 = buf[7];
           buf[7] = buf[4];
	   buf[4] = local0;
           local0 = buf[6];
           buf[6] = buf[5];
	   buf[5] = local0;
           for(i=8; i<vect->nBytes-1; i=i+2)
              {local0   = buf[i];
               buf[i]   = buf[i+1];
               buf[i+1] = local0;}}
      
       FrVectFExpand((float *) uncompr, (short *)vect->data, vect->nData);}

 else if(compress == 8)
      {if(swap)
          {buf = vect->dataU;
           for(i=0; i<vect->nBytes-3; i=i+4)
              {local0   = buf[i+3];
               local1   = buf[i+2];
               buf[i+3] = buf[i];
               buf[i+2] = buf[i+1];
               buf[i+1] = local1;
               buf[i]   = local0;}}
       FrVectZExpandI((int *)uncompr,(unsigned int *)vect->data,vect->nData);}

 else if(compress == 255)
      {FrVectUExpand(vect, uncompr);}

 else
    {FrError(3,"FrVectExpand","unknown compression level");
     return;}

 free(vect->data);
 vect->data = (char *) uncompr;
 FrVectMap(vect);

 vect->nBytes =  vect->nData * vect->wSize;

   /*---------------------- swap bytes if needed --------*/
       
 if(swap && (compress == 1 || compress == 3))
   {nData = vect->nData;
    if(vect->type == FR_VECT_C8)  nData = 2*nData;
    if(vect->type == FR_VECT_C16) nData = 2*nData;
    buf = vect->dataU;

    if((vect->type == FR_VECT_2S) ||
       (vect->type == FR_VECT_2U))
          {for(i=0; i<2*nData; i=i+2)
              {local0   = buf[i];
               buf[i]   = buf[i+1];
               buf[i+1] = local0;}}

    else if((vect->type == FR_VECT_4S) ||
         (vect->type == FR_VECT_4U) ||
         (vect->type == FR_VECT_4R) ||
         (vect->type == FR_VECT_C8))
       {for(i=0; i<4*nData; i=i+4)
           {local0 = buf[i];
            local1 = buf[i+1];
            buf[i]   = buf[i+3];
            buf[i+1] = buf[i+2];
            buf[i+2] = local1;
            buf[i+3] = local0;}} 

    else if((vect->type == FR_VECT_8S) ||
         (vect->type == FR_VECT_8U) ||
         (vect->type == FR_VECT_8R) ||
         (vect->type == FR_VECT_C16))
       {for(i=0; i<8*nData; i=i+8)
           {local0 = buf[i];
            local1 = buf[i+1];
            local2 = buf[i+2];
            local3 = buf[i+3];
            buf[i]   = buf[i+7];
            buf[i+1] = buf[i+6];
            buf[i+2] = buf[i+5];
            buf[i+3] = buf[i+4];
            buf[i+4] = local3;
            buf[i+5] = local2;
            buf[i+6] = local1;
            buf[i+7] = local0;}}}

   /*------------integrate the data if needed -----*/

 oldType = vect->type;
 if(compress == 8) vect->type = FR_VECT_4S;
 if(compress > 1 && compress < 255) FrVectInt(vect);
 if(compress == 8) vect->type = oldType;

 vect->compress = 0;

 return;}

/*------------------------------------------------------------FrVectExpandF--*/
void FrVectExpandF(FrVect *vect)
/*---------------------------------------------------------------------------*/
{
  FrVectExpand(vect);

  if(vect->next != NULL) FrVectExpandF(vect->next);

  return;}

/*--------------------------------------------------------------FrVectFillC--*/
int FrVectFillC(FrVect *vect,
                char value)
/*--------------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_C) 
      {FrError(3,"FrVectFillC","type missmatch");
       return(1);}
   if(vect->compress != 0) FrVectExpand(vect);
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(char));
       if(vect->data == NULL) return(2);}

   vect->data[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return(0);}

/*-------------------------------------------------------------FrVectFillD--*/
int FrVectFillD(FrVect *vect,
                double value)
/*--------------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_8R) 
      {FrError(3,"FrVectFillD","type missmatch");
       return(1);}
   if(vect->compress != 0) FrVectExpand(vect);
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(double));;
       if(vect->data == NULL) return(2);}

   vect->dataD[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return(0);}

/*--------------------------------------------------------------FrVectFillF--*/
int FrVectFillF(FrVect *vect,
                float value)
/*---------------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_4R) 
      {FrError(3,"FrVectFillF","type missmatch");
       return(1);}
   if(vect->compress != 0) FrVectExpand(vect);
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(float));;
       if(vect->data == NULL) return(2);}

   vect->dataF[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return(0);}

/*--------------------------------------------------------------FrVectFillI--*/
int FrVectFillI(FrVect *vect,
                int value)
/*---------------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_4S) 
      {FrError(3,"FrVectFillI","type missmatch");
       return(1);}
   if(vect->compress != 0) FrVectExpand(vect);
          
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(int));
       if(vect->data == NULL) return(2);}

   vect->dataI[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return(0);}

/*--------------------------------------------------------------FrVectFillS--*/
int FrVectFillS(FrVect *vect,
                short value)
/*---------------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_2S) 
      {FrError(3,"FrVectFillS","type missmatch");
       return(1);}
   if(vect->compress != 0) FrVectExpand(vect);
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(short));
       if(vect->data == NULL) return(2);}

   vect->dataS[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return(0);}
/*--------------------------------------------------------------FrVectFindQ--*/
int FrVectFindQ(FrVect *vect,
		char* name)
/*---------------------------------------------------------------------------*/
{int i;

 if(vect == NULL) return(-3);
 if(vect->type != FR_VECT_STRING) return (-2);

 for(i=0; i<vect->nData; i++)
    {if(strcmp(vect->dataQ[i], name) == 0) return(i);}

 return(-1);
}
/*---------------------------------------------------FrVectFree-------*/
void FrVectFree(FrVect *vect)
/*--------------------------------------------------------------------*/
{int i;

 if(vect == NULL) return;

 if(vect->next != NULL) FrVectFree(vect->next);

 if(vect->data != NULL) 
      {if(vect->type == FR_VECT_STRING)
	{for(i=0; i<vect->nData; i++) 
           {if(vect->dataQ[i] != NULL) free(vect->dataQ[i]);}}
       free(vect->data);}

 free(vect->nx);
 free(vect->dx);
 if(vect->unitY != NULL) {free(vect->unitY);}
 if(vect->unitX != NULL)
     {for(i=0; i<vect->nDim; i++)
       {if(vect->unitX[i] != NULL) free(vect->unitX[i]);}
      free(vect->unitX);}
 if(vect->name != NULL) free(vect->name);
 free(vect->startX);
 if(vect->expName != NULL) {free(vect->expName);}
 free(vect);

 return;}
/*-------------------------------------------------------------FrVectGetV--*/
double FrVectGetV(FrVect *vect, 
                  int i)
/*--------------------------------------------------------------------------*/
{
 if(vect == NULL)     return(0.);
 if(i >= vect->nData) return(0.);

 if(vect->compress != 0) FrVectExpand(vect); 

 if     (vect->type == FR_VECT_C)   {return((double) vect->data [i]);}
 else if(vect->type == FR_VECT_2S)  {return((double) vect->dataS[i]);}
 else if(vect->type == FR_VECT_8R)  {return(         vect->dataD[i]);}
 else if(vect->type == FR_VECT_4R)  {return((double) vect->dataF[i]);}
 else if(vect->type == FR_VECT_4S)  {return((double) vect->dataI[i]);}
 else if(vect->type == FR_VECT_8S)  {return((double) vect->dataL[i]);}
 else if(vect->type == FR_VECT_2U)  {return((double) vect->dataS[i]);}
 else if(vect->type == FR_VECT_4U)  {return((double) vect->dataI[i]);}
 else if(vect->type == FR_VECT_8U)  {return((double) vect->dataL[i]);}
 else if(vect->type == FR_VECT_1U)  {return((double) vect->data [i]);}

 return(0.);}
/*----------------------------------------------------------------FrVectInt--*/
void FrVectInt(FrVect *vect)
/*---------------------------------------------------------------------------*/
{int i;

 if(vect == NULL) return;

 else if(vect->type == FR_VECT_C)
     {for(i=1; i<vect->nData; i++)
          {vect->data[i] = vect->data[i] + vect->data[i-1];}}

 else if(vect->type == FR_VECT_2S)
     {for(i=1; i<vect->nData; i++)
          {vect->dataS[i] = vect->dataS[i] + vect->dataS[i-1];}}

 else if(vect->type == FR_VECT_4S)
     {for(i=1; i<vect->nData; i++)
          {vect->dataI[i] = vect->dataI[i] + vect->dataI[i-1];}}

 else if(vect->type == FR_VECT_1U) 
     {for(i=1; i<vect->nData; i++)
          {vect->dataU[i] = vect->data[i] + vect->data[i-1];}}

 else if(vect->type == FR_VECT_2U)
     {for(i=1; i<vect->nData; i++)
          {vect->dataUS[i] = vect->dataS[i] + vect->dataS[i-1];}}

 else if(vect->type == FR_VECT_4U) 
     {for(i=1; i<vect->nData; i++)
          {vect->dataUI[i] = vect->dataI[i] + vect->dataI[i-1];}}

return;}
/*--------------------------------------------------------- FrVectIsValid----*/
int FrVectIsValid(FrVect *vect)
/*---------------------------------------------------------------------------*/
/* returns 0 if the vector do not contains NaN or INF numbers                */
/* returns 0 if the vector is not an integer number                          */
/* returns 1 in the other cases                                              */
/*---------------------------------------------------------------------------*/
{
 unsigned int  nData, i, *dI, maskF = 0x7f800000, maskD = 0x7ff00000, swap; 
 char *swapC;

 if(vect == NULL) return(1);

 if(vect->compress != 0) FrVectExpand(vect);

 dI = vect->dataUI;

 nData = vect->nData;
 if((vect->type == FR_VECT_C8)  || 
    (vect->type == FR_VECT_H8)  ||
    (vect->type == FR_VECT_C16) ||
    (vect->type == FR_VECT_H16))  nData = 2*nData;

 if((vect->type == FR_VECT_4R) || 
    (vect->type == FR_VECT_C8) || 
    (vect->type == FR_VECT_H8))
   {for(i=0; i<  nData; i++) {if(dI[i] == 0)          continue;
                              if(dI[i] == 0x80000000) continue;
                              if((dI[i] & maskF) == maskF) return(i+1);
                              if((dI[i] & maskF) == 0)     return(i+1);}}

 else if((vect->type == FR_VECT_8R)  ||
         (vect->type == FR_VECT_C16) ||
         (vect->type == FR_VECT_H16))
  {nData = 2*nData; 
   swap = 1;
   swapC= (char *) &swap;

   if(swapC[0] == 1)
       {for(i=0; i<nData; i=i+2) 
            {if(dI[i+1] == 0          && dI[i] == 0) continue;
             if(dI[i+1] == 0x80000000 && dI[i] == 0) continue;
             if((dI[i+1] & maskD) == maskD) return(i/2+1);
             if((dI[i+1] & maskD) == 0)     return(i/2+1);}}
   else{for(i=0; i<nData; i=i+2) 
            {if(dI[i] == 0          && dI[i+1] == 0) continue;
             if(dI[i] == 0x80000000 && dI[i+1] == 0) continue;
             if((dI[i] & maskD) == maskD) return(i/2+1);
             if((dI[i] & maskD) == 0)     return(i/2+1);}}}

 return(0);}

/*----------------------------------------------------FrVectMap ------*/
void FrVectMap(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{
   if(vect == NULL) return;

   vect->dataS  = (short          *) vect->data;
   vect->dataI  = (int            *) vect->data;
   vect->dataL  = (FRLONG         *) vect->data;
   vect->dataF  = (float          *) vect->data;
   vect->dataD  = (double         *) vect->data;
   vect->dataU  = (unsigned char  *) vect->data;
   vect->dataUS = (unsigned short *) vect->data;
   vect->dataUI = (unsigned int   *) vect->data;
   vect->dataUL = (FRULONG        *) vect->data;
   vect->dataQ  = (char          **) vect->data;

   return;}
   
/*-------------------------------------------------------------FrVectMinMax--*/
int FrVectMinMax(FrVect *vect, double *min, double *max)
/*---------------------------------------------------------------------------*/
/* This function computes the min and max value of the input vector vect.    */
/* It returns 1 in case of failure or 0 in case of success.                  */
/*---------------------------------------------------------------------------*/
{int i;
 double value;

 if(vect == NULL)     return(1);
 if(vect->nData == 0) return(1);

 *min = 1.e+37;
 *max =-1.e+37;
 if(vect->type == FR_VECT_C)
    {for(i=0; i<vect->nData; i++) {value = vect->data[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_2S)
    {for(i=0; i<vect->nData; i++) {value = vect->dataS[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_8R)
    {for(i=0; i<vect->nData; i++) {value = vect->dataD[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_4R)
    {for(i=0; i<vect->nData; i++) {value = vect->dataF[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_4S)
    {for(i=0; i<vect->nData; i++) {value = vect->dataI[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_8S)
    {for(i=0; i<vect->nData; i++) {value = vect->dataL[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_C8)
    {return(0);}
 else if(vect->type == FR_VECT_C16)
    {return(0);}
 else if(vect->type == FR_VECT_2U)
    {for(i=0; i<vect->nData; i++) {value = vect->dataUS[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_4U)
    {for(i=0; i<vect->nData; i++) {value = vect->dataUI[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_8U)
    {for(i=0; i<vect->nData; i++) {value = vect->dataUL[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}
 else if(vect->type == FR_VECT_1U)
    {for(i=0; i<vect->nData; i++) {value = vect->dataU[i];
                                   if(value > *max) *max = value;
                                   if(value < *min) *min = value;}}

 return(0);}

/*----------------------------------------------------FrVectNew------*/
struct FrVect *FrVectNew(int type,
                         int nDim,
                          ...)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 va_list ap;
 char *unit;
 static int i, first = 0, wSize[FR_VECT_END];

 if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(FRLONG);
     wSize[FR_VECT_8U]  = sizeof(FRLONG);
     wSize[FR_VECT_STRING] = sizeof(char *);
     wSize[FR_VECT_C8]   = 2*sizeof(float);
     wSize[FR_VECT_C16]  = 2*sizeof(double);
     wSize[FR_VECT_H8]   = 2*sizeof(float);
     wSize[FR_VECT_H16]  = 2*sizeof(double);}

   vect = (struct FrVect *) calloc(1,sizeof(struct FrVect));
   if(vect == NULL)  
        {return(NULL);}
   else {vect->classe = FrVectDef();}

   vect->compress = 0;
   if(type < 0) 
         vect->type = -type;
   else  vect->type =  type;
   vect->nDim = nDim;
   vect->nData = 1;
   vect->nx    = malloc(nDim*sizeof(int));
   vect->unitX = malloc(nDim*sizeof(char *));
   vect->dx    = malloc(nDim*sizeof(double));
   vect->startX= malloc(nDim*sizeof(double));
   if(vect->nx    == NULL || 
      vect->unitX == NULL || 
      vect->dx    == NULL || 
      vect->startX== NULL) 
       {FrError(3,"FrVectNew","malloc failed");
        return(NULL);}

   va_start(ap,nDim);
   for(i=0; i<nDim; i++)
     {vect->nx[i] = va_arg(ap,int);
      vect->dx[i] = va_arg(ap,double);
      unit = va_arg(ap,char *);
      FrStrCpy(&vect->unitX[i], unit);
      vect->nData = vect->nData*vect->nx[i];
      vect->startX[i] = 0.;}
   va_end(ap);

   vect->wSize  = wSize[vect->type];
   vect->size   = vect->nData;
   vect->nBytes = vect->nData*vect->wSize;
   
   if(vect->nData > 0)
       {if(type >= 0)
             {vect->data = calloc(vect->nData, vect->wSize);}
        else {vect->data = malloc(vect->nBytes);}
        if(vect->data == NULL) 
           {FrError(3,"FrVectNew","calloc failed");
            return(NULL);}}
   else if(vect->nData <0)
        {FrError(3,"FrVectNew","nData is too big");
         return(NULL);}
   else {vect->data = NULL;}

   FrVectMap(vect);
 
   vect->unitY = NULL;
   vect->next  = NULL;

   return(vect);
}
/*-------------------------------------------------FrVectNewTS--------*/
struct FrVect *FrVectNewTS(char *name, 
                           double sampleRate, 
                           int nData, 
                           int nBits)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 double dx;
 int type;
 
  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  vect = FrVectNew1D(name,type,nData,dx,"time (s)",NULL);
  
  return(vect);} 
/*-------------------------------------------------------------FrVectNew1D--*/
struct FrVect *FrVectNew1D(char *name, 
                           int type, 
                           int nData, 
                           double dx,
                           char *unitx,
                           char *unity)
/*--------------------------------------------------------------------------*/
{struct FrVect *vect;
 
 vect = FrVectNew(type,1,nData,dx,unitx);
 if(vect == NULL) return(NULL);

 if(name != NULL)
   {if(FrStrCpy(&vect->name,name) == NULL) return(NULL);}

 if(unity != NULL)
   {if(FrStrCpy(&vect->unitY,unity) == NULL) return(NULL);}
  
 return(vect);} 

/*--------------------------------------------------------------FrVectRead--*/
struct FrVect *FrVectRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrVect *v;
 static int first=0, wSize[FR_VECT_END];
 unsigned short type;

 if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(FRLONG);
     wSize[FR_VECT_8U]  = sizeof(FRLONG);
     wSize[FR_VECT_C8]  = 2*sizeof(float);
     wSize[FR_VECT_C16] = 2*sizeof(double);
     wSize[FR_VECT_H8]  = 2*sizeof(float);
     wSize[FR_VECT_H16] = 2*sizeof(double);}
 
 v = (struct FrVect *) calloc(1,sizeof(struct FrVect));
 if(v == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 else {v->classe = FrVectDef();}
 
 FrReadHeader(iFile,  v);
 FrReadSChar( iFile, &v->name);
 FrReadShortU(iFile, &v->compress);
 if (v->compress == 256) v->compress = 0; /*we will swap bytes at reading time*/

 FrReadShortU(iFile, &type);
 v->type = type;
 FrReadIntU  (iFile, &v->nData);
 FrReadIntU  (iFile, &v->nBytes);
 v->size = v->nData;

 if     (v->compress != 0)  
        {FrReadVC (iFile, &v->data, v->nBytes);}

 else if((v->type == FR_VECT_C ) || (v->type == FR_VECT_1U)) 
        {FrReadVC (iFile, &v->data, v->nData);}
 else if((v->type == FR_VECT_2S) || (v->type == FR_VECT_2U))
        {FrReadVS (iFile, &v->dataS, v->nData);
	 v->data = (char *)v->dataS;}
 else if(v->type == FR_VECT_8R)  
        {FrReadVD (iFile, &v->dataD, v->nData);
	 v->data = (char *)v->dataD;}
 else if(v->type == FR_VECT_4R)  
        {FrReadVF (iFile, &v->dataF, v->nData);
	 v->data = (char *)v->dataF;}
 else if((v->type == FR_VECT_4S) || (v->type == FR_VECT_4U))
        {FrReadVI (iFile, &v->dataI, v->nData);
	 v->data = (char *)v->dataI;}
 else if((v->type == FR_VECT_8S) || (v->type == FR_VECT_8U)) 
        {FrReadVL (iFile, &v->dataL, v->nData);
	 v->data = (char *)v->dataL;}
 else if(v->type == FR_VECT_C8) 
        {FrReadVF (iFile, &v->dataF, v->nData*2);
	 v->data = (char *)v->dataF;}
 else if(v->type == FR_VECT_C16) 
        {FrReadVD (iFile, &v->dataD, v->nData*2);
 	 v->data = (char *)v->dataD;}
 else if(v->type == FR_VECT_STRING) 
        {FrReadVQ (iFile, &v->dataQ, v->nData);
 	 v->data = (char *)v->dataQ;}
 else {iFile->error = FR_ERROR_READ_ERROR;
       return(NULL);}

 if(iFile->error == FR_ERROR_MALLOC_FAILED) return(NULL);

 FrVectMap(v);

 FrReadIntU  (iFile, &v->nDim);
 FrReadVI (iFile,(int **) &v->nx,  v->nDim);
 FrReadVD (iFile, &v->dx,    v->nDim);
 FrReadVD (iFile, &v->startX,v->nDim);
 FrReadVQ (iFile, &v->unitX, v->nDim);
 FrReadSChar (iFile, &v->unitY);
 FrReadStruct(iFile, &v->next);
 
 v->wSize= wSize[v->type];

 if(FrDebugLvl > 2)
    {if(v->name != NULL) fprintf(FrFOut," %-24s ", v->name);
     fprintf(FrFOut," nBytes=%d\n", v->nBytes);}

 if(iFile->compress == 0 && v->compress != 0) {FrVectExpand(v);}
 
 return(v);}
/*-------------------------------------------------- FrVectReadNext--*/
struct FrVect *FrVectReadNext(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;

       /*-----search for FrVect (skip type FrSE and FrSH  records)----*/

 while(iFile->error == FR_OK)
    {FrReadInt  (iFile,  (int *) &iFile->length);
     FrReadShort(iFile,(short *) &iFile->type);

     if(iFile->type != 1 && iFile->type != 2) break; 
     FrReadSkipRecord(iFile);}

 if(iFile->type != iFile->FrVectId) 
      vect = NULL;
 else vect = FrVectRead(iFile);

 return(vect);}

/*--------------------------------------------------------FrVectStat--*/
char *FrVectStat(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{static char buf[256];
 int i, minI, maxI, valueI, pastI, deltaI, deltaMI, *dataI;
 int imax, nData, nDataH, real, imag;
 double mean, mean2, valueD, minD, maxD, pastD, deltaD, deltaMD, *dataD;
 double amplitude, amplitudeMax;
 float *dataF;
 short *dataS;
 char *dataC;

 sprintf(buf,"cannot compute statistique");

 if(vect == NULL)      return(buf);
 if(vect->nData == 0)  return(buf);

 if(FrVectIsValid(vect) != 0) 
   {sprintf(buf,"No stat: vector contains NAN or INF data");
    return(buf);}

 mean    = 0.;
 mean2   = 0.;
   
 if(vect->type == FR_VECT_C)
     {dataC = vect->data;
      minI    = dataC[0];
      maxI    = dataC[0];
      pastI   = dataC[0];
      deltaMI = 0.;

      for (i= 0; i<vect->nData; i++)
       {valueI = dataC[i];
        if (valueI > maxI)  maxI = valueI;
        if (valueI < minI)  minI = valueI;
        mean  += valueI;
        mean2 += valueI*valueI;
        deltaI  = pastI - valueI;
        if(deltaI < 0) deltaI = -deltaI;
        if(deltaI > deltaMI) deltaMI = deltaI;
        pastI   = valueI;}

      mean  = mean  / (double)vect->nData;
      mean2 = mean2/vect->nData-mean*mean;
      if(mean2 < 0) mean2 = 0.;
      sprintf(buf,"min %d mean %.2f max %d delta %d rms %.2f",
          minI, mean, maxI, deltaMI, sqrt(mean2));}

 if(vect->type == FR_VECT_2S)
     {dataS = vect->dataS;
      minI    = dataS[0];
      maxI    = dataS[0];
      pastI   = dataS[0];
      deltaMI = 0.;

      for (i= 0; i<vect->nData; i++)
       {valueI = dataS[i];
        if (valueI > maxI)  maxI = valueI;
        if (valueI < minI)  minI = valueI;
        mean  += valueI;
        mean2 += valueI*valueI;
        deltaI  = pastI - valueI;
        if(deltaI < 0) deltaI = -deltaI;
        if(deltaI > deltaMI) deltaMI = deltaI;
        pastI   = valueI;}

      mean  = mean  / (double)vect->nData;
      mean2 = mean2/vect->nData-mean*mean;
      if(mean2 < 0) mean2 = 0.;
      sprintf(buf,"min %d mean %.2f max %d delta %d rms %.2f",
          minI, mean, maxI, deltaMI, sqrt(mean2));}

 else if(vect->type == FR_VECT_4S)
     {dataI = vect->dataI;
      minI    = dataI[0];
      maxI    = dataI[0];
      pastI   = dataI[0];
      deltaMI = 0.;

      for (i= 0; i<vect->nData; i++)
       {valueI = dataI[i];
        if (valueI > maxI)  maxI = valueI;
        if (valueI < minI)  minI = valueI;
        valueD = valueI;
        mean  += valueD;
        mean2 += valueD*valueD;
        deltaI  = pastI - valueI;
        if(deltaI < 0) deltaI = -deltaI;
        if(deltaI > deltaMI) deltaMI = deltaI;
        pastI   = valueI;}

      mean  = mean  / (double)vect->nData;
      mean2 = mean2/vect->nData-mean*mean;
      if(mean2 < 0) mean2 = 0.;
      sprintf(buf,"min %d mean %.2f max %d delta %d rms %.2f",
          minI, mean, maxI, deltaMI, sqrt(mean2));}

 else if(vect->type == FR_VECT_4R)
     {dataF = vect->dataF;
      minD    = dataF[0];
      maxD    = dataF[0];
      pastD   = dataF[0];
      deltaMD = 0.;

      for (i= 0; i<vect->nData; i++)
       {valueD = dataF[i];
        if (valueD > maxD)  maxD = valueD;
        if (valueD < minD)  minD = valueD;
        mean  += valueD;
        mean2 += valueD*valueD;
        deltaD  = pastD - valueD;
        if(deltaD < 0) deltaD = -deltaD;
        if(deltaD > deltaMD) deltaMD = deltaD;
        pastD   = valueD;}

      mean  = mean  / (double)vect->nData;
      mean2 = mean2/vect->nData-mean*mean;
      if(mean2 < 0) mean2 = 0.;
      sprintf(buf,"min %.4e mean %.5e max %.4e delta %.4e rms %.4e",
          minD, mean, maxD, deltaMD, sqrt(mean2));}

 else if(vect->type == FR_VECT_8R)
     {dataD = vect->dataD;
      minD    = dataD[0];
      maxD    = dataD[0];
      pastD   = dataD[0];
      deltaMD = 0.;

      for (i= 0; i<vect->nData; i++)
       {valueD = dataD[i];
        if (valueD > maxD)  maxD = valueD;
        if (valueD < minD)  minD = valueD;
        mean  += valueD;
        if((valueD > -1.e+100) && 
           (valueD <  1.e+100)) mean2 += valueD*valueD;
        deltaD  = pastD - valueD;
        if(deltaD < 0) deltaD = -deltaD;
        if(deltaD > deltaMD) deltaMD = deltaD;
        pastD   = valueD;}

      mean  = mean  / (double)vect->nData;
      mean2 = mean2/vect->nData-mean*mean;
      if(mean2 < 0) mean2 = 0.;
      sprintf(buf,"min %.4e mean %.5e max %.4e delta %.4e rms %.4e",
          minD, mean, maxD, deltaMD, sqrt(mean2));}

 else if(vect->type == FR_VECT_H16)
     {nData  = 2*vect->nData;
      nDataH =   vect->nData;
      dataD  = vect->dataD;

      amplitudeMax = 0.;
      imax = 0;

      for (i=0; i<nDataH-1; i++) 
       {real = i+1;
        imag = nData-i-1;
        amplitude =  dataD[real]*dataD[real] + dataD[imag]*dataD[imag];
        if(amplitude > amplitudeMax)
	  {amplitudeMax = amplitude;
           imax = i;}}

      sprintf(buf,"amplitudeMax=%e (%e,%e) for i=%d (%e %s)",
          sqrt(amplitudeMax),dataD[imax+1],dataD[nData-imax-1],imax,
	      imax*vect->dx[0],vect->unitX[0]);}


 else{return(buf);}

 return(buf);
}
/*-------------------------------------------------------------FrVectWrite--*/
void FrVectWrite(struct FrVect *v, 
                 struct FrFile *oFile)
/*--------------------------------------------------------------------------*/
{unsigned short compress;
 unsigned char *data;
 unsigned int nBytes;
 short ref;
 char *swap;

 if(v == NULL) return;

    /*----- compress only if the vector is not properly compress -----*/
 
 compress = 0;
 if((oFile->compress != v->compress) &&
    (oFile->compress != -1) && (v->type != FR_VECT_STRING)) 
     {compress = FrVectCompData(v, oFile->compress, 
                                   oFile->gzipLevel,&data, &nBytes);}
 if(compress == 0)
    {compress = v->compress;
     data     = v->dataU;
     nBytes   = v->nBytes;}

 if(compress == 0)
    {swap = (char *)&ref;
     ref = 0x1234;
     if(swap[0] != 0x12) compress = 256;}
 
 FrPutNewRecord(oFile, v, FR_YES);
 FrPutSChar (oFile, v->name);
 FrPutShortU(oFile, compress);
 FrPutShortU(oFile, v->type);
 FrPutIntU  (oFile, v->nData);
 FrPutIntU  (oFile, nBytes);
 if(compress != 0 && compress != 256)             
     {FrPutVC (oFile, (char *)data, nBytes);
      if(data != v->dataU) free(data);}
 else if(v->type == FR_VECT_C)     {FrPutVC (oFile, v->data,  v->nData);}
 else if(v->type == FR_VECT_2S)    {FrPutVS (oFile, v->dataS, v->nData);}
 else if(v->type == FR_VECT_8R)    {FrPutVD (oFile, v->dataD, v->nData);}
 else if(v->type == FR_VECT_4R)    {FrPutVF (oFile, v->dataF, v->nData);}
 else if(v->type == FR_VECT_4S)    {FrPutVI (oFile, v->dataI, v->nData);}
 else if(v->type == FR_VECT_8S)    {FrPutVL (oFile, v->dataL, v->nData);}
 else if(v->type == FR_VECT_C8)    {FrPutVF (oFile, v->dataF, v->nData*2);}
 else if(v->type == FR_VECT_C16)   {FrPutVD (oFile, v->dataD, v->nData*2);}
 else if(v->type == FR_VECT_H8)    {FrPutVF (oFile, v->dataF, v->nData*2);}
 else if(v->type == FR_VECT_H16)   {FrPutVD (oFile, v->dataD, v->nData*2);}
 else if(v->type == FR_VECT_STRING){FrPutVQ (oFile, v->dataQ, v->nData);}
 else if(v->type == FR_VECT_2U)    {FrPutVS (oFile, v->dataS, v->nData);}
 else if(v->type == FR_VECT_4U)    {FrPutVI (oFile, v->dataI, v->nData);}
 else if(v->type == FR_VECT_8U)    {FrPutVL (oFile, v->dataL, v->nData);}
 else if(v->type == FR_VECT_1U)    {FrPutVC (oFile, v->data,  v->nData);}
 else     {oFile->error = FR_ERROR_WRITE_ERROR;
           return;}
 FrPutIntU(oFile, v->nDim);
 FrPutVI (oFile,(int *) v->nx,     v->nDim);
 FrPutVD (oFile,        v->dx,     v->nDim);
 FrPutVD (oFile,        v->startX, v->nDim);
 FrPutVQ (oFile,        v->unitX,  v->nDim);
 FrPutSChar(oFile,  v->unitY);
 FrPutStruct(oFile, v->next);
 FrPutWriteRecord(oFile); 
	
 if(v->next != NULL) FrVectWrite(v->next, oFile);

 return;}

/*------------------------------------------------------FrVectFComp---*/
int FrVectFComp(short *out, 
                unsigned long *compL,
                float *data,
                int nData,
                int bSize)
/*--------------------------------------------------------------------*/
{float *outF, delta, deltaMax, deltaMin, resolution, scale, halfScale,
   factor, rebuild, new;
 float resol[] = {1.,1.,2.,4.,6.5,14.5,30.5,62.,126.,254.,510.,1022.,2046.,
                   4094.,8190.,16382.,32766.,65532.};
 int i, step;

 /*---- store the bloc size -----*/

 outF = (float *) out;
 outF[0] = data[0];

      /*--------- first compute the step size  --------------*/

 deltaMax = 0.;
 deltaMin = 0.;
 for(i=0; i<nData-1; i++)  
    {delta = data[i+1] - data[i];
     if(delta < deltaMin) deltaMin = delta;
     if(delta > deltaMax) deltaMax = delta;}
 if(-deltaMin > deltaMax) deltaMax = -deltaMin;
 if(deltaMax == 0.) 
   {outF[1] = 0;
    *compL = 8;
    return(0);}

 resolution = resol[bSize];
 factor = resolution/deltaMax;
 scale  = 1./factor;
 halfScale = .5*scale;
 outF[1] = scale; 

      /*---------- then store the data --------------------*/

 rebuild   = data[0];

 for(i=1; i<nData; i++)
   {step = factor*(data[i] - data[i-1]);
    new = scale*step + rebuild;
    if(new > data[i])
         {step -= (int)(factor*( halfScale + new - data[i]));}
    else {step -= (int)(factor*(-halfScale + new - data[i]));}
    rebuild += scale*step;
    out[i+4] = step;}

out[4]  = bSize;

 *compL = 8 + 2*nData;
   
return(0);}

/*--------------------------------------------------FrVectFExpand-----*/
void FrVectFExpand(float *out, 
                   short  *data, 
                   int nData)
/*--------------------------------------------------------------------*/
{int  i;
 float *dataF, scale;

 dataF = (float *) data;
 out[0] = dataF[0];
 scale  = dataF[1];

 if(scale == 0.)
      {for(i=1; i<nData; i++) {out[i] = 0.;}}
 else {for(i=1; i<nData; i++) {out[i] = out[i-1] + scale*data[4+i];}}

return;}

#if !defined(FR_USER_COMPRESSION)
/*--------------------------------------------------------------------*/
/* The next two function are designec to provide a hook for user 
   defined compression algorithms. Just recompile the FrameLib with the
   flag FR_USER_COMPRESSION and provide the two following functions*/
/*------------------------------------------------------FrVectUComp---*/
int FrVectUComp(FrVect *vect,
                unsigned char *out, 
                unsigned long *compL,
                int  *compType)
/*--------------------------------------------------------------------*/
{   
return(0);}

/*--------------------------------------------------FrVectUExpand-----*/
void FrVectUExpand(FrVect *vect,
                   unsigned char *out)
/*--------------------------------------------------------------------*/
{
return;}
#endif

/*------------------------------------------------------FrVectZComp---*/
int FrVectZComp(unsigned short *out, 
                unsigned long *compL,
                short *data,
                int nData,
                int bSize)
/*--------------------------------------------------------------------*/
{unsigned short nBits, uData, limit;
 short max, pOut;
 int  iIn, iOut, i, maxOut;
 short wMax[] = {0,0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                   0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff};

  maxOut = *compL/2;

 /*---- store the bloc size -----*/

 out[0] = bSize;
 iOut = 0;
 pOut = 16;

 /*--------- store the data  --------------*/

 iIn = 0;
 while(iIn<nData)

   { /*-------- tune the size of the last bloc -----*/

     if(iIn + bSize > nData) {bSize = nData - iIn;}

      /*---- get the maximum amplitude --------------*/
      
     max = 0;
     for(i=0; i<bSize; i++)  
       {if(data[iIn+i] == -32768) return(-1);/* -32768 = -32768 for a short...*/
           if(data[iIn+i] > 0)
                {max = max |  data[iIn + i];}
           else {max = max | -data[iIn + i];}}

     /*----- determine the number of bits needed -----*/
     /*          (2*(max-1)  < 2**nBits)              */

     if(max > 127) 
       {if(max > 2047) 
          {if(max > 8191)
               {if(max > 16383) {nBits = 16;}
                else            {nBits = 15;}}
           else{if(max > 4095)  {nBits = 14;}
                else            {nBits = 13;}}}
        else
          {if(max > 511)
               {if(max > 1023)  {nBits = 12;}
                else            {nBits = 11;}}
           else{if(max > 255)   {nBits = 10;}
                else            {nBits = 9;}}}}
     else
       {if(max > 7) 
          {if(max > 31)
               {if(max > 63)    {nBits = 8;}
                else            {nBits = 7;}}
           else{if(max > 15)    {nBits = 6;}
                else            {nBits = 5;}}}
        else
          {if(max > 1)
               {if(max > 3)     {nBits = 4;}
                else            {nBits = 3;}}
           else{if(max > 0)     {nBits = 2;}
                else            {nBits = 1;}}}}

       /*---- encode the data size ----------*/
       /*---- we store nBits - 1 in 4 bits---*/

     out[iOut] = out[iOut] | ((nBits-1) << pOut);
     if(pOut > 12)
        {iOut ++;
         if(iOut >= maxOut) return(-1);
        pOut = pOut - 16;
        out[iOut] = (nBits-1) >> - pOut;}
     pOut  = pOut +4;

       /*--- encode the data itself ------*/

     if(nBits > 1)
       {limit = 16 - nBits;
        for(i = 0; i<bSize; i++)
          {uData = (unsigned short) (data[iIn+i] + wMax[nBits]);

           out[iOut] = out[iOut] | (uData << pOut);
           if(pOut > limit)
             {iOut ++;
              if(iOut >= maxOut) return(-1);
              pOut = pOut - 16;
              out[iOut] = uData >> -pOut;}
           pOut  = pOut + nBits;
        }  } 


     /*-------- increase pointer -------*/
  
     iIn = iIn + bSize;}

  *compL = 2*(iOut+1);

return(0);}

/*------------------------------------------------------FrVectZCompI--*/
int FrVectZCompI(unsigned int *out, 
                unsigned long *compL,
                int *data,
                int nData,
                int bSize)
/*--------------------------------------------------------------------*/
{unsigned int nBits, uData, limit;
 unsigned int max, pOut;
 int  iIn, iOut, i, maxOut;
 int wMax[] = {0,0,1,3,7,
                 0xf      ,0x1f      ,0x3f      ,0x7f,
                 0xff     ,0x1ff     ,0x3ff     ,0x7ff,
                 0xfff    ,0x1fff    ,0x3fff    ,0x7fff,
                 0xffff   ,0x1ffff   ,0x3ffff   ,0x7ffff,
                 0xfffff  ,0x1fffff  ,0x3fffff  ,0x7fffff,
                 0xffffff ,0x1ffffff ,0x3ffffff ,0x7ffffff,
                 0xfffffff,0x1fffffff,0x3fffffff,0x7fffffff};

  maxOut = *compL/4;

 /*---- store the bloc size -----*/

 out[0] = bSize;
 iOut = 0;
 pOut = 16;

 /*--------- store the data  --------------*/

 iIn = 0;
 while(iIn<nData)

   { /*-------- tune the size of the last bloc -----*/

     if(iIn + bSize > nData) {bSize = nData - iIn;}

      /*---- get the maximum amplitude --------------*/
      
     max = 0;
     
     for(i=0; i<bSize; i++)  
       {if(data[iIn+i] == 0xFFFFFFFF) return(-1); /*-32768 = -32768 for a short..*/
           if(data[iIn+i] > 0)
                {max = max |  data[iIn + i];}
           else {max = max | -data[iIn + i];}}

     /*----- determine the number of bits needed -----*/
     /*          (2*(max-1)  < 2**nBits)              */
     
     if(max > 0x7fff)
       {if(max > 0x7fffff) 
          {if(max > 0x7ffffff) 
             {if(max > 0x1fffffff)
                  {if(max > 0x3fffffff) {nBits = 32;}
                   else                 {nBits = 31;}}
              else{if(max > 0xfffffff)  {nBits = 30;}
                   else                 {nBits = 29;}}}
           else
             {if(max > 0x1ffffff)
                  {if(max > 0x3ffffff)  {nBits = 28;}
                   else                 {nBits = 27;}}
              else{if(max > 0xffffff)   {nBits = 26;}
                   else                 {nBits = 25;}}}}
        else
          {if(max > 0x7ffff) 
             {if(max > 0x1fffff)
                  {if(max > 0x3fffff)   {nBits = 24;}
                   else                 {nBits = 23;}}
              else{if(max > 0xfffff)    {nBits = 22;}
                   else                 {nBits = 21;}}}
           else
             {if(max > 0x1ffff)
                  {if(max > 0x3ffff)    {nBits = 20;}
                   else                 {nBits = 19;}}
              else{if(max > 0xffff)     {nBits = 18;}
 	           else                 {nBits = 17;}}}}}
     else
       {if(max > 0x7f) 
          {if(max > 0x7ff) 
             {if(max > 0x1fff)
                  {if(max > 0x3fff) {nBits = 16;}
                   else             {nBits = 15;}}
              else{if(max > 0xfff)  {nBits = 14;}
                   else             {nBits = 13;}}}
           else
             {if(max > 0x1ff)
                  {if(max > 0x3ff)  {nBits = 12;}
                   else             {nBits = 11;}}
              else{if(max > 0xff)   {nBits = 10;}
                   else             {nBits = 9;}}}}
        else
          {if(max > 0x7) 
             {if(max > 0x1f)
                  {if(max > 0x3f)   {nBits = 8;}
                   else             {nBits = 7;}}
              else{if(max > 0xf)    {nBits = 6;}
                   else             {nBits = 5;}}}
           else
             {if(max > 1)
                  {if(max > 3)    {nBits = 4;}
                   else           {nBits = 3;}}
              else{if(max > 0)    {nBits = 2;}
 	           else           {nBits = 1;}}}}}
     
       /*---- encode the data size ----------*/
       /*---- we store nBits - 1 in 4 bits---*/

     if(pOut != 32) out[iOut] = out[iOut] | ((nBits-1) << pOut);
     if(pOut > 27)
        {iOut ++;
         if(iOut >= maxOut) return(-1);
        pOut = pOut - 32;
        out[iOut] = (nBits-1) >> - pOut;}
     pOut  = pOut + 5;
     
       /*--- encode the data itself ------*/
     
     if(nBits > 1)
       {limit = 32 - nBits;
        for(i = 0; i<bSize; i++)
          {uData = (unsigned int) (data[iIn+i] + wMax[nBits]);

           if(pOut != 32) out[iOut] = out[iOut] | (uData << pOut);
           if(pOut > limit)
             {iOut ++;
              if(iOut >= maxOut) return(-1);
              pOut = pOut - 32;
              out[iOut] = uData >> -pOut;
            }
           pOut  = pOut + nBits;
        }  } 
     

     /*-------- increase pointer -------*/
  
     iIn = iIn + bSize;}

  *compL = 4*(iOut+1);

return(0);}

/*--------------------------------------------------FrVectZExpand-----*/
void FrVectZExpand(short *out, 
                   unsigned short *data, 
                   int nData)
/*--------------------------------------------------------------------*/
{unsigned short nBits, pIn, uData, *buf, *alpha;
 unsigned short wMax[] = {0,0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                      0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff};
 unsigned short mask[] = {0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                      0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff,0xffff};
 unsigned int iBuf, iAlpha;
 int  i, iIn, iOut, bSize;

 /*----- check which indian --------*/

 iAlpha = 0x12345678;
 alpha = (unsigned short *) &iAlpha;

 /*---- retrieve the bloc size -----*/

 bSize = data[0];
 iIn = 1;
 pIn = 0;

 /*--------- retrieve the data  --------------*/

 buf = (unsigned short *) &iBuf; 
 iOut = 0;
 do
    {/*-------- extract nBits -------------
        -----(we check if data is in 1 or 2 words) ------*/
        
    if(pIn <= 12)
       {uData = data[iIn] >> pIn;
        pIn = pIn + 4;}
     else
       {buf[0] = data[iIn];
        iIn++;
        if(alpha[0] == 0x1234)
             {buf[1] = buf[0];
              buf[0] = data[iIn];}
        else {buf[1] = data[iIn];}
        uData = iBuf >> pIn;
        pIn = pIn - 12;}

    nBits = 1 + (mask[4] & uData);
    if(nBits == 1) nBits = 0;

     /*----extract data ----------*/

     for(i=0; i<bSize; i++)
       {if(iOut >= nData) break;

        if(pIn + nBits <= 16)
          {uData = data[iIn] >> pIn;
           pIn = pIn + nBits;}
        else
          {buf[0] = data[iIn];
           iIn++;
           if(alpha[0] == 0x1234)
                {buf[1] = buf[0];
                 buf[0] = data[iIn];}
           else {buf[1] = data[iIn];}  
           uData = iBuf >> pIn;
           pIn = pIn + nBits - 16;}

        out[iOut] = (mask[nBits] & uData) - wMax[nBits];
        iOut++;}}
 while(iOut<nData);

return;}

/*--------------------------------------------------FrVectZExpandI----*/
void FrVectZExpandI(int *out, 
                    unsigned int *data, 
                    int nData)
/*--------------------------------------------------------------------*/
{unsigned short *alpha;
 unsigned int nBits, pIn, uData, *buf;
 unsigned int wMax[] = {0,0,1,3,7,
                 0xf      ,0x1f      ,0x3f      ,0x7f,
                 0xff     ,0x1ff     ,0x3ff     ,0x7ff,
                 0xfff    ,0x1fff    ,0x3fff    ,0x7fff,
                 0xffff   ,0x1ffff   ,0x3ffff   ,0x7ffff,
                 0xfffff  ,0x1fffff  ,0x3fffff  ,0x7fffff,
                 0xffffff ,0x1ffffff ,0x3ffffff ,0x7ffffff,
                 0xfffffff,0x1fffffff,0x3fffffff,0x7fffffff};
 unsigned int mask[] = {0,1,3,      7,       0xf,
              0x1f      ,0x3f      ,0x7f,      0xff,
              0x1ff     ,0x3ff     ,0x7ff,     0xfff,
              0x1fff    ,0x3fff    ,0x7fff,    0xffff,
              0x1ffff   ,0x3ffff   ,0x7ffff,   0xfffff,
              0x1fffff  ,0x3fffff  ,0x7fffff,  0xffffff,
              0x1ffffff ,0x3ffffff ,0x7ffffff, 0xfffffff,
              0x1fffffff,0x3fffffff,0x7fffffff,0xffffffff};
unsigned int iBuf, iAlpha;
 int  i, iIn, iOut, bSize;

 /*----- check which indian --------*/

 iAlpha = 0x12345678;
 alpha = (unsigned short *) &iAlpha;

 /*---- retrieve the bloc size -----*/

 bSize = data[0] & 0xffff;
 iIn = 0;
 pIn = 16;

 /*--------- retrieve the data  --------------*/

 buf = (unsigned int *) &iBuf; 
 iOut = 0;
 do
    {/*-------- extract nBits -(we check if data is in 1 or 2 words) ------*/
        
    if(pIn <= 27)
       {uData = data[iIn] >> pIn;
        pIn = pIn + 5;}
     else
       {uData = (data[iIn] >> pIn) & mask[32-pIn];
        iIn++;
        uData += data[iIn] << (32-pIn);
        pIn = pIn - 27;}

    nBits = 1 + (0x1f & uData);
    if(nBits == 1) nBits = 0;

     /*----extract data ----------*/

     for(i=0; i<bSize; i++)
       {if(iOut >= nData) break;

        if(pIn + nBits <= 32)
          {uData = data[iIn] >> pIn;
           pIn = pIn + nBits;}
        else
          {uData = (data[iIn] >> pIn) & mask[32-pIn];
           iIn++;
           uData += data[iIn] << (32-pIn);
           pIn = pIn + nBits - 32;}

        out[iOut] = (mask[nBits] & uData) - wMax[nBits];
        iOut++;}}
 while(iOut<nData);

return;}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*  Here is a set of function used for backward compatibility               */
/*    FrBackNxxx is used to read file written with format N                 */
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*-----------------------------------------------------FrBack4DetectorRead--*/
void FrBack4DetectorRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrDetector *detector;
 
  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {detector->classe = FrDetectorDef();} 
  
  FrReadHeader(iFile,  detector);
  FrReadSChar (iFile, &detector->name); 
  FrReadShort (iFile, &detector->longitudeD); 
  FrReadShort (iFile, &detector->longitudeM); 
  FrReadFloat (iFile, &detector->longitudeS); 
  FrReadShort (iFile, &detector->latitudeD); 
  FrReadShort (iFile, &detector->latitudeM); 
  FrReadFloat (iFile, &detector->latitudeS); 
  FrReadFloat (iFile, &detector->elevation); 
  FrReadFloat (iFile, &detector->armXazimuth); 
  FrReadFloat (iFile, &detector->armYazimuth); 
  FrReadFloat (iFile, &detector->armLength); 
  FrReadStruct(iFile, &detector->more); 

  FrCurDetector = detector;

  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", detector->name);

  return;}
 
/*------------------------------------------------------FrBack4FrameHRead---*/
void FrBack4FrameHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrameH *frameH;
 unsigned short id;

  frameH = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frameH == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {frameH->classe = FrameHDef();} 
  
  FrReadShortU(iFile, &id);  /*frameH are not referenced by pointer*/
  FrReadSChar (iFile, &frameH->name); 
  FrReadIntU  (iFile, &frameH->run);
  FrReadIntU  (iFile, &frameH->frame);
  FrReadIntU  (iFile, &frameH->GTimeS);
  FrReadIntU  (iFile, &frameH->GTimeN);
  FrReadShortU(iFile, &frameH->ULeapS); /*only since version 3.30*/
  FrReadInt   (iFile, &frameH->localTime);
  FrReadDouble(iFile, &frameH->dt);
  FrReadStruct(iFile, &frameH->type);
  FrReadStruct(iFile, &frameH->user);
  FrReadStruct(iFile, &frameH->detectSim);
  FrReadStruct(iFile, &frameH->detectProc);
  FrReadStruct(iFile, &frameH->history);
  FrReadStruct(iFile, &frameH->rawData);
  FrReadStruct(iFile, &frameH->procData);
  FrReadStruct(iFile, &frameH->strain);
  FrReadStruct(iFile, &frameH->simData);
  FrReadStruct(iFile, &frameH->trigData);
  FrReadStruct(iFile, &frameH->summaryData);
  FrReadStruct(iFile, &frameH->auxData);

  if(FrDebugLvl > 0) fprintf(FrFOut, 
          "FrBack4FrameHRead:  Run:%d Frame:%d\n",frameH->run,frameH->frame);

  iFile->curFrame = frameH;
   
  return;}
/*-----------------------------------------------------FrBack4ProcDataRead--*/
void FrBack4ProcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrProcData *procData;

  procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
  if(procData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {procData->classe = FrProcDataDef();}
  
  FrReadHeader(iFile,  procData);
  FrReadSChar( iFile, &procData->name);
  FrReadSChar( iFile, &procData->comment);
  FrReadDouble(iFile, &procData->sampleRate);
  FrReadIntU  (iFile, &procData->timeOffsetS);
  FrReadIntU  (iFile, &procData->timeOffsetN);
  FrReadDouble(iFile, &procData->fShift);
  FrReadStruct(iFile, &procData->data);
  FrReadStruct(iFile, &procData->aux);
  FrReadStruct(iFile, &procData->next);

  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", procData->name);

  return;}
/*------------------------------------------------------FrBack4RawDataRead--*/
void FrBack4RawDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrRawData *rawData;

 rawData = (struct FrRawData *) calloc(1,sizeof(struct FrRawData));
 if(rawData == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {rawData->classe = FrRawDataDef();}
  
 FrReadHeader(iFile,  rawData);
 FrReadSChar (iFile, &rawData->name); 
 FrReadStruct(iFile, &rawData->firstSer);
 FrReadStruct(iFile, &rawData->firstAdc);
 rawData->firstTable = NULL;
 FrReadStruct(iFile, &rawData->logMsg);
 FrReadStruct(iFile, &rawData->more);
  
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", rawData->name);

 return;}

/*------------------------------------------------------FrBack4SimDataRead--*/
void FrBack4SimDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrSimData *simData;

  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {simData->classe = FrSimDataDef();}
  
  FrReadHeader(iFile,  simData);
  FrReadSChar( iFile, &simData->name);
  FrReadSChar (iFile, &simData->comment);
  FrReadFloat (iFile, &simData->sampleRate);
  FrReadStruct(iFile, &simData->data);
  FrReadStruct(iFile, &simData->input);
  FrReadStruct(iFile, &simData->next);
    
  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", simData->name);

return;}
/*-----------------------------------------------------FrBack4StatDataRead--*/
void FrBack4StatDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrStatData *sData;
 unsigned short id;
 
  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {sData->classe = FrStatDataDef();}

  FrReadShortU(iFile, &id);  /*statData are not referenced by pointer*/
  FrReadSChar( iFile, &sData->name);
  FrReadSChar (iFile, &sData->comment); 
  FrReadIntU  (iFile, &sData->timeStart); 
  FrReadIntU  (iFile, &sData->timeEnd); 
  FrReadIntU  (iFile, &sData->version); 
  FrReadStruct(iFile, &sData->detector); 
  FrReadStruct(iFile, &sData->data); 

  sData->next = iFile->sDataCur;
  iFile->sDataCur = sData;

  if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", sData->name);

  return;}
/*------------------------------------------------------FrBack4SummaryRead--*/
void FrBack4SummaryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrSummary *summary;

 summary = (struct FrSummary *) calloc(1,sizeof(struct FrSummary));
 if(summary == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {summary->classe = FrSummaryDef();}

 FrReadHeader(iFile,  summary);
 FrReadSChar (iFile, &summary->name); 
 FrReadSChar (iFile, &summary->comment);
 FrReadSChar (iFile, &summary->test);
 FrReadStruct(iFile, &summary->moments);
 FrReadStruct(iFile, &summary->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", summary->name);

 return;}

/*-----------------------------------------------------FrBack4TrigDataRead--*/
void FrBack4TrigDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrTrigData *trigData;

 trigData = (struct FrTrigData *) calloc(1,sizeof(struct FrTrigData));
 if(trigData == NULL) 
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {trigData->classe = FrTrigDataDef();}

 FrReadHeader(iFile,  trigData);
 FrReadSChar (iFile, &trigData->name); 
 FrReadSChar (iFile, &trigData->comment);
 FrReadSChar (iFile, &trigData->inputs);
 FrReadIntU  (iFile, &trigData->GTimeS);
 FrReadIntU  (iFile, &trigData->GTimeN);
 FrReadIntU  (iFile, &trigData->triggerStatus);
 FrReadFloat (iFile, &trigData->amplitude);
 FrReadFloat (iFile, &trigData->probability);
 FrReadSChar (iFile, &trigData->statistics);
 FrReadStruct(iFile, &trigData->data);
 FrReadStruct(iFile, &trigData->next);
    
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", trigData->name);

 return;}

/*---------------------------------------------------------FrBack4VectRead--*/
void FrBack4VectRead(struct FrFile *iFile)
/*--------------------------------------------------------------------------*/
{struct FrVect *v;
 static int first=0, wSize[FR_VECT_END];
 int i;
 unsigned short type;

 if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(long);
     wSize[FR_VECT_8U]  = sizeof(long);
     wSize[FR_VECT_C8]  = 2*sizeof(float);
     wSize[FR_VECT_C16] = 2*sizeof(double);}
 
 v = (struct FrVect *) calloc(1,sizeof(struct FrVect));
 if(v == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {v->classe = FrVectDef();}
 
 FrReadHeader(iFile,  v);
 FrReadSChar( iFile, &v->name);
 FrReadShortU(iFile, &v->compress);
 FrReadShortU(iFile, &type);
 v->type = type;
 FrReadIntU  (iFile, &v->nData);
 FrReadIntU  (iFile, &v->nBytes);
 v->size = v->nData;

 if     (v->compress != 0)  
        {FrReadVC (iFile, &v->data, v->nBytes);}
 else if(v->type == FR_VECT_4R)  
        {FrReadVF (iFile, &v->dataF, v->nData);
	 v->data = (char *)v->dataF;}
 else if(v->type == FR_VECT_8R)  
        {FrReadVD (iFile, &v->dataD, v->nData);
	 v->data = (char *)v->dataD;}
 else if((v->type == FR_VECT_C ) || (v->type == FR_VECT_1U)) 
        {FrReadVC (iFile, &v->data, v->nData);}
 else if((v->type == FR_VECT_2S) || (v->type == FR_VECT_2U))
        {FrReadVS (iFile, &v->dataS, v->nData);
	 v->data = (char *)v->dataS;}
 else if((v->type == FR_VECT_4S) || (v->type == FR_VECT_4U))
        {FrReadVI (iFile, &v->dataI, v->nData);
	 v->data = (char *)v->dataI;}
 else if((v->type == FR_VECT_8S) || (v->type == FR_VECT_8U)) 
        {FrReadVL (iFile, &v->dataL, v->nData);
	 v->data = (char *)v->dataL;}
 else if(v->type == FR_VECT_C8) 
        {FrReadVF (iFile, &v->dataF, v->nData*2);
	 v->data = (char *)v->dataF;}
 else 
        {FrReadVD (iFile, &v->dataD, v->nData*2);
	 v->data = (char *)v->dataD;}

 if(iFile->error == FR_ERROR_MALLOC_FAILED) return;

 FrVectMap(v);

 FrReadIntU  (iFile, &v->nDim);
 FrReadVI (iFile,(int **) &v->nx,  v->nDim);
 FrReadVD (iFile, &v->dx,    v->nDim);
 FrReadVQ (iFile, &v->unitX, v->nDim);
 FrReadSChar (iFile, &v->unitY);
 FrReadStruct(iFile, &v->next);
 
 v->wSize= wSize[v->type];

 v->startX= malloc(v->nDim*sizeof(double));
 if(v->startX== NULL) 
       {FrError(3,"FrVectRead","malloc failed");
        return;}
 for(i=0; i<v->nDim; i++) {v->startX[i] = 0.;}

 /*------- fix bug in compression flags-----*/

 if(v->compress >0xff)
   {v->compress  = 256 + (v->compress/0x100);}
 if(iFile->compress == 0 && v->compress != 0) {FrVectExpand(v);}
 
 if(FrDebugLvl > 2) fprintf(FrFOut," %s\n", v->name);

 return;}
